# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   e
#
##############################################################################

from openerp.osv import osv, fields


class apac_cadastro_visitas(osv.Model):
    from funcoes import _apccvi_get_name

    _name = 'apac.cadastro.visitas'
    _description = 'Cadastro de visitas para os recuperandos'
    _columns = {
        'name': fields.function(_apccvi_get_name, string='Data da Visita', type='char', size=10, method=True,
                                stored=False),
        'apccvi_voluntario_id': fields.many2one('apac.voluntarios', 'Responsavel', ondelete="restrict", required=True,
                                                select=True),
        'apccvi_data_visita': fields.date('Data', required=True),
        'apccvi_observacoes': fields.text('Observacoes'),
        'apccvi_qtd_visitantes': fields.integer('Qtd. visitantes', required=True),
        'apccvi_visita_ativa': fields.boolean('Ativa'),
    }
    _defaults = {
        'apccvi_visita_ativa': lambda *a: True,
    }
    _order = 'apccvi_data_visita desc'

