# -*- encoding: utf-8 -*-
# #############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class apac_parente(osv.Model):
    """
    Tabela de Parentes
    """
    from funcoes import _apcprt_get_idade

    _name = 'apac.parente'
    _description = 'Cadastro de Parentes'
    _inherits = {
        'adm.pessoa': 'apcprt_pessoa_id',
    }
    _columns = {
        'apcprt_pessoa_id': fields.many2one("adm.pessoa", 'Parente', required=True,
                                            ondelete="restrict", select=True,
                                            domain="[('pessoa_tipo', '=', 'F')]"),
        'apcprt_parentesco_id': fields.many2one("apac.parentesco", 'Parentesco',
                                                ondelete="restrict", required=True, select=True),
        'apcprt_recuperando_id': fields.many2one("apac.recuperando", 'Recuperando',
                                                 ondelete="cascade", select=True),
        'apcprt_idade': fields.function(_apcprt_get_idade, string='Idade', type='integer',
                                        method=True, stored=False),
    }
    _defaults = {
        'pessoa_tipo': lambda *a: 'F',
    }
