# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class apac_recuperando(osv.Model):
    _name = 'apac.recuperando'
    _description = 'Cadastro de Recuperandos'
    _inherits = {
        'adm.pessoa': 'apcrcp_pessoa_id',
    }
    _columns = {
        'apcrcp_pessoa_id': fields.many2one("adm.pessoa", 'Recuperando', ondelete="restrict", required=True,
                                            select=True, domain="[('pessoa_tipo', '=', 'F')]"),
        'apcrcp_regime': fields.selection([('S', 'Semi-Aberto'), ('F', 'Fechado')], 'Regime', required=True, size=1),
        'apcrcp_info_pen_nro': fields.char('Info pen nro', size=10),
        'apcrcp_info_pri_nro': fields.char('Info pri nro', size=10),
        'apcrcp_parente_ids': fields.one2many('apac.parente', 'apcprt_recuperando_id', 'Parentes'),
        'apcrcp_ocorrencias_ids': fields.one2many('apac.ocorrencias', 'apcoco_recuperando_id', 'Ocorrencias'),
        'apcrcp_visitante_recuperando_ids': fields.one2many('apac.visitante.recuperando', 'apcvrc_recuperando_id',
                                                            'Visitantes'),
        'apcrcp_data_ingresso': fields.date('Data de Ingresso'),
    }
    _defaults = {
        'apcrcp_regime': lambda *a: 'F',
        'pessoa_tipo': lambda *a: 'F',
    }

