# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   e
#
##############################################################################

from openerp.osv import osv, fields
import time


class apac_visitantes(osv.Model):
    _name = 'apac.visitantes'
    _description = 'Cadastro de visitantes para a instituicao'
    _inherits = {
        'adm.pessoa': 'apcvis_pessoa_id',
    }
    _columns = {
        'id': fields.integer('Controle', readonly=True),
        'apcvis_pessoa_id': fields.many2one("adm.pessoa", 'Visitante', ondelete="restrict", required=True, select=True,
                                            domain="[('pessoa_tipo', '=', 'F')]"),
        'apcvis_observacao': fields.text('Observacao'),
        'apcvis_data_hora_entrada': fields.datetime('Data/Hora entrada'),
        'apcvis_data_hora_saida': fields.datetime('Data/Hora saida'),
        'apcvis_instituicao': fields.char('Instituicao', size=50),
    }
    _defaults = {
        'apcvis_data_hora_entrada': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
    }
    _order = 'id desc'
