# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   e
#
##############################################################################

from openerp.osv import osv, fields


class apac_visitante_recuperando(osv.Model):
    from funcoes import _apcvrc_get_qtd_visitantes
    from funcoes import _apcvrc_get_visita_id

    _name = 'apac.visitante.recuperando'
    _description = 'Cadastro de visitantes para os recuperandos'
    _rec_name = 'apcvrc_recuperando_id'
    _inherits = {
        'apac.cadastro.visitas': 'apcvrc_visita_id',
    }
    _columns = {
        'apcvrc_observacoes': fields.text('Observacoes'),
        'apcvrc_visita_id': fields.many2one("apac.cadastro.visitas", 'Visita', ondelete="restrict", required=True,
                                            select=True, domain="[('apccvi_visita_ativa', '=', True)]"),
        'apcvrc_recuperando_id': fields.many2one("apac.recuperando", 'Recuperando', required=True, ondelete="cascade",
                                                 select=True),
        'apcvrc_visitantes_ids': fields.one2many("apac.visitante.recuperando.parente", "apcvrp_visita_recuperando_id",
                                                 'Visitantes'),
        'apcvrc_qtd_visitantes': fields.function(_apcvrc_get_qtd_visitantes, method=True, string='Qtd. Visitantes',
                                                 type='integer', store=False),
    }
    _defaults = {
        'apcvrc_visita_id': lambda s, cr, uid, c: s._apcvrc_get_visita_id(cr, uid, context=c),
    }

