# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class apac_voluntarios(osv.Model):
    _name = 'apac.voluntarios'
    _description = 'Cadastro de Voluntarios'
    _inherits = {
        'adm.pessoa': 'apcvol_pessoa_id',
    }
    _columns = {
        'apcvol_pessoa_id': fields.many2one("adm.pessoa", 'Voluntario', required=True, ondelete="restrict", select=True,
                                            domain="[('pessoa_tipo', '=', 'F')]"),
        'active': fields.boolean('Ativo'),
        'apcvol_funcao': fields.char('Funcao', size=30, required=True),
        'apcvol_observacao': fields.text('Observacoes'),
        'apcvol_horario_ids': fields.one2many("apac.voluntarios.horario", "apcvlh_voluntario_id", 'Horarios'),
    }
    _defaults = {
        'active': lambda *a: True,
        'pessoa_tipo': lambda *a: 'F',
    }


