# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class asfipo_cadastro(osv.Model):
    _inherits = {
        'adm.pessoa': 'asfcad_assistido_id',
    }
    _name = 'asfipo.cadastro'
    _columns = {
        'asfcad_encaminhado_por_id': fields.many2one("adm.pessoa", 'Encaminhado(a) por',
                                                     help='Pessoa que encaminhou o assistido!', ondelete="restrict",
                                                     select=True),
        'asfcad_assistido_id': fields.many2one("adm.pessoa", 'Assistido', ondelete="restrict", required=True,
                                               select=True, domain="[('pessoa_tipo', '=', 'F')]"),
        'asfcad_trabalho_id': fields.many2one("adm.pessoa", 'Local de trabalho', ondelete="restrict", select=True,
                                              domain="[('pessoa_tipo', '=', 'J')]"), # Empresa onde trabalha
        'asfcad_escola_id': fields.many2one("adm.pessoa", 'Local onde estuda', ondelete="restrict", select=True,
                                            domain="[('pessoa_tipo', '=', 'J')]"), # Escola onde estuda
        'asfcad_qtd_pessoas': fields.integer('Nro de pessoas em sua residência'),
        'asfcad_faz_tratamento': fields.boolean('Faz tratamento de saude?'),
        'asfcad_usa_medicamentos': fields.boolean('Usa medicamentos?'),
        'asfcad_ja_fez_tratamentos': fields.boolean('Ja fez tratamentos anteriores?'),
        'asfcad_responsavel_id': fields.many2one("adm.pessoa", 'Responsavel pelo(a) dependente', ondelete="restrict",
                                                 select=True, domain="[('pessoa_tipo', '=', 'F')]"),
        'asfcad_problema_policial': fields.boolean('Tem problema Policial/Judicial?'),
        'asfcad_condenacao': fields.boolean('Ja foi Condenado/Cumprindo Pena?'),
        'asfcad_avaliacao_dependente': fields.text('Avaliacao do Dependente(a)'), # avaliacao do dependente
        'asfcad_avaliacao_codependentes': fields.text('Avaliacao dos Codependentes'), # avaliacao dos co-dependentes
        'asfcad_entrevistador_id': fields.many2one("adm.pessoa", 'Entrevistado(a) por', ondelete="restrict",
                                                   required=True, select=True, domain="[('pessoa_tipo', '=', 'F')]"),
        'asfcad_observacao': fields.text('Informacoes Complementares'), # Informacoes complemtares
        'asfcad_nro_entrevista': fields.char('Nro da Entrevista', size=11, readonly=True), # Numero da entrevista
        'asfcad_data': fields.date('Data', readonly=True),
        'asfcad_cadastro_dependencias_ids': fields.many2many('asfipo.dependencias', 'asfipo_cadastro_dependencias',
                                                             'Dependencias'),
        'asfcad_cadastro_instituicoes_ids': fields.one2many('asfipo.cadastro.instituicoes', 'asfcin_cadastro_id',
                                                            'Instituicoes'),
        'asfcad_ocorrencias_ids': fields.one2many('asfipo.ocorrencias', 'asfoco_cadastro_id', 'Ocorrencias'),
        'asfcad_cadastro_processos_ids': fields.one2many('asfipo.cadastro.processos', 'asfcpr_cadastro_id',
                                                         'Processos'),
        'asfcad_encaminhamento_grupos_ids': fields.one2many('asfipo.encaminhamento.grupos', 'asfegr_cadastro_id',
                                                            'Grupos'),
        'asfcad_encaminhamento_especialistas_ids': fields.one2many('asfipo.encaminhamento.especialistas',
                                                                   'asfeep_cadastro_id', 'Especialistas'),
        'asfcad_oficio_num': fields.char('Oficio N', size=10),
        'asfcad_periodo': fields.integer('asfcad_periodo encaminhamento', digits=(2)),
        'active': fields.boolean('Ativo'),
    }
    _defaults = {
        'asfcad_data': lambda *a: time.strftime('%Y-%m-%d'),
        'active': lambda *a: True,
        'pessoa_tipo': lambda *a: 'F',
    }



