# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class asfipo_encaminhamento_grupos(osv.Model):
    from funcoes import _nome_grupo

    _name = 'asfipo.encaminhamento.grupos'
    _description = 'Cadastro de encaminhamento para grupos de apoio'
    _columns = {
        'asfegr_cadastro_id': fields.many2one("asfipo.cadastro", 'Encaminhado(a)', ondelete="restrict", required=True,
                                              select=True), # id do dependente
        'asfegr_instituicao_id': fields.many2one("adm.pessoa", 'Instituicao', ondelete="restrict", required=True,
                                                 select=True, domain="[('pessoa_tipo', '=', 'J')]"),
        # id da instituicao para a qual foi encaminhada
        'asfegr_data': fields.date('Data'), # data do encaminhamento
        'asfegr_periodo_inicial': fields.date('Periodo Inicial'), # data do inicio do tratamento
        'asfegr_periodo_final': fields.date('Periodo Final'), # data do periodo final do tratamento\n
        'asfegr_qtd_reunioes': fields.integer('Qtda. de Reunioes'), # Quantidade de reunioes que o dependente participou
        'asfegr_observacoes': fields.text('Informacoes Complementares'), # Informacoes complementares
        'asfegr_oficio_ids': fields.one2many('asfipo.oficio', 'asfofi_encaminhamento_id', 'Oficios'),
        'name': fields.function(_nome_grupo, method=True, string='Instituicao', type='text', store=False),
    }
    _defaults = {
        'asfegr_data': lambda *a: time.strftime('%Y-%m-%d'),
    }

