# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class asfipo_oficio(osv.Model):
    _name = 'asfipo.oficio'
    _description = 'Cadastro de oficios enviados aos grupos'
    _columns = {
        'asfofi_numero': fields.char('Numero', size=11, readonly=True),
        'asfofi_encaminhamento_id': fields.many2one("asfipo.encaminhamento.grupos", 'Grupo encaminhado',
                                                    ondelete="restrict", required=True, select=True),
        'asfofi_data': fields.date("Data do oficio"),
        'asfofi_data_resposta': fields.date('Data da resposta'),
        'asfofi_qtd_reunioes': fields.integer('Qtda. de Reunioes frequentadas'),
        'asfofi_observacoes': fields.text('Informacoes Complementares'), # Informacoes complementares
    }
    _defaults = {
        'asfofi_data': lambda *a: time.strftime('%Y-%m-%d'),
    }
