# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
import time


class banfin_pixpag(osv.Model):

    _inherit = 'banfin.pixpag'

    def banfin_pixpag_onchange_pessoa_id(self, cr, uid, ids, company_id, pessoa_id, context=None):
        context = context and context.copy() or {}
        res = {'value': {'banfin_pixpag_chave_id': ''}}
        if not pessoa_id:
            return res
        args = [('company_id', '=', company_id), ('banfin_pixpg_ch_pessoa_id', '=', pessoa_id)]
        chave_ids = self.pool.get('banfin.pixpag.chaves').search(cr, uid, args, context=context)
        chave_dados = self.pool.get('banfin.pixpag.chaves').read(cr, uid, chave_ids, ['banfin_pixpg_ch_chave'],
                                                              context=context)
        if len(chave_dados) == 1:
            return {'value': {'banfin_pixpag_chave_id': chave_dados[0].get('id')}}
        return {}

    def banfin_pixpag_onchange_conta_id(self, cr, uid, ids, conta_id, context=None):
        context = context and context.copy() or {}
        res = {'value': {'banfin_pixpag_saldo': 0.0, 'banfin_pixpag_image_status': ''}}
        if not conta_id:
            return res
        conta_brw = self.pool.get('financeiro.tesouraria.contas').browse(cr, uid, conta_id, context=context)
        if not conta_brw.banco_id.admbco_codigo_interno_id:
            return {'warning': {'title': _('Aviso'),
                                'message': _('Conta de tesouraria sem integracao bancaria!')},
                    'value': {'banfin_pixpag_saldo': 0.0, 'banfin_pixpag_image_status': ''}
                    }
        ret = self.pool.get('bf.integracao').status_get(cr, uid,
                        conta_brw.banco_id.admbco_codigo_interno_id.banfin_cdin_codigo_interno,
                        conta_id,
                        'pixpag',
                        context=context)
        _imagem = ret.get('dados').get('imagem')
        ret = self.pool.get('bf.integracao').bank_get_saldo(cr, uid,
                                          conta_brw.banco_id.admbco_codigo_interno_id.banfin_cdin_codigo_interno,
                                          conta_id,
                                          context=context)
        if ret.get('status'):
            saldo = ret.get('dados').get('saldoDisponivel')
            return {'value': {'banfin_pixpag_saldo': saldo, 'banfin_pixpag_image_status': _imagem}}
        return {'warning': {'title': _('Aviso'),
                            'message': _('Nao consegui conectar com o banco!')},
                'value': {'banfin_pixpag_image_status': _imagem}
                }

    def banfin_pixpag_btn_consultar(self, cr, uid, ids, context=None):
        brw_linha = self.browse(cr, uid, ids[0], context=context)
        ret = self.pool.get('bf.integracao').pix_pag_consultar(cr, uid,
               brw_linha.banfin_pixpag_conta_id.banco_id.admbco_codigo_interno_id.banfin_cdin_codigo_interno,
               brw_linha.banfin_pixpag_conta_id.id,
               controle=brw_linha.banfin_pixpag_codigo_solicitacao,
               endToEnd=brw_linha.banfin_pixpag_codigo_endtoend,
               context=context)
        if ret.get('status'):
            vals = {
                'state': ret.get('dados').get('situacao'),
            }
            self.write(cr, uid, ids, vals, context=context)
            if vals.get('state') == 'R':
                self.banfin_pixpag_atualizar_financeiro(cr, uid, ids[0], 'D', context=context)
            return True
        raise osv.except_osv(_('Atencao'), ret.get('mensagem'))


    def banfin_pixpag_btn_enviar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        pix_brw = self.browse(cr, uid, ids[0], context=context)
        if not (pix_brw.banfin_pixpag_evento_id and pix_brw.banfin_pixpag_centro_custo_id):
            if not pix_brw.banfin_pixpag_conta_destino_id:
                raise osv.except_osv(_('Atencao'), _('Sem Evento e/ou Centro de custo, e necessário conta de destino!'))
        if pix_brw.banfin_pixpag_evento_id and pix_brw.banfin_pixpag_centro_custo_id:
            if pix_brw.banfin_pixpag_conta_destino_id:
                raise osv.except_osv(_('Atencao'),
                                     _('Informando conta de destino, nao deve informar custo nem centro de custo!'))
        if pix_brw.banfin_pixpag_evento_id and not pix_brw.banfin_pixpag_centro_custo_id:
            raise osv.except_osv(_('Atencao'),
                                 _('Informando Evento, e necessario informar centro de custo!'))
        if not pix_brw.banfin_pixpag_evento_id and pix_brw.banfin_pixpag_centro_custo_id:
            raise osv.except_osv(_('Atencao'),
                                 _('Informando Centro de custo, e necessario informar o evento!'))
        res = self.pool.get('bf.integracao').pix_pag_enviar(cr, uid,
                                                              pix_brw.banfin_pixpag_conta_id.banco_id.admbco_codigo_interno_id.banfin_cdin_codigo_interno,
                                                              pix_brw.banfin_pixpag_conta_id.id,
                                                              pix_brw.banfin_pixpag_chave_id.banfin_pixpg_ch_chave,
                                                              pix_brw.banfin_pixpag_valor,
                                                              descricao=pix_brw.banfin_pixpag_descricao,
                                                              data=pix_brw.banfin_pixpag_data,
                                                              context=context)
        if not res.get('status'):
            raise osv.except_osv(_('Atencao'), res.get('mensagem'))
        dados = res.get('dados')
        if dados.get('tipoRetorno') == 'APROVACAO':
            vals = {
                'banfin_pixpag_codigo_solicitacao': dados.get('codigoSolicitacao'),
                'state': 'V',
            }
            self.write(cr, uid, ids, vals, context=context)
        return True

    def banfin_pixpag_atualizar_financeiro(self, cr, uid, pixpag_id, creditoDebito, context=None):
        context = context and context.copy() or {}
        pixpagBrw = self.browse(cr, uid, pixpag_id, context=context)
        # Se ja foi lancado, não ha maia nada a fazer
        if creditoDebito =='C':
            _historico = '%s (Devolucao)' % pixpagBrw.banfin_pixpag_descricao
            vals = {'banfin_pixpag_credito_tesouraria_id': pixpagBrw.banfin_pixpag_conta_id.id}
            if pixpagBrw.banfin_pixpag_credito_tesouraria_id:
                return {'status': True, 'mensagem': ''}
        else:
            _historico = pixpagBrw.banfin_pixpag_historico
            vals = {'banfin_pixpag_debito_tesouraria_id': pixpagBrw.banfin_pixpag_conta_id.id}
            if pixpagBrw.banfin_pixpag_debito_tesouraria_id:
                return {'status': True, 'mensagem': ''}
        self.write(cr, uid, [pixpag_id], vals, context=context)
        vals = {
            'conta_id': pixpagBrw.banfin_pixpag_conta_id.id,
            'data_movimento': time.strftime('%Y-%m-%d'),
            'mes_competencia': time.strftime('%m'),
            'ano_competencia': time.strftime('%Y'),
            'valor': pixpagBrw.banfin_pixpag_valor,
            'historico': _historico,
            'debito_credito': creditoDebito,
            'state': 'A',
        }
        if pixpagBrw.banfin_pixpag_conta_destino_id:
            vals['conta_destino_id'] = pixpagBrw.banfin_pixpag_conta_destino_id.id
        if pixpagBrw.banfin_pixpag_centro_custo_id:
            vals['gerencial_movimento_ids'] = [[0, False, {
                'centro_custo_id': pixpagBrw.banfin_pixpag_centro_custo_id.id,
                'evento_id': pixpagBrw.banfin_pixpag_evento_id.id,
                'valor': pixpagBrw.banfin_pixpag_valor,
                'fingmo_data': time.strftime('%Y-%m-%d'),
                'mes_competencia': time.strftime('%m'),
                'ano_competencia': time.strftime('%Y'),
                'fingmo_historico': _historico,
                'fingmo_operacao': 'E' if creditoDebito == 'C' else 'S',
            }]]

        try:
            self.pool.get('financeiro.tesouraria.movimento').create(cr, uid, vals, context=context)
        except:
            return {'status': False, 'mensagem': _('Nao consegui atualizar o movimento da tesouraria')}
        res = {'status': True, 'mensagem': ''}
        return res

