# -*- encoding: utf-8 -*-
# ##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class banfin_pixpag_notificacoes(osv.Model):

    _inherit = 'banfin.pixpag.notificacoes'

    def banfin_not_pp_btn_processar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.banfin_not_pp_processar_notificacoes(cr, uid, ids, context=context)
        if not res.get('status'):
            raise osv.except_osv(_('Atencao'), res.get('mensagem'))
        return res

    def banfin_not_pp_processar_notificacoes(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = {'status': False, 'mensagem': _('Nao encontrei nada para processar')}
        for notiDados in self.read(cr, uid, ids, [], context=context):
            _controle = notiDados.get('banfin_not_pp_controle')
            pixpag_ids = self.pool.get('banfin.pixpag').search(cr, uid,
                                                               [('banfin_pixpag_codigo_solicitacao', '=', str(_controle))],
                                                              context=context, limit=1)
            if not pixpag_ids:
                return {'status': False, 'mensagem': _('Nao encontrei PIX para o controle "%s"') % _controle}
            pixpag_id = pixpag_ids[0]
            pixpagBrw = self.pool.get('banfin.pixpag').browse(cr, uid, pixpag_id, context=context)
            if notiDados.get('banfin_not_pp_status') != 'EFETIVADO':
                vals = {
                    'state': 'U',
                }
                self.write(cr, uid, notiDados.get('id'), vals, context=context)
                vals = {
                    'state': 'R',
                    'banfin_pixpag_codigo_endtoend': notiDados.get('banfin_not_pp_endtoend'),
                }
                self.pool.get('banfin.pixpag').write(cr, uid, [pixpag_id], vals, context=context)
                return {'status': True, 'mensagem': ''}

            # Verifica se ja foi processado
            if pixpagBrw.state == 'R':
                vals = {
                    'state': 'E',
                }
                self.write(cr, uid, notiDados.get('id'), vals, context=context)
                return {'status': True, 'mensagem': ''}
            context['sig_force'] = pixpagBrw.company_id.id
            vals = {
                'state': 'R',
                'banfin_pixpag_codigo_endtoend': notiDados.get('banfin_not_pp_endtoend'),
            }
            self.pool.get('banfin.pixpag').write(cr, uid, [pixpag_id], vals, context=context)
            if notiDados.get('banfin_not_pp_tipomovimento') == 'PAGAMENTO':
                self.pool.get('banfin.pixpag').banfin_pixpag_atualizar_financeiro(cr, uid, pixpag_id, 'D',
                                                                                  context=context)
            else:
                self.pool.get('banfin.pixpag').banfin_pixpag_atualizar_financeiro(cr, uid, pixpag_id, 'C',
                                                                                  context=context)
            vals = {
                'state': 'E',
            }
            self.write(cr, uid, notiDados.get('id'), vals, context=context)
            res = {'status': True, 'mensagem': ''}
        return res

