# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields

def brasiliex_get_ticker(moeda):
    """
    Busca o ticker na foxbit
    :return: dicionario com resultado
     ex: {"buy": 41150.0,
          "last": 41298.49,
          "sell": 41298.49,
    """
    _url = 'https://braziliex.com/api/v1/public/ticker/%s' % moeda
    response = requests.get(_url, {})
    a = response.json()
    """ retorno do ticker  brasiliex
      {"active":1,
      "market":"btc_brl",
      "last":"27400.00000000",
      "percentChange":"-1.52",
      "baseVolume24":"4.405",
      "quoteVolume24":"127875.111",
      "baseVolume":"4.405",
      "quoteVolume":"127875.111",
      "highestBid24":"32499.00000000",
      "lowestAsk24":"26500.00000000",
      "highestBid":"26502.01000000",
      "lowestAsk":"27599.99000000"}
    """
    return {
        'buy':a.get('highestBid'),
        'sell': a.get('lowestAsk'),
        'last': a.get('last'),
    }


class coin_servicos(osv.Model):
    """
    Classe para controle dos serviços(API)
    prefixo:coisrv
    """
    _inherit = 'coin.servicos'

    def coisrv_api_get_ticker(self, cr, uid, broker, moeda_code, moeda_par, context=None):
        res = super(coin_servicos, self).coisrv_api_get_ticker(cr, uid, broker, moeda_code, moeda_par, context=context)
        if broker.lower() == 'brasiliex':
            res = brasiliex_get_ticker(moeda_par)
        return res




import requests
from datetime import datetime

def brasiliex_get_trade(hora):
    """
    Busca o trade na foxbit
    :return: lista de dicionario com resultado
     ex: [{"tid": 2345, "date": 1418293867, "price": 1020.0, "amount": 0.001, "side": "sell"}]
    """
    _url = 'https://api.brasiliex.com/api/v1/BRL/trades?crypto_currency=BTC&since=%s&limit=100' % hora
    response = requests.get(_url, {})
    linhas = []
    for linha in response.json():
        linhas.append({
            'side': linhas.get('side'),
            'data': datetime.fromtimestamp(linha.get('date')).strftime('%Y-%m-%d %H:%M:%S'),
            'tid': linha.get('tid'),
            'amount': linha.get('amount'),
            'price': linha.get('price'),
        })
    return linhas

def brasiliex_get_orderbook(moeda='BTCBRL'):
    _url = 'https://api.brasiliex.com/api/v1/BRL/orderbook"'
    response = requests.get(_url, {})
    for linha in  response.json():
        if linha.get('pair') == moeda:
            return {
                'bids': linha.get('bids'),
                'asks': linha.get('asks'),
            }
    return {'bids':[], 'asks':[]}
