# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import time
import thread
import openerp.sql_db as sql_db
from datetime import datetime
import psutil
from .utils import controle_gravar, controle_ler
import locale


class coin_robot(osv.Model):
    _inherit = 'coin.robot'
    _robot_thread = {}

    def _get_foxbit(self, cr, uid, robot_id, context=None):
        def _registrar_historico(historico, operacao='H'):
            vals = {
                'coibhi_robot_id': robot_id,
                'coibhi_historico': historico,
                'coibhi_operacao': operacao,
            }
            _sql = 'select coibhi_historico from coin_robot_historicos where coibhi_robot_id = %s order by id desc limit 10' % robot_id
            cr.execute(_sql)
            for _dados_historicos in cr.dictfetchall():
                resultado = _dados_historicos and historico == _dados_historicos.get('coibhi_historico')
                if resultado:
                    return True
            res = self.pool.get('coin.robot.historicos').create(cr, uid, vals, context=context)
            _sql = "delete from coin_robot_historicos where id in (select id from coin_robot_historicos where coibhi_robot_id = %s and coibhi_operacao = 'H' order by id desc limit 100 offset 100)" % robot_id
            cr.execute(_sql)
            return True

        def _criar_order(qtd_coin, vr_compra, vr_moeda, operacao, tipo_ordem, comissao):
            vals = {
                'coiord_broker_id': _broker,
                'coiord_moeda_id': _moeda,
                'coiord_robot_id': robot_id,
                'coiord_quantidade': qtd_coin,
                'coiord_valor_operacao': vr_compra,
                'coiord_valor_moeda': vr_moeda,
                'coiord_order_operacao': operacao,
                'coiord_order_tipo': tipo_ordem,
                'coiord_comissao': comissao,
                'state': 'A',
            }
            self.pool.get('coin.orders').create(cr, uid, vals, context=context)
            return True

        def _comprar(vr_disponivel, vr_operacao, estrategia=None):
            _qtd_coin = vr_disponivel / vr_operacao
            vals = {
                'coibot_valor_compra': vr_operacao,
                'coibot_data_compra': datetime.now(),
                'coibot_saldo' : dados_robot.get('coibot_saldo') - vr_disponivel,
                'coibot_proxima_operacao': 'V',
                'coibot_qtd_compras': dados_robot.get('coibot_qtd_compras') + 1
            }
            if estrategia and estrategia == 'MM':
                vals['coibot_quantidade_comprada'] = dados_robot.get('coibot_quantidade_comprada') + _qtd_coin
                vals['coibot_proxima_operacao'] = 'S'
            else:
                vals['coibot_quantidade_comprada'] =  _qtd_coin
            self.write(cr, uid, robot_id, vals, context=context)
            _comissao = vr_disponivel * 0.25 / 100
            _criar_order(_qtd_coin, vr_disponivel, vr_operacao, 'C', 'M', _comissao )
            _historico = 'Comprei! Valor na compra: %s, qtd: %s' % (vr_operacao, _qtd_coin)
            _registrar_historico(_historico, 'O')
            return True

        def _vender(qtd_comprada, vr_operacao, estrategia=None):
            _vr_venda = qtd_comprada * vr_operacao
            vals = {
                'coibot_valor_compra': 0,
                'coibot_data_compra': 0,
                'coibot_saldo' : dados_robot.get('coibot_saldo') + _vr_venda,
                'coibot_proxima_operacao': 'C',
                'coibot_qtd_vendas': dados_robot.get('coibot_qtd_vendas') + 1
            }
            if estrategia and estrategia == 'MM':
                vals['coibot_quantidade_comprada'] = dados_robot.get('coibot_quantidade_comprada') - qtd_comprada
                vals['coibot_proxima_operacao'] = 'S'
                vals['coibot_valor_compra'] = vr_operacao
                vals['coibot_data_compra'] = datetime.now()
            else:
                vals['coibot_quantidade_comprada'] = 0
            self.write(cr, uid, robot_id, vals, context=context)
            _comissao = _vr_venda * 0.25 / 100
            _criar_order(qtd_comprada, _vr_venda, vr_operacao, 'V', 'M', _comissao)
            _historico = 'Vendi! Valor vendido: %s, vendido por: %s' % (_vr_venda, vr_operacao, )
            _registrar_historico(_historico, 'O')
            return True

        def _get_mx(): # Maximizado
            _sql = """select * 
                        from coin_ticker 
                        where coitck_broker_id = {broker} and 
                              coitck_moeda_id = {moeda} 
                              order by create_date desc limit 20000
                   """.format(broker=_broker, moeda=_moeda)
            cr.execute(_sql)
            _lin_sentido = False
            _vr_ticker_anterior = _valor_minimo = 0

            for _dados_ticker in cr.dictfetchall():
                if _proxima_operacao == 'C':
                    _vr_ticker_lido = _dados_ticker.get('coitck_valor_venda')
                else:
                    _vr_ticker_lido = _dados_ticker.get('coitck_valor_compra')

                if self.vr_operacao == 0:
                    self.vr_operacao = _valor_minimo = _valor_maximo = _vr_ticker_anterior = _vr_ticker_lido
                    continue
                if _vr_ticker_lido == _vr_ticker_anterior:  # ultimo é igual ao atual, não há nada a fazer
                    continue
                _vr_ticker_anterior = _vr_ticker_lido
                if not _lin_sentido:  # estabelecer o sentido
                    _per = 100 - (self.vr_operacao * 100 / _vr_ticker_lido)
                    if _per < 0:
                        _per = _per * -1
                    if _per < _var_mx_sentido:  # Não deu para identificar o sentido
                        continue
                    if _vr_ticker_lido > self.vr_operacao:
                        _lin_sentido = '-'
                        _valor_maximo = _vr_ticker_lido
                    else:
                        _lin_sentido = '+'
                        _valor_minimo = _vr_ticker_lido
                    continue
                if _lin_sentido == '-':
                    if _valor_maximo > _vr_ticker_lido:
                        _valor_maximo = _vr_ticker_lido
                else:
                    if _valor_minimo < _vr_ticker_lido:
                        _valor_minimo = _vr_ticker_lido
                if _proxima_operacao == 'C' and _lin_sentido == '-':
                    _historico = 'Nao posso comprar, valor em queda! vr Atual: %s Encontrado: %s' % (self.vr_operacao, _vr_ticker_lido)
                    _registrar_historico(_historico)
                    break  # Não fazer nada
                if _proxima_operacao == 'V' and _lin_sentido == '+':
                    _historico = 'Nao posso vender, valor subindo! vr Atual: %s Encontrado: %s' % (self.vr_operacao, _vr_ticker_lido)
                    _registrar_historico(_historico)
                    break  # Não fazer nada

                if _lin_sentido == '+':  # Sentido positivo - Verificar se compra
                    if _vr_mx_dif_outro > 0:
                        _sql = "select coibot_valor_compra from coin_robot where coibot_estrategia = 'MX' and coibot_proxima_operacao = 'V' and coibot_ativo = True order by coibot_valor_compra limit 1"
                        cr.execute(_sql)
                        dados_bot = cr.dictfetchone()
                        if dados_bot:
                            _dif = 100 - (self.vr_operacao * 100 / dados_bot.get('coibot_valor_compra'))
                            if _dif < 0:
                                _dif = _dif * -1
                            if _dif < _vr_mx_dif_outro:
                                _dif = locale.format('%.2f', _dif)
                                _historico = 'Nao posso comprar, valor de compra abaixo do diferenca minima entre bots! Atual:%s vr.Compra:%s dif.:%s' % \
                                             (self.vr_operacao, dados_bot.get('coibot_valor_compra'), _dif)
                                _registrar_historico(_historico)
                                return True
                    if self.vr_operacao > _limite_compra:  # Não posso comprar, valor muito auto.
                        _historico = 'Nao posso comprar, valor acima do limite! Valor atual: %s Limite: %s' % (
                        self.vr_operacao, _limite_compra)
                        _registrar_historico(_historico)
                        break
                    if self.vr_operacao > _avg:
                        _avg_e = locale.format('%.2f', _avg)
                        _historico = 'Nao posso comprar, valor acima da media! Valor atual: %s, Media: %s' % (
                                                                                            self.vr_operacao, _avg_e)
                        _registrar_historico(_historico)
                        break  # valor está
                        # alto para comprar
                    # confirmar mudança de sentido
                    _var_ult = 100 - (self.vr_operacao * 100 / _valor_minimo)
                    if _var_ult < 0:
                        _var_ult = _var_ult * -1
                    if _var_ult < _var_mx_sentido:  # Não foi suficiente para mudança de direção
                        continue
                    # Confirmar variação para compra
                    if _var_ult < _var_mx_compra:  # ainda não da pra comprar
                        continue
                    _comprar(_vr_disponivel, self.vr_operacao)
                    break

                # Sentido negativo - Verificar se vende
                # confirmar mudança de sentido
                _var_ult = 100 - (self.vr_operacao * 100 / _valor_maximo)
                if _var_ult < 0:
                    _per = _per * -1
                if _var_ult < _var_mx_sentido:  # Não foi suficiente para mudança de direção
                    continue
                # Confirmar variação para venda
                if _var_ult < _var_mx_venda:  # não vender ainda
                    continue
                _vl_a_vender = _qtd_comprada * self.vr_operacao
                _vl_min_com_lucro = (_qtd_comprada * _vr_comprado) * ((100 + _mx_lucro) / 100)
                if _vl_a_vender < _vl_min_com_lucro:  # não cobriu margem de lucro, naõ vender
                    _vl_min = _vr_comprado * ((100 + _mx_lucro) / 100)
                    _historico = 'Nao posso vender, nao deu lucro! Valor atual: %s,  Var.minimo p/venda: %s' % (
                                self.vr_operacao,  _vl_min)
                    _registrar_historico(_historico)
                    break
                _vender(_qtd_comprada, self.vr_operacao)
                break
            return True

        def _get_fx(): # Fixo
            _obj_ticker = self.pool.get('coin.ticker')
            _vr_compra, _vr_venda, _vr_ultima = _obj_ticker.coitck_get_ultima_cotacao(cr, uid, _broker, _moeda,
                                                                          context=context)
            if _proxima_operacao == 'V':
                _vr_min_venda = _vr_comprado * (100 + _vr_fx_ganho) / 100
                if _vr_compra < _vr_min_venda:
                    if _vr_compra < _vr_comprado:
                        _historico = 'Nao posso vender, Valor abaixo do comprado! Comprado: %s Atual: %s' % (_vr_comprado, _vr_compra)
                    else:
                        _margem = _vr_compra * 100 / _vr_comprado
                        _margem = locale.format('%.4f', _margem)
                        _vr_min_venda = locale.format('%.2f', _vr_min_venda)
                        _historico = 'Nao posso vender, Sem _margem para venda! Min.Venda: %s Atual: %s Margem:%s' % (_vr_min_venda, _vr_compra, _margem)
                    _registrar_historico(_historico)
                else:
                    _vender(_qtd_comprada, _vr_compra)
            if _proxima_operacao == 'C':
                if _vr_fx_dif_outro > 0:
                    _sql = "select coibot_valor_compra from coin_robot where coibot_estrategia = 'FX' and coibot_proxima_operacao = 'V' and coibot_ativo = True order by coibot_valor_compra limit 1"
                    cr.execute(_sql)
                    dados_bot = cr.dictfetchone()
                    if dados_bot:
                        if dados_bot.get('coibot_valor_compra') < _vr_venda:
                            _historico = 'Nao posso comprar, valor de compra acima da ultima compra! Atual:%s ultima:%s' % \
                                         (_vr_venda, dados_bot.get('coibot_valor_compra'))
                            _registrar_historico(_historico)
                            return True
                        _vr_max_compra =  dados_bot.get('coibot_valor_compra') - (dados_bot.get('coibot_valor_compra') * _vr_fx_dif_outro / 100)
                        if _vr_venda > _vr_max_compra:
                            _historico = 'Nao posso comprar, valor de compra acima do limite! Atual:%s ultima:%s' % \
                                         (_vr_venda, _vr_max_compra)
                            _registrar_historico(_historico)
                            return True
                if _vr_venda > _avg:
                    _avg_e = locale.format('%.2f', _avg)
                    _historico = 'Nao posso comprar, valor acima da media! Atual:%s Media:%s' % (_vr_venda, _avg_e)
                    _registrar_historico(_historico)
                    return True
                if _vr_venda > _limite_compra:
                    _historico = 'Nao posso comprar, valor acima do limite! Atual:%s Limite: %s' % (_vr_venda, _limite_compra)
                    _registrar_historico(_historico)
                    return True
                _comprar(_vr_disponivel, _vr_venda)
            return True

        def _get_mm(): # Meio a meio
            _obj_ticker = self.pool.get('coin.ticker')
            _vr_compra, _vr_venda, _vr_ultima = _obj_ticker.coitck_get_ultima_cotacao(cr, uid, _broker, _moeda,
                                                                          context=context)
            _saldo_real = dados_robot.get('coibot_saldo')
            _saldo_bit = dados_robot.get('coibot_quantidade_comprada') * _vr_ultima
            if _saldo_real > _saldo_bit: # comprar
                _dif = (100 - (_saldo_bit * 100 / _saldo_real))
                if _dif < dados_robot.get('coibot_mm_variacao_para_operacao'):
                    _saldo_real = locale.format('%.2f', _saldo_real)
                    _saldo_bit = locale.format('%.2f', _saldo_bit)
                    _dif = locale.format('%.4f', _dif)
                    _historico = 'Nao posso comprar, valor abaixo da variacao! S.Real:%s S.coin: %s dif:%s' % (_saldo_real, _saldo_bit, _dif)
                    _registrar_historico(_historico)
                    return True
                if _vr_venda > _limite_compra:
                    _historico = 'Nao posso comprar, valor de compra acima do limite! Atual:%s limite:%s' % \
                                 (_vr_venda, _limite_compra)
                    _registrar_historico(_historico)
                    return True
                if _vr_venda > _avg:
                    _avg_e = locale.format('%.2f', _avg)
                    _historico = 'Nao posso comprar, valor de compra acima da media! Atual:%s media:%s' % \
                                 (_vr_venda, _avg_e)
                    _registrar_historico(_historico)
                    return True
                _vr_disponivel = ((_dif / 2) * _saldo_real / 100)
                _comprar(_vr_disponivel, _vr_venda, 'MM')
            else: # vender
                _dif = ((_saldo_bit * 100 / _saldo_real) - 100)
                if _dif < dados_robot.get('coibot_mm_variacao_para_operacao'):
                    _saldo_real = locale.format('%.2f', _saldo_real)
                    _saldo_bit = locale.format('%.2f', _saldo_bit)
                    _dif = locale.format('%.4f', _dif)
                    _historico = 'Nao posso vender, valor abaixo da variacao! S.Real:%s S.coin: %s dif:%s' % (_saldo_real, _saldo_bit, _dif)
                    _registrar_historico(_historico)
                    return True
                vr_operacao = _saldo_real * (_dif / 2) / 100
                _qtd_comprada = vr_operacao / _vr_compra
                _vender(_qtd_comprada, _vr_compra, 'MM')
            return True

        def _get_ba(): # Banheira
            _obj_ticker = self.pool.get('coin.ticker')
            _vr_compra, _vr_venda, _vr_ultima = _obj_ticker.coitck_get_ultima_cotacao(cr, uid, _broker, _moeda,
                                                                          context=context)
            _vr_minimo_pra_compra = _vr_venda * ((100 - _vr_ba_ganho)/100)
            if _proxima_operacao == 'V':
                _vr_min_venda = _vr_comprado * (100 + _vr_fx_ganho) / 100
                if _vr_compra < _vr_min_venda:
                    if _vr_compra < _vr_comprado:
                        _historico = 'Nao posso vender, Valor abaixo do comprado! Comprado: %s Atual: %s' % (_vr_comprado, _vr_compra)
                    else:
                        _margem = _vr_compra * 100 / _vr_comprado
                        _margem = locale.format('%.4f', _margem)
                        _vr_min_venda = locale.format('%.2f', _vr_min_venda)
                        _historico = 'Nao posso vender, Sem _margem para venda! Min.Venda: %s Atual: %s Margem:%s' % (_vr_min_venda, _vr_compra, _margem)
                    _registrar_historico(_historico)
                else:
                    _vender(_qtd_comprada, _vr_compra)
            if _proxima_operacao == 'C':
                if _vr_minimo_pra_compra > _vr_compra:
                    _historico = 'Nao posso comprar, valor de compra acima do minimo! Atual:%s minimo:%s' % \
                                 (_vr_compra, _vr_minimo_pra_compra)
                    _registrar_historico(_historico)
                    return True
                return True
                if _vr_ba_dif_outro > 0:
                    _sql = "select coibot_valor_compra from coin_robot where coibot_estrategia = 'BA' and coibot_proxima_operacao = 'V' and coibot_ativo = True order by coibot_valor_compra limit 1"
                    cr.execute(_sql)
                    dados_bot = cr.dictfetchone()
                    if dados_bot:
                        if dados_bot.get('coibot_valor_compra') < _vr_compra:
                            _historico = 'Nao posso comprar, valor de compra acima da ultima compra! Atual:%s ultima:%s' % \
                                         (_vr_compra, dados_bot.get('coibot_valor_compra'))
                            _registrar_historico(_historico)
                            return True
                        _vr_max_compra =  dados_bot.get('coibot_valor_compra') - (dados_bot.get('coibot_valor_compra') * _vr_ba_dif_outro / 100)
                        if _vr_compra > _vr_max_compra:
                            _historico = 'Nao posso comprar, valor de compra acima do limite! Atual:%s ultima:%s' % \
                                         (_vr_compra, _vr_max_compra)
                            _registrar_historico(_historico)
                            return True
                if _vr_compra > _avg:
                    _avg_e = locale.format('%.2f', _avg)
                    _historico = 'Nao posso comprar, valor acima da media! Atual:%s Media:%s' % (_vr_compra, _avg_e)
                    _registrar_historico(_historico)
                    return True
                if _vr_compra > _limite_compra:
                    _historico = 'Nao posso comprar, valor acima do limite! Atual:%s Limite: %s' % (_vr_compra, _limite_compra)
                    _registrar_historico(_historico)
                    return True
                _comprar(_vr_disponivel, _vr_compra)
            return True

        context = context and context.copy() or {}
        dados_robot = self.read(cr, uid, robot_id, [], context=context, load='_classic_write')
        _broker = dados_robot.get('coibot_broker_id')
        _moeda = dados_robot.get('coibot_moeda_id')
        _var_mx_compra = dados_robot.get('coibot_mx_variacao_compra')
        _var_mx_venda = dados_robot.get('coibot_mx_variacao_venda')
        _var_mx_sentido = dados_robot.get('coibot_mx_variacao_sentido')
        _mx_lucro = dados_robot.get('coibot_ganho')
        _limite_compra = dados_robot.get('coibot_limite_compra')
        _proxima_operacao = dados_robot.get('coibot_proxima_operacao')
        _qtd_comprada = dados_robot.get('coibot_quantidade_comprada')
        _vr_comprado = dados_robot.get('coibot_valor_compra')
        _vr_disponivel = dados_robot.get('coibot_valor')
        _estrategia = dados_robot.get('coibot_estrategia')
        _vr_fx_ganho = dados_robot.get('coibot_ganho')
        _vr_ba_ganho = dados_robot.get('coibot_ganho')
        _vr_fx_dif_outro = dados_robot.get('coibot_diferenca_outro')
        _vr_mx_dif_outro = dados_robot.get('coibot_diferenca_outro')
        _vr_ba_dif_outro = dados_robot.get('coibot_diferenca_outro')
        _perc_mm_variacao_para_operacao = dados_robot.get('coibot_mm_variacao_para_operacao')
        self.vr_operacao = 0
        _tempo_para_media = dados_robot.get('coibot_horas_media')

        # Calculando media das ultimas 24 horas#
        _final = datetime.now()
        _final = self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, _final, formato='%Y-%m-%d %H:%M:%S')
        _final = datetime.strptime(_final, '%Y-%m-%d %H:%M:%S')
        _inicio = datetime.fromtimestamp(time.mktime(_final.timetuple()) - (_tempo_para_media * 3600)).strftime('%Y-%m-%d %H:%M:%S')
        _sql = """select avg(coitck_valor_compra) as v_avg 
                          from coin_ticker 
                          where create_date 
                          between '%s' and '%s'""" % (_inicio, _final)
        cr.execute(_sql)
        _dados = cr.dictfetchall()[0]
        _avg = _dados.get('v_avg')
        if not _avg:
            _avg = _limite_compra
        # Fim de media
        # if _estrategia == 'MX':
        #     _get_mx()
        # if _estrategia == 'FX':
        #     _get_fx()
        # if _estrategia == 'MM':
        #     _get_mm()
        if _estrategia == 'BA':
            _get_ba()
        return True

    def coibot_thread_robot(self, cr, dados_robot):
        _id = dados_robot.get('coibot_broker_id')[0]
        dados_broker = self.pool.get('coin.brokers').read(cr, 1, _id, ['coibrk_codigo'])
        if dados_broker.get('coibrk_codigo') == 'FoxBit':
            self._get_foxbit(cr, 1, dados_robot.get('id'), context=None)
        # time.sleep(dados_robot.get('coibot_tempo_execucao') or 1)
        self._robot_thread[dados_robot.get('id')]['Ativo'] = False
        return True

    def coibot_thread_geral(self, cr, _none):
        _pid_registrado = controle_ler('coibot')
        _pid = str(psutil.Process().pid)
        if _pid_registrado:
            if _pid != _pid_registrado: # pid atual diferente do registrado
                if psutil.pid_exists(int(_pid_registrado)): # ver se o registrado ainda existe
                    return True
                else:
                    controle_gravar('coibot', _pid)
        else:
            controle_gravar('coibot', _pid)
        cr_novo = sql_db.db_connect(cr.dbname).cursor()
        while True:
            for robot_id in self.search(cr_novo, 1, [('coibot_ativo', '=', True)]):
                if self._robot_thread.get(robot_id) and self._robot_thread.get(robot_id).get('Ativo'): # Thread do robo está em atividade
                    continue
                if not self._robot_thread.get(robot_id):
                    self._robot_thread[robot_id]= {'Ativo':False,'hora':0}
                tempo = time.mktime(datetime.now().timetuple())
                if tempo < self._robot_thread.get(robot_id).get('hora'):
                    continue
                dados_robot = self.read(cr_novo, 1, robot_id, [])
                self._robot_thread[robot_id] = {'Ativo':True, 'hora': time.mktime(datetime.now().timetuple()) + dados_robot.get('coibot_tempo_execucao')}
                self.coibot_thread_robot(cr_novo, dados_robot)
                cr_novo.commit()
                time.sleep(1)
        cr_novo.close()
        return True


    # def coibot_btn_pesquisar(self, cr, uid, ids, context=None):
    #     thread.start_new_thread(self.coibot_thread_geral, (cr, uid))
    #     thread.start_new_thread(self.pool.get('coin.ticker').coitck_thread_pesquisas,(cr, uid))
    #     return True
    #
    #
    # def __init__(self, pool, cr):
    #     super(coin_robot, self).__init__(pool, cr)
    #     thread.start_new_thread(self.coibot_thread_geral,(cr, 1))
    #     return True

