# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from datetime import datetime
import time
from SigUtils.numero import getNumeroEditado

class coin_servicos(osv.Model):
    """
    Classe para controle dos serviços(API)
    prefixo:coisrv
    """
    _name = 'coin.servicos'
    _auto = False

    def coisrv_api_get_ticker(self, cr, uid, broker, moeda_code, moeda_par, context=None):
        res = {'buy':0, 'sell': 0, 'last': 0}
        return res

    def coisrv_get_ticker(self, cr, uid, context=None):
        context = context and context.copy() or {}
        _obj_broker = self.pool.get('coin.brokers')
        _obj_broker_moedas = self.pool.get('coin.broker.moedas')
        for _broker in _obj_broker.search(cr, uid, [('coibrk_ativo', '=', True)], context=context):
            dados_broker = _obj_broker.read(cr, uid, _broker, ['coibrk_codigo', 'coibrk_moedas_ids'], context=context,
                                            load='_classic_write')
            if dados_broker.get('coibrk_moedas_ids'):
                for _dados_moeda in _obj_broker_moedas.read(cr, uid, dados_broker.get('coibrk_moedas_ids'), [],
                                                            context=context, load='_classic_write'):
                    _broker = dados_broker.get('coibrk_codigo')
                    _moeda_code = _dados_moeda.get('coibrm_codigo')
                    _moeda_par = _dados_moeda.get('coibrm_par')
                    res = self.coisrv_api_get_ticker(cr, uid, _broker, _moeda_code, _moeda_par, context=context)
                    _sql = 'select * from coin_ticker where coitck_broker_id = %s  and coitck_moeda_id =  %s order by create_date desc limit 5' % (dados_broker.get('id'), _dados_moeda.get('coibrm_moeda_id'))
                    cr.execute(_sql)
                    _gravar = True
                    for linha in cr.dictfetchall():
                        lin_com = getNumeroEditado(linha.get('coitck_valor_compra'), 2)
                        lin_ven = getNumeroEditado(linha.get('coitck_valor_venda'), 2)
                        lin_ult = getNumeroEditado(linha.get('coitck_valor_ultima'), 2)
                        res_com = getNumeroEditado(res.get('buy'), 2)
                        res_ven = getNumeroEditado(res.get('sell'), 2)
                        res_ult = getNumeroEditado(res.get('last'), 2)
                        if lin_com == res_com and lin_ven == res_ven and lin_ult == res_ult:
                           _gravar = False
                           break
                    if _gravar:
                        vals = {
                            'coitck_broker_id': dados_broker.get('id'),
                            'coitck_moeda_id': _dados_moeda.get('coibrm_moeda_id'),
                            'coitck_valor_compra': res.get('buy'),
                            'coitck_valor_venda': res.get('sell'),
                            'coitck_valor_ultima': res.get('last'),
                        }
                        self.pool.get('coin.ticker').create(cr, uid, vals, context=context)
                        _hora = datetime.now()
                        _hora = time.mktime(_hora.timetuple()) - 864000 # 10 dias para tras
                        _date = datetime.fromtimestamp(_hora).strftime('%Y-%m-%d %H:%M:%S')
                        _sql = "delete from coin_ticker where create_date < '%s'" % _date
                        cr.execute(_sql)
        return True

    def coisrv_get_trades(self, cr, uid, _hora, context=None):
        return True