# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import logging
import thread
import openerp.sql_db as sql_db
import time
import psutil
from .utils import controle_gravar, controle_ler


class coin_ticker(osv.Model): # Cotação
    _inherit = 'coin.ticker'
    _logger = logging.getLogger(_inherit)

    def _auto_init(self, cr, context=None):
        context = context and context.copy() or {}
        super(coin_ticker, self)._auto_init(cr, context)
        cr.execute("SELECT 1 FROM pg_indexes WHERE indexname='coin_ticker_create_date_data_idx'")
        if not cr.fetchone():
            cr.execute(
                'CREATE INDEX coin_ticker_create_date_data_idx ON coin_ticker (create_date)')

    def coitck_thread_pesquisas(self, cr, uid):
        _pid_registrado = controle_ler('ticker')
        _pid = str(psutil.Process().pid)
        if _pid_registrado:
            if _pid != _pid_registrado: # pid atual diferente do registrado
                if psutil.pid_exists(int(_pid_registrado)): # ver se o registrado ainda existe
                    return True
                else:
                    controle_gravar('ticker', _pid)
        else:
            controle_gravar('ticker', _pid)
        cr_novo = sql_db.db_connect(cr.dbname).cursor()
        while True:
            self.pool.get('coin.servicos').coisrv_get_ticker(cr_novo, uid, context={})
            cr_novo.commit()
            time.sleep(5)
        cr_novo.close()
        return True

    # def coitck_cron_pesquisar_ticker(self, cr, uid, context=None):
    #     thread.start_new_thread(self.coitck_thread_pesquisas,(cr, uid))
    #     return True

    def coitck_get_ultima_cotacao(self, cr, uid, broker_id, moeda_id, context=None):
        """
        Este método retorna a ultima cotação de compra e de venda
        :param cr:
        :param uid:
        :param broker_id: broker a veriricar
        :param moeda_id:  moeda a verificar
        :param context:
        :return: lista contendo valor de compra e de venda
        """
        args = [('coitck_broker_id', '=', broker_id), ('coitck_moeda_id', '=', moeda_id)]
        ticker_ids = self.search(cr, uid, args, limit=1, context=context)
        _vr_compra = _vr_venda = 0
        if ticker_ids:
            _dados_ticker = self.read(cr, uid, ticker_ids[0],['coitck_valor_compra','coitck_valor_venda','coitck_valor_ultima'], context=context)
            _vr_compra = _dados_ticker.get('coitck_valor_compra')
            _vr_venda = _dados_ticker.get('coitck_valor_venda')
            _vr_ultima = _dados_ticker.get('coitck_valor_ultima')
        return _vr_compra, _vr_venda, _vr_ultima

    # def __init__(self, pool, cr):
    #     super(coin_ticker, self).__init__(pool, cr)
    #     thread.start_new_thread(self.coitck_thread_pesquisas,(cr, 1))
    #     return True

#{"high": 55995.0, "vol": 557.62851852, "buy": 55012.01, "last": 55012.01, "low": 49600.01, "pair": "BTCBRL", "sell": 55027.0, "vol_brl": 29914107.77871212}
#https://api.blinktrade.com/api/v1/BRL/trades?crypto_currency=BTC&since=1514332710.0&limit=100
# #a=datetime.now()
#time.mktime(a.timetuple())
