
# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import logging
from datetime import datetime
import time
import api


class coin_trades(osv.Model):
    _inherit = 'coin.trades'
    _logger = logging.getLogger(_inherit)

    def coitrd_cron_pesquisar_trades(self, cr, uid, context=None):
        context = context and context.copy() or {}
        _broker = self.pool.get('coin.brokers').search(cr, uid, [('coibrk_codigo','=','FoxBit')], context=context)
        _moeda = self.pool.get('coin.moedas').search(cr, uid, [('coimoe_codigo','=','BTC')], context=context)
        if _broker and _moeda:
            _broker = _broker[0]
            _moeda = _moeda[0]
            _sql = 'select max(coitrd_data) from coin_trades where coitrd_broker_id = %s and coitrd_moeda_id = %s' % (_broker, _moeda)
            cr.execute(_sql)
            _max_date = cr.fetchone()
            if _max_date:
                _hora = datetime.now()
                _hora = time.mktime(_hora.timetuple()) - 300 # Ultimos 5 minutos
            else:
                _hora = datetime.strptime(_max_date[0], '%Y-%m-%d %H:%M:%S')
                _hora = time.mktime(_hora.timetuple())
            # _url = 'https://api.blinktrade.com/api/v1/BRL/trades?crypto_currency=BTC&since=%s&limit=100' % _hora
            # response = requests.get(_url, {})
            # linhas = response.json()
            # linhas = api.foxbit.blinktrade_get_trade(_hora)
            linhas = self.pool.get('coin.servicos').coisrv_get_trades(cr, uid, _hora, context=None)
            if isinstance(linhas, (list, tuple)):
                for linha in linhas:
                    _side = linha.get('side')
                    # _data = datetime.fromtimestamp(linha.get('date')).strftime('%Y-%m-%d %H:%M:%S')
                    _data = linha.get('data')
                    args = [('coitrd_broker_id', '=', _broker),
                            ('coitrd_moeda_id', '=', _moeda),
                            ('coitrd_codigo', '=', linha.get('tid'))
                            ]
                    _order_ids = self.search(cr, uid, args, context=context)
                    if _order_ids:
                        continue
                    if _side == 'sell':
                        _operacao = 'V'
                    else:
                        _operacao = 'C'
                    vals = {
                        'coitrd_broker_id': _broker,
                        'coitrd_moeda_id': _moeda,
                        'coitrd_data': _data,
                        'coitrd_quantidade': linha.get('amount'),
                        'coitrd_valor': linha.get('price'),
                        'coitrd_operacao': _operacao,
                        'coitrd_codigo': linha.get('tid'),
                    }
                    self.create(cr, uid, vals, context=context)
        return True

