# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class coin_brokers(osv.Model):
    """
    Cadastro de operadores(brokers)
    prefixo:coibrk
    """
    _name = 'coin.brokers'
    _columns = {
        'coibrk_codigo': fields.char('Codigo', required=True, size=10, select=1),
        'name': fields.char('Descricao', required=True, size=50),
        'coibrk_site': fields.char('Site', size=128),
        'coibrk_ativo': fields.boolean('Ativo'),
        'coibrk_ticker_ids': fields.one2many('coin.ticker', 'coitck_broker_id', 'Cotacoes'),
        'coibrk_trades_ids': fields.one2many('coin.trades', 'coitrd_broker_id',
                                                        'Ordens executadas'),
        'coibrk_robot_ids': fields.one2many('coin.robot', 'coibot_broker_id', 'Robot'),
        'coibrk_orders_ids': fields.one2many('coin.orders', 'coiord_broker_id', 'Ordens'),
        'coibrk_moedas_ids': fields.one2many('coin.broker.moedas', 'coibrm_broker_id', 'Moedas'),
        'coibrk_carteira': fields.char('Carteira', size=64),
        'coibrk_key': fields.char('Chave', size=64),
        'coibrk_pasword': fields.char('Senha', size=64),
        'coibrk_secret_key': fields.char('Secret key', size=64),
        'coibrk_comissao_order_ativa': fields.float('Comissao ordem ativa', decimal=(1,2)),
        'coibrk_comissao_order_passiva': fields.float('Comissao ordem passiva', decimal=(1,2)),
    }
# TODO: Implementar comissão nas operaçoes
    _sql_constraints = [
        ('name_uniq', 'unique(coibrk_codigo)', 'Este codigo ja existe!'),
    ]
    _defaults = {
        'coibrk_ativo' : 0,
    }
