# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
from datetime import datetime
import time


#Funcoes da classe coin.trades
def _coitrd_get_total(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    ret = {}
    res = self.read(cr, uid, ids, ['coitrd_quantidade','coitrd_valor'], context=context)
    for x in res:
        ret[x['id']] = x.get('coitrd_quantidade') * x.get('coitrd_valor')
    return ret


#Funcoes da classe coin.ticker
def _coitck_get_dados(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    ret = {}
    res = self.read(cr, uid, ids, ['create_date'], context=context)
    for x in res:
        if x.get('create_date')[15:16] in ('0','1','2','3','4'):
            _min = 0
        else:
            _min = 5
        ret[x['id']] = x.get('create_date')[:15] + str(_min) +':00'
    return ret


#Funcoes da classe coin.robot
def _coibot_get_dados(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    if not ids:
        return res
    _obj_ticker = self.pool.get('coin.ticker')
    _campos = ['coibot_broker_id','coibot_moeda_id','coibot_proxima_operacao','coibot_valor_compra','coibot_quantidade_comprada', 'coibot_saldo', 'coibot_valor']
    for _dados_read in self.read(cr, uid, ids, _campos, context=context, load='_classic_write'):
        _broker_id = _dados_read.get('coibot_broker_id')
        _moeda_id = _dados_read.get('coibot_moeda_id')
        _proxima_op = _dados_read.get('coibot_proxima_operacao')
        _vr_comprado = _dados_read.get('coibot_valor_compra')
        _qtd_coin = _dados_read.get('coibot_quantidade_comprada')
        _saldo_real = _dados_read.get('coibot_saldo')
        _valor_ref = _dados_read.get('coibot_valor')
        _vr_compra, _vr_venda, _vr_ultima = _obj_ticker.coitck_get_ultima_cotacao(cr, uid, _broker_id, _moeda_id, context=context)
        _saldo = _vr_ultima * _qtd_coin
        if _proxima_op == 'V':
            _margem = 100 - (_vr_comprado * 100 / _vr_compra)
        elif _proxima_op == 'S':
            _margem = (100 - ((_saldo + _saldo_real) * 100 / _valor_ref)) * -1
        else:
            _margem = 0
        res[_dados_read.get('id')] = {
            'coibot_cotacao_compra':_vr_compra,
            'coibot_cotacao_venda': _vr_venda,
            'coibot_cotacao_ultima': _vr_ultima,
            'coibot_margem_no_momento': _margem,
            'coibot_saldo_coin': _saldo,
        }
    return res

#Funcoes da classe coin.robot.estatisticas
def _coibte_get_dados(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    if not ids:
        return res
    dados_read = self.read(cr, uid, ids, ['coibte_tempo','coibte_unidade', 'coibot_data_compra'], context=context)
    for dados_estat in dados_read:
        try:
            _tempo = dados_estat.get('coibte_tempo')
        except:
            _tempo = 0
        _unidade = dados_estat.get('coibte_unidade')
        if _unidade == 'M':
            _tempo = _tempo * 60 # 1 minuto = 60 seg.
        elif _unidade == 'H':
            _tempo = _tempo * 3600 # 1 hora = 3600 seg.
        else:
            _tempo = _tempo * 86400 # 1 dia = 86400 seg.
        _final = datetime.now().strftime('%Y-%m-%d %H:%M:%S')
        # _final = self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, _final, formato='%Y-%m-%d %H:%M:%S')
        _final = datetime.strptime(_final, '%Y-%m-%d %H:%M:%S')
        _inicio = datetime.fromtimestamp(time.mktime(_final.timetuple()) - _tempo).strftime('%Y-%m-%d %H:%M:%S')
        if _unidade == 'C' and dados_estat.get('coibot_data_compra'):
            _inicio = dados_estat.get('coibot_data_compra')
        _sql = """
           select avg(coitck_valor_compra) as v_avg, 
                  min(coitck_valor_compra) as v_min, 
                  max(coitck_valor_compra) as v_max,
                  (select coitck_valor_compra from coin_ticker where create_date between '%s' and '%s' order by create_date limit 1) as v_prim,
                  (select coitck_valor_compra from coin_ticker where create_date between '%s' and '%s' order by create_date desc limit 1) as v_ult
              from coin_ticker 
              where create_date 
              between '%s' and '%s'""" % (_inicio, _final, _inicio, _final, _inicio, _final)
        cr.execute(_sql)
        _dados = cr.dictfetchall()[0]
        res[dados_estat.get('id')] = {
            'coibte_media':0,
            'coibte_minimo': 0,
            'coibte_maximo': 0,
            'coibte_variacao_min_max': 0,
            'coibte_primeiro': 0,
            'coibte_ultimo': 0,
            'coibte_variacao_prim_ult': 0
        }
        if _dados:
            _prim = _dados.get('v_prim') or 0
            _ult = _dados.get('v_ult') or 0
            if _prim and _ult:
                _var_prim_ult = (_ult * 100 / _prim) - 100
            else:
                _var_prim_ult = 0
            if _dados.get('v_min') and _dados.get('v_max'):
                _val_mim_max = (_dados.get('v_max') * 100 / _dados.get('v_min')) - 100
            else:
                _val_mim_max = 0
            res[dados_estat.get('id')] = {
                'coibte_media':_dados.get('v_avg') or 0,
                'coibte_minimo': _dados.get('v_min') or 0,
                'coibte_maximo': _dados.get('v_max') or 0,
                'coibte_variacao_min_max': _val_mim_max,
                'coibte_primeiro': _prim,
                'coibte_ultimo': _ult,
                'coibte_variacao_prim_ult': _var_prim_ult
            }
    return res
