# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class coin_moedas(osv.Model):
    """
    Cadastro de moedas
    prefixo:coimoe
    """
    _name = 'coin.moedas'
    _columns = {
        'coimoe_codigo': fields.char('Codigo', required=True, size=10, select=1),
        'name': fields.char('Descricao', required=True, size=50),
        'coimoe_ticker_ids': fields.one2many('coin.ticker', 'coitck_moeda_id', 'Cotacoes'),
        'coimoe_trades_ids': fields.one2many('coin.trades', 'coitrd_moeda_id',
                                                        'Ordens executadas'),
        'coimoe_robot_ids': fields.one2many('coin.robot', 'coibot_moeda_id', 'Robot'),
        'coimoe_orders_ids': fields.one2many('coin.orders', 'coiord_moeda_id', 'Ordens'),
        'coimoe_brokers_ids': fields.one2many('coin.broker.moedas', 'coibrm_moeda_id', 'Brokers'),
    }

    _sql_constraints = [
        ('name_uniq', 'unique(coimoe_codigo)', 'Este codigo ja existe!'),
    ]
