# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class coin_orders(osv.Model):
    """
    Ordens de compra e de venda
    prefixo:coiord
    """
    _name = 'coin.orders'

    _columns = {
        'id': fields.integer('Id', readonly=True),
        'coiord_broker_id': fields.many2one('coin.brokers','Operador', required=True, select=True,
                                             ondelete='cascade'),
        'coiord_moeda_id': fields.many2one('coin.moedas','Moeda', required=True, select=True,
                                           ondelete='cascade'),
        'coiord_robot_id': fields.many2one('coin.robot', 'Robot', select=True, ondelete='restrict'),
        'create_date': fields.datetime('Data', readonly=True, select=1),
        'coiord_quantidade': fields.float('Quantidade', digits=(16,8)),
        'coiord_valor_operacao': fields.float('Valor da operacao', oldname='coiord_valor'),
        'coiord_valor_moeda': fields.float('Valor da moeda'),
        'coiord_comissao': fields.float('Valor da comissao'),
        'coiord_order_operacao': fields.selection([('V', 'Venda'),('C', 'Compra')], 'Operacao', required=True),
        'coiord_order_tipo': fields.selection([('M', 'Mercado'), ('C', 'Compra')], 'Tipo de ordem', required=True),
        'state': fields.selection([('A', 'Aguardando'), ('E', 'Executada')], 'Estado'),
    }
    _order = 'id desc'
