# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import logging


class coin_robot_estatisticas(osv.Model):
    """
    robot para avaliação de oportunidades
    prefixo:coibte
    """
    _name = 'coin.robot.estatisticas'
    _inherits = {'coin.robot':'coibte_robot_id'}
    _logger = logging.getLogger(_name)
    from funcoes import _coibte_get_dados
    _columns = {
        'coibte_robot_id': fields.many2one('coin.robot','Robot', required=True, select=1, ondelete='cascade'),
        'sequence': fields.integer('Sequencia'),
        'coibte_tempo': fields.integer('Tempo'),
        'coibte_unidade': fields.selection([('M', 'Minutos'), ('H', 'Horas'), ('D', 'Dias'), ('C','Ultima Compra')], 'Unidade de tempo', size=1),
        'coibte_media': fields.function(_coibte_get_dados, method=True, string='Media', type='float', store=False, multi='dados'),
        'coibte_minimo': fields.function(_coibte_get_dados, method=True, string='Minimo', type='float', store=False, multi='dados'),
        'coibte_maximo': fields.function(_coibte_get_dados, method=True, string='Maximo', type='float', store=False, multi='dados'),
        'coibte_variacao_min_max': fields.function(_coibte_get_dados, method=True, string='Variacao', type='float', store=False,
                                        multi='dados', digits=(8,4)),
        'coibte_primeiro': fields.function(_coibte_get_dados, method=True, string='Primeiro', type='float', store=False,
                                         multi='dados'),
        'coibte_ultimo': fields.function(_coibte_get_dados, method=True, string='Ultimo', type='float', store=False,
                                         multi='dados'),
        'coibte_variacao_prim_ult': fields.function(_coibte_get_dados, method=True, string='Variacao', type='float', store=False,
                                        multi='dados', digits=(8,4))
    }
    _order = 'coibte_robot_id,sequence'
    _defaults = {
        'sequence':10,
        'coibte_unidade': 'M'
    }
