# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class coin_ticker(osv.Model):
    """
    Cotacoes das moedas(Ticker)
    prefixo:coitck
    """
    _name = 'coin.ticker'

    from funcoes import _coitck_get_dados

    _columns = {
        'coitck_broker_id': fields.many2one('coin.brokers','Operador', required=True, select=1,
                                             ondelete='cascade'),
        'coitck_moeda_id': fields.many2one('coin.moedas','Moeda', required=True, select=1,
                                           ondelete='cascade'),
        'create_date': fields.datetime('Data', readonly=True),
        'coitck_valor_compra': fields.float('Valor de compra'),
        'coitck_valor_venda': fields.float('Valor de venda'),
        'coitck_valor_ultima': fields.float('Valor ultima operacao'),
        'coitck_hora':fields.function(_coitck_get_dados, method=True, string='Horario', type='char', store=True)
    }
    _order = 'create_date desc'
