# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class coin_trades(osv.Model):
    """
    trades(de terceiros)
    prefixo:coitrd
    """
    _name = 'coin.trades'
    from funcoes import _coitrd_get_total
    _columns = {
        'coitrd_broker_id': fields.many2one('coin.brokers','Operador', required=True, select=1,
                                              ondelete='cascade'),
        'coitrd_moeda_id': fields.many2one('coin.moedas','Moeda', required=True, select=1,
                                           ondelete='cascade'),
        'coitrd_data': fields.datetime('Data operacao', required=1, select=1),
        'coitrd_valor': fields.float('Valor'),
        'coitrd_quantidade': fields.float('Quantidade', digits=(9,9)),
        'coitrd_operacao': fields.selection([('V', 'Venda'), ('C', 'Compra')],'Operacao', size=1),
        'coitrd_codigo': fields.integer('Id da transacao', select=1),
        'coitrd_total': fields.function(_coitrd_get_total, method=True, string='Total', type='float', store=True)
    }
    _order = 'coitrd_broker_id,coitrd_moeda_id,coitrd_codigo desc'
