# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
from openerp.osv import osv, fields
from datetime import datetime
import time


class coin_analise_wiz(osv.TransientModel):
    """
    Analise de variacoes 
    prefixo:coiana
    """
    _name = 'coin.analise.wiz'
    _columns = {
        'coiana_broker_id': fields.many2one('coin.brokers','Operador', required=True, ondelete='cascade'),
        'coiana_moeda_id': fields.many2one('coin.moedas','Moeda', required=True, ondelete='cascade'),
        'coiana_inicio': fields.datetime('Inicio', required=True),
        'coiana_fim': fields.datetime('Termino', required=True),
        'coiana_variacao_descida': fields.float('Variacao Descida', digits=(8,4),help='Variacao para considerar mudanca'),
        'coiana_variacao_subida': fields.float('Variacao Subida', digits=(8,4),help='Variacao para considerar mudanca'),
        'coiana_lucro_bruto': fields.float('lucro bruto', digits=(8,4),help='Lucro bruto esperado'),
        'coiana_valor_investimento': fields.float('Investimento', help='Valor a ser investido'),
        'state': fields.selection([('E','Esboco'),('C','Calculado')], 'Estado'),
        'coiana_linhas_ids': fields.one2many('coin.analise.linha.wiz', 'coianl_capa_id', 'Linhas'),
    }

    def coiana_button_pesquisar(self, cr, uid, ids, context=None):
        def calc_media(data):
            _final = datetime.strptime(data[:19], '%Y-%m-%d %H:%M:%S')
            _inicio = datetime.fromtimestamp(time.mktime(_final.timetuple()) - 86400).strftime('%Y-%m-%d %H:%M:%S')
            _sql = """
               select avg(coitck_valor_compra) as v_avg 
                  from coin_ticker 
                  where create_date 
                  between '%s' and '%s'""" % (_inicio, _final)
            cr.execute(_sql)
            _dados = cr.dictfetchall()[0]
            return _dados.get('v_avg')

        context = context and context.copy() or {}
        for _dados_wiz in self.read(cr, uid, ids, context=context, load='_classic_write'):
            _sql = 'delete from coin_analise_linha_wiz where coianl_capa_id = %s' % _dados_wiz.get('id')
            cr.execute(_sql)
            _broker = _dados_wiz.get('coiana_broker_id')
            _moeda = _dados_wiz.get('coiana_moeda_id')
            _inicio = _dados_wiz.get('coiana_inicio')
            _fim = _dados_wiz.get('coiana_fim')
            _var_subida = _dados_wiz.get('coiana_variacao_subida')
            _var_descida = _dados_wiz.get('coiana_variacao_descida')
            _valor_investimento = _dados_wiz.get('coiana_valor_investimento')
            _lucro = _dados_wiz.get('coiana_lucro_bruto')
            _sql = """select * 
                        from coin_ticker 
                        where coitck_broker_id = {broker} and 
                              coitck_moeda_id = {moeda} and 
                              create_date between '{inicio}' and '{fim}'
                   """.format(broker=_broker,moeda=_moeda,inicio=_inicio,fim=_fim)
            cr.execute(_sql)
            lin_data_referencia = _lin_data_ref_min_max = 0
            _lin_sentido = False
            _lin_valor_ultimo = _lin_valor_ref_min_max = 0
            _lin_valor_referencia = _quantidade = _quebra = 0
            for _dados_ticker in cr.dictfetchall():
                if lin_data_referencia == 0:
                    lin_data_referencia = _lin_data_ref_min_max =_dados_ticker.get('create_date')
                    _lin_valor_referencia = _lin_valor_ref_min_max = _dados_ticker.get('coitck_valor_compra')
                    _lin_valor_ultimo = _dados_ticker.get('coitck_valor_compra')
                    continue
                if _dados_ticker.get('coitck_valor_compra') == _lin_valor_ultimo:
                    continue
                _lin_valor_ultimo = _dados_ticker.get('coitck_valor_compra')
                if not _lin_sentido:
                    if _dados_ticker.get('coitck_valor_compra') < _lin_valor_referencia:
                        _lin_sentido = '-'
                    else:
                        _lin_sentido = '+'
                    _lin_valor_ref_min_max = _dados_ticker.get('coitck_valor_compra')
                    _lin_data_ref_min_max = _dados_ticker.get('create_date')
                    continue
                if _lin_sentido == '+': # Sentido positivo
                    if _dados_ticker.get('coitck_valor_compra') > _lin_valor_ref_min_max:
                        _lin_valor_ref_min_max = _dados_ticker.get('coitck_valor_compra')
                        _lin_data_ref_min_max = _dados_ticker.get('create_date')
                        continue
                    else:
                        _var_ult = 100 - (_dados_ticker.get('coitck_valor_compra') * 100 / _lin_valor_ref_min_max)
                        if _var_ult > _var_descida + _lucro: # mudança de sentido
                        # if _var_ult > _var_descida: # mudança de sentido
                        #     _quebra = _dados_ticker.get('coitck_valor_compra')
                            _quantidade = _valor_investimento / (_quebra or _lin_valor_referencia)
                        #     _valor_venda  = (_quantidade * _quebra) * ((100 - _lucro) / 100)
                        #     print 'qtd:', _quantidade, 'quebra:', _quebra, 'lucro:', _lucro, 'venda:', _valor_venda
                        #     if _valor_venda < _valor_investimento:
                        #         continue

                            _media = calc_media(_lin_data_ref_min_max)
                            _quebra = _dados_ticker.get('coitck_valor_compra')
                            vals = {
                                'coianl_capa_id': _dados_wiz.get('id'),
                                'coianl_data_inicio': lin_data_referencia,
                                'coianl_data_fim': _lin_data_ref_min_max,
                                'coianl_sentido': _lin_sentido,
                                'coianl_valor_inicio': _lin_valor_referencia,
                                'coianl_valor_fim': _lin_valor_ref_min_max,
                                'coianl_valor_media': _media,
                                'coianl_valor_quebra': _quebra,
                                'coinal_variacao': (_lin_valor_ref_min_max * 100 / _lin_valor_referencia) - 100,
                                'coinal_quantidade': _quantidade,
                                'coinal_valor_investimento': _valor_investimento * -1,
                            }
                            self.pool.get('coin.analise.linha.wiz').create(cr, uid, vals, context=context)
                            _lin_sentido = '-'
                            lin_data_referencia = _lin_data_ref_min_max
                            _lin_valor_referencia = _lin_valor_ref_min_max
                            continue
                        else:
                            continue
                else: # Sentido negativo
                    if _dados_ticker.get('coitck_valor_compra') < _lin_valor_ref_min_max:
                        _lin_valor_ref_min_max = _dados_ticker.get('coitck_valor_compra')
                        _lin_data_ref_min_max = _dados_ticker.get('create_date')
                        continue
                    else:
                        _var_ult = (_dados_ticker.get('coitck_valor_compra') * 100 / _lin_valor_ref_min_max) - 100
                        if _var_ult > _var_subida: # mudança de sentido
                            _valor_venda = _quantidade * (_quebra or _dados_ticker.get('coitck_valor_compra'))
                            # print _valor_venda, _valor_investimento
                            # if _valor_venda < _valor_investimento:
                                # continue
                            _media = calc_media(_lin_data_ref_min_max)
                            _quebra_nova = _dados_ticker.get('coitck_valor_compra')
                            vals = {
                                'coianl_capa_id': _dados_wiz.get('id'),
                                'coianl_data_inicio': lin_data_referencia,
                                'coianl_data_fim': _lin_data_ref_min_max,
                                'coianl_sentido': _lin_sentido,
                                'coianl_valor_inicio': _lin_valor_referencia,
                                'coianl_valor_fim': _lin_valor_ref_min_max,
                                'coianl_valor_media': _media,
                                'coianl_valor_quebra': _quebra_nova,
                                'coinal_variacao': (_lin_valor_ref_min_max * 100 / _lin_valor_referencia) - 100,
                                'coinal_quantidade': _quantidade,
                                'coinal_valor_investimento': _valor_venda,
                            }
                            self.pool.get('coin.analise.linha.wiz').create(cr, uid, vals, context=context)
                            _quebra = _quebra_nova
                            _lin_sentido = '+'
                            lin_data_referencia = _lin_data_ref_min_max
                            _lin_valor_referencia = _lin_valor_ref_min_max
                            continue
                        else:
                            continue
        self.write(cr, uid, ids, {'state': 'C'}, context=context)
        return True



class coin_analise_linha_wiz(osv.TransientModel):
    _name = 'coin.analise.linha.wiz'
    _columns = {
        'id': fields.integer('Id', readonly=True),
        'coianl_capa_id': fields.many2one('coin.analise.wiz','Capa', required=True, ondelete='cascade', select=True),
        'coianl_data_inicio': fields.datetime('Data inicio', select=True),
        'coianl_data_fim': fields.datetime('Data fim'),
        'coianl_sentido': fields.selection([('+', 'Subindo'), ('-','Descendo')], 'Sentido', size=1),
        'coianl_valor_inicio': fields.float('Valor inicio'),
        'coianl_valor_fim': fields.float('Valor fim'),
        'coianl_valor_media': fields.float('Media'),
        'coianl_valor_quebra': fields.float('Quebra'),
        'coinal_variacao': fields.float('Variacao', digits=(8,4)),
        'coinal_quantidade': fields.float('Quantidade', digits=(16,8)),
        'coinal_valor_investimento': fields.float('Valor Investimento'),
    }
    _order = 'id'
