
alter table res_partner_event
    drop column canal_id;
DROP table res_config_users;
drop table res_partner_canal;

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: base_module_upgrade; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE base_module_upgrade (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    module_info text
);


--
-- Name: TABLE base_module_upgrade; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE base_module_upgrade IS 'Module Upgrade';


--
-- Name: COLUMN base_module_upgrade.module_info; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_module_upgrade.module_info IS 'Modules to update';


--
-- Name: base_module_upgrade_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE base_module_upgrade_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: base_module_upgrade_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE base_module_upgrade_id_seq OWNED BY base_module_upgrade.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE base_module_upgrade ALTER COLUMN id SET DEFAULT nextval('base_module_upgrade_id_seq'::regclass);


--
-- Name: base_module_upgrade_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY base_module_upgrade
    ADD CONSTRAINT base_module_upgrade_pkey PRIMARY KEY (id);


--
-- Name: base_module_upgrade_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_module_upgrade
    ADD CONSTRAINT base_module_upgrade_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: base_module_upgrade_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_module_upgrade
    ADD CONSTRAINT base_module_upgrade_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: ir_act_client; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE ir_act_client (
    params_store bytea,
    tag character varying(64) NOT NULL
)
INHERITS (ir_actions);


--
-- Name: COLUMN ir_act_client.params_store; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_act_client.params_store IS 'Params storage';


--
-- Name: COLUMN ir_act_client.tag; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_act_client.tag IS 'Client action tag';


--
-- Name: ir_act_client_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY ir_act_client
    ADD CONSTRAINT ir_act_client_pkey PRIMARY KEY (id);


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: partner_massmail_wizard; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE partner_massmail_wizard (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    text text NOT NULL,
    email_from character varying(256) NOT NULL,
    subject character varying(256) NOT NULL
);


--
-- Name: TABLE partner_massmail_wizard; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE partner_massmail_wizard IS 'Mass Mailing';


--
-- Name: COLUMN partner_massmail_wizard.text; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN partner_massmail_wizard.text IS 'Message';


--
-- Name: COLUMN partner_massmail_wizard.email_from; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN partner_massmail_wizard.email_from IS 'Sender''s email';


--
-- Name: COLUMN partner_massmail_wizard.subject; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN partner_massmail_wizard.subject IS 'Subject';


--
-- Name: partner_massmail_wizard_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE partner_massmail_wizard_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: partner_massmail_wizard_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE partner_massmail_wizard_id_seq OWNED BY partner_massmail_wizard.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE partner_massmail_wizard ALTER COLUMN id SET DEFAULT nextval('partner_massmail_wizard_id_seq'::regclass);


--
-- Name: partner_massmail_wizard_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY partner_massmail_wizard
    ADD CONSTRAINT partner_massmail_wizard_pkey PRIMARY KEY (id);


--
-- Name: partner_massmail_wizard_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY partner_massmail_wizard
    ADD CONSTRAINT partner_massmail_wizard_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: partner_massmail_wizard_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY partner_massmail_wizard
    ADD CONSTRAINT partner_massmail_wizard_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: base_setup_terminology; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE base_setup_terminology (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    partner character varying NOT NULL
);


--
-- Name: TABLE base_setup_terminology; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE base_setup_terminology IS 'base.setup.terminology';


--
-- Name: COLUMN base_setup_terminology.partner; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_setup_terminology.partner IS 'How do you call a Customer';


--
-- Name: base_setup_terminology_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE base_setup_terminology_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: base_setup_terminology_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE base_setup_terminology_id_seq OWNED BY base_setup_terminology.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE base_setup_terminology ALTER COLUMN id SET DEFAULT nextval('base_setup_terminology_id_seq'::regclass);


--
-- Name: base_setup_terminology_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY base_setup_terminology
    ADD CONSTRAINT base_setup_terminology_pkey PRIMARY KEY (id);


--
-- Name: base_setup_terminology_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_setup_terminology
    ADD CONSTRAINT base_setup_terminology_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: base_setup_terminology_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_setup_terminology
    ADD CONSTRAINT base_setup_terminology_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = true;

--
-- Name: res_groups_implied_rel; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE res_groups_implied_rel (
    gid integer NOT NULL,
    hid integer NOT NULL
);


--
-- Name: TABLE res_groups_implied_rel; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE res_groups_implied_rel IS 'RELATION BETWEEN res_groups AND res_groups';


--
-- Name: res_groups_implied_rel_gid_hid_key; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY res_groups_implied_rel
    ADD CONSTRAINT res_groups_implied_rel_gid_hid_key UNIQUE (gid, hid);


--
-- Name: res_groups_implied_rel_gid_index; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX res_groups_implied_rel_gid_index ON res_groups_implied_rel USING btree (gid);


--
-- Name: res_groups_implied_rel_hid_index; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX res_groups_implied_rel_hid_index ON res_groups_implied_rel USING btree (hid);


--
-- Name: res_groups_implied_rel_gid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_groups_implied_rel
    ADD CONSTRAINT res_groups_implied_rel_gid_fkey FOREIGN KEY (gid) REFERENCES res_groups(id) ON DELETE CASCADE;


--
-- Name: res_groups_implied_rel_hid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_groups_implied_rel
    ADD CONSTRAINT res_groups_implied_rel_hid_fkey FOREIGN KEY (hid) REFERENCES res_groups(id) ON DELETE CASCADE;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: ir_actions_todo_category; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE ir_actions_todo_category (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    name character varying(64) NOT NULL,
    sequence integer
);


--
-- Name: TABLE ir_actions_todo_category; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE ir_actions_todo_category IS 'Configuration Wizard Category';


--
-- Name: COLUMN ir_actions_todo_category.name; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_actions_todo_category.name IS 'Name';


--
-- Name: COLUMN ir_actions_todo_category.sequence; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_actions_todo_category.sequence IS 'Sequence';


--
-- Name: ir_actions_todo_category_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE ir_actions_todo_category_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: ir_actions_todo_category_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE ir_actions_todo_category_id_seq OWNED BY ir_actions_todo_category.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ir_actions_todo_category ALTER COLUMN id SET DEFAULT nextval('ir_actions_todo_category_id_seq'::regclass);


--
-- Name: ir_actions_todo_category_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY ir_actions_todo_category
    ADD CONSTRAINT ir_actions_todo_category_pkey PRIMARY KEY (id);


--
-- Name: ir_actions_todo_category_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ir_actions_todo_category
    ADD CONSTRAINT ir_actions_todo_category_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: ir_actions_todo_category_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ir_actions_todo_category
    ADD CONSTRAINT ir_actions_todo_category_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--
--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: partner_wizard_ean_check; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE partner_wizard_ean_check (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer
);


--
-- Name: TABLE partner_wizard_ean_check; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE partner_wizard_ean_check IS 'Ean Check';


--
-- Name: partner_wizard_ean_check_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE partner_wizard_ean_check_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: partner_wizard_ean_check_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE partner_wizard_ean_check_id_seq OWNED BY partner_wizard_ean_check.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE partner_wizard_ean_check ALTER COLUMN id SET DEFAULT nextval('partner_wizard_ean_check_id_seq'::regclass);


--
-- Name: partner_wizard_ean_check_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY partner_wizard_ean_check
    ADD CONSTRAINT partner_wizard_ean_check_pkey PRIMARY KEY (id);


--
-- Name: partner_wizard_ean_check_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY partner_wizard_ean_check
    ADD CONSTRAINT partner_wizard_ean_check_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: partner_wizard_ean_check_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY partner_wizard_ean_check
    ADD CONSTRAINT partner_wizard_ean_check_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: migrade_application_installer_modules; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE migrade_application_installer_modules (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    quickbooks_ippids boolean,
    sync_google_contact boolean,
    import_saleforce boolean,
    import_sugarcrm boolean
);


--
-- Name: TABLE migrade_application_installer_modules; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE migrade_application_installer_modules IS 'migrade.application.installer.modules';


--
-- Name: COLUMN migrade_application_installer_modules.quickbooks_ippids; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN migrade_application_installer_modules.quickbooks_ippids IS 'Quickbooks Ippids';


--
-- Name: COLUMN migrade_application_installer_modules.sync_google_contact; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN migrade_application_installer_modules.sync_google_contact IS 'Sync Google Contact';


--
-- Name: COLUMN migrade_application_installer_modules.import_saleforce; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN migrade_application_installer_modules.import_saleforce IS 'Import Saleforce';


--
-- Name: COLUMN migrade_application_installer_modules.import_sugarcrm; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN migrade_application_installer_modules.import_sugarcrm IS 'Import Sugarcrm';


--
-- Name: migrade_application_installer_modules_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE migrade_application_installer_modules_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: migrade_application_installer_modules_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE migrade_application_installer_modules_id_seq OWNED BY migrade_application_installer_modules.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE migrade_application_installer_modules ALTER COLUMN id SET DEFAULT nextval('migrade_application_installer_modules_id_seq'::regclass);


--
-- Name: migrade_application_installer_modules_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY migrade_application_installer_modules
    ADD CONSTRAINT migrade_application_installer_modules_pkey PRIMARY KEY (id);


--
-- Name: migrade_application_installer_modules_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY migrade_application_installer_modules
    ADD CONSTRAINT migrade_application_installer_modules_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: migrade_application_installer_modules_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY migrade_application_installer_modules
    ADD CONSTRAINT migrade_application_installer_modules_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: maintenance_contract; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE maintenance_contract (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer
);


--
-- Name: TABLE maintenance_contract; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE maintenance_contract IS 'maintenance.contract';


--
-- Name: maintenance_contract_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE maintenance_contract_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: maintenance_contract_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE maintenance_contract_id_seq OWNED BY maintenance_contract.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE maintenance_contract ALTER COLUMN id SET DEFAULT nextval('maintenance_contract_id_seq'::regclass);


--
-- Name: maintenance_contract_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY maintenance_contract
    ADD CONSTRAINT maintenance_contract_pkey PRIMARY KEY (id);


--
-- Name: maintenance_contract_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY maintenance_contract
    ADD CONSTRAINT maintenance_contract_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: maintenance_contract_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY maintenance_contract
    ADD CONSTRAINT maintenance_contract_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: wizard_ir_model_menu_create; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE wizard_ir_model_menu_create (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    menu_id integer NOT NULL,
    name character varying(64) NOT NULL
);


--
-- Name: TABLE wizard_ir_model_menu_create; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE wizard_ir_model_menu_create IS 'wizard.ir.model.menu.create';


--
-- Name: COLUMN wizard_ir_model_menu_create.menu_id; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN wizard_ir_model_menu_create.menu_id IS 'Parent Menu';


--
-- Name: COLUMN wizard_ir_model_menu_create.name; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN wizard_ir_model_menu_create.name IS 'Menu Name';


--
-- Name: wizard_ir_model_menu_create_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE wizard_ir_model_menu_create_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: wizard_ir_model_menu_create_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE wizard_ir_model_menu_create_id_seq OWNED BY wizard_ir_model_menu_create.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE wizard_ir_model_menu_create ALTER COLUMN id SET DEFAULT nextval('wizard_ir_model_menu_create_id_seq'::regclass);


--
-- Name: wizard_ir_model_menu_create_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY wizard_ir_model_menu_create
    ADD CONSTRAINT wizard_ir_model_menu_create_pkey PRIMARY KEY (id);


--
-- Name: wizard_ir_model_menu_create_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY wizard_ir_model_menu_create
    ADD CONSTRAINT wizard_ir_model_menu_create_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: wizard_ir_model_menu_create_menu_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY wizard_ir_model_menu_create
    ADD CONSTRAINT wizard_ir_model_menu_create_menu_id_fkey FOREIGN KEY (menu_id) REFERENCES ir_ui_menu(id) ON DELETE CASCADE;


--
-- Name: wizard_ir_model_menu_create_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY wizard_ir_model_menu_create
    ADD CONSTRAINT wizard_ir_model_menu_create_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: osv_memory_autovacuum; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE osv_memory_autovacuum (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer
);


--
-- Name: TABLE osv_memory_autovacuum; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE osv_memory_autovacuum IS 'osv_memory.autovacuum';


--
-- Name: osv_memory_autovacuum_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE osv_memory_autovacuum_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: osv_memory_autovacuum_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE osv_memory_autovacuum_id_seq OWNED BY osv_memory_autovacuum.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE osv_memory_autovacuum ALTER COLUMN id SET DEFAULT nextval('osv_memory_autovacuum_id_seq'::regclass);


--
-- Name: osv_memory_autovacuum_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY osv_memory_autovacuum
    ADD CONSTRAINT osv_memory_autovacuum_pkey PRIMARY KEY (id);


--
-- Name: osv_memory_autovacuum_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY osv_memory_autovacuum
    ADD CONSTRAINT osv_memory_autovacuum_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: osv_memory_autovacuum_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY osv_memory_autovacuum
    ADD CONSTRAINT osv_memory_autovacuum_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: ir_actions_configuration_wizard; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE ir_actions_configuration_wizard (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    note text
);


--
-- Name: TABLE ir_actions_configuration_wizard; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE ir_actions_configuration_wizard IS 'ir.actions.configuration.wizard';


--
-- Name: COLUMN ir_actions_configuration_wizard.note; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_actions_configuration_wizard.note IS 'Next Wizard';


--
-- Name: ir_actions_configuration_wizard_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE ir_actions_configuration_wizard_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: ir_actions_configuration_wizard_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE ir_actions_configuration_wizard_id_seq OWNED BY ir_actions_configuration_wizard.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ir_actions_configuration_wizard ALTER COLUMN id SET DEFAULT nextval('ir_actions_configuration_wizard_id_seq'::regclass);


--
-- Name: ir_actions_configuration_wizard_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY ir_actions_configuration_wizard
    ADD CONSTRAINT ir_actions_configuration_wizard_pkey PRIMARY KEY (id);


--
-- Name: ir_actions_configuration_wizard_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ir_actions_configuration_wizard
    ADD CONSTRAINT ir_actions_configuration_wizard_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: ir_actions_configuration_wizard_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ir_actions_configuration_wizard
    ADD CONSTRAINT ir_actions_configuration_wizard_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: user_preferences_config; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE user_preferences_config (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    context_tz character varying(64),
    view character varying NOT NULL,
    context_lang character varying NOT NULL,
    menu_tips boolean
);


--
-- Name: TABLE user_preferences_config; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE user_preferences_config IS 'user.preferences.config';


--
-- Name: COLUMN user_preferences_config.context_tz; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN user_preferences_config.context_tz IS 'Timezone';


--
-- Name: COLUMN user_preferences_config.view; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN user_preferences_config.view IS 'Interface';


--
-- Name: COLUMN user_preferences_config.context_lang; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN user_preferences_config.context_lang IS 'Language';


--
-- Name: COLUMN user_preferences_config.menu_tips; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN user_preferences_config.menu_tips IS 'Display Tips';


--
-- Name: user_preferences_config_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE user_preferences_config_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: user_preferences_config_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE user_preferences_config_id_seq OWNED BY user_preferences_config.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE user_preferences_config ALTER COLUMN id SET DEFAULT nextval('user_preferences_config_id_seq'::regclass);


--
-- Name: user_preferences_config_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY user_preferences_config
    ADD CONSTRAINT user_preferences_config_pkey PRIMARY KEY (id);


--
-- Name: user_preferences_config_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY user_preferences_config
    ADD CONSTRAINT user_preferences_config_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: user_preferences_config_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY user_preferences_config
    ADD CONSTRAINT user_preferences_config_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: base_language_install; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE base_language_install (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    lang character varying NOT NULL,
    state character varying,
    overwrite boolean
);


--
-- Name: TABLE base_language_install; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE base_language_install IS 'Install Language';


--
-- Name: COLUMN base_language_install.lang; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_language_install.lang IS 'Language';


--
-- Name: COLUMN base_language_install.state; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_language_install.state IS 'state';


--
-- Name: COLUMN base_language_install.overwrite; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_language_install.overwrite IS 'Overwrite Existing Terms';


--
-- Name: base_language_install_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE base_language_install_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: base_language_install_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE base_language_install_id_seq OWNED BY base_language_install.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE base_language_install ALTER COLUMN id SET DEFAULT nextval('base_language_install_id_seq'::regclass);


--
-- Name: base_language_install_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY base_language_install
    ADD CONSTRAINT base_language_install_pkey PRIMARY KEY (id);


--
-- Name: base_language_install_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_language_install
    ADD CONSTRAINT base_language_install_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: base_language_install_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_language_install
    ADD CONSTRAINT base_language_install_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: res_currency_rate_type; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE res_currency_rate_type (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    name character varying(64) NOT NULL
);


--
-- Name: TABLE res_currency_rate_type; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE res_currency_rate_type IS 'Currency Rate Type';


--
-- Name: COLUMN res_currency_rate_type.name; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN res_currency_rate_type.name IS 'Name';


--
-- Name: res_currency_rate_type_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE res_currency_rate_type_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: res_currency_rate_type_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE res_currency_rate_type_id_seq OWNED BY res_currency_rate_type.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE res_currency_rate_type ALTER COLUMN id SET DEFAULT nextval('res_currency_rate_type_id_seq'::regclass);


--
-- Name: res_currency_rate_type_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY res_currency_rate_type
    ADD CONSTRAINT res_currency_rate_type_pkey PRIMARY KEY (id);


--
-- Name: res_currency_rate_type_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_currency_rate_type
    ADD CONSTRAINT res_currency_rate_type_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: res_currency_rate_type_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_currency_rate_type
    ADD CONSTRAINT res_currency_rate_type_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--


--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: wizard_ir_model_menu_create_line; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE wizard_ir_model_menu_create_line (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    view_id integer,
    sequence integer,
    wizard_id integer,
    view_type character varying NOT NULL
);


--
-- Name: TABLE wizard_ir_model_menu_create_line; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE wizard_ir_model_menu_create_line IS 'wizard.ir.model.menu.create.line';


--
-- Name: COLUMN wizard_ir_model_menu_create_line.view_id; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN wizard_ir_model_menu_create_line.view_id IS 'View';


--
-- Name: COLUMN wizard_ir_model_menu_create_line.sequence; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN wizard_ir_model_menu_create_line.sequence IS 'Sequence';


--
-- Name: COLUMN wizard_ir_model_menu_create_line.wizard_id; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN wizard_ir_model_menu_create_line.wizard_id IS 'Wizard';


--
-- Name: COLUMN wizard_ir_model_menu_create_line.view_type; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN wizard_ir_model_menu_create_line.view_type IS 'View Type';


--
-- Name: wizard_ir_model_menu_create_line_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE wizard_ir_model_menu_create_line_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: wizard_ir_model_menu_create_line_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE wizard_ir_model_menu_create_line_id_seq OWNED BY wizard_ir_model_menu_create_line.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE wizard_ir_model_menu_create_line ALTER COLUMN id SET DEFAULT nextval('wizard_ir_model_menu_create_line_id_seq'::regclass);


--
-- Name: wizard_ir_model_menu_create_line_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY wizard_ir_model_menu_create_line
    ADD CONSTRAINT wizard_ir_model_menu_create_line_pkey PRIMARY KEY (id);


--
-- Name: wizard_ir_model_menu_create_line_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY wizard_ir_model_menu_create_line
    ADD CONSTRAINT wizard_ir_model_menu_create_line_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: wizard_ir_model_menu_create_line_view_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY wizard_ir_model_menu_create_line
    ADD CONSTRAINT wizard_ir_model_menu_create_line_view_id_fkey FOREIGN KEY (view_id) REFERENCES ir_ui_view(id) ON DELETE CASCADE;


--
-- Name: wizard_ir_model_menu_create_line_wizard_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY wizard_ir_model_menu_create_line
    ADD CONSTRAINT wizard_ir_model_menu_create_line_wizard_id_fkey FOREIGN KEY (wizard_id) REFERENCES wizard_ir_model_menu_create(id) ON DELETE SET NULL;


--
-- Name: wizard_ir_model_menu_create_line_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY wizard_ir_model_menu_create_line
    ADD CONSTRAINT wizard_ir_model_menu_create_line_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: ir_mail_server; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE ir_mail_server (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    name character varying(64) NOT NULL,
    sequence integer,
    smtp_port integer NOT NULL,
    smtp_host character varying(128) NOT NULL,
    smtp_user character varying(64),
    smtp_pass character varying(64),
    smtp_debug boolean,
    smtp_encryption character varying NOT NULL
);


--
-- Name: TABLE ir_mail_server; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE ir_mail_server IS 'ir.mail_server';


--
-- Name: COLUMN ir_mail_server.name; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_mail_server.name IS 'Description';


--
-- Name: COLUMN ir_mail_server.sequence; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_mail_server.sequence IS 'Priority';


--
-- Name: COLUMN ir_mail_server.smtp_port; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_mail_server.smtp_port IS 'SMTP Port';


--
-- Name: COLUMN ir_mail_server.smtp_host; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_mail_server.smtp_host IS 'SMTP Server';


--
-- Name: COLUMN ir_mail_server.smtp_user; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_mail_server.smtp_user IS 'Username';


--
-- Name: COLUMN ir_mail_server.smtp_pass; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_mail_server.smtp_pass IS 'Password';


--
-- Name: COLUMN ir_mail_server.smtp_debug; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_mail_server.smtp_debug IS 'Debugging';


--
-- Name: COLUMN ir_mail_server.smtp_encryption; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_mail_server.smtp_encryption IS 'Connection Security';


--
-- Name: ir_mail_server_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE ir_mail_server_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: ir_mail_server_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE ir_mail_server_id_seq OWNED BY ir_mail_server.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ir_mail_server ALTER COLUMN id SET DEFAULT nextval('ir_mail_server_id_seq'::regclass);


--
-- Name: ir_mail_server_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY ir_mail_server
    ADD CONSTRAINT ir_mail_server_pkey PRIMARY KEY (id);


--
-- Name: ir_mail_server_name_index; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ir_mail_server_name_index ON ir_mail_server USING btree (name);


--
-- Name: ir_mail_server_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ir_mail_server
    ADD CONSTRAINT ir_mail_server_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: ir_mail_server_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ir_mail_server
    ADD CONSTRAINT ir_mail_server_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: ir_wizard_screen; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE ir_wizard_screen (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer
);


--
-- Name: TABLE ir_wizard_screen; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE ir_wizard_screen IS 'ir.wizard.screen';


--
-- Name: ir_wizard_screen_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE ir_wizard_screen_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: ir_wizard_screen_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE ir_wizard_screen_id_seq OWNED BY ir_wizard_screen.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ir_wizard_screen ALTER COLUMN id SET DEFAULT nextval('ir_wizard_screen_id_seq'::regclass);


--
-- Name: ir_wizard_screen_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY ir_wizard_screen
    ADD CONSTRAINT ir_wizard_screen_pkey PRIMARY KEY (id);


--
-- Name: ir_wizard_screen_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ir_wizard_screen
    ADD CONSTRAINT ir_wizard_screen_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: ir_wizard_screen_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ir_wizard_screen
    ADD CONSTRAINT ir_wizard_screen_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: product_installer; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE product_installer (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    customers character varying(32) NOT NULL
);


--
-- Name: TABLE product_installer; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE product_installer IS 'product.installer';


--
-- Name: COLUMN product_installer.customers; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN product_installer.customers IS 'Customers';


--
-- Name: product_installer_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE product_installer_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: product_installer_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE product_installer_id_seq OWNED BY product_installer.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE product_installer ALTER COLUMN id SET DEFAULT nextval('product_installer_id_seq'::regclass);


--
-- Name: product_installer_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY product_installer
    ADD CONSTRAINT product_installer_pkey PRIMARY KEY (id);


--
-- Name: product_installer_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY product_installer
    ADD CONSTRAINT product_installer_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: product_installer_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY product_installer
    ADD CONSTRAINT product_installer_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: publisher_warranty_contract_wizard; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE publisher_warranty_contract_wizard (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    state character varying,
    name character varying(256) NOT NULL
);


--
-- Name: TABLE publisher_warranty_contract_wizard; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE publisher_warranty_contract_wizard IS 'publisher_warranty.contract.wizard';


--
-- Name: COLUMN publisher_warranty_contract_wizard.state; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN publisher_warranty_contract_wizard.state IS 'unknown';


--
-- Name: COLUMN publisher_warranty_contract_wizard.name; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN publisher_warranty_contract_wizard.name IS 'Serial Key';


--
-- Name: publisher_warranty_contract_wizard_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE publisher_warranty_contract_wizard_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: publisher_warranty_contract_wizard_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE publisher_warranty_contract_wizard_id_seq OWNED BY publisher_warranty_contract_wizard.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE publisher_warranty_contract_wizard ALTER COLUMN id SET DEFAULT nextval('publisher_warranty_contract_wizard_id_seq'::regclass);


--
-- Name: publisher_warranty_contract_wizard_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY publisher_warranty_contract_wizard
    ADD CONSTRAINT publisher_warranty_contract_wizard_pkey PRIMARY KEY (id);


--
-- Name: publisher_warranty_contract_wizard_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY publisher_warranty_contract_wizard
    ADD CONSTRAINT publisher_warranty_contract_wizard_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: publisher_warranty_contract_wizard_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY publisher_warranty_contract_wizard
    ADD CONSTRAINT publisher_warranty_contract_wizard_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: partner_sms_send; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE partner_sms_send (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    text text NOT NULL,
    password character varying(256) NOT NULL,
    mobile_to character varying(256) NOT NULL,
    "user" character varying(256) NOT NULL,
    app_id character varying(256) NOT NULL
);


--
-- Name: TABLE partner_sms_send; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE partner_sms_send IS 'Send SMS';


--
-- Name: COLUMN partner_sms_send.text; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN partner_sms_send.text IS 'SMS Message';


--
-- Name: COLUMN partner_sms_send.password; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN partner_sms_send.password IS 'Password';


--
-- Name: COLUMN partner_sms_send.mobile_to; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN partner_sms_send.mobile_to IS 'To';


--
-- Name: COLUMN partner_sms_send."user"; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN partner_sms_send."user" IS 'Login';


--
-- Name: COLUMN partner_sms_send.app_id; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN partner_sms_send.app_id IS 'API ID';


--
-- Name: partner_sms_send_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE partner_sms_send_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: partner_sms_send_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE partner_sms_send_id_seq OWNED BY partner_sms_send.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE partner_sms_send ALTER COLUMN id SET DEFAULT nextval('partner_sms_send_id_seq'::regclass);


--
-- Name: partner_sms_send_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY partner_sms_send
    ADD CONSTRAINT partner_sms_send_pkey PRIMARY KEY (id);


--
-- Name: partner_sms_send_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY partner_sms_send
    ADD CONSTRAINT partner_sms_send_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: partner_sms_send_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY partner_sms_send
    ADD CONSTRAINT partner_sms_send_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: base_module_configuration; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE base_module_configuration (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer
);


--
-- Name: TABLE base_module_configuration; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE base_module_configuration IS 'base.module.configuration';


--
-- Name: base_module_configuration_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE base_module_configuration_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: base_module_configuration_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE base_module_configuration_id_seq OWNED BY base_module_configuration.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE base_module_configuration ALTER COLUMN id SET DEFAULT nextval('base_module_configuration_id_seq'::regclass);


--
-- Name: base_module_configuration_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY base_module_configuration
    ADD CONSTRAINT base_module_configuration_pkey PRIMARY KEY (id);


--
-- Name: base_module_configuration_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_module_configuration
    ADD CONSTRAINT base_module_configuration_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: base_module_configuration_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_module_configuration
    ADD CONSTRAINT base_module_configuration_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: base_language_export; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE base_language_export (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    lang character varying,
    name character varying(16),
    format character varying NOT NULL,
    advice text,
    state character varying,
    data bytea
);


--
-- Name: TABLE base_language_export; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE base_language_export IS 'base.language.export';


--
-- Name: COLUMN base_language_export.lang; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_language_export.lang IS 'Language';


--
-- Name: COLUMN base_language_export.name; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_language_export.name IS 'Filename';


--
-- Name: COLUMN base_language_export.format; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_language_export.format IS 'File Format';


--
-- Name: COLUMN base_language_export.advice; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_language_export.advice IS 'Advice';


--
-- Name: COLUMN base_language_export.state; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_language_export.state IS 'unknown';


--
-- Name: COLUMN base_language_export.data; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_language_export.data IS 'File';


--
-- Name: base_language_export_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE base_language_export_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: base_language_export_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE base_language_export_id_seq OWNED BY base_language_export.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE base_language_export ALTER COLUMN id SET DEFAULT nextval('base_language_export_id_seq'::regclass);


--
-- Name: base_language_export_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY base_language_export
    ADD CONSTRAINT base_language_export_pkey PRIMARY KEY (id);


--
-- Name: base_language_export_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_language_export
    ADD CONSTRAINT base_language_export_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: base_language_export_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_language_export
    ADD CONSTRAINT base_language_export_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: base_module_update; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE base_module_update (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    add integer,
    state character varying,
    update integer
);


--
-- Name: TABLE base_module_update; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE base_module_update IS 'Update Module';


--
-- Name: COLUMN base_module_update.add; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_module_update.add IS 'Number of modules added';


--
-- Name: COLUMN base_module_update.state; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_module_update.state IS 'state';


--
-- Name: COLUMN base_module_update.update; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_module_update.update IS 'Number of modules updated';


--
-- Name: base_module_update_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE base_module_update_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: base_module_update_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE base_module_update_id_seq OWNED BY base_module_update.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE base_module_update ALTER COLUMN id SET DEFAULT nextval('base_module_update_id_seq'::regclass);


--
-- Name: base_module_update_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY base_module_update
    ADD CONSTRAINT base_module_update_pkey PRIMARY KEY (id);


--
-- Name: base_module_update_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_module_update
    ADD CONSTRAINT base_module_update_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: base_module_update_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_module_update
    ADD CONSTRAINT base_module_update_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: base_language_import; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE base_language_import (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    code character varying(5) NOT NULL,
    data bytea NOT NULL,
    name character varying(64) NOT NULL,
    overwrite boolean
);


--
-- Name: TABLE base_language_import; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE base_language_import IS 'Language Import';


--
-- Name: COLUMN base_language_import.code; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_language_import.code IS 'Code (eg:en__US)';


--
-- Name: COLUMN base_language_import.data; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_language_import.data IS 'File';


--
-- Name: COLUMN base_language_import.name; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_language_import.name IS 'Language Name';


--
-- Name: COLUMN base_language_import.overwrite; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_language_import.overwrite IS 'Overwrite Existing Terms';


--
-- Name: base_language_import_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE base_language_import_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: base_language_import_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE base_language_import_id_seq OWNED BY base_language_import.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE base_language_import ALTER COLUMN id SET DEFAULT nextval('base_language_import_id_seq'::regclass);


--
-- Name: base_language_import_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY base_language_import
    ADD CONSTRAINT base_language_import_pkey PRIMARY KEY (id);


--
-- Name: base_language_import_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_language_import
    ADD CONSTRAINT base_language_import_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: base_language_import_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_language_import
    ADD CONSTRAINT base_language_import_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: res_widget_wizard; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE res_widget_wizard (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    widgets_list character varying NOT NULL
);


--
-- Name: TABLE res_widget_wizard; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE res_widget_wizard IS 'Add a widget for User';


--
-- Name: COLUMN res_widget_wizard.widgets_list; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN res_widget_wizard.widgets_list IS 'Widget';


--
-- Name: res_widget_wizard_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE res_widget_wizard_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: res_widget_wizard_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE res_widget_wizard_id_seq OWNED BY res_widget_wizard.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE res_widget_wizard ALTER COLUMN id SET DEFAULT nextval('res_widget_wizard_id_seq'::regclass);


--
-- Name: res_widget_wizard_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY res_widget_wizard
    ADD CONSTRAINT res_widget_wizard_pkey PRIMARY KEY (id);


--
-- Name: res_widget_wizard_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_widget_wizard
    ADD CONSTRAINT res_widget_wizard_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: res_widget_wizard_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_widget_wizard
    ADD CONSTRAINT res_widget_wizard_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: res_config; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE res_config (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer
);


--
-- Name: TABLE res_config; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE res_config IS 'res.config';


--
-- Name: res_config_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE res_config_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: res_config_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE res_config_id_seq OWNED BY res_config.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE res_config ALTER COLUMN id SET DEFAULT nextval('res_config_id_seq'::regclass);


--
-- Name: res_config_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY res_config
    ADD CONSTRAINT res_config_pkey PRIMARY KEY (id);


--
-- Name: res_config_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_config
    ADD CONSTRAINT res_config_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: res_config_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_config
    ADD CONSTRAINT res_config_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: partner_clear_ids; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE partner_clear_ids (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer
);


--
-- Name: TABLE partner_clear_ids; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE partner_clear_ids IS 'Clear IDs';


--
-- Name: partner_clear_ids_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE partner_clear_ids_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: partner_clear_ids_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE partner_clear_ids_id_seq OWNED BY partner_clear_ids.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE partner_clear_ids ALTER COLUMN id SET DEFAULT nextval('partner_clear_ids_id_seq'::regclass);


--
-- Name: partner_clear_ids_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY partner_clear_ids
    ADD CONSTRAINT partner_clear_ids_pkey PRIMARY KEY (id);


--
-- Name: partner_clear_ids_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY partner_clear_ids
    ADD CONSTRAINT partner_clear_ids_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: partner_clear_ids_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY partner_clear_ids
    ADD CONSTRAINT partner_clear_ids_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: base_module_import; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE base_module_import (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    module_name character varying(128),
    module_file bytea NOT NULL,
    state character varying
);


--
-- Name: TABLE base_module_import; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE base_module_import IS 'Import Module';


--
-- Name: COLUMN base_module_import.module_name; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_module_import.module_name IS 'Module Name';


--
-- Name: COLUMN base_module_import.module_file; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_module_import.module_file IS 'Module .ZIP file';


--
-- Name: COLUMN base_module_import.state; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_module_import.state IS 'state';


--
-- Name: base_module_import_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE base_module_import_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: base_module_import_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE base_module_import_id_seq OWNED BY base_module_import.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE base_module_import ALTER COLUMN id SET DEFAULT nextval('base_module_import_id_seq'::regclass);


--
-- Name: base_module_import_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY base_module_import
    ADD CONSTRAINT base_module_import_pkey PRIMARY KEY (id);


--
-- Name: base_module_import_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_module_import
    ADD CONSTRAINT base_module_import_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: base_module_import_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_module_import
    ADD CONSTRAINT base_module_import_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: base_update_translations; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE base_update_translations (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer,
    lang character varying NOT NULL
);


--
-- Name: TABLE base_update_translations; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE base_update_translations IS 'base.update.translations';


--
-- Name: COLUMN base_update_translations.lang; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN base_update_translations.lang IS 'Language';


--
-- Name: base_update_translations_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE base_update_translations_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: base_update_translations_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE base_update_translations_id_seq OWNED BY base_update_translations.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE base_update_translations ALTER COLUMN id SET DEFAULT nextval('base_update_translations_id_seq'::regclass);


--
-- Name: base_update_translations_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY base_update_translations
    ADD CONSTRAINT base_update_translations_pkey PRIMARY KEY (id);


--
-- Name: base_update_translations_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_update_translations
    ADD CONSTRAINT base_update_translations_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: base_update_translations_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY base_update_translations
    ADD CONSTRAINT base_update_translations_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: res_config_installer; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE res_config_installer (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer
);


--
-- Name: TABLE res_config_installer; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE res_config_installer IS 'res.config.installer';


--
-- Name: res_config_installer_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE res_config_installer_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: res_config_installer_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE res_config_installer_id_seq OWNED BY res_config_installer.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE res_config_installer ALTER COLUMN id SET DEFAULT nextval('res_config_installer_id_seq'::regclass);


--
-- Name: res_config_installer_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY res_config_installer
    ADD CONSTRAINT res_config_installer_pkey PRIMARY KEY (id);


--
-- Name: res_config_installer_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_config_installer
    ADD CONSTRAINT res_config_installer_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: res_config_installer_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_config_installer
    ADD CONSTRAINT res_config_installer_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = true;

--
-- Name: rel_modules_langexport; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE rel_modules_langexport (
    wiz_id integer NOT NULL,
    module_id integer NOT NULL
);


--
-- Name: TABLE rel_modules_langexport; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE rel_modules_langexport IS 'RELATION BETWEEN base_language_export AND ir_module_module';


--
-- Name: rel_modules_langexport_wiz_id_module_id_key; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY rel_modules_langexport
    ADD CONSTRAINT rel_modules_langexport_wiz_id_module_id_key UNIQUE (wiz_id, module_id);


--
-- Name: rel_modules_langexport_module_id_index; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX rel_modules_langexport_module_id_index ON rel_modules_langexport USING btree (module_id);


--
-- Name: rel_modules_langexport_wiz_id_index; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX rel_modules_langexport_wiz_id_index ON rel_modules_langexport USING btree (wiz_id);


--
-- Name: rel_modules_langexport_module_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY rel_modules_langexport
    ADD CONSTRAINT rel_modules_langexport_module_id_fkey FOREIGN KEY (module_id) REFERENCES ir_module_module(id) ON DELETE CASCADE;


--
-- Name: rel_modules_langexport_wiz_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY rel_modules_langexport
    ADD CONSTRAINT rel_modules_langexport_wiz_id_fkey FOREIGN KEY (wiz_id) REFERENCES base_language_export(id) ON DELETE CASCADE;


--
-- PostgreSQL database dump complete
--


alter table res_company
   drop column rml_footer2,
   add column paper_format  text,
   add column company_registry text;

alter table    ir_sequence
    add column implementation text;

alter table res_currency
    add column position text;

alter table res_partner
    add column color int;

ALTER TABLE ir_module_module ADD COLUMN "sequence" integer;
ALTER TABLE ir_module_module ALTER COLUMN "sequence" SET DEFAULT 100;
ALTER TABLE ir_module_module ADD COLUMN complexity character varying(32);
ALTER TABLE ir_module_module ADD COLUMN icon character varying(128);
ALTER TABLE ir_module_module ADD COLUMN application boolean;
ALTER TABLE ir_module_module ALTER COLUMN application SET DEFAULT false;

alter table ir_actions_todo
   drop column restart,
   add column category_id int,
   add column type text;

alter table ir_values
   drop column object;

alter table res_partner_bank_type
    add column format_layout text;

alter table ir_module_category
    add column visible bool,
    add column description text,
    add column sequence int;

alter table res_users
   drop column address_id,
   add column  user_email text;

alter table res_partner_address
   add column color int;

alter table res_country
    add column address_format text;

ALTER TABLE ir_model_fields ADD column serialization_field_id int references ir_model_fields on delete cascade;   

alter table res_bank
    drop column code;

alter table res_currency_rate
    add column  currency_rate_type_id int;

alter table res_groups
    add column category_id int;

alter table ir_act_window
    drop column menus;

alter table res_partner_bank  
    add column company_id int,
    add column bank_name text,
    add column bank_bic text,
    add column footer bool;

alter table ir_translation
    drop column xml_id,
    drop column module;

delete from ir_module_module where certificate in ('00899858104035139949', '001056784984222247309', '001278773815818292125');
update ir_sequence set implementation = 'no_gap';
