begin transaction;

-- ===========================================
-- Tables in 'vazio7' that are not in 'vazio8'
-- =========================================== 

drop table if exists process_transition, ir_actions_configuration_wizard, res_groups_wizard_rel, process_process, process_transition_ids cascade;
drop table if exists res_request, process_condition, wkf_logs, process_transition_group_rel, ir_ui_view_sc, ir_act_report_custom cascade;
drop table if exists base_module_import, ir_act_wizard, res_currency_rate_type, res_request_history, process_node cascade;
drop table if exists process_transition_action cascade;

-- ===========================================
-- Tables in 'vazio8' that are not in 'vazio7'
-- =========================================== 

SET statement_timeout = 0;
SET lock_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;


-- ***************************************
-- *        public.im_chat_session       *
-- ***************************************

--
-- Name: im_chat_session; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE im_chat_session (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    uuid character varying(50),
    write_uid integer,
    write_date timestamp without time zone
);


--
-- Name: TABLE im_chat_session; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE im_chat_session IS 'im_chat.session';


--
-- Name: COLUMN im_chat_session.create_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_session.create_uid IS 'Created by';


--
-- Name: COLUMN im_chat_session.create_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_session.create_date IS 'Created on';


--
-- Name: COLUMN im_chat_session.uuid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_session.uuid IS 'UUID';


--
-- Name: COLUMN im_chat_session.write_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_session.write_uid IS 'Last Updated by';


--
-- Name: COLUMN im_chat_session.write_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_session.write_date IS 'Last Updated on';


--
-- Name: im_chat_session_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE im_chat_session_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: im_chat_session_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE im_chat_session_id_seq OWNED BY im_chat_session.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY im_chat_session ALTER COLUMN id SET DEFAULT nextval('im_chat_session_id_seq'::regclass);


--
-- Name: im_chat_session_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY im_chat_session
    ADD CONSTRAINT im_chat_session_pkey PRIMARY KEY (id);


--
-- Name: im_chat_session_uuid_index; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX im_chat_session_uuid_index ON im_chat_session USING btree (uuid);


--
-- Name: im_chat_session_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY im_chat_session
    ADD CONSTRAINT im_chat_session_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: im_chat_session_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY im_chat_session
    ADD CONSTRAINT im_chat_session_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;



-- ***************************************
-- *        public.im_chat_message       *
-- ***************************************


--
-- Name: im_chat_message; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE im_chat_message (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone NOT NULL,
    write_uid integer,
    to_id integer NOT NULL,
    write_date timestamp without time zone,
    message character varying,
    type character varying,
    from_id integer
);


--
-- Name: TABLE im_chat_message; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE im_chat_message IS 'im_chat.message';


--
-- Name: COLUMN im_chat_message.create_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_message.create_uid IS 'Created by';


--
-- Name: COLUMN im_chat_message.create_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_message.create_date IS 'Create Date';


--
-- Name: COLUMN im_chat_message.write_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_message.write_uid IS 'Last Updated by';


--
-- Name: COLUMN im_chat_message.to_id; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_message.to_id IS 'Session To';


--
-- Name: COLUMN im_chat_message.write_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_message.write_date IS 'Last Updated on';


--
-- Name: COLUMN im_chat_message.message; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_message.message IS 'Message';


--
-- Name: COLUMN im_chat_message.type; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_message.type IS 'Type';


--
-- Name: COLUMN im_chat_message.from_id; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_message.from_id IS 'Author';


--
-- Name: im_chat_message_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE im_chat_message_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: im_chat_message_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE im_chat_message_id_seq OWNED BY im_chat_message.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY im_chat_message ALTER COLUMN id SET DEFAULT nextval('im_chat_message_id_seq'::regclass);


--
-- Name: im_chat_message_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY im_chat_message
    ADD CONSTRAINT im_chat_message_pkey PRIMARY KEY (id);


--
-- Name: im_chat_message_create_date_index; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX im_chat_message_create_date_index ON im_chat_message USING btree (create_date);


--
-- Name: im_chat_message_to_id_index; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX im_chat_message_to_id_index ON im_chat_message USING btree (to_id);


--
-- Name: im_chat_message_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY im_chat_message
    ADD CONSTRAINT im_chat_message_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: im_chat_message_from_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY im_chat_message
    ADD CONSTRAINT im_chat_message_from_id_fkey FOREIGN KEY (from_id) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: im_chat_message_to_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY im_chat_message
    ADD CONSTRAINT im_chat_message_to_id_fkey FOREIGN KEY (to_id) REFERENCES im_chat_session(id) ON DELETE CASCADE;


--
-- Name: im_chat_message_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY im_chat_message
    ADD CONSTRAINT im_chat_message_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;



-- ***************************************
-- * public.im_chat_session_res_users_rel *
-- ***************************************

--
-- Name: im_chat_session_res_users_rel; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE im_chat_session_res_users_rel (
    id integer NOT NULL,
    create_uid integer,
    user_id integer NOT NULL,
    session_id integer NOT NULL,
    write_uid integer,
    state character varying,
    write_date timestamp without time zone,
    create_date timestamp without time zone
);


--
-- Name: TABLE im_chat_session_res_users_rel; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE im_chat_session_res_users_rel IS 'im_chat.conversation_state';


--
-- Name: COLUMN im_chat_session_res_users_rel.create_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_session_res_users_rel.create_uid IS 'Created by';


--
-- Name: COLUMN im_chat_session_res_users_rel.user_id; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_session_res_users_rel.user_id IS 'Users';


--
-- Name: COLUMN im_chat_session_res_users_rel.session_id; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_session_res_users_rel.session_id IS 'Session';


--
-- Name: COLUMN im_chat_session_res_users_rel.write_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_session_res_users_rel.write_uid IS 'Last Updated by';


--
-- Name: COLUMN im_chat_session_res_users_rel.state; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_session_res_users_rel.state IS 'unknown';


--
-- Name: COLUMN im_chat_session_res_users_rel.write_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_session_res_users_rel.write_date IS 'Last Updated on';


--
-- Name: COLUMN im_chat_session_res_users_rel.create_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_session_res_users_rel.create_date IS 'Created on';


--
-- Name: im_chat_session_res_users_rel_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE im_chat_session_res_users_rel_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: im_chat_session_res_users_rel_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE im_chat_session_res_users_rel_id_seq OWNED BY im_chat_session_res_users_rel.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY im_chat_session_res_users_rel ALTER COLUMN id SET DEFAULT nextval('im_chat_session_res_users_rel_id_seq'::regclass);


--
-- Name: im_chat_session_res_users_rel_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY im_chat_session_res_users_rel
    ADD CONSTRAINT im_chat_session_res_users_rel_pkey PRIMARY KEY (id);


--
-- Name: im_chat_session_res_users_rel_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY im_chat_session_res_users_rel
    ADD CONSTRAINT im_chat_session_res_users_rel_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: im_chat_session_res_users_rel_session_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY im_chat_session_res_users_rel
    ADD CONSTRAINT im_chat_session_res_users_rel_session_id_fkey FOREIGN KEY (session_id) REFERENCES im_chat_session(id) ON DELETE CASCADE;


--
-- Name: im_chat_session_res_users_rel_user_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY im_chat_session_res_users_rel
    ADD CONSTRAINT im_chat_session_res_users_rel_user_id_fkey FOREIGN KEY (user_id) REFERENCES res_users(id) ON DELETE CASCADE;


--
-- Name: im_chat_session_res_users_rel_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY im_chat_session_res_users_rel
    ADD CONSTRAINT im_chat_session_res_users_rel_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;

--

-- ***************************************
-- *       public.im_chat_presence       *
-- ***************************************
--
-- PostgreSQL database dump
--

--
-- Name: im_chat_presence; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE im_chat_presence (
    id integer NOT NULL,
    status character varying,
    create_uid integer,
    create_date timestamp without time zone,
    last_presence timestamp without time zone,
    write_uid integer,
    write_date timestamp without time zone,
    last_poll timestamp without time zone,
    user_id integer NOT NULL
);


--
-- Name: TABLE im_chat_presence; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE im_chat_presence IS 'im_chat.presence';


--
-- Name: COLUMN im_chat_presence.status; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_presence.status IS 'IM Status';


--
-- Name: COLUMN im_chat_presence.create_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_presence.create_uid IS 'Created by';


--
-- Name: COLUMN im_chat_presence.create_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_presence.create_date IS 'Created on';


--
-- Name: COLUMN im_chat_presence.last_presence; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_presence.last_presence IS 'Last Presence';


--
-- Name: COLUMN im_chat_presence.write_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_presence.write_uid IS 'Last Updated by';


--
-- Name: COLUMN im_chat_presence.write_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_presence.write_date IS 'Last Updated on';


--
-- Name: COLUMN im_chat_presence.last_poll; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_presence.last_poll IS 'Last Poll';


--
-- Name: COLUMN im_chat_presence.user_id; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN im_chat_presence.user_id IS 'Users';


--
-- Name: im_chat_presence_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE im_chat_presence_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: im_chat_presence_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE im_chat_presence_id_seq OWNED BY im_chat_presence.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY im_chat_presence ALTER COLUMN id SET DEFAULT nextval('im_chat_presence_id_seq'::regclass);


--
-- Name: im_chat_presence_im_chat_user_status_unique; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY im_chat_presence
    ADD CONSTRAINT im_chat_presence_im_chat_user_status_unique UNIQUE (user_id);


--
-- Name: im_chat_presence_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY im_chat_presence
    ADD CONSTRAINT im_chat_presence_pkey PRIMARY KEY (id);


--
-- Name: im_chat_presence_user_id_index; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX im_chat_presence_user_id_index ON im_chat_presence USING btree (user_id);


--
-- Name: im_chat_presence_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY im_chat_presence
    ADD CONSTRAINT im_chat_presence_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: im_chat_presence_user_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY im_chat_presence
    ADD CONSTRAINT im_chat_presence_user_id_fkey FOREIGN KEY (user_id) REFERENCES res_users(id) ON DELETE CASCADE;


--
-- Name: im_chat_presence_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY im_chat_presence
    ADD CONSTRAINT im_chat_presence_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

-- ***************************************
-- *           public.res_font           *
-- ***************************************
--
-- PostgreSQL database dump
--


--
-- Name: res_font; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE res_font (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    name character varying NOT NULL,
    family character varying NOT NULL,
    write_uid integer,
    mode character varying NOT NULL,
    write_date timestamp without time zone,
    path character varying NOT NULL
);


--
-- Name: TABLE res_font; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE res_font IS 'Fonts available';


--
-- Name: COLUMN res_font.create_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN res_font.create_uid IS 'Created by';


--
-- Name: COLUMN res_font.create_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN res_font.create_date IS 'Created on';


--
-- Name: COLUMN res_font.name; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN res_font.name IS 'Font Name';


--
-- Name: COLUMN res_font.family; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN res_font.family IS 'Font family';


--
-- Name: COLUMN res_font.write_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN res_font.write_uid IS 'Last Updated by';


--
-- Name: COLUMN res_font.mode; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN res_font.mode IS 'Mode';


--
-- Name: COLUMN res_font.write_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN res_font.write_date IS 'Last Updated on';


--
-- Name: COLUMN res_font.path; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN res_font.path IS 'Path';


--
-- Name: res_font_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE res_font_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: res_font_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE res_font_id_seq OWNED BY res_font.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_font ALTER COLUMN id SET DEFAULT nextval('res_font_id_seq'::regclass);


--
-- Name: res_font_name_font_uniq; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY res_font
    ADD CONSTRAINT res_font_name_font_uniq UNIQUE (family, name);


--
-- Name: res_font_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY res_font
    ADD CONSTRAINT res_font_pkey PRIMARY KEY (id);


--
-- Name: res_font_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_font
    ADD CONSTRAINT res_font_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: res_font_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_font
    ADD CONSTRAINT res_font_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

-- ***************************************
-- *          public.ir_logging          *
-- ***************************************
--
-- PostgreSQL database dump
--


--
-- Name: ir_logging; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE ir_logging (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    name character varying NOT NULL,
    level character varying,
    line character varying NOT NULL,
    dbname character varying,
    write_uid integer,
    func character varying NOT NULL,
    write_date timestamp without time zone,
    path character varying NOT NULL,
    message text NOT NULL,
    type character varying NOT NULL
);


--
-- Name: TABLE ir_logging; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE ir_logging IS 'ir.logging';


--
-- Name: COLUMN ir_logging.create_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_logging.create_uid IS 'Uid';


--
-- Name: COLUMN ir_logging.create_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_logging.create_date IS 'Create Date';


--
-- Name: COLUMN ir_logging.name; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_logging.name IS 'Name';


--
-- Name: COLUMN ir_logging.level; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_logging.level IS 'Level';


--
-- Name: COLUMN ir_logging.line; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_logging.line IS 'Line';


--
-- Name: COLUMN ir_logging.dbname; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_logging.dbname IS 'Database Name';


--
-- Name: COLUMN ir_logging.write_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_logging.write_uid IS 'Last Updated by';


--
-- Name: COLUMN ir_logging.func; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_logging.func IS 'Function';


--
-- Name: COLUMN ir_logging.write_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_logging.write_date IS 'Last Updated on';


--
-- Name: COLUMN ir_logging.path; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_logging.path IS 'Path';


--
-- Name: COLUMN ir_logging.message; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_logging.message IS 'Message';


--
-- Name: COLUMN ir_logging.type; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN ir_logging.type IS 'Type';


--
-- Name: ir_logging_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE ir_logging_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: ir_logging_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE ir_logging_id_seq OWNED BY ir_logging.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY ir_logging ALTER COLUMN id SET DEFAULT nextval('ir_logging_id_seq'::regclass);


--
-- Name: ir_logging_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY ir_logging
    ADD CONSTRAINT ir_logging_pkey PRIMARY KEY (id);


--
-- Name: ir_logging_dbname_index; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ir_logging_dbname_index ON ir_logging USING btree (dbname);


--
-- Name: ir_logging_level_index; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ir_logging_level_index ON ir_logging USING btree (level);


--
-- Name: ir_logging_type_index; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ir_logging_type_index ON ir_logging USING btree (type);


--
-- Name: ir_logging_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ir_logging
    ADD CONSTRAINT ir_logging_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- PostgreSQL database dump complete
--

-- ***************************************
-- *            public.bus_bus           *
-- ***************************************
--
-- PostgreSQL database dump
--


--
-- Name: bus_bus; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE bus_bus (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_uid integer,
    write_date timestamp without time zone,
    message character varying,
    channel character varying
);


--
-- Name: TABLE bus_bus; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE bus_bus IS 'bus.bus';


--
-- Name: COLUMN bus_bus.create_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN bus_bus.create_uid IS 'Created by';


--
-- Name: COLUMN bus_bus.create_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN bus_bus.create_date IS 'Create date';


--
-- Name: COLUMN bus_bus.write_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN bus_bus.write_uid IS 'Last Updated by';


--
-- Name: COLUMN bus_bus.write_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN bus_bus.write_date IS 'Last Updated on';


--
-- Name: COLUMN bus_bus.message; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN bus_bus.message IS 'Message';


--
-- Name: COLUMN bus_bus.channel; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN bus_bus.channel IS 'Channel';


--
-- Name: bus_bus_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE bus_bus_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: bus_bus_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE bus_bus_id_seq OWNED BY bus_bus.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY bus_bus ALTER COLUMN id SET DEFAULT nextval('bus_bus_id_seq'::regclass);


--
-- Name: bus_bus_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY bus_bus
    ADD CONSTRAINT bus_bus_pkey PRIMARY KEY (id);


--
-- Name: bus_bus_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY bus_bus
    ADD CONSTRAINT bus_bus_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: bus_bus_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY bus_bus
    ADD CONSTRAINT bus_bus_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;


-- ***************************************
-- *       public.res_country_group      *
-- ***************************************


--
-- Name: res_country_group; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE res_country_group (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    name character varying NOT NULL,
    write_uid integer,
    write_date timestamp without time zone
);


--
-- Name: TABLE res_country_group; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE res_country_group IS 'Country Group';


--
-- Name: COLUMN res_country_group.create_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN res_country_group.create_uid IS 'Created by';


--
-- Name: COLUMN res_country_group.create_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN res_country_group.create_date IS 'Created on';


--
-- Name: COLUMN res_country_group.name; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN res_country_group.name IS 'Name';


--
-- Name: COLUMN res_country_group.write_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN res_country_group.write_uid IS 'Last Updated by';


--
-- Name: COLUMN res_country_group.write_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN res_country_group.write_date IS 'Last Updated on';


--
-- Name: res_country_group_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE res_country_group_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: res_country_group_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE res_country_group_id_seq OWNED BY res_country_group.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_country_group ALTER COLUMN id SET DEFAULT nextval('res_country_group_id_seq'::regclass);


--
-- Name: res_country_group_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY res_country_group
    ADD CONSTRAINT res_country_group_pkey PRIMARY KEY (id);


--
-- Name: res_country_group_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_country_group
    ADD CONSTRAINT res_country_group_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: res_country_group_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_country_group
    ADD CONSTRAINT res_country_group_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;



   

-- ***************************************
-- * public.res_country_res_country_group_rel *
-- ***************************************


--
-- Name: res_country_res_country_group_rel; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE res_country_res_country_group_rel (
    res_country_id integer NOT NULL,
    res_country_group_id integer NOT NULL
);


--
-- Name: TABLE res_country_res_country_group_rel; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE res_country_res_country_group_rel IS 'RELATION BETWEEN res_country AND res_country_group';


--
-- Name: res_country_res_country_group_res_country_id_res_country_gr_key; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY res_country_res_country_group_rel
    ADD CONSTRAINT res_country_res_country_group_res_country_id_res_country_gr_key UNIQUE (res_country_id, res_country_group_id);


--
-- Name: res_country_res_country_group_rel_res_country_group_id_index; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX res_country_res_country_group_rel_res_country_group_id_index ON res_country_res_country_group_rel USING btree (res_country_group_id);


--
-- Name: res_country_res_country_group_rel_res_country_id_index; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX res_country_res_country_group_rel_res_country_id_index ON res_country_res_country_group_rel USING btree (res_country_id);


--
-- Name: res_country_res_country_group_rel_res_country_group_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_country_res_country_group_rel
    ADD CONSTRAINT res_country_res_country_group_rel_res_country_group_id_fkey FOREIGN KEY (res_country_group_id) REFERENCES res_country_group(id) ON DELETE CASCADE;


--
-- Name: res_country_res_country_group_rel_res_country_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY res_country_res_country_group_rel
    ADD CONSTRAINT res_country_res_country_group_rel_res_country_id_fkey FOREIGN KEY (res_country_id) REFERENCES res_country(id) ON DELETE CASCADE;


-- ***************************************
-- *            public.report            *
-- ***************************************


--
-- Name: report; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE report (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer
);


--
-- Name: TABLE report; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE report IS 'Report';


--
-- Name: COLUMN report.create_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report.create_uid IS 'Created by';


--
-- Name: COLUMN report.create_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report.create_date IS 'Created on';


--
-- Name: COLUMN report.write_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report.write_date IS 'Last Updated on';


--
-- Name: COLUMN report.write_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report.write_uid IS 'Last Updated by';


--
-- Name: report_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE report_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: report_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE report_id_seq OWNED BY report.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY report ALTER COLUMN id SET DEFAULT nextval('report_id_seq'::regclass);


--
-- Name: report_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY report
    ADD CONSTRAINT report_pkey PRIMARY KEY (id);


--
-- Name: report_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY report
    ADD CONSTRAINT report_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: report_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY report
    ADD CONSTRAINT report_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;



-- ***************************************
-- *      public.report_paperformat      *
-- ***************************************


--
-- Name: report_paperformat; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE report_paperformat (
    id integer NOT NULL,
    create_uid integer,
    page_width integer,
    create_date timestamp without time zone,
    name character varying NOT NULL,
    format character varying,
    "default" boolean,
    header_line boolean,
    header_spacing integer,
    dpi integer NOT NULL,
    write_uid integer,
    margin_right integer,
    margin_top integer,
    margin_left integer,
    write_date timestamp without time zone,
    margin_bottom integer,
    page_height integer,
    orientation character varying
);


--
-- Name: TABLE report_paperformat; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE report_paperformat IS 'Allows customization of a report.';


--
-- Name: COLUMN report_paperformat.create_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report_paperformat.create_uid IS 'Created by';


--
-- Name: COLUMN report_paperformat.page_width; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report_paperformat.page_width IS 'Page width (mm)';


--
-- Name: COLUMN report_paperformat.create_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report_paperformat.create_date IS 'Created on';


--
-- Name: COLUMN report_paperformat.name; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report_paperformat.name IS 'Name';


--
-- Name: COLUMN report_paperformat.format; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report_paperformat.format IS 'Paper size';


--
-- Name: COLUMN report_paperformat."default"; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report_paperformat."default" IS 'Default paper format ?';


--
-- Name: COLUMN report_paperformat.header_line; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report_paperformat.header_line IS 'Display a header line';


--
-- Name: COLUMN report_paperformat.header_spacing; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report_paperformat.header_spacing IS 'Header spacing';


--
-- Name: COLUMN report_paperformat.dpi; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report_paperformat.dpi IS 'Output DPI';


--
-- Name: COLUMN report_paperformat.write_uid; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report_paperformat.write_uid IS 'Last Updated by';


--
-- Name: COLUMN report_paperformat.margin_right; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report_paperformat.margin_right IS 'Right Margin (mm)';


--
-- Name: COLUMN report_paperformat.margin_top; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report_paperformat.margin_top IS 'Top Margin (mm)';


--
-- Name: COLUMN report_paperformat.margin_left; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report_paperformat.margin_left IS 'Left Margin (mm)';


--
-- Name: COLUMN report_paperformat.write_date; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report_paperformat.write_date IS 'Last Updated on';


--
-- Name: COLUMN report_paperformat.margin_bottom; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report_paperformat.margin_bottom IS 'Bottom Margin (mm)';


--
-- Name: COLUMN report_paperformat.page_height; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report_paperformat.page_height IS 'Page height (mm)';


--
-- Name: COLUMN report_paperformat.orientation; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON COLUMN report_paperformat.orientation IS 'Orientation';


--
-- Name: report_paperformat_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE report_paperformat_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- Name: report_paperformat_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE report_paperformat_id_seq OWNED BY report_paperformat.id;


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE ONLY report_paperformat ALTER COLUMN id SET DEFAULT nextval('report_paperformat_id_seq'::regclass);


--
-- Name: report_paperformat_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY report_paperformat
    ADD CONSTRAINT report_paperformat_pkey PRIMARY KEY (id);


--
-- Name: report_paperformat_create_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY report_paperformat
    ADD CONSTRAINT report_paperformat_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES res_users(id) ON DELETE SET NULL;


--
-- Name: report_paperformat_write_uid_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY report_paperformat
    ADD CONSTRAINT report_paperformat_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES res_users(id) ON DELETE SET NULL;



-- ***************************************
-- * public.ir_config_parameter_groups_rel *
-- ***************************************

--
-- Name: ir_config_parameter_groups_rel; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE ir_config_parameter_groups_rel (
    icp_id integer NOT NULL,
    group_id integer NOT NULL
);


--
-- Name: TABLE ir_config_parameter_groups_rel; Type: COMMENT; Schema: public; Owner: -
--

COMMENT ON TABLE ir_config_parameter_groups_rel IS 'RELATION BETWEEN ir_config_parameter AND res_groups';


--
-- Name: ir_config_parameter_groups_rel_icp_id_group_id_key; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY ir_config_parameter_groups_rel
    ADD CONSTRAINT ir_config_parameter_groups_rel_icp_id_group_id_key UNIQUE (icp_id, group_id);


--
-- Name: ir_config_parameter_groups_rel_group_id_index; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ir_config_parameter_groups_rel_group_id_index ON ir_config_parameter_groups_rel USING btree (group_id);


--
-- Name: ir_config_parameter_groups_rel_icp_id_index; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ir_config_parameter_groups_rel_icp_id_index ON ir_config_parameter_groups_rel USING btree (icp_id);


--
-- Name: ir_config_parameter_groups_rel_group_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ir_config_parameter_groups_rel
    ADD CONSTRAINT ir_config_parameter_groups_rel_group_id_fkey FOREIGN KEY (group_id) REFERENCES res_groups(id) ON DELETE CASCADE;


--
-- Name: ir_config_parameter_groups_rel_icp_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ir_config_parameter_groups_rel
    ADD CONSTRAINT ir_config_parameter_groups_rel_icp_id_fkey FOREIGN KEY (icp_id) REFERENCES ir_config_parameter(id) ON DELETE CASCADE;


-- =================================================================
 -- Tables that are in both databases but have different attributes
-- =================================================================

alter table res_company 
   drop column paper_format,
   add column rml_paper_format text,
   add column paperformat_id int, 
   add column font int, 
   add column email text,
   add column phone text,
   add CONSTRAINT res_company_paperformat_id_fkey FOREIGN KEY(paperformat_id)
       REFERENCES report_paperformat(id) MATCH SIMPLE,
   add CONSTRAINT res_company_font_fkey FOREIGN KEY(font)
       REFERENCES res_font(id) MATCH SIMPLE;
update res_company set rml_paper_format= 'a4';
alter table res_company
   alter column  rml_paper_format set not null;

alter table res_currency
   drop column date;

alter table ir_act_report_xml
   add column paperformat_id int, 
   add column parser text,
   add CONSTRAINT ir_act_report_xml_paperformat_id_fkey FOREIGN KEY(paperformat_id)
       REFERENCES report_paperformat(id) MATCH SIMPLE;

alter table res_partner
   add column display_name text,
   add column commercial_partner_id int,
   add CONSTRAINT res_partner_commercial_partner_id_fkey FOREIGN KEY(commercial_partner_id)
       REFERENCES res_partner(id) MATCH SIMPLE;
   
alter table ir_module_module
   drop column complexity;

alter table ir_module_module_dependency
   drop column version_pattern;


alter table ir_ui_view
   add column active bool,
   add column model_data_id int,
   add CONSTRAINT ir_ui_view_model_data_id_fkey FOREIGN KEY(model_data_id)
       REFERENCES ir_model_data(id) MATCH SIMPLE;

update ir_ui_view set active=True;

alter table ir_values
   drop column meta;

alter table ir_act_server
   drop column loop_action,
   drop column trigger_obj_id,
   drop column mobile,
   drop column copy_object,
   drop column trigger_name,
   drop column srcmodel_id,
   drop column write_id,
   drop column record_id,
   drop column message,
   drop column expression,
   drop column email,
   drop column subject,
   add column write_expression text,
   add column wkf_field_id int,
   add column sub_model_object_field int,
   add column crud_model_id int,
   add column model_object_field int,
   add column link_field_id int,
   add column menu_ir_values_id int,
   add column link_new_record bool,
   add column wkf_transition_id int,
   add column id_value text,
   add column sub_object int,
   add column crud_model_name text,
   add column wkf_model_name text,
   add column copyvalue text,
   add CONSTRAINT ir_act_server_wkf_field_id_fkey FOREIGN KEY(wkf_field_id)
       REFERENCES ir_model_fields(id) MATCH SIMPLE,
   add CONSTRAINT ir_act_server_sub_model_object_field_fkey FOREIGN KEY(sub_model_object_field)
       REFERENCES ir_model_fields(id) MATCH SIMPLE,
   add CONSTRAINT ir_act_server_model_object_field_fkey FOREIGN KEY(model_object_field)
       REFERENCES ir_model_fields(id) MATCH SIMPLE,
   add CONSTRAINT ir_act_server_link_field_id_fkey FOREIGN KEY(link_field_id)
       REFERENCES ir_model_fields(id) MATCH SIMPLE,
   add CONSTRAINT ir_act_server_menu_ir_values_id_fkey FOREIGN KEY(menu_ir_values_id)
       REFERENCES ir_values(id) MATCH SIMPLE,
   add CONSTRAINT ir_act_server_wkf_transition_id_fkey FOREIGN KEY(wkf_transition_id)
       REFERENCES wkf_transition(id) MATCH SIMPLE,
   add CONSTRAINT ir_act_server_sub_object_fkey FOREIGN KEY(sub_object)
       REFERENCES ir_model(id) MATCH SIMPLE,
   add CONSTRAINT ir_act_server_crud_model_id_fkey FOREIGN KEY(crud_model_id)
       REFERENCES ir_model(id) MATCH SIMPLE;

alter table ir_filters
   add column action_id int,
   add CONSTRAINT ir_filters_action_id_fkey FOREIGN KEY(action_id)
       REFERENCES ir_actions(id) MATCH SIMPLE;


alter table wkf_transition
   drop column trigger_type,
   add column sequence int;
update wkf_transition set sequence = 10;


alter table res_users
   drop column menu_id,
   add column password_crypt text;
   

alter table base_module_update
   drop column add,
   drop column update,
   add column added int,
   add column updated int;


alter table res_country
   add column image text;

alter table ir_model_fields
   drop column relate,
   drop column view_load;

alter table res_currency_rate
   drop column currency_rate_type_id;

commit;


-- alterações da sig
begin transaction;
delete from ir_ui_view where id = (select res_id from ir_model_data where name = 'user_groups_view');
delete from ir_model_data where name = 'user_groups_view';
delete from res_currency where name = 'GTQ';
delete from ir_rule where name = 'res_partner: portal/public: read access on my commercial partner';
update ir_model_data set module = 'base' where id = (select id from ir_model_data where name = 'group_portal')
insert into ir_model_data (noupdate, name, module, model, res_id) 
  values (true, 'financeiro_parametros_1', 'financeiro', 'financeiro.parametros', (select id from financeiro_parametros where company_id = 1));

update ir_model_data set res_id = (select id from financeiro_parametros where company_id = 1) where model = 'financeiro.parametros'
commit;