Parametros: db1 teste_9 db2 teste_7 u1 openerp u2 openerp p1 -p2 p2 None h1 localhost h2 localhost

--===============================================
--Tables in 'teste_9' that are not in 'teste_7'
--===============================================
begin;
SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET client_min_messages = warning;
SET row_security = off;

SET default_tablespace = '';

SET default_with_oids = false;

CREATE TABLE public.web_planner (
    id integer NOT NULL,
    menu_id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    name character varying NOT NULL,
    planner_application character varying NOT NULL,
    view_id integer NOT NULL,
    write_uid integer,
    write_date timestamp without time zone,
    active boolean,
    progress integer,
    data text,
    tooltip_planner text
);
COMMENT ON TABLE public.web_planner IS 'Planner';
COMMENT ON COLUMN public.web_planner.menu_id IS 'Menu';
COMMENT ON COLUMN public.web_planner.create_uid IS 'Created by';
COMMENT ON COLUMN public.web_planner.create_date IS 'Created on';
COMMENT ON COLUMN public.web_planner.name IS 'Name';
COMMENT ON COLUMN public.web_planner.planner_application IS 'Planner Application';
COMMENT ON COLUMN public.web_planner.view_id IS 'Template';
COMMENT ON COLUMN public.web_planner.write_uid IS 'Last Updated by';
COMMENT ON COLUMN public.web_planner.write_date IS 'Last Updated on';
COMMENT ON COLUMN public.web_planner.active IS 'Active';
COMMENT ON COLUMN public.web_planner.progress IS 'Progress Percentage';
COMMENT ON COLUMN public.web_planner.data IS 'Data';
COMMENT ON COLUMN public.web_planner.tooltip_planner IS 'Planner Tooltips';
CREATE SEQUENCE public.web_planner_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;
ALTER SEQUENCE public.web_planner_id_seq OWNED BY public.web_planner.id;
ALTER TABLE ONLY public.web_planner ALTER COLUMN id SET DEFAULT nextval('public.web_planner_id_seq'::regclass);
ALTER TABLE ONLY public.web_planner
    ADD CONSTRAINT web_planner_pkey PRIMARY KEY (id);
ALTER TABLE ONLY public.web_planner
    ADD CONSTRAINT web_planner_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;
ALTER TABLE ONLY public.web_planner
    ADD CONSTRAINT web_planner_menu_id_fkey FOREIGN KEY (menu_id) REFERENCES public.ir_ui_menu(id) ON DELETE SET NULL;
ALTER TABLE ONLY public.web_planner
    ADD CONSTRAINT web_planner_view_id_fkey FOREIGN KEY (view_id) REFERENCES public.ir_ui_view(id) ON DELETE SET NULL;
ALTER TABLE ONLY public.web_planner
    ADD CONSTRAINT web_planner_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;

CREATE TABLE public.ir_autovacuum (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer
);
COMMENT ON COLUMN public.ir_autovacuum.create_uid IS 'Created by';
COMMENT ON COLUMN public.ir_autovacuum.create_date IS 'Created on';
COMMENT ON COLUMN public.ir_autovacuum.write_date IS 'Last Updated on';
COMMENT ON COLUMN public.ir_autovacuum.write_uid IS 'Last Updated by';
CREATE SEQUENCE public.ir_autovacuum_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;
ALTER SEQUENCE public.ir_autovacuum_id_seq OWNED BY public.ir_autovacuum.id;
ALTER TABLE ONLY public.ir_autovacuum ALTER COLUMN id SET DEFAULT nextval('public.ir_autovacuum_id_seq'::regclass);
ALTER TABLE ONLY public.ir_autovacuum
    ADD CONSTRAINT ir_autovacuum_pkey PRIMARY KEY (id);
ALTER TABLE ONLY public.ir_autovacuum
    ADD CONSTRAINT ir_autovacuum_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;
ALTER TABLE ONLY public.ir_autovacuum
    ADD CONSTRAINT ir_autovacuum_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;

CREATE TABLE public.res_font (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    name character varying NOT NULL,
    family character varying NOT NULL,
    write_uid integer,
    mode character varying NOT NULL,
    write_date timestamp without time zone,
    path character varying NOT NULL
);
COMMENT ON TABLE public.res_font IS 'Fonts available';
COMMENT ON COLUMN public.res_font.create_uid IS 'Created by';
COMMENT ON COLUMN public.res_font.create_date IS 'Created on';
COMMENT ON COLUMN public.res_font.name IS 'Font Name';
COMMENT ON COLUMN public.res_font.family IS 'Font family';
COMMENT ON COLUMN public.res_font.write_uid IS 'Last Updated by';
COMMENT ON COLUMN public.res_font.mode IS 'Mode';
COMMENT ON COLUMN public.res_font.write_date IS 'Last Updated on';
COMMENT ON COLUMN public.res_font.path IS 'Path';
CREATE SEQUENCE public.res_font_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;
ALTER SEQUENCE public.res_font_id_seq OWNED BY public.res_font.id;
ALTER TABLE ONLY public.res_font ALTER COLUMN id SET DEFAULT nextval('public.res_font_id_seq'::regclass);
ALTER TABLE ONLY public.res_font
    ADD CONSTRAINT res_font_name_font_uniq UNIQUE (family, name);
ALTER TABLE ONLY public.res_font
    ADD CONSTRAINT res_font_pkey PRIMARY KEY (id);
ALTER TABLE ONLY public.res_font
    ADD CONSTRAINT res_font_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;
ALTER TABLE ONLY public.res_font
    ADD CONSTRAINT res_font_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;

CREATE TABLE public.res_users_log (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer
);
COMMENT ON TABLE public.res_users_log IS 'res.users.log';
COMMENT ON COLUMN public.res_users_log.create_uid IS 'Created by';
COMMENT ON COLUMN public.res_users_log.create_date IS 'Created on';
COMMENT ON COLUMN public.res_users_log.write_date IS 'Last Updated on';
COMMENT ON COLUMN public.res_users_log.write_uid IS 'Last Updated by';
CREATE SEQUENCE public.res_users_log_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;
ALTER SEQUENCE public.res_users_log_id_seq OWNED BY public.res_users_log.id;
ALTER TABLE ONLY public.res_users_log ALTER COLUMN id SET DEFAULT nextval('public.res_users_log_id_seq'::regclass);
ALTER TABLE ONLY public.res_users_log
    ADD CONSTRAINT res_users_log_pkey PRIMARY KEY (id);
ALTER TABLE ONLY public.res_users_log
    ADD CONSTRAINT res_users_log_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;
ALTER TABLE ONLY public.res_users_log
    ADD CONSTRAINT res_users_log_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;

CREATE TABLE public.report (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    write_date timestamp without time zone,
    write_uid integer
);
COMMENT ON TABLE public.report IS 'Report';
COMMENT ON COLUMN public.report.create_uid IS 'Created by';
COMMENT ON COLUMN public.report.create_date IS 'Created on';
COMMENT ON COLUMN public.report.write_date IS 'Last Updated on';
COMMENT ON COLUMN public.report.write_uid IS 'Last Updated by';
CREATE SEQUENCE public.report_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;
ALTER SEQUENCE public.report_id_seq OWNED BY public.report.id;
ALTER TABLE ONLY public.report ALTER COLUMN id SET DEFAULT nextval('public.report_id_seq'::regclass);
ALTER TABLE ONLY public.report
    ADD CONSTRAINT report_pkey PRIMARY KEY (id);
ALTER TABLE ONLY public.report
    ADD CONSTRAINT report_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;
ALTER TABLE ONLY public.report
    ADD CONSTRAINT report_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;

CREATE TABLE public.web_tip (
    id integer NOT NULL,
    create_uid integer,
    placement character varying,
    end_selector character varying,
    title character varying,
    description text NOT NULL,
    end_event character varying,
    write_uid integer,
    mode character varying,
    write_date timestamp without time zone,
    trigger_selector character varying,
    create_date timestamp without time zone,
    model character varying,
    type character varying,
    highlight_selector character varying,
    action_id integer
);
COMMENT ON TABLE public.web_tip IS 'Tips';
COMMENT ON COLUMN public.web_tip.create_uid IS 'Created by';
COMMENT ON COLUMN public.web_tip.placement IS 'Placement';
COMMENT ON COLUMN public.web_tip.end_selector IS 'End selector';
COMMENT ON COLUMN public.web_tip.title IS 'Tip title';
COMMENT ON COLUMN public.web_tip.description IS 'Tip Description';
COMMENT ON COLUMN public.web_tip.end_event IS 'End event';
COMMENT ON COLUMN public.web_tip.write_uid IS 'Last Updated by';
COMMENT ON COLUMN public.web_tip.mode IS 'Mode';
COMMENT ON COLUMN public.web_tip.write_date IS 'Last Updated on';
COMMENT ON COLUMN public.web_tip.trigger_selector IS 'Trigger selector';
COMMENT ON COLUMN public.web_tip.create_date IS 'Created on';
COMMENT ON COLUMN public.web_tip.model IS 'Model';
COMMENT ON COLUMN public.web_tip.type IS 'Type';
COMMENT ON COLUMN public.web_tip.highlight_selector IS 'Highlight selector';
COMMENT ON COLUMN public.web_tip.action_id IS 'Action';
CREATE SEQUENCE public.web_tip_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;
ALTER SEQUENCE public.web_tip_id_seq OWNED BY public.web_tip.id;
ALTER TABLE ONLY public.web_tip ALTER COLUMN id SET DEFAULT nextval('public.web_tip_id_seq'::regclass);
ALTER TABLE ONLY public.web_tip
    ADD CONSTRAINT web_tip_pkey PRIMARY KEY (id);
ALTER TABLE ONLY public.web_tip
    ADD CONSTRAINT web_tip_action_id_fkey FOREIGN KEY (action_id) REFERENCES public.ir_act_window(id) ON DELETE SET NULL;
ALTER TABLE ONLY public.web_tip
    ADD CONSTRAINT web_tip_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;
ALTER TABLE ONLY public.web_tip
    ADD CONSTRAINT web_tip_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;

CREATE TABLE public.res_country_res_country_group_rel (
    res_country_id integer NOT NULL,
    res_country_group_id integer NOT NULL
);
COMMENT ON TABLE public.res_country_res_country_group_rel IS 'RELATION BETWEEN res_country AND res_country_group';
ALTER TABLE ONLY public.res_country_res_country_group_rel
    ADD CONSTRAINT res_country_res_country_group_res_country_id_res_country_gr_key UNIQUE (res_country_id, res_country_group_id);
CREATE INDEX res_country_res_country_group_rel_res_country_group_id_idx ON public.res_country_res_country_group_rel USING btree (res_country_group_id);
CREATE INDEX res_country_res_country_group_rel_res_country_id_idx ON public.res_country_res_country_group_rel USING btree (res_country_id);
ALTER TABLE ONLY public.res_country_res_country_group_rel
    ADD CONSTRAINT res_country_res_country_group_rel_res_country_group_id_fkey FOREIGN KEY (res_country_group_id) REFERENCES public.res_country_group(id) ON DELETE CASCADE;
ALTER TABLE ONLY public.res_country_res_country_group_rel
    ADD CONSTRAINT res_country_res_country_group_rel_res_country_id_fkey FOREIGN KEY (res_country_id) REFERENCES public.res_country(id) ON DELETE CASCADE;

CREATE TABLE public.ir_config_parameter_groups_rel (
    icp_id integer NOT NULL,
    group_id integer NOT NULL
);
COMMENT ON TABLE public.ir_config_parameter_groups_rel IS 'RELATION BETWEEN ir_config_parameter AND res_groups';
ALTER TABLE ONLY public.ir_config_parameter_groups_rel
    ADD CONSTRAINT ir_config_parameter_groups_rel_icp_id_group_id_key UNIQUE (icp_id, group_id);
CREATE INDEX ir_config_parameter_groups_rel_group_id_idx ON public.ir_config_parameter_groups_rel USING btree (group_id);
CREATE INDEX ir_config_parameter_groups_rel_icp_id_idx ON public.ir_config_parameter_groups_rel USING btree (icp_id);
ALTER TABLE ONLY public.ir_config_parameter_groups_rel
    ADD CONSTRAINT ir_config_parameter_groups_rel_group_id_fkey FOREIGN KEY (group_id) REFERENCES public.res_groups(id) ON DELETE CASCADE;
ALTER TABLE ONLY public.ir_config_parameter_groups_rel
    ADD CONSTRAINT ir_config_parameter_groups_rel_icp_id_fkey FOREIGN KEY (icp_id) REFERENCES public.ir_config_parameter(id) ON DELETE CASCADE;

CREATE TABLE public.res_country_group (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    name character varying NOT NULL,
    write_uid integer,
    write_date timestamp without time zone
);
COMMENT ON TABLE public.res_country_group IS 'Country Group';
COMMENT ON COLUMN public.res_country_group.create_uid IS 'Created by';
COMMENT ON COLUMN public.res_country_group.create_date IS 'Created on';
COMMENT ON COLUMN public.res_country_group.name IS 'Name';
COMMENT ON COLUMN public.res_country_group.write_uid IS 'Last Updated by';
COMMENT ON COLUMN public.res_country_group.write_date IS 'Last Updated on';
CREATE SEQUENCE public.res_country_group_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;
ALTER SEQUENCE public.res_country_group_id_seq OWNED BY public.res_country_group.id;
ALTER TABLE ONLY public.res_country_group ALTER COLUMN id SET DEFAULT nextval('public.res_country_group_id_seq'::regclass);
ALTER TABLE ONLY public.res_country_group
    ADD CONSTRAINT res_country_group_pkey PRIMARY KEY (id);
ALTER TABLE ONLY public.res_country_group
    ADD CONSTRAINT res_country_group_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;
ALTER TABLE ONLY public.res_country_group
    ADD CONSTRAINT res_country_group_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;

CREATE TABLE public.web_editor_converter_test_sub (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    name character varying,
    write_uid integer,
    write_date timestamp without time zone
);
COMMENT ON TABLE public.web_editor_converter_test_sub IS 'web_editor.converter.test.sub';
COMMENT ON COLUMN public.web_editor_converter_test_sub.create_uid IS 'Created by';
COMMENT ON COLUMN public.web_editor_converter_test_sub.create_date IS 'Created on';
COMMENT ON COLUMN public.web_editor_converter_test_sub.name IS 'unknown';
COMMENT ON COLUMN public.web_editor_converter_test_sub.write_uid IS 'Last Updated by';
COMMENT ON COLUMN public.web_editor_converter_test_sub.write_date IS 'Last Updated on';
CREATE SEQUENCE public.web_editor_converter_test_sub_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;
ALTER SEQUENCE public.web_editor_converter_test_sub_id_seq OWNED BY public.web_editor_converter_test_sub.id;
ALTER TABLE ONLY public.web_editor_converter_test_sub ALTER COLUMN id SET DEFAULT nextval('public.web_editor_converter_test_sub_id_seq'::regclass);
ALTER TABLE ONLY public.web_editor_converter_test_sub
    ADD CONSTRAINT web_editor_converter_test_sub_pkey PRIMARY KEY (id);
ALTER TABLE ONLY public.web_editor_converter_test_sub
    ADD CONSTRAINT web_editor_converter_test_sub_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;
ALTER TABLE ONLY public.web_editor_converter_test_sub
    ADD CONSTRAINT web_editor_converter_test_sub_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;

CREATE TABLE public.ir_sequence_date_range (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    number_next integer NOT NULL,
    date_from date NOT NULL,
    write_uid integer,
    sequence_id integer NOT NULL,
    write_date timestamp without time zone,
    date_to date NOT NULL
);
COMMENT ON TABLE public.ir_sequence_date_range IS 'ir.sequence.date_range';
COMMENT ON COLUMN public.ir_sequence_date_range.create_uid IS 'Created by';
COMMENT ON COLUMN public.ir_sequence_date_range.create_date IS 'Created on';
COMMENT ON COLUMN public.ir_sequence_date_range.number_next IS 'Next Number';
COMMENT ON COLUMN public.ir_sequence_date_range.date_from IS 'From';
COMMENT ON COLUMN public.ir_sequence_date_range.write_uid IS 'Last Updated by';
COMMENT ON COLUMN public.ir_sequence_date_range.sequence_id IS 'Main Sequence';
COMMENT ON COLUMN public.ir_sequence_date_range.write_date IS 'Last Updated on';
COMMENT ON COLUMN public.ir_sequence_date_range.date_to IS 'To';
CREATE SEQUENCE public.ir_sequence_date_range_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;
ALTER SEQUENCE public.ir_sequence_date_range_id_seq OWNED BY public.ir_sequence_date_range.id;
ALTER TABLE ONLY public.ir_sequence_date_range ALTER COLUMN id SET DEFAULT nextval('public.ir_sequence_date_range_id_seq'::regclass);
ALTER TABLE ONLY public.ir_sequence_date_range
    ADD CONSTRAINT ir_sequence_date_range_pkey PRIMARY KEY (id);
ALTER TABLE ONLY public.ir_sequence_date_range
    ADD CONSTRAINT ir_sequence_date_range_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;
ALTER TABLE ONLY public.ir_sequence_date_range
    ADD CONSTRAINT ir_sequence_date_range_sequence_id_fkey FOREIGN KEY (sequence_id) REFERENCES public.ir_sequence(id) ON DELETE CASCADE;
ALTER TABLE ONLY public.ir_sequence_date_range
    ADD CONSTRAINT ir_sequence_date_range_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;

CREATE TABLE public.res_users_web_tip_rel (
    web_tip_id integer NOT NULL,
    res_users_id integer NOT NULL
);
COMMENT ON TABLE public.res_users_web_tip_rel IS 'RELATION BETWEEN web_tip AND res_users';
ALTER TABLE ONLY public.res_users_web_tip_rel
    ADD CONSTRAINT res_users_web_tip_rel_web_tip_id_res_users_id_key UNIQUE (web_tip_id, res_users_id);
CREATE INDEX res_users_web_tip_rel_res_users_id_idx ON public.res_users_web_tip_rel USING btree (res_users_id);
CREATE INDEX res_users_web_tip_rel_web_tip_id_idx ON public.res_users_web_tip_rel USING btree (web_tip_id);
ALTER TABLE ONLY public.res_users_web_tip_rel
    ADD CONSTRAINT res_users_web_tip_rel_res_users_id_fkey FOREIGN KEY (res_users_id) REFERENCES public.res_users(id) ON DELETE CASCADE;
ALTER TABLE ONLY public.res_users_web_tip_rel
    ADD CONSTRAINT res_users_web_tip_rel_web_tip_id_fkey FOREIGN KEY (web_tip_id) REFERENCES public.web_tip(id) ON DELETE CASCADE;

CREATE TABLE public.ir_logging (
    id integer NOT NULL,
    create_uid integer,
    create_date timestamp without time zone,
    name character varying NOT NULL,
    level character varying,
    line character varying NOT NULL,
    dbname character varying,
    write_uid integer,
    func character varying NOT NULL,
    write_date timestamp without time zone,
    path character varying NOT NULL,
    message text NOT NULL,
    type character varying NOT NULL
);
COMMENT ON TABLE public.ir_logging IS 'ir.logging';
COMMENT ON COLUMN public.ir_logging.create_uid IS 'Uid';
COMMENT ON COLUMN public.ir_logging.create_date IS 'Create Date';
COMMENT ON COLUMN public.ir_logging.name IS 'Name';
COMMENT ON COLUMN public.ir_logging.level IS 'Level';
COMMENT ON COLUMN public.ir_logging.line IS 'Line';
COMMENT ON COLUMN public.ir_logging.dbname IS 'Database Name';
COMMENT ON COLUMN public.ir_logging.write_uid IS 'Last Updated by';
COMMENT ON COLUMN public.ir_logging.func IS 'Function';
COMMENT ON COLUMN public.ir_logging.write_date IS 'Last Updated on';
COMMENT ON COLUMN public.ir_logging.path IS 'Path';
COMMENT ON COLUMN public.ir_logging.message IS 'Message';
COMMENT ON COLUMN public.ir_logging.type IS 'Type';
CREATE SEQUENCE public.ir_logging_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;
ALTER SEQUENCE public.ir_logging_id_seq OWNED BY public.ir_logging.id;
ALTER TABLE ONLY public.ir_logging ALTER COLUMN id SET DEFAULT nextval('public.ir_logging_id_seq'::regclass);
ALTER TABLE ONLY public.ir_logging
    ADD CONSTRAINT ir_logging_pkey PRIMARY KEY (id);
CREATE INDEX ir_logging_dbname_index ON public.ir_logging USING btree (dbname);
CREATE INDEX ir_logging_level_index ON public.ir_logging USING btree (level);
CREATE INDEX ir_logging_type_index ON public.ir_logging USING btree (type);
ALTER TABLE ONLY public.ir_logging
    ADD CONSTRAINT ir_logging_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;

CREATE TABLE public.report_paperformat (
    id integer NOT NULL,
    create_uid integer,
    page_width integer,
    create_date timestamp without time zone,
    name character varying NOT NULL,
    format character varying,
    "default" boolean,
    header_line boolean,
    header_spacing integer,
    dpi integer NOT NULL,
    write_uid integer,
    margin_right double precision,
    margin_top double precision,
    margin_left double precision,
    write_date timestamp without time zone,
    margin_bottom double precision,
    page_height integer,
    orientation character varying
);
COMMENT ON TABLE public.report_paperformat IS 'Allows customization of a report.';
COMMENT ON COLUMN public.report_paperformat.create_uid IS 'Created by';
COMMENT ON COLUMN public.report_paperformat.page_width IS 'Page width (mm)';
COMMENT ON COLUMN public.report_paperformat.create_date IS 'Created on';
COMMENT ON COLUMN public.report_paperformat.name IS 'Name';
COMMENT ON COLUMN public.report_paperformat.format IS 'Paper size';
COMMENT ON COLUMN public.report_paperformat."default" IS 'Default paper format ?';
COMMENT ON COLUMN public.report_paperformat.header_line IS 'Display a header line';
COMMENT ON COLUMN public.report_paperformat.header_spacing IS 'Header spacing';
COMMENT ON COLUMN public.report_paperformat.dpi IS 'Output DPI';
COMMENT ON COLUMN public.report_paperformat.write_uid IS 'Last Updated by';
COMMENT ON COLUMN public.report_paperformat.margin_right IS 'Right Margin (mm)';
COMMENT ON COLUMN public.report_paperformat.margin_top IS 'Top Margin (mm)';
COMMENT ON COLUMN public.report_paperformat.margin_left IS 'Left Margin (mm)';
COMMENT ON COLUMN public.report_paperformat.write_date IS 'Last Updated on';
COMMENT ON COLUMN public.report_paperformat.margin_bottom IS 'Bottom Margin (mm)';
COMMENT ON COLUMN public.report_paperformat.page_height IS 'Page height (mm)';
COMMENT ON COLUMN public.report_paperformat.orientation IS 'Orientation';
CREATE SEQUENCE public.report_paperformat_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;
ALTER SEQUENCE public.report_paperformat_id_seq OWNED BY public.report_paperformat.id;
ALTER TABLE ONLY public.report_paperformat ALTER COLUMN id SET DEFAULT nextval('public.report_paperformat_id_seq'::regclass);
ALTER TABLE ONLY public.report_paperformat
    ADD CONSTRAINT report_paperformat_pkey PRIMARY KEY (id);
ALTER TABLE ONLY public.report_paperformat
    ADD CONSTRAINT report_paperformat_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;
ALTER TABLE ONLY public.report_paperformat
    ADD CONSTRAINT report_paperformat_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;

CREATE TABLE public.web_editor_converter_test (
    id integer NOT NULL,
    "binary" bytea,
    selection integer,
    create_date timestamp without time zone,
    create_uid integer,
    text text,
    "float" double precision,
    "numeric" numeric,
    datetime timestamp without time zone,
    "char" character varying,
    html text,
    selection_str character varying,
    write_date timestamp without time zone,
    many2one integer,
    date date,
    "integer" integer,
    write_uid integer
);
COMMENT ON TABLE public.web_editor_converter_test IS 'web_editor.converter.test';
COMMENT ON COLUMN public.web_editor_converter_test."binary" IS 'unknown';
COMMENT ON COLUMN public.web_editor_converter_test.selection IS 'unknown';
COMMENT ON COLUMN public.web_editor_converter_test.create_date IS 'Created on';
COMMENT ON COLUMN public.web_editor_converter_test.create_uid IS 'Created by';
COMMENT ON COLUMN public.web_editor_converter_test.text IS 'unknown';
COMMENT ON COLUMN public.web_editor_converter_test."float" IS 'unknown';
COMMENT ON COLUMN public.web_editor_converter_test."numeric" IS 'unknown';
COMMENT ON COLUMN public.web_editor_converter_test.datetime IS 'unknown';
COMMENT ON COLUMN public.web_editor_converter_test."char" IS 'unknown';
COMMENT ON COLUMN public.web_editor_converter_test.html IS 'unknown';
COMMENT ON COLUMN public.web_editor_converter_test.selection_str IS 'Lorsqu''un pancake prend l''avion à destination de Toronto et qu''il fait une escale technique à St Claude, on dit:';
COMMENT ON COLUMN public.web_editor_converter_test.write_date IS 'Last Updated on';
COMMENT ON COLUMN public.web_editor_converter_test.many2one IS 'unknown';
COMMENT ON COLUMN public.web_editor_converter_test.date IS 'unknown';
COMMENT ON COLUMN public.web_editor_converter_test."integer" IS 'unknown';
COMMENT ON COLUMN public.web_editor_converter_test.write_uid IS 'Last Updated by';
CREATE SEQUENCE public.web_editor_converter_test_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;
ALTER SEQUENCE public.web_editor_converter_test_id_seq OWNED BY public.web_editor_converter_test.id;
ALTER TABLE ONLY public.web_editor_converter_test ALTER COLUMN id SET DEFAULT nextval('public.web_editor_converter_test_id_seq'::regclass);
ALTER TABLE ONLY public.web_editor_converter_test
    ADD CONSTRAINT web_editor_converter_test_pkey PRIMARY KEY (id);
ALTER TABLE ONLY public.web_editor_converter_test
    ADD CONSTRAINT web_editor_converter_test_create_uid_fkey FOREIGN KEY (create_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;
ALTER TABLE ONLY public.web_editor_converter_test
    ADD CONSTRAINT web_editor_converter_test_many2one_fkey FOREIGN KEY (many2one) REFERENCES public.web_editor_converter_test_sub(id) ON DELETE SET NULL;
ALTER TABLE ONLY public.web_editor_converter_test
    ADD CONSTRAINT web_editor_converter_test_write_uid_fkey FOREIGN KEY (write_uid) REFERENCES public.res_users(id) ON DELETE SET NULL;

--===============================================
--Tables in 'teste_7' that are not in 'teste_9'
--===============================================

drop table if exists process_process, base_module_import, ir_act_wizard, res_partner_bank_type, res_request_history cascade;
drop table if exists process_transition_ids, ir_fields_converter, multi_company_default, res_partner_bank_type_field cascade;
drop table if exists process_node, process_transition_action, osv_memory_autovacuum, ir_actions_configuration_wizard cascade;
drop table if exists res_groups_wizard_rel, ir_default, res_currency_rate_type, wkf_logs, ir_sequence_type cascade;
drop table if exists process_condition, ir_ui_view_sc, process_transition, res_request, process_transition_group_rel cascade:

--=================================================================
-- Tables that are in both databases but have different attributes
--=================================================================
alter table  public.ir_model_constraint
   add column definition text;
-------------------------------------------------------------------
--| rml_paper_format: text       |                                |
--| phone: text                  |                                |
--| font: int                    |                                |
--| email: text                  |                                |
--| paperformat_id: int          |                                |
--|                                | paper_format: text             |
-------------------------------------------------------------------
alter table public.res_company
   add column rml_paper_format text,
   add column phone text,
   add column font int,
   add column email text,
   add column paperformat_id int,
   drop column paper_format;

-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| use_date_range: bool         |                                |
-------------------------------------------------------------------
alter table public.ir_sequence
   add column use_date_range bool;

--There are differences in the table 'public.res_currency'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--|                                | date: date                     |
--|                                | base: bool                     |
--|                                | company_id: int                |
--|                                | accuracy: int                  |
-------------------------------------------------------------------
alter table public.res_currency
   DROP COLUMN date,
   drop column base,
   drop column company_id,
   drop column accuracy;

--There are differences in the table 'public.ir_act_report_xml'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| paperformat_id: int          |                                |
--| ir_values_id: int            |                                |
--| parser: text                 |                                |
-------------------------------------------------------------------
alter table public.ir_act_report_xml
   add column paperformat_id int,
   add column ir_values_id int,
   add column parser text;


--There are differences in the table 'public.res_partner'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| display_name: text           |                                |
--| barcode: text                |                                |
--| company_type: text           |                                |
--| commercial_partner_id: int   |                                |
--|                                | ean13: text                    |
--|                                | image: bytea                   |
--|                                | image_medium: bytea            |
--|                                | image_small: bytea             |
-------------------------------------------------------------------
alter table public.res_partner
   add column display_name,
   add column barcode text,
   add column company_type text,
   add column commercial_partner_id int;
update public.res_partner
   set barcode = ean13;
alter table public.res_partner
   drop column ean13,
   drop column image,
   drop column image_medium,
   drop column image_small;
--There are differences in the table 'public.ir_module_module'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--|                                | complexity: text               |
-------------------------------------------------------------------
alter table public.ir_module_module
   drop column complexity;
--There are differences in the table 'public.ir_module_module_dependency'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--|                                | version_pattern: text          |
-------------------------------------------------------------------
alter table public.ir_module_module_dependency
   drop column version_pattern;
--There are differences in the table 'public.ir_ui_view'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| arch_db: text                |                                |
--| model_data_id: int           |                                |
--| mode: text                   |                                |
--| key: text                    |                                |
--| active: bool                 |                                |
--| arch_fs: text                |                                |
--|                                | arch: text                     |
-------------------------------------------------------------------
alter table public.ir_ui_view
   add column arch_db text,
   add column model_data_id int,
   add column mode text,
   add column key text,
   add column active bool,
   add column arch_fs text;
update public.ir_ui_view
   set arch_fs  = arch;
alter table public.ir_ui_view
   drop column arch;

--There are differences in the table 'public.ir_attachment'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| mimetype: text               |                                |
--| checksum: text               |                                |
--| public: bool                 |                                |
--| res_field: text              |                                |
--| index_content: text          |                                |
-------------------------------------------------------------------
alter table public.ir_attachment
   add column mimetype text,
   add column checksum text,
   add column public text,
   add column res_field text,
   add column index_content text;
--There are differences in the table 'public.ir_values'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--|                                | meta: text                     |
-------------------------------------------------------------------
alter table public.ir_values
   drop column meta;
--There are differences in the table 'public.res_partner_title'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--|                                | domain: text                   |
-------------------------------------------------------------------
alter table public.ir_values
   drop column domain;
--There are differences in the table 'public.base_language_import'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| filename: text               |                                |
-------------------------------------------------------------------
alter table public.base_language_import
   add column filename text;
--There are differences in the table 'public.ir_act_server'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| use_relational_model: text   |                                |
--| write_expression: text       |                                |
--| wkf_field_id: int            |                                |
--| sub_model_object_field: int  |                                |
--| use_create: text             |                                |
--| crud_model_id: int           |                                |
--| model_object_field: int      |                                |
--| ref_object: text             |                                |
--| id_object: text              |                                |
--| link_field_id: int           |                                |
--| menu_ir_values_id: int       |                                |
--| link_new_record: bool        |                                |
--| wkf_transition_id: int       |                                |
--| id_value: text               |                                |
--| sub_object: int              |                                |
--| use_write: text              |                                |
--| crud_model_name: text        |                                |
--| wkf_model_name: text         |                                |
--| copyvalue: text              |                                |
--|                                | loop_action: int               |
--|                                | trigger_obj_id: int            |
--|                                | mobile: text                   |
--|                                | copy_object: text              |
--|                                | sms: text                      |
--|                                | email: text                    |
--|                                | record_id: int                 |
--|                                | write_id: text                 |
--|                                | srcmodel_id: int               |
--|                                | message: text                  |
--|                                | expression: text               |
--|                                | trigger_name: text             |
--|                                | subject: text                  |
-------------------------------------------------------------------
alter table 'public.ir_act_server
   add column use_relational_model text,
   add column write_expression text,
   add column  wkf_field_id int,
   add column  sub_model_object_field int,
   add column  use_create text,
   add column  crud_model_id int,
   add column  model_object_field int,
   add column  ref_object text,
   add column  id_object text,
   add column  link_field_id int,
   add column  menu_ir_values_id int,
   add column  link_new_record bool,
   add column  wkf_transition_id int,
   add column  id_value text,
   add column  sub_object int,
   add column  use_write text,
   add column  crud_model_name text,
   add column  wkf_model_name text,
   add column  copyvalue text;
alter table 'public.ir_act_server
   drop column loop_action,
   drop column trigger_obj_id,
   drop column mobile,
   drop column copy_object,
   drop column sms,
   drop column email,
   drop column record_id,
   drop column write_id,
   drop column srcmodel_id,
   drop column message,
   drop column expression,
   drop column trigger_name,
   drop column subject;
--There are differences in the table 'public.ir_filters'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| sort: text                   |                                |
--| active: bool                 |                                |
--| action_id: int               |                                |
-------------------------------------------------------------------
alter table public.ir_filters
   add column sort text,
   add column active bool,
   add column action_id int;
update public.ir_filters
   set active is True;
--There are differences in the table 'public.res_groups'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| color: int                   |                                |
--| share: bool                  |                                |
-------------------------------------------------------------------
alter table public.res_groups
   add column color int,
   add column share bool;

--There are differences in the table 'public.wkf_transition'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| sequence: int                |                                |
--|                                | trigger_type: text             |
-------------------------------------------------------------------
alter table public.wkf_transition
   drop column trigger_type;

--There are differences in the table 'public.res_users'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| password_crypt: text         |                                |
--| share: bool                  |                                |
--|                                | menu_id: int                   |
--|                                | login_date: date               |
-------------------------------------------------------------------
alter table public.res_users
   add column password_crypt text,
   add column share bool,
   drop column menu_id,
   drop column login_date;
--There are differences in the table 'public.base_module_update'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| updated: int                 |                                |
--| added: int                   |                                |
--|                                | add: int                       |
--|                                | update: int                    |
-------------------------------------------------------------------
alter table public.base_module_update
   rename column add to added,
   rename column update to updated;
--There are differences in the table 'public.res_partner_category'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| color: int                   |                                |
-------------------------------------------------------------------
alter table public.res_partner_category
   drop column color;
--There are differences in the table 'public.res_country'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| phone_code: int              |                                |
-------------------------------------------------------------------
alter table public.res_country
   drop column phone_code;
--There are differences in the table 'public.ir_model_fields'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| index: bool                  |                                |
--| compute: text                |                                |
--| help: text                   |                                |
--| relation_table: text         |                                |
--| related: text                |                                |
--| depends: text                |                                |
--| copy: bool                   |                                |
--| column1: text                |                                |
--| column2: text                |                                |
--|                                | relate: bool                   |
--|                                | select_level: text             |
--|                                | view_load: bool                |
-------------------------------------------------------------------
alter table public.ir_model_fields
   add column index bool,
   add column compute text,
   add column help text,
   add column relation_table text,
   add column related text,
   add column depends text,
   add column copy bool,
   add column column1 text,
   add column column2 text,
   drop column relate,
   drop column select_lever,
   drop column view_load;
--There are differences in the table 'public.ir_model'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| transient: bool              |                                |
-------------------------------------------------------------------
alter table public.ir_model
   add column transient bool;
--There are differences in the table 'public.res_currency_rate'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| company_id: int              |                                |
--|                                | currency_rate_type_id: int     |
-------------------------------------------------------------------
alter table public.res_currency_rate
   drop column currency_rate_type_id;
--There are differences in the table 'public.ir_ui_menu'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| action: text                 |                                |
--|                                | web_icon_data: bytea           |
--|                                | needaction_enabled: bool       |
--|                                | web_icon_hover: text           |
--|                                | web_icon_hover_data: bytea     |
--|                                | icon: text                     |
-------------------------------------------------------------------
alter table public.ir_ui_menu
   add column action text,
   drop column web_icon_data,
   drop column needaction_enabled,
   drop column web_icon_hover,
   drop column web_icon_hover_data,
   drop column icon;
--There are differences in the table 'public.res_partner_bank'
-------------------------------------------------------------------
--| teste_9                        | teste_7                        |
-------------------------------------------------------------------
--| currency_id: int             |                                |
--| bank_id: int                 |                                |
--| sanitized_acc_number: text   |                                |
--|                                | bank_name: text                |
--|                                | owner_name: text               |
--|                                | bank_bic: text                 |
--|                                | zip: text                      |
--|                                | city: text                     |
--|                                | footer: bool                   |
--|                                | country_id: int                |
--|                                | state: text                    |
--|                                | street: text                   |
--|                                | state_id: int                  |
--|                                | bank: int                      |
--|                                | name: text                     |
-------------------------------------------------------------------
alter table public.res_partner_bank
   add column currency_id int,
   add column bank_id int,
   add column sanitized_acc_number text,
   drop column bank_name,
   drop column owner_name,
   drop column bank_bic,
   drop column zip,