# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009-2014 All Rights Reserved. Luiz Fernando Maciel Franca
#                     www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


from openerp.osv import osv, fields
from datetime import datetime
import time
from dateutil.parser import parse
from openerp.tools.translate import _

class estoquepedidos_pedido_capa(osv.Model):
    """
    Pedidos
    """
    _inherit = 'estoquepedidos.pedido.capa'

    def default_get(self, cr, uid, fields_list, context=None):
        context = context and context.copy() or {}
        res = super(estoquepedidos_pedido_capa, self).default_get(cr, uid, fields_list, context)
        if context.get('view_name') == 'estoquepedidos_venda':
            res['data_entrega'] = datetime.strftime(self.pool.get('adm.utils').
                                                      admutl_converte_tz(cr, uid, datetime.now(),
                                                      'UTC', context=context), '%Y-%m-%d')
        if context.get('tree_view_ref') == 'delivery.view_delivery_estoquepedidos_pedido_tree':
            raise osv.except_osv(_('Atencao'), _('Nao e possivel criar pedido por esse menu.'))
        return res

    def pedcap_button_delivery_montar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        context.update({'pedcap_write_state': True})
        vals = {'state': 'E', 'pedcap_montagem_inicio': datetime.now()}
        res = self.write(cr, uid, ids, vals, context)
        return res

    def pedcap_button_delivery_encerrar_montagem(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        context.update({'pedcap_write_state': True})
        vals = {'state': 'O', 'pedcap_montagem_fim': datetime.now()}
        for pedido in self.browse(cr, uid, ids, context):
            pedido_item_ids = list()
            for item in pedido.pedido_item_ids:
                if item.qtde_atendida:
                    continue
                pedido_item_ids.append((1, item.id, {'qtde_atendida': item.qtde_pedida}))
            if pedido_item_ids:
                vals.update({'pedido_item_ids': pedido_item_ids})
            res = self.write(cr, uid, [pedido.id], vals, context)
        return res

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        if context.get('delivery_montagem'):
            order = 'pedcap_origem ASC, pedcap_horario_entrega ASC'
        res = super(estoquepedidos_pedido_capa, self).search(cr, uid, args, offset, limit, order,
                                                             context, count)
        return res

    def pedcap_get_dado_extra(self, cr, uid, ids, context=None):
        """
        O metodo encontra os dados que se encontram nesse modulo, necessarios para a impressao
        dos pedidos.
        :param cr: cursor no banco de dados.
        :type: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type: integer
        :param ids: lista de id da tabela desse objeto.
        :type: list
        :param context: dicionario com valores contextuais.
        :type: dict
        :return: dicionario. Cada chave representa um id de um pedido. Cada valor dessa chave e um
        dicionario com os campos e seus respectivos valores.
        :rtype: dict
        """
        if not isinstance(ids, list):
            ids = [ids]
        context = context and context.copy() or {}
        res = super(estoquepedidos_pedido_capa, self).pedcap_get_dado_extra(cr, uid, ids, context)
        brw_pedido_capa = self.browse(cr, uid, ids, context)
        obj_adm_utils = self.pool.get('adm.utils')
        for pedido in brw_pedido_capa:
            horario_entrega = pedido.pedcap_horario_entrega or ''
            if horario_entrega:
                horario_entrega = obj_adm_utils.admutl_float_to_time(horario_entrega)
            data_entrega = pedido.data_entrega or ''
            if data_entrega:
                data_entrega = parse(data_entrega).strftime('%d/%m/%Y')
            origem = pedido.pedcap_origem or ''
            if origem == '1':
                origem = 'Balcao'
            elif origem == '2':
                origem = 'Externo'
            condicao_ids = {}
            map(lambda i: condicao_ids.update({i.id: i.pedcdc_valor_troco or 0}),
                pedido.pedido_condicao_ids)
            vals = {
                'horario_entrega': horario_entrega,
                'origem': origem,
                'condicao_dados': condicao_ids,
                'data_entrega': data_entrega
            }
            if pedido.id in res.keys():
                res[pedido.id].update(vals)
            else:
                res[pedido.id] = vals
        return res
