#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv

# TIPO DE CARREGAMENTO A SER UTILIZADO NO READ
READ_LOAD = '_classic_write'


class control_legado_empresa(osv.Model):

    _inherit = 'legado.empresa'
    _message_erro = ''
    _tem_erro = ''

    def legemp_get_erro(self):
        return self._message_erro

    def legemp_clear_globals(self):
        # ALTERA AS VARIAVEIS GLOBAIS DE MENSAGEM DE ERRO E TEM ERRO PARA VAZIO E FALSE
        self._message_erro = ''
        self._tem_erro = False
        return True

    def legemp_read_all_data(self, cr, uid, args=[], fields_to_read=[], context=None):
        """
        FUNCAO REALIZA PESQUISA(args=[]) E LEITURA(fields_to_read=[]) NO OBJETO
        """
        context = context and context.copy() or {}
        self.legemp_clear_globals()

        res = []
        leg_empresa_ids = self.search(cr, uid, args, context=context)
        if not leg_empresa_ids:
            self._message_erro += 'Nenhuma Correlacao de Empresas cadastradas, '
            if not fields_to_read:
                # SE NENHUM CAMPO FOI ESCOLHIDO PARA SER LIDO, LE TODOS OS CAMPOS
                fields_to_read = self._columns.keys()
            leg_empresa_dados = self.read(cr, uid, leg_empresa_ids, fields_to_read, context=context, load=READ_LOAD)
            res = leg_empresa_dados
        if self._message_erro:
            self._tem_erro = True
        return res

