#!/usr/bin/python
# -*- coding: utf-8 -*-
"""
Criar uma estrutura de diretorios para que este exportador possa ser integrado com o integra.py
Em qualquer pasta, crie a seguinte estrutura
arquivos
arquivos/int
arquivos/logs
objetos

Dentro da pasta objetos crie o arquivo sigerp.cfg com a seguinte estrutura:
hostname,username,password,porta,database,dbhostname,dbuser,dbpasswd
localhost,admin,admin,8062,trunk_teste,localhost,luiz,
"""
idPrograma='export_emc.py'
idVersao='Versao 1.01 de 06/07/2017'
idObs='Copyrigth by Sig Informatica Ltda'
from SigUtils import datas
from SigUtils import numero
import os
import time
from re import sub as re_sub

_hoje = datas.getDataDeHoje('I', '')

print '*** Exportador de arquivos do sistema EMC ***'
try:
    import fdb
except:
    print 'instale o modulo python_fdb!'
    exit()

fdb_db = raw_input('DB do Emc: (/var/firebird/modamix.fdb)')
if not fdb_db:
    fdb_db = '/var/firebird/modamix.fdb'

try:
    con = fdb.connect(dsn=fdb_db, user='sysdba', password='masterkey')
    cur = con.cursor()
except:
    print 'Nao consegui conectar com o DB Emc!'
    exit()
diretorio = raw_input('Diretorio para gerar arquivos:(/tmp/arquivos/int) ')
if not diretorio:
    diretorio = '/tmp/arquivos/int'
ultima_hora = 0

def get_nome_arquivo(arquivo):
    _horas = datas.getDataDeHoje('H', '')
    _arq = diretorio + '/' + arquivo + '_' + _hoje + '_' + _horas + '_001_X'
    return _arq

def ver_se_tem_tributacao(aliquota, base, tipo, reducao):
    """
    Método para verificar se já existe uma tributacao, se não existir inclui na lista de tributações para gerar o est14
    :param aliquota: Aliquota do imposto
    :param base: percentual da base do imposto
    :param tipo: tipo T=Tributado, U=Substituicao, I=Isento, O=Outros, D = Diferido
    :param reducao: Percentual de redução da base
    :return: Codigo da tributacao
    """
    codigo = 0
    for tribut in lista_tributacao:
        codigo = tribut.get('codigo')
        if tribut.get('aliquota') != aliquota:
            continue
        if tribut.get('base') != base:
            continue
        if tribut.get('tipo') != tipo:
            continue
        if tribut.get('reducao') != reducao:
            continue
        return tribut.get('codigo')
    codigo =+ 1
    lista_tributacao.append({
        'codigo': codigo,
        'aliquota': aliquota,
        'base': base,
        'tipo': tipo,
        'reducao': reducao,
    })
    return codigo

def exportar_produto():
    def _gerar_est01(linha):
        # Gerar Est01 cadastro
        cod_peca = str(linha.get('CODIGO'))
        digito = '0'
        unidade = linha.get('UNIDADE')
        subgrupo = linha.get('SUBGRUPO') or '000'
        if subgrupo != '000':
            dcGrupoSubgrupo[linha.get('GRUPO')] = subgrupo
        chave_2_grupos = linha.get('GRUPO') + subgrupo +'000000'
        margem_ideal = '0'
        margem_min = numero.getNumToStr(linha.get('MARGEMREAJUSTE') or '0', 3, 2, 'N')
        margem_bruta = numero.getNumToStr(linha.get('MARGEMLUCRO') or '0', 3, 2, 'N')
        mva = '00000'
        cst_no_estado = linha.get('CST')
        cst_fora_estado = linha.get('CST')
        cst_produtor_rural = linha.get('CST')
        cst_ultima_entrada = '000'
        aliquota = numero.getNumToStr(linha.get('ALIQUOTA_ICMS') or '0', 2, 2, 'N')
        base = '100'
        tipo = 'T'
        if cst_no_estado[1:] in ('00', '20'):
            tipo = 'T'
        if cst_no_estado[1:] in ('10', '30', '60', '70'):
            tipo = 'U'
        if cst_no_estado[1:] == '40':
            tipo = 'I'
        if cst_no_estado[1:] in ('41', '50', '90'):
            tipo = 'O'
        if cst_no_estado[1:] == '51':
            tipo = 'O'
        reducao = '0'
        codigo_tribut = str(ver_se_tem_tributacao(aliquota,base,tipo,reducao))
        cod_tribut_cons_final = codigo_tribut
        cod_tribut_contribuin = codigo_tribut
        cod_tribut_prod_rural = codigo_tribut
        cod_tribut_entrada = '000'
        cod_tribut_subst = '000'
        cod_tribut_entrada_sub = '000'
        aliq_ipi = numero.getNumToStr(linha.get('ALIQUOTA_IPI') or '0', 2, 2, 'N')
        classif_fiscal = ''
        classif_ncm = linha.get('CLASSE_IPI')
        pis = ''
        pis_cst_entrada = linha.get('CSTPIS_COMPRA')
        pis_cst_saida = linha.get('CSTPIS_VENDA')
        pis_nat_rec = linha.get('NATUREZA_PIS_COFINS')
        cofins = ''
        cofins_cst_entrada = linha.get('CSTCOFINS_COMPRA')
        cofins_cst_saida = linha.get('CSTCOFINS_VENDA')
        cofins_nat_rec = ''
        fornecedor_principal = ''
        representante = ''
        tempo_reposicao = '000'
        tem_grade = 'N'
        comprador = ''
        tem_nro_serie = 'N'
        politica_preco = ''
        conta_custo = ''
        servico_agregado = ''
        kit_mercadorias = ''
        kit_tipo_preco = ''
        kit_montagem = ''
        cod_ex_ipi = linha.get('EX_IPI')
        vazio = ''
        cod_genero = linha.get('COD_GEN')
        cod_tab_servicos = ''
        ultima_pauta = ''
        producao = ''
        tipo_item = ''
        codigo_anp = linha.get('CODIGO_ANP')
        codigo_cest = linha.get('COD_CEST')
        campos_01 = (cod_peca, digito, unidade, chave_2_grupos, margem_ideal, margem_min, margem_bruta, mva, cst_no_estado,
                  cst_fora_estado, cst_produtor_rural, cst_ultima_entrada, cod_tribut_cons_final, cod_tribut_contribuin,
                  cod_tribut_prod_rural, cod_tribut_entrada, cod_tribut_subst, cod_tribut_entrada_sub, aliq_ipi,
                  classif_fiscal, classif_ncm, pis, pis_cst_entrada, pis_cst_saida, pis_nat_rec, cofins,
                  cofins_cst_entrada, cofins_cst_saida, cofins_nat_rec, fornecedor_principal, representante,
                  tempo_reposicao, tem_grade, comprador, tem_nro_serie, politica_preco, conta_custo, servico_agregado,
                  kit_mercadorias, kit_tipo_preco, kit_montagem, cod_ex_ipi, vazio, cod_genero, cod_tab_servicos,
                  ultima_pauta, producao, tipo_item, codigo_anp, codigo_cest)
        reg_01 = '*|*'.join(str(x).replace('None', '') for x in campos_01)
        _file_01.write(reg_01 + '\n')

    def _gerar_est04(linha):
        # Gerar est04 grupo
        codigo = linha.get('CODIGO')+'000000000'
        descricao = linha.get('DESCRICAO')
        tipo_grupo = ''
        atualiza_saldo = 'S'
        conta_custos = ''
        conta_contabil = ''
        campos_04 = (codigo, descricao, tipo_grupo, atualiza_saldo, conta_custos, conta_contabil)
        reg_04 = '*|*'.join(str(x).replace('None','') for x in campos_04)
        _file_04.write(reg_04 + '\n')

    def _gerar_est04_subgrupo():
        # Gerar est04 grupo para os subgrupos
        for grupo in dcGrupoSubgrupo.keys():
            codigo = grupo+dcGrupoSubgrupo.get(grupo) +'000000'
            descricao = dcSubgrupo.get(dcGrupoSubgrupo.get(grupo))
            tipo_grupo = ''
            atualiza_saldo = 'S'
            conta_custos = ''
            conta_contabil = ''
            campos_04 = (codigo, descricao, tipo_grupo, atualiza_saldo, conta_custos, conta_contabil)
            reg_04 = '*|*'.join(str(x).replace('None','') for x in campos_04)
            _file_04.write(reg_04 + '\n')

    def _gerar_est05(linha):
        #Gerar Est05 Grade
        cod_peca = linha.get('CODIGO')
        grade = ''
        nome = linha.get('DESCRICAO')
        nome_resumido = linha.get('DESCRICAORESUMIDA')
        minimo = linha.get('ESTOQUEMINIMO') or '0'
        maximo = minimo
        balanca = linha.get('BALANCA')
        if balanca == 'N\xc3O':
            balanca = ''
        peso_unidade = linha.get('PESOUNIDADE')
        validade = linha.get('VALIDADE_FRIOS')
        tecla = balanca
        setor = ''
        lista_pesquisa = ''
        qtd_ent = ''
        dt_entr = datas.sigDatas(linha.get('DATACOMPRA')).getDataNoFormato('I') if linha.get('DATACOMPRA') else '00000000'
        qtd_sai = ''
        dt_said = ''
        periodo_dia = ''
        periodo_semana = ''
        periodo_quinzena = ''
        periodo_mes = ''
        item_ativo = 'N' if linha.get('SITUACAO') == 'DESATIVADO' else 'S'
        data_inclusao = datas.sigDatas(linha.get('DATACADASTRO')).getDataNoFormato('I')
        cod_peca_baixa = ''
        grade_baixa = ''
        campos_05 = (cod_peca, grade, nome, nome_resumido, minimo, maximo, balanca, peso_unidade, validade, tecla, setor,
                   lista_pesquisa, qtd_ent, dt_entr, qtd_sai, dt_said, periodo_dia, periodo_semana, periodo_quinzena,
                   periodo_mes, item_ativo, data_inclusao, cod_peca_baixa, grade_baixa)
        reg_05 = '*|*'.join(str(x).replace('None','') for x in campos_05)
        _file_05.write(reg_05 + '\n')

    def _gerar_est10(linha):
        # Gerar est10 Saldo
        cod_peca = linha.get('CODIGO')
        grade = ''
        local = '01'
        uni_entrada = linha.get('UNIDADE')
        qtd_embalagem = '1'
        lastro = '0'
        capac_palete = '0'
        chave_3_locacao = ''
        wvalor1 = '+' + numero.getNumToStr(linha.get('QUANTIDADE'), 9, 3).replace('.', '')
        wvalor2 = '+000000000000'
        wvalor3 = '+000000000000'
        wvalor4 = '+000000000000'
        percentual_lastro = ''
        campos_10 = (cod_peca, grade, local, uni_entrada, qtd_embalagem, lastro, capac_palete, chave_3_locacao, wvalor1,
                     wvalor2, wvalor3, wvalor4, percentual_lastro)
        reg_10 = '*|*'.join(str(x).replace('None','') for x in campos_10)
        _file_10.write(reg_10 + '\n')

    def _gerar_est14():

        for tribut in lista_tributacao:
            est14_cod_tributacao = tribut.get('codigo')
            if tribut.get('tipo') == 'U':
                 est14_nome = 'Substituicao tributaria'
            if tribut.get('tipo') == 'I':
                 est14_nome = 'Isento'
            if tribut.get('tipo') == 'O':
                 est14_nome = 'Nao tributado'
            if tribut.get('tipo') == 'D':
                 est14_nome = 'Diferido'
            if tribut.get('tipo') == 'T':
                 est14_nome = 'Tributado a %s' % tribut.get('aliquota')
            est14_aliquota = tribut.get('aliquota')
            est14_base = tribut.get('base')
            est14_dispositivo1 = ''
            est14_dispositivo2 = ''
            est14_dispositivo3 = ''
            est14_tipo = tribut.get('tipo')
            est14_imposto = 'I'
            est14_tributa_icms_sobre = ''
            est14_base_reduzida_desc = ''
            est14_base_subst_integral = ''
            campos_14 = (est14_cod_tributacao, est14_nome, est14_aliquota, est14_base, est14_dispositivo1,
                         est14_dispositivo2, est14_dispositivo3, est14_tipo, est14_imposto, est14_tributa_icms_sobre,
                         est14_base_reduzida_desc, est14_base_subst_integral)
            reg_14 = '*|*'.join(str(x).replace('None','') for x in campos_14)
            _file_14.write(reg_14 + '\n')

    def _gerar_est55(linha):
        # Gerar est55 precos
        cod_peca = linha.get('CODIGO')
        p_venda1 = numero.getNumToStr(linha.get('PRECOVENDA'), 11, 3).replace('.', '')
        p_venda2 = '0'
        tabela_correcao = ''
        indexa_p_venda = ''
        nome_indexador = ''
        p_custo = numero.getNumToStr(linha.get('CUSTO_LIQUIDO'), 10,3).replace('.', '')
        p_medio = numero.getNumToStr(linha.get('PRECO_MEDIO'), 11,3).replace('.', '')
        p_reposicao = numero.getNumToStr(linha.get('PRECOCOMPRA'), 11,3).replace('.', '')
        custo_corr = '0'
        ultimo_fornec = ''
        penul_p_custo = ''
        penul_p_medio = ''
        penul_custo_cor = ''
        penul_p_reposic = ''
        penult_fornec = ''
        campos_55 = (cod_peca, p_venda1, p_venda2, tabela_correcao, indexa_p_venda, nome_indexador, p_custo, p_medio,
                     p_reposicao, custo_corr, ultimo_fornec, penul_p_custo, penul_p_medio, penul_custo_cor,
                     penul_p_reposic, penult_fornec, '')
        reg_55 = '*|*'.join(str(x).replace('None','') for x in campos_55)
        _file_55.write(reg_55 + '\n')

    # Esta ordem é importante porcausa do horario do arquivo, o time tambem para o horario nao ficar igual
    _arq_14 = get_nome_arquivo('est14')
    time.sleep(0.1)
    _arq_04 = get_nome_arquivo('est04')
    time.sleep(0.1)
    _arq_01 = get_nome_arquivo('est01')
    time.sleep(0.1)
    _arq_05 = get_nome_arquivo('est05')
    time.sleep(0.1)
    _arq_10 = get_nome_arquivo('est10')
    time.sleep(0.1)
    _arq_55 = get_nome_arquivo('est55')

    #
    _file_01 = open(_arq_01 + '.tmp', 'w')
    _file_04 = open(_arq_04 + '.tmp', 'w')
    _file_05 = open(_arq_05 + '.tmp', 'w')
    _file_10 = open(_arq_10 + '.tmp', 'w')
    _file_14 = open(_arq_14 + '.tmp', 'w')
    _file_55 = open(_arq_55 + '.tmp', 'w')

    sql = 'select * from GRUPO'
    cur.execute(sql)
    for linha in  cur.fetchallmap():
        _gerar_est04(linha)


    sql = 'select * from SUBGRUPO'
    cur.execute(sql)
    for linha in  cur.fetchallmap():
        dcSubgrupo[str(linha.get('CODIGO'))] = str(linha.get('DESCRICAO'))


    sql = 'select * from PRODUTO'
    cur.execute(sql)
    for linha in cur.fetchallmap():
        _gerar_est01(linha)
        _gerar_est05(linha)
        _gerar_est10(linha)
        _gerar_est55(linha)
    _gerar_est14()
    _gerar_est04_subgrupo()
    _file_14.close()
    os.rename(_arq_14+'.tmp', _arq_14+'.txt')
    _file_04.close()
    os.rename(_arq_04+'.tmp', _arq_04+'.txt')
    _file_01.close()
    os.rename(_arq_01+'.tmp', _arq_01+'.txt')
    _file_05.close()
    os.rename(_arq_05+'.tmp', _arq_05+'.txt')
    _file_10.close()
    os.rename(_arq_10+'.tmp', _arq_10+'.txt')
    _file_55.close()
    os.rename(_arq_55+'.tmp', _arq_55+'.txt')

def exportar_cliente():
    def _gerar_cre01(linha):

        # Gerar CRE01 cadastro de Clientes
        cliente = linha.get('CODIGO')
        data_inclusao = datas.sigDatas(linha.get('DATACADASTRO')).getDataNoFormato('I') if linha.get('DATACADASTRO') else '00000000'
        nome = linha.get('NOME') or linha.get('RAZAO')
        fantasia_apelido = linha.get('APELIDO')
        codigo_fidelidade = ''
        endcli = linha.get('ENDERECO')
        baicli = linha.get('BAIRRO')
        muncli = linha.get('CIDADE')
        estcli = linha.get('ESTADO')
        cepcli = linha.get('CEP')
        endcob = ''
        baicob = ''
        muncob = ''
        estcob = ''
        cepcob = ''
        cod_pais = '01058'
        nome_pais = 'Brasil'
        cod_muncli = linha.get('CODIGO_MUNICIPIO')
        cod_muncob = ''
        suframa = ''
        grupo1 = ''
        nome_grupo1 = ''
        grupo2 = ''
        nome_grupo2 = ''
        vendedor = ''
        telefone = linha.get('FONE')
        fax = linha.get('FAX')
        telcelular = linha.get('CELULAR')
        lim_credito = '+' + numero.getNumToStr(linha.get('LIMITECREDITO'), 9,2).replace('.', '')
        dtult_compra = datas.sigDatas(linha.get('DATAULTIMACOMPRA')).getDataNoFormato('I') if linha.get('DATAULTIMACOMPRA') else '00000000'
        pag_extrato = 0
        cond_pagto = ''
        tipo_prazo = ''
        cod_mensagem = ''
        mensagem = ''
        data_mensagem = ''
        produtor_rural = ''
        if linha.get('CGC'):
            cgccpf = linha.get('CGC')
            tipo_cgc = 'J'
        else:
            cgccpf = linha.get('CPF')
            tipo_cgc = 'F'
        identidade = linha.get('INSCRICAO')
        data_nascimento = datas.sigDatas(linha.get('DATAANIVER')).getDataNoFormato('I') if linha.get('DATAANIVER') else '00000000'
        pai = ''
        mae = ''
        conjuge = ''
        tipo_empresa = ''
        telefone_com = ''
        sexo = ''
        ativo = 'A'
        tabela_correcao = ''
        dia_mes_bonus = ''
        pis_deduzir = ''
        cofins_deduzir = ''
        conta_contabil = ''
        email = linha.get('EMAIL')
        email_celular = ''

        campos_01 = (cliente, data_inclusao, nome, fantasia_apelido, codigo_fidelidade, endcli, baicli, muncli, estcli,
                     cepcli, endcob, baicob, muncob, estcob, cepcob, cod_pais, nome_pais, cod_muncli, cod_muncob, suframa,
                     grupo1, nome_grupo1, grupo2, nome_grupo2, vendedor, telefone, fax, telcelular, lim_credito, dtult_compra,
                     pag_extrato, cond_pagto, tipo_prazo, cod_mensagem, mensagem, data_mensagem, produtor_rural,
                     tipo_cgc, cgccpf, identidade, data_nascimento, pai, mae, conjuge, tipo_empresa, telefone_com, sexo,
                     ativo, tabela_correcao, dia_mes_bonus, pis_deduzir, cofins_deduzir, conta_contabil, email,
                     email_celular)
        reg_01 = '*|*'.join(str(x).replace('None', '') for x in campos_01)
        _file_01.write(reg_01 + '\n')

    _arq_01 = get_nome_arquivo('cre01')
    time.sleep(0.1)

    #
    _file_01 = open(_arq_01 + '.tmp', 'w')
    sql = 'select * from CLIENTE'
    cur.execute(sql)
    for linha in cur.fetchallmap():
        _gerar_cre01(linha)
    _gerar_cre01(linha)
    _file_01.close()
    os.rename(_arq_01+'.tmp', _arq_01+'.txt')

def exportar_fornecedor():
    def _gerar_cpg01(linha):

        # Gerar CPG01 cadastro de fornecedor
        codigo = linha.get('CODIGO')
        nome = linha.get('RAZAO')
        fantasia = ''
        endereco_rua = linha.get('ENDERECO')
        endereco_nro = linha.get('NUMERO')
        endereco_compl = linha.get('COMPLEMENTO')
        cod_pais = linha.get('COD_PAIS')
        nome_pais = 'Brasil'
        cod_municipio = linha.get('CODIGO_MUNICIPIO')
        nome_municipio = linha.get('CIDADE')
        bairro = linha.get('BAIRRO')
        estado = linha.get('ESTADO')
        email = ''
        inscr_estadual = linha.get('INSCRICAO')
        tipo_cgc_cpf = 'J'
        cgc = re_sub('[^0-9]', '', linha.get('CGC')).rjust(15, '0')
        cep = linha.get('CEP')
        fone = linha.get('FONE1')
        fax = linha.get('FAX')
        celular = ''
        contato = ''
        ultima_compra = ''
        conta_ctb = ''
        conta_ccu = ''
        comprador = ''
        transportadora = ''
        placa = ''
        ativo = 'A'
        tipo_empresa = 'M' # M=Micro empresa, E=EPP, O=Outros
        regime_tributario = 'I' # I=Simples Nacional, D=Debito-credito
        suframa = linha.get('SUFRAMA')
        centro_custo = ''
        conta_ctb_imob = ''
        cnae = ''

        campos_01 = ( codigo, nome, fantasia, endereco_rua, endereco_nro, endereco_compl, cod_pais, nome_pais,
                      cod_municipio, nome_municipio, bairro, estado, email, inscr_estadual, tipo_cgc_cpf, cgc, cep,
                      fone, fax, celular, contato, ultima_compra, conta_ctb, conta_ccu, comprador, transportadora,
                      placa, ativo, tipo_empresa, regime_tributario, suframa, centro_custo, conta_ctb_imob, cnae)
        reg_01 = '*|*'.join(str(x).replace('None', '') for x in campos_01)
        _file_01.write(reg_01 + '\n')

    _arq_01 = get_nome_arquivo('cpg01')
    time.sleep(0.1)

    #
    _file_01 = open(_arq_01 + '.tmp', 'w')
    sql = 'select * from FORNECEDOR'
    cur.execute(sql)
    for linha in cur.fetchallmap():
        _gerar_cpg01(linha)
    _gerar_cpg01(linha)
    _file_01.close()
    os.rename(_arq_01+'.tmp', _arq_01+'.txt')

lista_tributacao = []
dcSubgrupo = {}
dcGrupoSubgrupo = {}

exportar_produto()
exportar_cliente()
exportar_fornecedor()

print '****** Fim de Exportação ******'

