#!/usr/bin/python
# -*- encoding: utf-8 -*-


import psycopg2
from re import sub as re_sub
from ..integracao.connection.integ_db import IntegracaoConnection

CRE01 = {
    1: 'CLIENTE CODIGO', 2: 'DATA INCLUSAO', 3: 'NOME', 4: 'FIDELIDADE CODIGO', 5: 'CLIENTE ENDERECO',
    6: 'CLIENTE BAIRRO', 7: 'CLIENTE CIDADE', 8: 'CLIENTE UF', 9: 'CLIENTE CEP', 10: 'CLIENTE ENDERECO COBRANCA',
    11: 'CLIENTE BAIRRO COBRANCA', 12: 'CLIENTE CIDADE COBRANCA', 13: 'CLIENTE UF COBRANCA', 14: 'CLIENTE CEP COBRANCA',
    15: 'PAIS CODIGO', 16: 'PAIS NOME', 17: 'CLIENTE CIDADE CODIGO', 18: 'CLIENTE CIDADE COBRANCA CODIGO',
    19: 'SUFRAMA', 20: 'GRUPO1', 21: 'GRUPO1 NOME', 22: 'GRUPO2', 23: 'GRUPO2 NOME', 24: 'VENDEDOR',
    25: 'TELEFONE', 26: 'FAX', 27: 'CELULAR', 28: 'LIMITE CREDITO', 29: 'DATA ULTIMA COMPRA', 30: 'PAGAMENTO EXTRATO',
    31: 'PAGAMENTO CONDICAO', 32: 'PRAZO TIPO',
    33: 'MENSAGEM CODIGO',
    34: 'MENSAGEM',
    35: 'MENSAGEM_DATA',
    36: 'PRODUTOR RURAL',
    37: 'PESSOA TIPO',
    38: 'CPF/CNPJ',
    39: 'J - IE ou F - IDENTIDADE',
    40: 'J - FUNDACAO DATA ou F - DATA NASCIMENTO',
    41: 'J - CONTATO1 ou F - PAI',
    42: 'J - CONTATO2 ou F - MAE',
    43: 'J - CONTATO3 ou F - CONJUGE',
    44: 'EMPRESA TIPO',
    45: 'TELEFONE',
    46: 'GENERO',
    47: 'ATIVO',
    48: 'TABELA CORRECAO',
    49: 'BONUS DIA MES',
    50: 'PIS DEDUZIR',
    51: 'CONFIS DEDUZIR',
    52: 'CONTA CTB',
    53: 'EMAIL',
    54: 'EMAIL CELULAR',
    55: 'OBSERCAOES',
    }

conn_string = "host='localhost' dbname='integracao' user='openerp' password='' connect_timeout=3"
print "Connecting to database\n -> %s" % conn_string
cr = False
id = 22964
try:
    conn = psycopg2.connect(conn_string)
    print "Connected!\n"
    cr = conn.cursor()

    db = IntegracaoConnection(cr)
    legado_dados = db.select(table='legado_logs', fields=['lelg_conteudo'], where=[('id', '=', id)])
    if db.tem_erro:
        print "ERRO: ", db.get_erro()
    else:
        col_indice = 4
        col_value = 50

        str_indice = 'IND.'.ljust(col_indice, ' ')
        str_value = 'VALOR'.ljust(col_value, ' ')
        print '%s %s' % (str_indice, str_value)
        for i in legado_dados:
            conteudo = i.get('lelg_conteudo')
            if conteudo:
                lista_dados = re_sub('#', ' ', conteudo).replace('\n', '').split('*|*')
                index = 0
                for d in lista_dados:
                    indice = str(index).rjust(2, '0').ljust(col_indice, ' ')
                    value = str(d).ljust(col_value, ' ')

                    print '%s %s' % (indice, value)
                    index += 1
except Exception as e:
    print "Erro -- ", str(e)
finally:
    if cr:
        conn.close()

