#!/usr/bin/python
# -*- encoding: utf-8 -*-

from re import sub as re_sub
from dateutil.parser import parse
from SigUtils.datas import sigDatas
from SigUtils.email import validar_email as sig_validar_email
from psycopg2.extensions import TransactionRollbackError
from ..funcoes.integ_funcoes import funct_capitalize_all, funct_formata_cpf_cnpj, funct_retira_acentos
from traceback import format_exc as traceback_format_exc
from ..funcoes.integ_funcoes import funct_get_empresa


def cpg01_format_data(dados):
    lista_dados = re_sub('#', ' ', dados).replace('\n', '').split('*|*')

    # lista_dados[0] = lista_dados[0]
    lista_dados[1] = funct_retira_acentos(lista_dados[1].strip().upper())
    lista_dados[2] = lista_dados[2].strip()
    lista_dados[3] = funct_retira_acentos(funct_capitalize_all(lista_dados[3].strip().replace(']', '').replace('[', '').replace('\\', '').replace(';', ',')))
    lista_dados[4] = funct_retira_acentos(funct_capitalize_all(lista_dados[4].strip().replace(']', '').replace('[', '').replace('\\', '').replace(';', ',')))
    lista_dados[5] = funct_retira_acentos(funct_capitalize_all(lista_dados[5].strip().replace(']', '').replace('[', '').replace('\\', '').replace(';', ',')))
    # lista_dados[6] = lista_dados[6]
    lista_dados[7] = lista_dados[7].upper().strip()
    # lista_dados[8] = lista_dados[8]
    lista_dados[9] = funct_retira_acentos(funct_capitalize_all(lista_dados[9].strip()))
    lista_dados[10] = funct_retira_acentos(funct_capitalize_all(lista_dados[10].strip().replace(']', '').replace('[', '').replace('\\', '')))
    lista_dados[11] = lista_dados[11].strip().upper()
    lista_dados[12] = lista_dados[12].strip()
    lista_dados[13] = lista_dados[13][:14]
    # lista_dados[14] = lista_dados[14]
    lista_dados[15] = funct_formata_cpf_cnpj(lista_dados[15], lista_dados[14])
    # lista_dados[16] = lista_dados[16]
    lista_dados[17] = lista_dados[17].strip()
    lista_dados[18] = lista_dados[18].strip()
    lista_dados[19] = lista_dados[19].strip()
    lista_dados[20] = funct_retira_acentos(lista_dados[20].strip().upper())
    lista_dados[21] = sigDatas(lista_dados[21]).getDataNoFormato('I', 'S', '-')
    # lista_dados[22] = lista_dados[22]
    # lista_dados[23] = lista_dados[23]
    # lista_dados[24] = lista_dados[24]
    # lista_dados[25] = lista_dados[25]
    lista_dados[26] = lista_dados[26].strip()
    # lista_dados[27] = lista_dados[27]
    lista_dados[28] = lista_dados[28].strip()
    lista_dados[29] = lista_dados[29].strip()
    lista_dados[30] = lista_dados[30].strip()
    lista_dados[31] = lista_dados[31].strip()
    lista_dados[32] = lista_dados[32].strip()
    lista_dados[33] = lista_dados[33].strip()

    return lista_dados


# FORNECEDORES________________________
def gerarCpg01(db_registro, legado_log_id, dados, company_com_nf_id, company_sem_nf_id, empresa_legado, operacao, context=None):

    try:


        lista_dados = cpg01_format_data(dados)

        dados_fornecedor_codigo = lista_dados[0]
        dados_nome = lista_dados[1]
        dados_fantasia_apelido = lista_dados[2]
        dados_end_rua_nome = lista_dados[3]
        dados_end_numero = lista_dados[4]
        # dados_end_complemento = lista_dados[5]
        dados_pais_codigo = lista_dados[6]
        dados_pais_nome = lista_dados[7]
        dados_cidade_codigo = lista_dados[8]
        dados_cidade_nome = lista_dados[9]
        dados_bairro_nome = lista_dados[10]
        dados_uf_sigla = lista_dados[11]
        dados_email = lista_dados[12]
        dados_rg_or_inscrica_estadual = lista_dados[13]
        dados_pessoa_tipo = lista_dados[14]
        dados_cpf_cnpj = lista_dados[15]
        dados_cep = lista_dados[16]
        dados_telefone = lista_dados[17]
        dados_fax = lista_dados[18]
        dados_celular = lista_dados[19]
        # dados_contato1 = lista_dados[20]
        # dados_data_ultima_compra = lista_dados[21]
        # dados_conta_contabil = lista_dados[22]
        # dados_conta_accu = lista_dados[23]
        # daados_comprador = lista_dados[24]
        # dados_transportadora = lista_dados[25]
        # dados_placa = lista_dados[26]
        dados_ativo = lista_dados[27]
        dados_empresa_tipo = lista_dados[28]
        dados_registro_tributario = lista_dados[29]
        dados_suframa = lista_dados[30]
        # dados_centro_custo = lista_dados[31]
        # dados_conta_contavil_imob = lista_dados[32]
        # dados_cnae = lista_dados[33]

        observacao = ''

        if dados_nome[:3] == 'AAA':
            msg_erro = 'CPG01: Nome = AAA.'
            raise Exception(msg_erro)

        if not sig_validar_email(dados_email):
            observacao = dados_email
            dados_email = ''

        if dados_pessoa_tipo not in ('F', 'J'):
            dados_pessoa_tipo = 'F'

        if dados_ativo == 'N':
            dados_ativo = False
        else:
            dados_ativo = True

        if dados_cpf_cnpj.__len__() > 6:
            args_pessoa = [('cpf_cnpj', '=', dados_cpf_cnpj)]
        else:
            args_pessoa = [('nome', 'ilike', dados_nome), ('pessoa_tipo', '=', dados_pessoa_tipo)]

        pessoa_dados = db_registro.select(table='adm_pessoa', fields=['id'], where=args_pessoa)
        if pessoa_dados:
            pessoa_id = pessoa_dados[0]['id']

        else:

            # CRIA PESSOA
            dados_to_reg_pessoa = {
                'sexo': '',
                'nome': dados_nome,
                'ativo': dados_ativo,
                'suframa': dados_suframa,
                'cpf_cnpj': dados_cpf_cnpj,
                'pais_nome': dados_pais_nome,
                'cliente_uf': dados_uf_sigla,
                'endcli_rua': dados_end_rua_nome,
                'pessoa_tipo': dados_pessoa_tipo,
                'observacoes': observacao,
                'cliente_cep': dados_cep,
                'empresa_tipo': dados_empresa_tipo,
                'end_cli_numero': dados_end_numero,
                'produtor_rural': False,
                'cliente_cidade': dados_cidade_nome,
                'cliente_bairro': dados_bairro_nome,
                'fantasia_apelido': dados_fantasia_apelido,
            }
            if dados_pessoa_tipo == 'J':
                pesadmpes_jur_tipo_atividade = 'C'
                if dados_registro_tributario == 'I':
                    pes_admpes_jur_regime_tribut = 'S'
                else:
                    pes_admpes_jur_regime_tribut = 'R'
                pesadmpes_jur_ie = dados_rg_or_inscrica_estadual

                dados_to_reg_pessoa['ie'] = pesadmpes_jur_ie
                dados_to_reg_pessoa['empresa_tipo'] = dados_empresa_tipo
                dados_to_reg_pessoa['admpes_jur_tipo_atividade'] = pesadmpes_jur_tipo_atividade
                dados_to_reg_pessoa['admpes_jur_regime_tributario'] = pes_admpes_jur_regime_tribut
            else:
                pesadmpes_fis_rg = dados_rg_or_inscrica_estadual
                dados_to_reg_pessoa['identidade'] = pesadmpes_fis_rg

            pessoa_id = db_registro.registro_pessoa(dados_to_reg_pessoa)
            if not pessoa_id:
                raise Exception('Pessoa nao foi incluida')

        # VERIFICA SE EXITE O FORNECEDOR, SE NAO EXISTIR É CRIADO
        fornecedor_id = db_registro.registro_fornecedor(company_com_nf_id, pessoa_id, dados_ativo)
        if not fornecedor_id:
            raise Exception(
                'Cpg01: Fornecedor nao incluido. Pessoa_id - %s, Company_id - %s'
                % (str(pessoa_id), str(company_com_nf_id))
            )

        legado_control_pessoa_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=dados_fornecedor_codigo,
            reg_tabela_legado='cpg01',
            reg_check_table='adm_pessoa',
            reg_empresa_tipo=dados_empresa_tipo
        )

        if not legado_control_pessoa_id:
            db_registro.create_legado_controle(
                reg_empresa_legado=empresa_legado,
                reg_tabela_legado='cpg01',
                reg_chave_legado=dados_fornecedor_codigo,
                reg_chave_sigerp=pessoa_id,
                reg_check_table='adm_pessoa',
                reg_empresa_tipo=dados_empresa_tipo
            )
        else:
            args_legado_controle = [
                ('empresa', '=', empresa_legado), ('tabela_legado', '=', 'cpg01'),
                ('chave_legado', '=', dados_fornecedor_codigo)
            ]
            db_registro.update_legado_controle(
                reg_values={'chave_sigerp': pessoa_id},
                reg_args=args_legado_controle,
                reg_check_table='adm_pessoa',
                reg_empresa_tipo=dados_empresa_tipo
            )

        # CADASTRO DO PAIS
        pais_id = db_registro.registro_pais(dados_pais_codigo, dados_pais_nome)
        if not pais_id:
            raise Exception('Pais nao incluido: Codigo - %s, Nome - %s' % (dados_pais_codigo, dados_pais_nome))
        else:
            # CADASTRO DO UF
            uf_id = db_registro.registro_uf(dados_uf_sigla, pais_id)
            if not uf_id:
                raise Exception('UF nao incluido: UF - %s' % dados_uf_sigla)
            else:
                # CADASTRO DA CIDADE
                cidade_id = db_registro.registro_cidade(
                    dados_cidade_codigo, dados_cidade_nome, uf_id, dados_uf_sigla
                )
                if not cidade_id:
                    raise Exception('Cidade nao incluida: Codigo - %s, Nome - %s, UF - %s. '
                                    'OBS: Cidade com nome menor que 3 caracteres nao serao incluidas' %
                                    (dados_cidade_codigo, dados_cidade_nome, dados_uf_sigla))
                else:
                    # CADASTRO DO BAIRRO
                    bairro_id = db_registro.registro_bairro(dados_bairro_nome)
                    if not bairro_id:
                        raise Exception('Bairro nao incluido: Nome - %s' % dados_bairro_nome)
                    else:
                        # CADASTRO DO LOGRADOURO
                        logradouro_id = db_registro.registro_logradouro(dados_end_rua_nome)
                        if not logradouro_id:
                            raise Exception('Logradouro nao incluido: Nome - %s' % dados_end_rua_nome)
                        else:
                            # CADASTRO DO TIPO DE ENDERECO
                            endereco_tipo_id = db_registro.registro_endereco_tipo('Normal')
                            if not endereco_tipo_id:
                                raise Exception('Tipo de endereco Normal nao incluido')
                            else:
                                # CADASTRO DO ENDERECO
                                endereco_id = db_registro.registro_endereco(dados_end_numero, dados_cep,
                                                                            pessoa_id, endereco_tipo_id, pais_id, uf_id,
                                                                            cidade_id, bairro_id, logradouro_id,
                                                                            dados={'tipo': 'normal'})
                                if not endereco_id:
                                    raise Exception('Endereco do fornecedor nao incluido')

        # CADASTRO DE EMAIL
        if dados_email and dados_email.count('@') + dados_email.count('.') > 1:
            email_tipo_id = db_registro.registro_email_tipo('Comum')
            if not email_tipo_id:
                raise Exception('Tipo de email - Comum - nao incluido')
            else:
                email_id = db_registro.registro_email(pessoa_id, dados_email, email_tipo_id)
                if not email_id:
                    raise Exception('Email nao incluido: %s' % dados_email)

        def cpg01_registrar_telefone(telefone, tipo_telefone):
            tel_tipo_id = db_registro.registro_telefone_tipo(tipo_telefone)
            if not tel_tipo_id:
                return False
            else:
                tel_id = db_registro.registro_telefone(pessoa_id, telefone, tel_tipo_id)
                if not tel_id:
                    return False
            return True

        if dados_pessoa_tipo == 'F':
            label_telefone = 'Residencial'
        else:
            label_telefone = 'Comercial'

        # CADASTRO DO TELEFONE
        telefone_id = cpg01_registrar_telefone(dados_telefone, label_telefone)
        if not telefone_id:
            raise Exception('Telefone %s nao incluido: %s' % (label_telefone, dados_telefone))
        # CADASTRO DO CELULAR
        celular_id = cpg01_registrar_telefone(dados_celular, 'Celular')
        if not celular_id:
            raise Exception('Telefone Celular nao incluido: %s' % dados_celular)
        # CADASTRO DO FAX
        fax_id = cpg01_registrar_telefone(dados_fax, 'Fax')
        if not fax_id:
            raise Exception('Fax nao incluido: %s' % dados_fax)

        return True

    except TransactionRollbackError:
        return False

    except:
        db_registro.cr_integracao.connection.rollback()
        msg_erro = traceback_format_exc().replace("'", '"')
        db_registro.registro_gravar_erro(legado_log_id, msg_erro)
        return False


def cpg03_format_data(dados):
    lista_dados = re_sub('#', ' ', dados).replace('\n', '').split('*|*')

    # lista_dados[0] = lista_dados[0]
    lista_dados[1] = lista_dados[1].strip()
    # lista_dados[2] = lista_dados[2]
    lista_dados[3] = sigDatas(lista_dados[3]).getDataNoFormato('I', 'S', '-')
    lista_dados[4] = '%s.%s' % (lista_dados[4][:10], lista_dados[4][10:])
    # lista_dados[5] = lista_dados[5]
    lista_dados[6] = sigDatas(lista_dados[6]).getDataNoFormato('I', 'S', '-')
    # lista_dados[7] = lista_dados[7]
    # lista_dados[8] = lista_dados[8]
    lista_dados[9] = '%s.%s' % (lista_dados[9][:10], lista_dados[9][10:])
    # lista_dados[10] = lista_dados[10]
    # lista_dados[11] = lista_dados[11]
    # lista_dados[12] = lista_dados[12]
    lista_dados[13] = lista_dados[13].strip()
    lista_dados[14] = lista_dados[14].strip()
    # lista_dados[15] = lista_dados[15]

    return lista_dados


# TITULOS____________________________
def gerarCpg03(db_registro, legado_log_id, dados, company_com_nf_id, company_sem_nf_id, empresa_legado, operacao, context=None):

    try:
        lista_dados = cpg03_format_data(dados)

        dados_fornecedor_codigo = lista_dados[0]
        dados_duplicata = lista_dados[1]
        dados_loja = lista_dados[2]
        dados_data_emissao = lista_dados[3]
        dados_valor = lista_dados[4]
        # dados_fatura = lista_dados[5]
        dados_data_prorrogacao = lista_dados[6]
        # dados_nota_id = lista_dados[7]
        dados_local_cobranca = lista_dados[8]
        dados_saldo = lista_dados[9]
        dados_csnf = lista_dados[10]
        # dados_conta_ccu = lista_dados[11]
        # dados_nota = lista_dados[12]
        # dados_serie = lista_dados[13]
        dados_observacao = lista_dados[14]
        # dados_duplicata_tipo = lista_dados[15]

        documento = '%s-%s' % (dados_loja, dados_duplicata)
        chave_fornecedor_documento_vencimento = '%s%s%s' % (dados_fornecedor_codigo, documento, dados_data_prorrogacao)

        if dados_csnf != 'S':
            dados_csnf = 'C'
        if dados_csnf == 'S':
            company_id = company_sem_nf_id
        else:
            company_id = company_com_nf_id

        titulo_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=chave_fornecedor_documento_vencimento,
            reg_tabela_legado='cpg03',
            reg_check_table='financeiro_titulo',
            reg_empresa_tipo=dados_csnf
        )

        if operacao != 'w':
            if not titulo_id:
                raise Exception(
                    'Cpg03 - Titulo nao encontrado no legado_controle: chave_legado - %s' %
                    chave_fornecedor_documento_vencimento
                )

            if operacao == 'd':
                values_titulo = {'state': 'C'}
                db_registro.update(table='financeiro_titulo', values=values_titulo, where=[('id', '=', titulo_id)])
                return True
        # DATA EMISSAO
        try:
            parse(dados_data_emissao, yearfirst=True)
        except:
            raise Exception('Cpg03 - Data de Emissao invalida: %s' % dados_data_emissao)
        # DATA VENCIMENTO
        try:
            parse(dados_data_prorrogacao, yearfirst=True)
        except:
            raise Exception('Cpg03 - Data de Prorrogacao invalida: %s' % dados_data_prorrogacao)

        pessoa_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=dados_fornecedor_codigo,
            reg_tabela_legado='cpg01',
            reg_check_table='adm_pessoa',
            reg_empresa_tipo=dados_csnf
        )
        # FORNECEDOR NAO CADASTRADO NO SISTEMA
        if not pessoa_id:
            raise Exception('Cpg03 - Fornecedor nao cadastrado: %s' % dados_fornecedor_codigo)

        if dados_duplicata[:2] == 'NF':
            args_doc_tipo = [('sigla', '=', 'NF')]
        else:
            args_doc_tipo = [('sigla', '=', 'DP')]

        doc_tipo_dados = db_registro.select(table='documento_documento_tipo', fields=['id'], where=args_doc_tipo)
        if doc_tipo_dados:
            doc_tipo_id = doc_tipo_dados[0]['id']
        else:
            raise Exception('Cpg03 - Sigla DP nao encontradata na tabela - documento_documento_tipo')

        local_cobranca_dados = False
        # LOCAL DE COBRANCA
        if dados_local_cobranca != '000':
            banco_dados = db_registro.select(
                table='adm_banco', fields=['id'], where=[('admbco_codigo_bc', '=', dados_local_cobranca)]
            )
            if not banco_dados:
                dados_local_cobranca = '000'
            else:
                banco_id = banco_dados[0]['id']
                local_cobranca_dados = db_registro.select(
                    table='financeiro_local_cobranca', fields=['id'], where=[('finloc_banco_id', '=', banco_id)]
                )

        # LOCAL DE COBRANCA
        if dados_local_cobranca == '000':
            local_cobranca_dados = db_registro.select(
                table='financeiro_local_cobranca', fields=['id'], where=[('tipo', '=', 'C')]
            )
            if not local_cobranca_dados:
                raise Exception('Cre02 - Nenhum local de cobranca do tipo Carteira encontrado')

        if not local_cobranca_dados:
            raise Exception('Cpg03 - Nenhum local de cobranca encontrado com o tipo = C')

        local_cobranca_id = local_cobranca_dados[0]['id']

        adm_moeda_dados = db_registro.select(table='adm_moeda', fields=['id'], where=[('sigla', '=', 'R$')])
        if adm_moeda_dados:
            adm_moed_id = adm_moeda_dados[0]['id']
        else:
            raise Exception('Cpg03 - Nenhuma moeda cadastrada com a sigla igual R$')

        titulo_company_id = funct_get_empresa(db_registro, 'financeiro.titulo', company_com_nf_id)
        try:
            if float(dados_valor) < 0:
                tipo_titulo = 'R'
                dados_valor = float(dados_valor).__abs__()
                dados_saldo = float(dados_saldo).__abs__()
            else:
                tipo_titulo = 'P'
        except ValueError:
            raise Exception('Cpg03 - Valor do titulo invalido')

        vals_titulo = {
            'company_id': titulo_company_id,
            'doc_tipo_id': doc_tipo_id,
            'pessoa_id': pessoa_id,
            'documento': documento,
            'parcela': 0,
            'local_cobranca_id': local_cobranca_id,
            'tipo_titulo': tipo_titulo,
            'state': 'A',
            'data_emissao': dados_data_emissao,
            'data_prorrogacao': dados_data_prorrogacao,
            'data_vencimento': dados_data_prorrogacao,
            'tipo_sacado': 'F',
            'vr_original': dados_valor,
            'saldo': dados_saldo,
            'adm_moeda_id': adm_moed_id,
            'tipo_lancamento': 'M'
        }
        if dados_observacao:
            vals_titulo['observacoes'] = dados_observacao

        if not titulo_id:
            if operacao == 'w':
                # CRIA UM TITULO A PAGAR
                titulo_id = db_registro.insert(table='financeiro_titulo', vals=vals_titulo)

                db_registro.create_legado_controle(
                    reg_empresa_legado=empresa_legado,
                    reg_tabela_legado='cpg03',
                    reg_chave_legado=chave_fornecedor_documento_vencimento,
                    reg_chave_sigerp=titulo_id,
                    reg_check_table='financeiro_titulo',
                    reg_empresa_tipo=dados_csnf
                )
        else:
            state_titulo = db_registro.select(
                table='financeiro_titulo', fields=['state'], where=[('id', '=', titulo_id)]
            )
            state = state_titulo[0].get('state') if isinstance(state_titulo, list) else False
            if state != 'B':
                db_registro.update(table='financeiro_titulo', values=vals_titulo,
                                   where=[('id', '=', titulo_id)])

        return True

    except TransactionRollbackError:
        return False

    except:
        db_registro.cr_integracao.connection.rollback()
        msg_erro = traceback_format_exc().replace("'", '"')
        db_registro.registro_gravar_erro(legado_log_id, msg_erro)
        return False


def cpg06_format_data(dados):

    lista_dados = re_sub('#', ' ', dados).replace('\n', '').split('*|*')

    # lista_dados[0] = lista_dados[0]
    # lista_dados[1] = lista_dados[1]
    # lista_dados[2] = lista_dados[2]
    lista_dados[3] = lista_dados[3].strip()
    lista_dados[4] = sigDatas(lista_dados[4]).getDataNoFormato('I', 'S', '-')
    # lista_dados[5] = lista_dados[5]
    # lista_dados[6] = lista_dados[6]
    # lista_dados[7] = lista_dados[7]
    lista_dados[8] = sigDatas(lista_dados[8]).getDataNoFormato('I', 'S', '-')
    lista_dados[9] = '%s.%s' % (lista_dados[9][:10], lista_dados[9][10:])
    lista_dados[10] = sigDatas(lista_dados[10]).getDataNoFormato('I', 'S', '-')
    lista_dados[11] = sigDatas(lista_dados[11]).getDataNoFormato('I', 'S', '-')
    lista_dados[12] = lista_dados[12].replace(' ', '0')
    # lista_dados[13] = lista_dados[13]
    lista_dados[14] = '%s.%s' % (lista_dados[14][:10], lista_dados[14][10:])
    lista_dados[15] = '%s.%s' % (lista_dados[15][:10], lista_dados[15][10:])
    # lista_dados[16] = lista_dados[16]
    # lista_dados[17] = lista_dados[17]
    lista_dados[18] = lista_dados[18].strip()

    return lista_dados


# MOVIMENTO ____________________________________
def gerarCpg06(db_registro, legado_log_id, dados, company_com_nf_id, company_sem_nf_id, empresa_legado, operacao, context=None):

    try:

        # REGRAVAO OU DELECAO DO HISTORICO NAO IMPORTA, POIS NO HISTORICO SO EXISTE E INCLUSAO DE NOVOS REGISTROS
        if operacao in ('d', 'r'):
            return True

        lista_dados = cpg06_format_data(dados)

        dados_tipo_movimento = lista_dados[0]
        dados_movimento_codigo = lista_dados[1]
        dados_fornecedor = lista_dados[2]
        dados_duplicata = lista_dados[3]
        dados_data_movimento = lista_dados[4]
        dados_sequencia = lista_dados[5]
        # dados_nota_id = lista_dados[6]
        dados_loja = lista_dados[7]
        dados_data_emissao = lista_dados[8]
        dados_valor = lista_dados[9]
        dados_data_vencimento = lista_dados[10]
        dados_data_baixa = lista_dados[11]
        # dados_local_cobranca = lista_dados[12]
        dados_tipo_juros_desconto = lista_dados[13]
        dados_valor_juros_desconto = lista_dados[14]
        dados_saldo = lista_dados[15]
        dados_csnf = lista_dados[16]
        dados_observacao = lista_dados[17]
        # dados_razao_auxiliar = lista_dados[18]

        # DATA MOVIMENTO
        try:
            parse(dados_data_movimento, yearfirst=True)
        except:
            raise Exception('Cpg06 - Data de Movimento invalida: %s' % dados_data_movimento)
            # DATA BAIXA
        try:
            parse(dados_data_baixa, yearfirst=True)
        except:
            if dados_movimento_codigo in ('A', 'B', 'C'):
                dados_data_baixa = dados_data_vencimento
            else:
                raise Exception('Cpg06 - Data da Baixa invalida: %s' % dados_data_baixa)
        # DATA EMISSAO
        try:
            parse(dados_data_emissao, yearfirst=True)
        except:
            raise Exception('Cpg06 - Data de Emissao invalida: %s' % dados_data_emissao)

        if dados_csnf != 'S':
            dados_csnf = 'C'
        if dados_csnf == 'S':
            company_id = company_sem_nf_id
        else:
            company_id = company_com_nf_id

        # BUSCA A PESSOA ID RELACIONADA AO CODIGO DO FORNECEDOR
        legado_fornec_pessoa_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=dados_fornecedor,
            reg_tabela_legado='cpg01',
            reg_check_table='adm_pessoa',
            reg_empresa_tipo=dados_csnf
        )

        if not legado_fornec_pessoa_id:
            raise Exception('Cpg06 - Fornecedor nao cadastrado na legado_controle. Chave_legado - %s', dados_fornecedor)

        chave_cpg06 = '%s%s%s%s%s%s' % (dados_tipo_movimento, dados_movimento_codigo, dados_fornecedor,
                                        dados_duplicata, dados_data_movimento, dados_sequencia)

        legado_historico_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=chave_cpg06,
            reg_tabela_legado='cpg06',
            reg_check_table='financeiro_titulo_historico',
            reg_empresa_tipo=dados_csnf
        )

        if legado_historico_id:
            raise Exception('Cpg06 - Movimento ja lancado na tabela legado_controle. Chave_legado: %s' % chave_cpg06)

        # LOCAL DE COBRANCA
        local_cobranca_dados = db_registro.select(
            table='financeiro_local_cobranca', fields=['id'], where=[('tipo', '=', 'C')]
        )
        if not local_cobranca_dados:
            raise Exception('Nenhum local de cobranca encontrado com o tipo - C')
        local_cobranca_id = local_cobranca_dados[0]['id']

        if dados_movimento_codigo == 'A':  # ENTRADA
            titulo_state = 'B'
            # historico_state = 'A'
            historico_titulo = 'I'
        elif dados_movimento_codigo == 'B':  # BAIXA
            titulo_state = 'B'
            # historico_state = 'B'
            historico_titulo = 'B'
        elif dados_movimento_codigo == 'C':  # BAIXA PARCIAL
            titulo_state = 'B'
            # historico_state = 'A'
            historico_titulo = 'BP'
        elif dados_movimento_codigo == 'D':  # CANCELAMENTO
            titulo_state = 'C'
            # historico_state = 'C'
            historico_titulo = 'C'
        elif dados_movimento_codigo == 'E':  # REGISTRO
            if dados_tipo_movimento == 'A':
                titulo_state = 'C'
                # historico_state = 'A'
                historico_titulo = 'TR'
            else:
                titulo_state = 'A'
                # historico_state = 'A'
                historico_titulo = 'R'
        else:
            raise Exception(
                'Tipo de movimento informacao invalido. O movimento informado deve estar entre os tipos: '
                'A - Entrada, B - Baixa, C - Baixa Parcial, D - Cancelamento ou E - Registro')

        if dados_data_baixa:
            try:
                data_baixa = parse(dados_data_baixa, yearfirst=True).date().strftime('%Y-%m-%d')
            except:
                # AO IMPORTAR, SE A DATA DA BAIXA NAO FOR UMA DATA VÁLIDA, A DATA 2000-01-01 SERÁ UTILIZADA.
                # ESTA DATA FIXA FOI ESTIPULADA EM CONVERSA ENTRE LUIZ E LUIS NO DIA 2013-05-31.
                data_baixa = '2000-01-01'
        else:
            data_baixa = ''

        documento = '%s-%s' % (dados_loja, dados_duplicata)
        chave_fornecedor_documento_vencimento = '%s%s%s' % (dados_fornecedor, documento, dados_data_vencimento)

        titulo_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=chave_fornecedor_documento_vencimento,
            reg_tabela_legado='cpg03',
            reg_check_table='financeiro_titulo',
            reg_empresa_tipo=dados_csnf
        )

        if not titulo_id:
            if operacao != 'w':
                raise Exception('Titulo nao encontrado na legado_controle: Chave_legado - %s' %
                                chave_fornecedor_documento_vencimento)

            if dados_duplicata[:2] == 'NF':
                documento_tipo = 'NF'
            else:
                documento_tipo = 'DP'

            # DOCUMENTO TIPO
            doc_tipo_dados = db_registro.select(
                table='documento_documento_tipo', fields=['id'], where=[('sigla', '=', documento_tipo)]
            )
            if not doc_tipo_dados:
                raise Exception('Nenhum documento encontrado com a sigla - %s')

            # MOEDA
            adm_moeda_dados = db_registro.select(table='adm_moeda', fields=['id'], where=[('sigla', '=', 'R$')])
            if not adm_moeda_dados:
                raise Exception('Nenhuma moeda encontrada com a sigla R$')

            doc_tipo_id = doc_tipo_dados[0]['id']
            adm_moeda_id = adm_moeda_dados[0]['id']

            titulo_company_id = funct_get_empresa(db_registro, 'financeiro.titulo', company_com_nf_id)
            vals_titulo = {
                'company_id': titulo_company_id,
                'doc_tipo_id': doc_tipo_id,
                'pessoa_id': legado_fornec_pessoa_id,
                'documento': documento,
                'parcela': 0,
                'local_cobranca_id': local_cobranca_id,
                'tipo_titulo': 'P',
                'state': titulo_state,
                'data_emissao': dados_data_emissao,
                'data_vencimento': dados_data_vencimento,
                'data_prorrogacao': dados_data_vencimento,
                'tipo_sacado': 'F',
                'vr_original': dados_valor,
                'saldo': dados_saldo,
                'adm_moeda_id': adm_moeda_id,
                'tipo_lancamento': 'M',
            }
            if dados_observacao:
                vals_titulo['observacoes'] = dados_observacao
            if data_baixa:
                vals_titulo['data_pagamento'] = data_baixa

            # CRIA UM TITULO
            titulo_id = db_registro.insert(table='financeiro_titulo', vals=vals_titulo)

            # INSERE NA LEGADO CONTROLE A CHAVE DO TITULO
            db_registro.create_legado_controle(
                reg_empresa_legado=empresa_legado,
                reg_tabela_legado='cpg03',
                reg_chave_legado=chave_fornecedor_documento_vencimento,
                reg_chave_sigerp=titulo_id,
                reg_check_table='financeiro_titulo',
                reg_empresa_tipo=dados_csnf
            )

        vals_titulo_historico = {
            'titulo_id': titulo_id,
            'local_cobranca_id': local_cobranca_id,
            'data_prorrogacao': dados_data_vencimento,
            'operacao': historico_titulo
        }
        # CRIA O HISTORICO DO TITULO
        historico_id = db_registro.insert(table='financeiro_titulo_historico', vals=vals_titulo_historico)

        # INSERE NO LEGADO CONTROLE A CHAVE DO HISTORICO
        db_registro.create_legado_controle(
            reg_empresa_legado=empresa_legado,
            reg_tabela_legado='cpg06',
            reg_chave_legado=chave_cpg06,
            reg_chave_sigerp=historico_id,
            reg_check_table='financeiro_titulo_historico',
            reg_empresa_tipo=dados_csnf
        )

        juros = 0
        desconto = 0
        if dados_tipo_juros_desconto.lower() == 'j':
            juros = dados_valor_juros_desconto
        elif dados_tipo_juros_desconto.lower() == 'd':
            desconto = dados_valor_juros_desconto

        if dados_movimento_codigo in ('B', 'C'):
            if data_baixa:
                vals_titulo_baixa = {
                    'data_baixa': data_baixa,
                    'data_pgto': data_baixa,
                    'titulo_id': titulo_id,
                    'valor_pago': dados_valor,
                    'valor_juros': juros,
                    'valor_desconto': desconto
                }
                # CRIA UMA BAIXA PARA O TITULO
                db_registro.insert(table='financeiro_titulo_baixa', vals=vals_titulo_baixa)

            if operacao != 'x' and dados_movimento_codigo == 'B':
                values_titulo = {
                    'data_pagamento': data_baixa,
                    'juros': juros,
                    'desconto': desconto,
                    'state': 'B',
                    'saldo': 0
                }
                db_registro.update(table='financeiro_titulo', values=values_titulo, where=[('id', '=', titulo_id)])

        return True

    except TransactionRollbackError:
        return False

    except:
        db_registro.cr_integracao.connection.rollback()
        msg_erro = traceback_format_exc().replace("'", '"')
        db_registro.registro_gravar_erro(legado_log_id, msg_erro)
        return False


def cpg08_format_data(dados):

    lista_dados = re_sub('#', ' ', dados).replace('\n', '').split('*|*')

    # lista_dados[0] = lista_dados[0]
    # lista_dados[1] = lista_dados[1]
    lista_dados[2] = lista_dados[2].strip()

    return lista_dados


# OBSERVACAO
def gerarCpg08(db_registro, legado_log_id, dados, company_com_nf_id, company_sem_nf_id, empresa_legado, operacao, context=None):

    try:

        if operacao != 'w':
            return True

        lista_dados = cpg08_format_data(dados)

        dados_fornecedor_codigo = lista_dados[0]
        # dados_sequencia = lista_dados[1]
        dados_observacao = lista_dados[2]

        if not dados_observacao:
            return True

        legado_fornecedor_pessoa_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=dados_fornecedor_codigo,
            reg_tabela_legado='cpg01',
            reg_check_table='adm_pessoa',
        )

        if not legado_fornecedor_pessoa_id:
            raise Exception(
                'Cpg08 - Fornecedor nao encontrado na legado_controle: Chave_legado - %s', dados_fornecedor_codigo
            )

        pessoa_dados = db_registro.select(
            table='adm_pessoa', fields=['id', 'observacoes'], where=[('id', '=', legado_fornecedor_pessoa_id)]
        )

        if pessoa_dados:
            pessoa_id = pessoa_dados[0]['id']
            pessoa_obs = pessoa_dados[0]['observacoes']

            obs = '%s \n %s' % (dados_observacao, pessoa_obs)

            values_pessoa = {'observacoes': obs}

            db_registro.update(table='adm_pessoa', values=values_pessoa, where=[('id', '=', pessoa_id)])

        return True

    except TransactionRollbackError:
        return False

    except:
        db_registro.cr_integracao.connection.rollback()
        msg_erro = traceback_format_exc().replace("'", '"')
        db_registro.registro_gravar_erro(legado_log_id, msg_erro)
        return False


# REPRESENTANTE
def gerarCpg11(db_registro, legado_log_id, dados, company_com_nf_id, company_sem_nf_id, empresa_legado, operacao, context=None):
    try:

        lista_dados = re_sub('#', ' ', dados).replace('\n', '').split('*|*')

        dados_fornecedor_codigo = lista_dados[0].strip()
        dados_representante_codigo = lista_dados[1].strip()
        dados_representante_nome = lista_dados[2].strip()
        dados_representante_email = lista_dados[3].strip()
        dados_representante_telefone = lista_dados[4].strip()
        dados_representante_fax = lista_dados[5].strip()
        dados_representante_celular = lista_dados[6].strip()
        # dados_representante_tempo_atendimento = lista_dados[7].strip()

        if not dados_representante_nome:
            raise Exception('Cpg11: Nome do representante nao informado!')

        cpg11_chave = '%s%s' % (dados_fornecedor_codigo, dados_representante_codigo)

        cpg01_pessoa_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=dados_fornecedor_codigo,
            reg_tabela_legado='cpg01',
            reg_check_table='adm_pessoa',
        )

        if not cpg01_pessoa_id:
            raise Exception(
                'Cpg11: Fornecedor nao encontrado na legado_controle. Tabela_legado - cpg01, Chave_legado - %s' %
                dados_fornecedor_codigo
            )

        cpg11_representante_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=cpg11_chave,
            reg_tabela_legado='cpg11',
            reg_check_table='financeiro_representante'
        )

        # VERFIICAR SE O REPRESENTANTE ESTA CADASTRADO.
        pessoa_ja_cadastrada_id = db_registro.select(
            table='adm_pessoa', fields=['id'], where=[('nome', 'ilike', dados_representante_nome)]
        )

        fornecedor_company_id = funct_get_empresa(db_registro, 'financeiro.fornecedor',
                                                  company_com_nf_id)
        if operacao in ('w', 'r'):

            if pessoa_ja_cadastrada_id:
                pessoa_id = pessoa_ja_cadastrada_id[0]['id']
                # ATUALIZA O NOME DO REPRESENTANTE
                db_registro.update(
                    table='adm_pessoa', values={'nome': dados_representante_nome}, where=[('id', '=', pessoa_id)]
                )
            else:
                ir_sequence_dados = db_registro.select(
                    table='ir_sequence', fields=['id', 'number_next'], where=[('code', '=', 'pessoa.codigo')]
                )

                sequence_id = ir_sequence_dados[0]['id']
                sequence_codigo = int(ir_sequence_dados[0]['number_next'])
                sequence_proximo_codigo = sequence_codigo + 1

                vals_partner = {
                    'name': dados_representante_nome,
                    'notification_email_send': 'comment'
                }
                partner_id = db_registro.insert(table='res_partner', vals=vals_partner)

                vals_pessoa = {
                    'partner_id': partner_id,
                    'codigo': sequence_codigo,
                    'nome': dados_representante_nome,
                    'pessoa_tipo': 'F',
                    'active': False
                }
                # ATUALIZA O IR_SEQUENCE
                db_registro.update(
                    table='ir_sequence',
                    values={'number_next': sequence_proximo_codigo},
                    where=[('id', '=', sequence_id)]
                )
                # CRIA UMA PESSOA
                pessoa_id = db_registro.insert(table='adm_pessoa', vals=vals_pessoa)

            # ______________________________ DADOS DA PESSOA ___________________________________
            # TELEFONE
            telefone_tipo_id = db_registro.registro_telefone_tipo(reg_tel_tipo='Comercial')
            db_registro.registro_telefone(
                reg_pessoa_id=pessoa_id, reg_telefone=dados_representante_telefone, reg_telefone_tipo_id=telefone_tipo_id
            )
            # EMAIL
            email_tipo_id = db_registro.registro_email_tipo(reg_tipo='Comum')
            db_registro.registro_email(
                reg_pessoa_id=pessoa_id, reg_email=dados_representante_email, reg_email_tipo_id=email_tipo_id
            )
            # FAX
            fax_tipo_id = db_registro.registro_telefone_tipo(reg_tel_tipo='Fax')
            db_registro.registro_telefone(
                reg_pessoa_id=pessoa_id, reg_telefone=dados_representante_fax, reg_telefone_tipo_id=fax_tipo_id
            )
            # CELULAR
            celular_tipo_id = db_registro.registro_telefone_tipo(reg_tel_tipo='Celular')
            db_registro.registro_telefone(
                reg_pessoa_id=pessoa_id, reg_telefone=dados_representante_celular, reg_telefone_tipo_id=celular_tipo_id
            )

            # SE NAO EXISTIR O FORNECEDOR, É CRIADO.
            fornecedor_id = db_registro.registro_fornecedor(
                reg_company_id=fornecedor_company_id, reg_pessoa_id=pessoa_id, reg_ativo=True
            )

            args_representante = [
                ('fornecedor_id', '=', fornecedor_id), ('pessoa_id', '=', pessoa_id)
            ]
            representante_dados = db_registro.select(
                table='financeiro_representante', fields=['id'], where=args_representante
            )

            if representante_dados:
                representante_id = representante_dados[0]['id']
            else:
                vals_representante = {
                    'pessoa_id': pessoa_id,
                    'fornecedor_id': fornecedor_id
                }
                # CRIA UM NOVO REPRESENTANTE
                representante_id = db_registro.insert(table='financeiro_representante', vals=vals_representante)

            if cpg11_representante_id:
                args_legado_controle = [
                    ('empresa', '=', empresa_legado), ('tabela_legado', '=', 'cpg11'),
                    ('chave_legado', '=', cpg11_chave)
                ]
                # ATUALIZA A LEGADO_CONTROLE
                db_registro.update_legado_controle(
                    reg_values={'chave_sigerp': representante_id},
                    reg_args=args_legado_controle,
                    reg_check_table='financeiro_representante',
                )

            else:
                # CRIA A LEGADO_CONTROLE
                db_registro.create_legado_controle(
                    reg_empresa_legado=empresa_legado,
                    reg_tabela_legado='cpg11',
                    reg_chave_legado=cpg11_chave,
                    reg_chave_sigerp=representante_id,
                    reg_check_table='financeiro_representante',
                )

        elif operacao == 'd':

            if pessoa_ja_cadastrada_id:
                args_fornecedor = [
                    ('company_id', '=', fornecedor_company_id), ('pessoa_id', '=', pessoa_ja_cadastrada_id)
                ]

                fornecedor_dados = db_registro.select(
                    table='financeiro_fornecedor', fields=['id'], where=args_fornecedor
                )
                if fornecedor_dados:
                    fornecedor_id = fornecedor_dados[0]['id']

                    args_representante = [
                        ('fornecedor_id', '=', fornecedor_id), ('pessoa_id', '=', pessoa_ja_cadastrada_id)
                    ]
                    db_registro.delete(table='financeiro_representante', where=args_representante)

            args_cpg11 = [
                ('empresa', '=', empresa_legado), ('tabela_legado', '=', 'cpg11'), ('chave_legado', '=', cpg11_chave)
            ]
            db_registro.delete_legado_controle(reg_args=args_cpg11, reg_check_table='financeiro_representante')

        return True

    except TransactionRollbackError:
        return False

    except:
        db_registro.cr_integracao.connection.rollback()
        msg_erro = traceback_format_exc().replace("'", '"')
        db_registro.registro_gravar_erro(legado_log_id, msg_erro)
        return False

