#!/usr/bin/python
# -*- encoding: utf-8 -*-

from re import sub as re_sub
from dateutil.parser import parse
from SigUtils.datas import sigDatas
from SigUtils.email import validar_email as sig_validar_email
from psycopg2.extensions import TransactionRollbackError
from ..funcoes.integ_funcoes import funct_acha_numero, funct_capitalize_all, funct_formata_cpf_cnpj, \
    funct_retira_acentos
from traceback import format_exc as traceback_format_exc
from ..funcoes.integ_funcoes import funct_get_empresa


def cre01_format_data(dados):
    lista_dados = re_sub('#', ' ', dados).replace('\n', '').split('*|*')

    # lista_dados[0] = lista_dados[0]
    lista_dados[1] = sigDatas(lista_dados[1]).getDataNoFormato('I', 'S', '-')
    lista_dados[2] = funct_retira_acentos(lista_dados[2].strip().upper())
    lista_dados[3] = funct_retira_acentos(lista_dados[3].strip())
    # lista_dados[4] = lista_dados[4]
    lista_dados[5] = funct_retira_acentos(funct_capitalize_all(lista_dados[5].strip().replace(']', '').replace('[', '').replace('\\', '').replace(';', ',')))
    lista_dados[6] = funct_retira_acentos(funct_capitalize_all(lista_dados[6].strip().replace(']', '').replace('[', '').replace('\\', '')))
    lista_dados[7] = funct_retira_acentos(funct_capitalize_all(lista_dados[7].strip().replace(']', '').replace('[', '').replace('\\', '')))
    lista_dados[8] = lista_dados[8].strip().upper()
    # lista_dados[9] = lista_dados[9]
    lista_dados[10] = funct_retira_acentos(funct_capitalize_all(lista_dados[10].strip().replace(']', '').replace('[', '').replace('\\', '').replace(';', ',')))
    lista_dados[11] = funct_retira_acentos(funct_capitalize_all(lista_dados[11].strip().replace(']', '').replace('[', '').replace('\\', '')))
    lista_dados[12] = funct_retira_acentos(funct_capitalize_all(lista_dados[12].strip().replace(']', '').replace('[', '').replace('\\', '')))
    lista_dados[13] = lista_dados[13].strip().upper()
    # lista_dados[14] = lista_dados[14]
    # lista_dados[15] = lista_dados[15]
    lista_dados[16] = lista_dados[16].upper().strip()
    # lista_dados[17] = lista_dados[17]
    # lista_dados[18] = lista_dados[18]
    lista_dados[19] = lista_dados[19].strip()
    # lista_dados[20] = lista_dados[20]
    lista_dados[21] = lista_dados[21].strip()
    # lista_dados[22] = lista_dados[22]
    lista_dados[23] = lista_dados[23].strip()
    # lista_dados[24] = lista_dados[24]
    lista_dados[25] = lista_dados[25].strip()
    lista_dados[26] = lista_dados[26].strip()
    lista_dados[27] = lista_dados[27].strip()
    lista_dados[28] = (lista_dados[28][:10]+'.'+lista_dados[28][10:]).replace(' ', '0')
    lista_dados[29] = sigDatas(lista_dados[29]).getDataNoFormato('I', 'S', '-')
    # lista_dados[30] = lista_dados[30]
    # lista_dados[31] = lista_dados[31]
    lista_dados[32] = lista_dados[32].strip()
    # lista_dados[33] = lista_dados[33]
    lista_dados[34] = lista_dados[34].strip()
    lista_dados[35] = sigDatas(lista_dados[35]).getDataNoFormato('I', 'S', '-')
    # lista_dados[36] = lista_dados[36]
    # lista_dados[37] = lista_dados[37]
    lista_dados[38] = funct_formata_cpf_cnpj(lista_dados[38], lista_dados[37])
    lista_dados[39] = lista_dados[39].strip()
    lista_dados[40] = sigDatas(lista_dados[40]).getDataNoFormato('I', 'S', '-')
    lista_dados[41] = funct_retira_acentos(lista_dados[41].strip().upper())
    lista_dados[42] = funct_retira_acentos(lista_dados[42].strip().upper())
    lista_dados[43] = funct_retira_acentos(lista_dados[43].strip().upper())
    lista_dados[44] = lista_dados[44].strip()
    lista_dados[45] = lista_dados[45].strip()
    # lista_dados[46] = lista_dados[46]
    # lista_dados[47] = lista_dados[47]
    lista_dados[48] = lista_dados[48].strip()
    # lista_dados[49] = lista_dados[49]
    lista_dados[50] = lista_dados[50][:1] + '.' + lista_dados[50][1:]
    lista_dados[51] = lista_dados[51][:1] + '.' + lista_dados[51][1:]
    # lista_dados[52] = lista_dados[52]
    lista_dados[53] = lista_dados[53].strip()
    lista_dados[54] = lista_dados[54].strip()

    return lista_dados


# CLIENTES_____________________________________
def gerarCre01(db_registro, legado_log_id, dados, company_com_nf_id, company_sem_nf_id, empresa_legado, operacao, context=None):

    try:
        lista_dados = cre01_format_data(dados)

        # LEITURA DOS REGISTROS
        dados_cliente_codigo = lista_dados[0]
        dados_data_inclusao = lista_dados[1]
        dados_nome = lista_dados[2]
        dados_fantasia_apelido = lista_dados[3]
        dados_fidelidade_codigo = lista_dados[4]
        dados_cliente_endereco = lista_dados[5]
        dados_cliente_bairro = lista_dados[6]
        dados_cliente_cidade = lista_dados[7]
        dados_cliente_uf = lista_dados[8]
        dados_cliente_cep = lista_dados[9]
        dados_cobranca_endereco = lista_dados[10]
        dados_cobranca_bairro = lista_dados[11]
        dados_cobranca_cidade = lista_dados[12]
        dados_cobranca_uf = lista_dados[13]
        dados_cobranca_cep = lista_dados[14]
        dados_pais_codigo = lista_dados[15]
        dados_pais_nome = lista_dados[16]
        dados_cliente_cidade_codigo = lista_dados[17]
        dados_cobranca_cidade_codigo = lista_dados[18]
        dados_suframa = lista_dados[19]
        dados_grupo1 = lista_dados[20]
        dados_grupo1_nome = lista_dados[21]
        dados_grupo2 = lista_dados[22]
        dados_grupo2_nome = lista_dados[23]
        # dados_vendedor = lista_dados[24]
        dados_telefone = lista_dados[25]
        dados_fax = lista_dados[26]
        dados_celular = lista_dados[27]
        dados_limite_credito = lista_dados[28]
        # dados_data_ultima_compra = lista_dados[29]
        # dados_pagamento_extrato = lista_dados[30]
        dados_pagamento_condicao = lista_dados[31]
        # dados_prazo_tipo = lista_dados[32]
        dados_mensagem_codigo = lista_dados[33]
        dados_mensagem = lista_dados[34]
        # dados_mensagem_data = lista_dados[35]
        dados_produtor_rural = lista_dados[36]
        dados_pessoa_tipo = lista_dados[37]
        dados_cpf_cnpj = lista_dados[38]

        if dados_pessoa_tipo == 'J':  # PESSOA JURIDICA
            dados_pes_juridica_ie = lista_dados[39]
            dados_pes_juridica_fundacao_data = lista_dados[40]
            dados_pes_juridica_contato1 = lista_dados[41]
            dados_pes_juridica_contato2 = lista_dados[42]
            dados_pes_juridica_contato3 = lista_dados[43]
        else:  # PESSOA FISICA
            dados_pes_fisica_identidade = lista_dados[39]
            dados_pes_fisica_data_nascimento = lista_dados[40]
            dados_pes_fisica_pai = lista_dados[41]
            dados_pes_fisica_mae = lista_dados[42]
            dados_pes_fisica_conjuge = lista_dados[43]

        dados_empresa_tipo = lista_dados[44]
        # dados_telefone_com = lista_dados[45]
        dados_genero = lista_dados[46]
        dados_ativo = lista_dados[47]
        # dados_tabela_correcao = lista_dados[48]
        dados_bonus_dia_mes = lista_dados[49]
        # dados_pis_deduzir = lista_dados[50]
        # dados_cofins_deduzir = lista_dados[51]
        # dados_conta_ctb = lista_dados[52]
        dados_email = lista_dados[53]
        dados_email_celular = lista_dados[54]
        dados_observacoes = ''


        if dados_nome.__len__() < 5:
            if dados_nome[:3] == 'AAA':
                erro = 'Nome do cliente igual a AAA: %s ' % str(dados_nome)
            else:
                erro = 'Nome do cliente menor que 5 bytes: %s' % str(dados_nome)
            raise Exception(erro)

        try:
            if int(dados_fidelidade_codigo) == 0:
                dados_fidelidade_codigo = ''
        except:
            pass

        if dados_produtor_rural in ('Y', 'S'):
            dados_produtor_rural = True
        else:
            dados_produtor_rural = False

        if dados_pessoa_tipo not in ('F', 'J'):
            dados_pessoa_tipo = 'F'

        if dados_pessoa_tipo == 'F':
            if dados_genero not in ('M', 'F'):
                dados_genero = ''

        if dados_ativo == 'N':
            dados_ativo = False
        else:
            dados_ativo = True

        try:
            int(dados_bonus_dia_mes)
        except:
            dados_bonus_dia_mes = False

        if not sig_validar_email(dados_email):
            dados_observacoes = dados_email
            dados_email = ''

        if not sig_validar_email(dados_email_celular):
            dados_observacoes = dados_email_celular
            dados_email_celular = ''

        dados_observacoes = funct_retira_acentos(dados_observacoes)

        cliente_end_rua, cliente_end_numero = funct_acha_numero(dados_cliente_endereco)
        cliente_endcob_rua, cliente_endcob_numero = funct_acha_numero(dados_cobranca_endereco)

        if dados_cpf_cnpj.__len__() > 6:
            args_pessoa = [('cpf_cnpj', '=', dados_cpf_cnpj)]
        else:
            args_pessoa = [('nome', '=', dados_nome), ('pessoa_tipo', '=', dados_pessoa_tipo)]

        pessoa_dados = db_registro.select(table='adm_pessoa', fields=['id'], where=args_pessoa)

        if pessoa_dados:
            pessoa_dados = pessoa_dados[0]
            pessoa_id = pessoa_dados['id']
        else:
            # CRIA PESSOA
            dados_to_reg_pessoa = {
                'sexo': dados_genero,
                'nome': dados_nome,
                'ativo': dados_ativo,
                'suframa': dados_suframa,
                'cpf_cnpj': dados_cpf_cnpj,
                'pais_nome': dados_pais_nome,
                'cliente_uf': dados_cliente_uf,
                'endcli_rua': cliente_end_rua,
                'pessoa_tipo': dados_pessoa_tipo,
                'observacoes': dados_observacoes,
                'cliente_cep': dados_cliente_cep,
                'empresa_tipo': dados_empresa_tipo,
                'end_cli_numero': cliente_end_numero,
                'produtor_rural': dados_produtor_rural,
                'cliente_cidade': dados_cliente_cidade,
                'cliente_bairro': dados_cliente_bairro,
                'fantasia_apelido': dados_fantasia_apelido,
            }
            if dados_pessoa_tipo == 'F':
                dados_to_reg_pessoa.update({
                    'identidade': dados_pes_fisica_identidade,
                })
                if dados_pes_fisica_data_nascimento[:4] != '0000':
                    try:
                        parse(dados_pes_fisica_data_nascimento, yearfirst=True)
                        data_nascimento_valida = True
                    except:
                        data_nascimento_valida = False

                    if data_nascimento_valida:
                        dados_to_reg_pessoa.update({
                            'data_nascimento': dados_pes_fisica_data_nascimento
                        })
            else:
                if dados_pes_juridica_fundacao_data[:4] != '0000':
                    try:
                        parse(dados_pes_juridica_fundacao_data, yearfirst=True)
                        data_fundacao_valida = True
                    except:
                        data_fundacao_valida = False

                    if data_fundacao_valida:
                        dados_to_reg_pessoa.update({
                            'fundacao_data': dados_pes_juridica_fundacao_data,
                        })

                dados_to_reg_pessoa.update({
                    'ie': dados_pes_juridica_ie
                })

            pessoa_id = db_registro.registro_pessoa(dados_to_reg_pessoa)
            if not pessoa_id:
                raise Exception('Pessoa nao incluida: Nome - %s' % dados_nome)

        if dados_pessoa_tipo == 'F':

            def pessoa_fisica_registrar(str_nome, str_tipo):
                if str(str_nome).__len__() > 10:
                    pes_dependente_id = db_registro.registro_pessoa_dependente(str_nome, dados_pessoa_tipo)
                    if not pes_dependente_id:
                        return False
                    else:
                        relacionamento_tipo_id = db_registro.registro_pessoa_relacionamento_tipo(
                            str_tipo, dados_pessoa_tipo
                        )
                        if not relacionamento_tipo_id:
                            return False
                        else:
                            dependente_id = db_registro.registro_dependente(
                                pessoa_id, relacionamento_tipo_id, pes_dependente_id
                            )
                            if not dependente_id:
                                return False
                return True

            pes_pai = pessoa_fisica_registrar(dados_pes_fisica_pai, 'PM')
            if not pes_pai:
                raise Exception('Pai da pessoa fisica nao incluido: Pai - %s' % dados_pes_fisica_pai)
            pes_mae = pessoa_fisica_registrar(dados_pes_fisica_mae, 'PM')
            if not pes_mae:
                raise Exception('Mae da pessoa fisica nao incluido: Mae - %s' % dados_pes_fisica_mae)
            if dados_genero == 'M':
                label_conjuge = 'MAR'
            else:
                label_conjuge = 'ESPOS'
            pes_conjuge = pessoa_fisica_registrar(dados_pes_fisica_conjuge, label_conjuge)
            if not pes_conjuge:
                raise Exception('Conjuge da pessoa fisica nao incluido: Conjuge - %s' % dados_pes_fisica_conjuge)

        # DADOS DO CONTATO DA PESSOA JURIDICA
        else:
            def pessoa_juridica_registrar(contato_name):
                if contato_name:
                    pesadmpes_jur_contato_dependente_id = db_registro.registro_pessoa_dependente(contato_name, 'F')
                    if not pesadmpes_jur_contato_dependente_id:
                        return False
                    else:
                        relat_tipo_id = db_registro.registro_pessoa_relacionamento_tipo('CONT', dados_pessoa_tipo)
                        if not relat_tipo_id:
                            return False
                        else:
                            dependente_id = db_registro.registro_dependente(
                                pessoa_id, relat_tipo_id, pesadmpes_jur_contato_dependente_id
                            )
                            if not dependente_id:
                                return False
                return True

            admpes_jur_contato1 = pessoa_juridica_registrar(dados_pes_juridica_contato1)
            if not admpes_jur_contato1:
                raise Exception(
                    'Contato 1 para pessoa juridica nao inluido: Contato - %s' % dados_pes_juridica_contato1
                )
            admpes_jur_contato2 = pessoa_juridica_registrar(dados_pes_juridica_contato2)
            if not admpes_jur_contato2:
                raise Exception(
                    'Contato 2 para pessoa juridica nao incluido: Contato - %s' % dados_pes_juridica_contato2
                )
            admpes_jur_contato3 = pessoa_juridica_registrar(dados_pes_juridica_contato3)
            if not admpes_jur_contato3:
                raise Exception(
                    'Contato 3 para pessoa juridica nao incluido: Contato - %s' % dados_pes_juridica_contato3
                )

        # REGISTRO DO PAIS
        pais_id = db_registro.registro_pais(dados_pais_codigo, dados_pais_nome)
        if not pais_id:
            raise Exception('Pais nao incluido: Codigo - %s, Nome - %s' %
                            (dados_pais_codigo, dados_pais_nome))
        else:
            # REGISTRO DO UF
            uf_id = db_registro.registro_uf(dados_cliente_uf, pais_id)
            if not uf_id:
                raise Exception('UF nao incluido: UF - %s' % dados_cliente_uf)
            else:
                # REGISTRO DA CIDADE
                cidade_id = db_registro.registro_cidade(
                    dados_cliente_cidade_codigo, dados_cliente_cidade, uf_id, dados_cliente_uf
                )
                if not cidade_id:
                    raise Exception('Cidade nao incluida: Codigo - %s, Nome - %s, UF - %s. '
                                    'OBS: Cidade com nome menor que 3 caracteres nao serao incluidas' %
                                    (dados_cliente_cidade_codigo, dados_cliente_cidade, dados_cliente_uf))
                else:
                    # REGISTRO DO BAIRRO
                    bairro_id = db_registro.registro_bairro(dados_cliente_bairro)
                    if not bairro_id:
                        raise Exception('Bairro nao incluido: Nome - %s' % dados_cliente_bairro)
                    else:
                        # REGISTRO DO LOGRADOURO
                        logradouro_id = db_registro.registro_logradouro(cliente_end_rua)
                        if not logradouro_id:
                            raise Exception('Logradouro nao incluido: Nome - %s' % cliente_end_rua)
                        else:
                            # REGISTRO DO TIPO DE ENDERECO
                            endereco_tipo_id = db_registro.registro_endereco_tipo('Normal')
                            if not endereco_tipo_id:
                                raise Exception('Tipo de endereco Normal nao incluido')
                            else:
                                # REGISTRO DO ENDERECO
                                endereco_id = db_registro.registro_endereco(cliente_end_numero, dados_cliente_cep,
                                                                            pessoa_id, endereco_tipo_id, pais_id, uf_id,
                                                                            cidade_id, bairro_id, logradouro_id)
                                if not endereco_id:
                                    raise Exception('Endereco do cliente nao incluido')

            ## SE O ENDERECO DE COBRANCA NAO CONSEGUI INSERIR ALGUMA INFORMACAO, PROSSEGUIR COM A OPERACAO

            # UF DIFERENTE DO UF DE COBRANCA
            cob_uf_id = uf_id
            if dados_cliente_uf != dados_cobranca_uf:
                # REGISTRO DO UF DE COBRANCA
                cob_uf_id = db_registro.registro_uf(dados_cobranca_uf, pais_id)
                if not cob_uf_id:
                    cob_uf_id = 0

            cob_cidade_id = cidade_id
            if dados_cliente_cidade_codigo != dados_cobranca_cidade_codigo and cob_uf_id:
                # REGISTRO DA CIDADE DE COBRANCA
                cob_cidade_id = db_registro.registro_cidade(dados_cobranca_cidade_codigo, dados_cobranca_cidade,
                                                            cob_uf_id, dados_cobranca_uf)
                if not cob_cidade_id:
                    cob_cidade_id = 0
            cob_bairro_id = bairro_id
            if dados_cliente_bairro != dados_cobranca_bairro:
                # REGISTRO DO BAIRRO DE COBRANCA
                cob_bairro_id = db_registro.registro_bairro(dados_cobranca_bairro)
                if not cob_bairro_id:
                    cob_bairro_id = 0

            cob_logradouro_id = logradouro_id
            if cliente_end_rua != cliente_endcob_rua:
                # REGISTRO DO LOGRADOURO DE COBRANCA
                cob_logradouro_id = db_registro.registro_logradouro(cliente_endcob_rua)
                if not cob_logradouro_id:
                    cob_logradouro_id = 0

            normal_endereco = hash('%d%d%d%d' % (uf_id, cidade_id, bairro_id, logradouro_id))
            cobranca_endereco = hash('%d%d%d%d' % (cob_uf_id, cob_cidade_id, cob_bairro_id, cob_logradouro_id))

            if normal_endereco == cobranca_endereco:
                criar_endereco_cobranca = False
            else:
                criar_endereco_cobranca = True

            if cliente_end_numero != cliente_endcob_numero or criar_endereco_cobranca:
                # REGISTRO DO TIPO DE ENDERECO
                cob_endereco_tipo_id = db_registro.registro_endereco_tipo('Cobranca')
                if cob_endereco_tipo_id:
                    # REGISTRO DO ENDERECO
                    db_registro.registro_endereco(cliente_endcob_numero, dados_cobranca_cep, pessoa_id,
                                                  cob_endereco_tipo_id, pais_id, cob_uf_id,
                                                  cob_cidade_id, cob_bairro_id, cob_logradouro_id)

        def pessoa_registrar_email(email, email_tipo):
            if email and email.count('@') + email.count('.') > 1:
                email_tipo_id = db_registro.registro_email_tipo(email_tipo)
                if not email_tipo_id:
                    return False
                else:
                    email_id = db_registro.registro_email(pessoa_id, email, email_tipo_id)
                    if not email_id:
                        return False
            return True

        # REGISTRO DE EMAIL
        email_registrado = pessoa_registrar_email(dados_email, 'Comum')
        if not email_registrado:
            raise Exception('Email nao incluido: Email - %s, Tipo - Comun' % dados_email)
        # REGISTRO DE EMAIL CELULAR
        email_celular_registrado = pessoa_registrar_email(dados_email_celular, 'Celular')
        if not email_celular_registrado:
            raise Exception('Email Celular nao incluido: Email - %s, Tipo - Comun' % dados_email_celular)

        def pessoa_registar_telefone(telefone, telefone_tipo):
            tel_tipo_id = db_registro.registro_telefone_tipo(telefone_tipo)
            if not tel_tipo_id:
                return False
            else:
                telefone_id = db_registro.registro_telefone(pessoa_id, telefone, tel_tipo_id)
                if not telefone_id:
                    return False
            return True

        if dados_pessoa_tipo == 'F':
            label_telefone = 'Residencial'
        else:
            label_telefone = 'Comercial'

        # REGISTRO DO TELEFONE
        telefone_registrado = pessoa_registar_telefone(dados_telefone, label_telefone)
        if not telefone_registrado:
            raise Exception('Telefone nao incluido: Telefone - %s, Tipo - %s' % (dados_telefone, label_telefone))
        # REGISTRO DO CELULAR
        celular_registrado = pessoa_registar_telefone(dados_celular, 'Celular')
        if not celular_registrado:
            raise Exception('Celular nao incluido: Celular - %s' % dados_celular)
        # REGISTRO DO FAX
        fax_registrado = pessoa_registar_telefone(dados_fax, 'Fax')
        if not fax_registrado:
            raise Exception('Fax nao incluido: Fax - %s' % dados_fax)

        dados_to_reg_cliente = {
            'condicao_pgto': dados_pagamento_condicao,
            'data_inclusao': dados_data_inclusao,
            'bonus_dia_mes': dados_bonus_dia_mes,
            'fidelidade_codigo': dados_fidelidade_codigo,
            'limite_credito': dados_limite_credito,
            'ativo': dados_ativo
        }

        if dados_grupo1:
            # CRIA CATEGORIA PARA O GRUPO1
            categoria_grupo1 = db_registro.registro_categoria_tipo(dados_grupo1_nome)
            if not categoria_grupo1:
                raise Exception('Tipo de categoria nao incluida: Tipo - %s' % dados_grupo1_nome)
            db_registro.registro_categoria_pessoa(pessoa_id, categoria_grupo1)
        if dados_grupo2:
            # CRIA CATEGORIA PARA O GRUPO2
            categoria_grupo2 = db_registro.registro_categoria_tipo(dados_grupo2_nome)
            if not categoria_grupo2:
                raise Exception('Tipo de categoria nao incluida: Tipo - %s' % dados_grupo2_nome)
            db_registro.registro_categoria_pessoa(pessoa_id, categoria_grupo2)

        cliente_company_id = funct_get_empresa(db_registro, 'financeiro.cliente', company_com_nf_id)
        cliente_id = db_registro.registro_cliente(cliente_company_id, pessoa_id, dados_to_reg_cliente)
        if not cliente_id:
            raise Exception('Cliente nao incluido: Codigo')
        legado_controle_cliente_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=dados_cliente_codigo,
            reg_tabela_legado='cre01',
            reg_check_table='adm_pessoa',
            reg_empresa_tipo=dados_empresa_tipo
        )

        if not legado_controle_cliente_id:

            # CRIA UM LEGADO CONTROLE PARA RELACIONAR O CODIGO DO CLIENTE COM A PESSOA NO ERP
            leg_controle_id = db_registro.create_legado_controle(
                reg_empresa_legado=empresa_legado,
                reg_tabela_legado='cre01',
                reg_chave_legado=dados_cliente_codigo,
                reg_chave_sigerp=pessoa_id,
                reg_check_table='adm_pessoa',
                reg_empresa_tipo=dados_empresa_tipo
            )

            if not leg_controle_id:
                raise Exception('Legado controle nao incluido para o codigo do cliente: %s' % dados_cliente_codigo)
        else:
            args_legado_controle = [
                ('empresa', '=', empresa_legado), ('tabela_legado', '=', 'cre01'),
                ('chave_legado', '=', dados_cliente_codigo)
            ]

            db_registro.update_legado_controle(
                reg_values={'chave_sigerp': pessoa_id},
                reg_args=args_legado_controle,
                reg_check_table='adm_pessoa',
                reg_empresa_tipo=dados_empresa_tipo
            )

        msg_nome_id = db_registro.registro_mensagem_nome(dados_mensagem_codigo, dados_mensagem, 'N')
        if not msg_nome_id:
            raise Exception('Mensagem nao incluida: Codigo - %s, Nome - %s, Tipo - N' %
                            (dados_mensagem_codigo, dados_mensagem))
        else:
            msg_cliente = db_registro.registro_cliente_mensagem(msg_nome_id, cliente_id, {})
            if not msg_cliente:
                raise Exception('Mensagem nao foi associada ao cliente - Mensagem ID - %s, Cliente ID - %s' %
                                (str(msg_nome_id), str(cliente_id)))

        return True

    except TransactionRollbackError:
        return False

    except:
        db_registro.cr_integracao.connection.rollback()
        msg_erro = traceback_format_exc().replace("'", '"')
        db_registro.registro_gravar_erro(legado_log_id, msg_erro)
        return False


def cre02_format_data(dados):

    lista_dados = re_sub('#', ' ', dados).replace('\n', '').split('*|*')

    # lista_dados[1] = lista_dados[1]
    # lista_dados[2] = lista_dados[2]
    lista_dados[3] = lista_dados[3].strip()
    # lista_dados[4] = lista_dados[4]
    # lista_dados[5] = lista_dados[5]
    # lista_dados[6] = lista_dados[6]
    # lista_dados[7] = lista_dados[7]
    lista_dados[8] = sigDatas(lista_dados[8]).getDataNoFormato('I', 'S', '-')
    lista_dados[9] = '%s.%s' % (lista_dados[9][:10], lista_dados[9][10:])
    lista_dados[10] = sigDatas(lista_dados[10]).getDataNoFormato('I', 'S', '-')
    lista_dados[11] = sigDatas(lista_dados[11]).getDataNoFormato('I', 'S', '-')
    # lista_dados[12] = lista_dados[12]
    lista_dados[13] = lista_dados[13].strip()
    # lista_dados[14] = lista_dados[14]
    # lista_dados[15] = lista_dados[15]
    # lista_dados[16] = lista_dados[16]
    lista_dados[17] = sigDatas(lista_dados[17]).getDataNoFormato('I', 'S', '-')
    lista_dados[18] = '%s.%s' % (lista_dados[18][:10], lista_dados[18][10:])
    # lista_dados[19] = lista_dados[19]
    lista_dados[20] = funct_retira_acentos(lista_dados[20].strip())
    lista_dados[21] = lista_dados[21].strip()

    return lista_dados


# TITULOS _____________________________________
def gerarCre02(db_registro, legado_log_id, dados, company_com_nf_id, company_sem_nf_id, empresa_legado, operacao, context=None):

    try:

        lista_dados = cre02_format_data(dados)

        dados_cliente_codigo = lista_dados[0]
        dados_loja = lista_dados[1]
        dados_duplicata = lista_dados[2]
        dados_desdobramento = lista_dados[3]
        # dados_tipo_documento = lista_dados[4]
        # dados_departamento = lista_dados[5]
        dados_vendedor = lista_dados[6]
        dados_vendedor_externo = lista_dados[7]
        dados_emissao = lista_dados[8]
        dados_valor = lista_dados[9]
        dados_prorrogacao = lista_dados[10]
        dados_vencimento = lista_dados[11]
        dados_local_cobranca = lista_dados[12]
        dados_conta_banco = lista_dados[13]
        # dados_agencia = lista_dados[14]
        # dados_bordero = lista_dados[15]
        dados_natureza = lista_dados[16]
        # dados_data_baixa = lista_dados[17]
        dados_saldo = lista_dados[18]
        dados_csnf = lista_dados[19]
        dados_obs = lista_dados[20]
        # dados_origem = lista_dados[21]

        documento = '%s-%s' % (str(dados_loja), str(dados_duplicata))
        if dados_desdobramento != '':
            documento = '%s-%s' % (documento, str(dados_desdobramento))

        if dados_emissao == '0000-00-00':
            raise Exception(
                'Data Emissao invalida: %s' % dados_emissao
            )

        if dados_vencimento == '0000-00-00':
            raise Exception(
                'Data Vencimento invalida: %s' % dados_vencimento
            )

        if dados_prorrogacao == '0000-00-00':
            raise Exception(
                'Data Prorrogacao invalida: %s' % dados_prorrogacao
            )

        if not float(dados_valor):
            raise Exception('Valor zerado: %s' % dados_valor)

        if dados_csnf != 'S':
            dados_csnf = 'C'

        if dados_csnf == 'S':
            company_id = company_sem_nf_id
        else:
            company_id = company_com_nf_id

        pessoa_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=dados_cliente_codigo,
            reg_tabela_legado='cre01',
            reg_check_table='adm_pessoa',
            reg_empresa_tipo=dados_csnf
        )

        if not pessoa_id:
            raise Exception('Cre02 - Cliente nao cadastrado na legado_controle. Chave_legado - %s' % dados_cliente_codigo)

        documento_dados = db_registro.select(table='documento_documento_tipo', fields=['id'], where=[('sigla', '=', 'DP')])
        if not documento_dados:
            raise Exception('Tipo de Documento com sigla DP nao encontrado')

        doc_tipo_id = documento_dados[0]['id']

        titulo_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=dados_cliente_codigo + documento,
            reg_tabela_legado='cre02',
            reg_check_table='financeiro_titulo',
            reg_empresa_tipo=dados_csnf
        )

        # LOCAL DE COBRANCA
        if dados_local_cobranca != '000':
            banco_dados = db_registro.select(
                table='adm_banco', fields=['admbco_pessoa_id'], where=[('admbco_codigo_bc', '=', dados_local_cobranca)]
            )
            if not banco_dados:
                dados_local_cobranca = '000'
            else:
                banco_pessoa_id = banco_dados[0]['admbco_pessoa_id']
                local_cobranca_dados = db_registro.select(
                    table='financeiro_local_cobranca', fields=['id'], where=[('pessoa_id', '=', banco_pessoa_id)]
                )
                if local_cobranca_dados:
                    local_cobranca_id = local_cobranca_dados[0]['id']

        # LOCAL DE COBRANCA
        if dados_local_cobranca == '000':
            local_cobranca_dados = db_registro.select(
                table='financeiro_local_cobranca', fields=['id'], where=[('tipo', '=', 'C')]
            )
            if not local_cobranca_dados:
                raise Exception('Cre02 - Nenhum local de cobranca do tipo Carteira encontrado')
            else:
                local_cobranca_id = local_cobranca_dados[0]['id']

        DICT_NATUREZA = {'1': 'Cobranca simples', '2': 'Desconto', '3': 'Caucao'}

        # BUSCA MOEDA DO TIPO R$
        moeda_dados = db_registro.select(table='adm_moeda', fields=['id'], where=[('sigla', '=', 'R$')])
        if not moeda_dados:
            raise Exception('Cre02 - Moeda com sigla R$ nao cadastrada')
        else:
            moeda_id = moeda_dados[0]['id']

        if operacao != 'w':
            if not titulo_id:
                raise Exception('Cre02 - Titulo nao cadastrado: %s. Cliente: %s' % (documento, dados_cliente_codigo))
        elif operacao == 'd':
            # TODO: NAO IMPLEMENTADO AINDA. O TITULO NAO DEVE SER EXLCUIDO E SIM CANCELADO. AGUARDAR O CRE03 PARA SABER
            return True

        # VERIFICANDO AS EMPRESAS
        titulo_company_id = funct_get_empresa(db_registro, 'financeiro.titulo', company_com_nf_id)
        try:
            if float(dados_valor) < 0:
                tipo_titulo = 'P'
                dados_valor = float(dados_valor).__abs__()
                dados_saldo = float(dados_saldo).__abs__()
            else:
                tipo_titulo = 'R'
        except ValueError:
            raise Exception('Cre02 - Valor do titulo invalido')

        vals_titulo = {
            'company_id': titulo_company_id,
            'doc_tipo_id': doc_tipo_id,
            'pessoa_id': pessoa_id,
            'documento': documento,
            'parcela': 0,
            'local_cobranca_id': local_cobranca_id,
            'tipo_titulo': '%s' % tipo_titulo,
            'state': 'A',
            'data_emissao': dados_emissao,
            'data_vencimento': dados_vencimento,
            'data_prorrogacao': dados_prorrogacao,
            'tipo_sacado': 'C',
            'vr_original': dados_valor,
            'saldo': dados_saldo,
            'adm_moeda_id': moeda_id,
            'tipo_lancamento': 'M',
        }
        vendedor_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=dados_vendedor,
            reg_tabela_legado='est11',
            reg_check_table='vendas_vendedor',
            reg_empresa_tipo=dados_csnf
        )

        vendedor_externo_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=dados_vendedor_externo,
            reg_tabela_legado='est11',
            reg_check_table='vendas_vendedor',
            reg_empresa_tipo=dados_csnf
        )

        if vendedor_id:
            vals_titulo['vendedor_id'] = vendedor_id
        if vendedor_externo_id:
            vals_titulo['vendedor_externo_id'] = vendedor_externo_id

        # NATUREZA DE COBRANCA
        if dados_natureza in DICT_NATUREZA.keys():
            natureza_cob_dados = db_registro.select(
                table='financeiro_natureza_cobranca', fields=['id'], where=[('name', 'ilike', DICT_NATUREZA[dados_natureza])]
            )
            if natureza_cob_dados:
                natureza_cob_id = natureza_cob_dados[0]['id']
                vals_titulo['natureza_cobranca_id'] = natureza_cob_id

        # OBSERVACAO
        if dados_obs:
            vals_titulo['observacoes'] = dados_obs

        if not titulo_id:
            if operacao == 'w':
                # CRIA UM TITULO
                titulo_id = db_registro.insert(table='financeiro_titulo', vals=vals_titulo)

                db_registro.create_legado_controle(
                    reg_empresa_legado=empresa_legado,
                    reg_tabela_legado='cre02',
                    reg_chave_legado=dados_cliente_codigo + documento,
                    reg_chave_sigerp=titulo_id,
                    reg_check_table='financeiro_titulo',
                    reg_empresa_tipo=dados_csnf
                )
        else:
            # ATUALIZA OS DADOS DO TITULO
            # o titulo já existindo, o status não deve ser mudado
            x = vals_titulo.pop('state')
            db_registro.update(table='financeiro_titulo', values=vals_titulo, where=[('id', '=', titulo_id)])

        # só tem boleto se tem natureza
        if dados_natureza in DICT_NATUREZA.keys():
            titulo_boleto_ids = db_registro.select(
                table='financeiro_titulo_boleto', fields=['id'],
                where=[('fintib_titulo_id', '=', titulo_id),
                       ('fintib_local_cobranca_id', '=', local_cobranca_id),
                       ('fintib_nosso_numero', '=', dados_conta_banco)])
            if not titulo_boleto_ids:
                vals_titulo_boleto = {
                    'fintib_titulo_id': titulo_id,
                    'fintib_local_cobranca_id': local_cobranca_id,
                    'fintib_natureza_cobranca_id': natureza_cob_id,
                    'fintib_nosso_numero': dados_conta_banco,
                    'state': 'A'
                }
                db_registro.insert(table='financeiro_titulo_boleto', vals=vals_titulo_boleto)

        return True

    except TransactionRollbackError:
        return False

    except:
        db_registro.cr_integracao.connection.rollback()
        msg_erro = traceback_format_exc().replace("'", '"')
        db_registro.registro_gravar_erro(legado_log_id, msg_erro)
        return False


def cre03_format_data(dados):

    lista_dados = re_sub('#', ' ', dados).replace('\n', '').split('*|*')

    # lista_dados[0] = lista_dados[0]
    lista_dados[1] = re_sub(' ', '', lista_dados[1])
    # lista_dados[2] = lista_dados[2]
    # lista_dados[3] = lista_dados[3]
    lista_dados[4] = lista_dados[4].strip()
    lista_dados[5] = sigDatas(lista_dados[5]).getDataNoFormato('I', 'S', '-')
    # lista_dados[6] = lista_dados[6]
    # lista_dados[7] = lista_dados[7]
    # lista_dados[8] = lista_dados[8]
    # lista_dados[9] = lista_dados[9]
    lista_dados[10] = sigDatas(lista_dados[10]).getDataNoFormato('I', 'S', '-')
    lista_dados[11] = '%s.%s' % (lista_dados[11][:10], lista_dados[11][10:])
    lista_dados[12] = sigDatas(lista_dados[12]).getDataNoFormato('I', 'S', '-')
    lista_dados[13] = lista_dados[13].replace(' ', '0')
    # lista_dados[14] = lista_dados[14]
    lista_dados[15] = sigDatas(lista_dados[15]).getDataNoFormato('I', 'S', '-')
    lista_dados[16] = '%s.%s' % (lista_dados[16][:10], lista_dados[16][10:])
    lista_dados[17] = '%s.%s' % (lista_dados[17][:10], lista_dados[17][10:])
    lista_dados[18] = '%s.%s' % (lista_dados[18][:10], lista_dados[18][10:])
    # lista_dados[19] = lista_dados[19]
    lista_dados[20] = lista_dados[20].strip()
    lista_dados[21] = lista_dados[21].strip()
    # lista_dados[22] = lista_dados[22]

    return lista_dados


# HISTORICO DO TITULO ___________________________________
def gerarCre03(db_registro, legado_log_id, dados, company_com_nf_id, company_sem_nf_id, empresa_legado, operacao, context=None):

    try:

        # REGRAVAO OU DELECAO DO HISTORICO NAO IMPORTA, POIS NO HISTORICO SO EXISTE E INCLUSAO DE NOVOS REGISTROS
        if operacao in ('d', 'r'):
            return True

        lista_dados = cre03_format_data(dados)

        dados_tipo_movimento = lista_dados[0]
        dados_cliente_codigo = lista_dados[1]
        dados_loja = lista_dados[2]
        dados_duplicata = lista_dados[3]
        dados_desdobramento = lista_dados[4]
        dados_data_movimento = lista_dados[5]
        dados_sequencia = lista_dados[6]
        # dados_tipo_documento = lista_dados[7]
        # dados_departamento = lista_dados[8]
        # dados_vendedor = lista_dados[9]
        dados_data_emissao = lista_dados[10]
        dados_valor_original = lista_dados[11]
        dados_data_vencimento = lista_dados[12]
        dados_local_cobranca = lista_dados[13]
        dados_natureza = lista_dados[14]
        dados_data_baixa = lista_dados[15]
        dados_juros = lista_dados[16]
        dados_desconto = lista_dados[17]
        dados_valor_pago = lista_dados[18]
        dados_csnf = lista_dados[19]
        dados_obs = lista_dados[20]
        # dados_usuario = lista_dados[21]
        # dados_vendedor_externo = lista_dados[22]

        try:
            int(dados_cliente_codigo)
        except:
            raise Exception('Cre03 - Codigo do cliente invalido: %s' % dados_cliente_codigo)

        chave_cre03 = '%s%s%s%s%s%s' % (dados_tipo_movimento, dados_cliente_codigo, dados_duplicata, dados_desdobramento,
                                        dados_data_movimento, dados_sequencia)

        chave_erp_titulo_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=chave_cre03,
            reg_tabela_legado='cre03',
            reg_check_table='financeiro_titulo_historico',
            reg_empresa_tipo=dados_csnf
        )

        if chave_erp_titulo_id:
            raise Exception('Cre03 - Movimento ja lancado na tabela legado_controle. Chave_legado: %s' % chave_cre03)

        # DATA EMISSAO
        try:
            parse(dados_data_emissao, yearfirst=True)
        except:
            raise Exception('Cre03 - Data Emissao invalida: %s', dados_data_emissao)
        # DATA VENCIMENTO
        try:
            parse(dados_data_vencimento, yearfirst=True)
        except:
            raise Exception('Cre03 - Data Vencimento invalida: %s', dados_data_vencimento)
        # DATA MOVIMENTO
        try:
            parse(dados_data_movimento, yearfirst=True)
        except:
            raise Exception('Cre03 - Data Movimento invalida: %s', dados_data_movimento)
        # VALOR
        if not float(dados_valor_original):
            raise Exception('Cre03 - Valor Original igual a zero: %s' % dados_valor_original)

        if dados_csnf != 'S':
            dados_csnf = 'C'

        if dados_csnf == 'S':
            company_id = company_sem_nf_id
        else:
            company_id = company_com_nf_id

        pessoa_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=dados_cliente_codigo,
            reg_tabela_legado='cre01',
            reg_check_table='adm_pessoa',
            reg_empresa_tipo=dados_csnf
        )

        if not pessoa_id:
            raise Exception('Cre03 - Codigo cliente nao cadastrado no legado controle: %s' % dados_cliente_codigo)

        documento = '%s-%s' % (dados_loja, dados_duplicata)
        if dados_desdobramento:
            documento = '%s-%s' % (documento, dados_desdobramento)

        if dados_local_cobranca != '000':
            adm_banco_dados = db_registro.select(
                table='adm_banco', fields=['admbco_pessoa_id'], where=[('admbco_codigo_bc', '=', dados_local_cobranca)]
            )
            if not adm_banco_dados:
                dados_local_cobranca = '000'
            else:
                banco_pessoa_id = adm_banco_dados[0]['admbco_pessoa_id']
                local_cobranca_dados = db_registro.select(
                    table='financeiro_local_cobranca', fields=['id'], where=[('pessoa_id', '=', banco_pessoa_id)]
                )

        if dados_local_cobranca == '000':
            local_cobranca_dados = db_registro.select(
                table='financeiro_local_cobranca', fields=['id'], where=[('tipo', '=', 'C')],  order_by=['id']
            )

        if not local_cobranca_dados:
            raise Exception('Cre03 - Local nao cadastrado: %s' % dados_local_cobranca)

        local_id = local_cobranca_dados[0]['id']
        DICT_NATUREZA = {'1': 'Cobranca simples', '2': 'Desconto', '3': 'Caucao'}

        if dados_tipo_movimento == 'A':  # ENTRADA
            titulo_state = 'B'
            # historico_state = 'A'
            historico_titulo = 'I'
        elif dados_tipo_movimento == 'B':  # BAIXA
            titulo_state = 'B'
            # historico_state = 'B'
            historico_titulo = 'B'
        elif dados_tipo_movimento == 'C':  # BAIXA PARCIAL
            titulo_state = 'B'
            # historico_state = 'A'
            historico_titulo = 'BP'
        elif dados_tipo_movimento == 'D':  # CANCELAMENTO
            titulo_state = 'C'
            # historico_state = 'C'
            historico_titulo = 'C'
        elif dados_tipo_movimento == 'E':  # REGISTRO
            titulo_state = 'B'
            # historico_state = 'A'
            historico_titulo = 'R'
        elif dados_tipo_movimento == 'F':  # PRORROGACAO
            titulo_state = 'B'
            # historico_state = 'A'
            historico_titulo = 'PR'
        else:
            raise Exception(
                'Tipo de movimento informacao invalido. O movimento informado deve estar entre os tipos: A - Entrada, '
                'B - Baixa, C - Baixa Parcial, D - Cancelamento, E - Registro ou F - Prorrogacao'
            )

        cre02_titulo_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=dados_cliente_codigo + documento,
            reg_tabela_legado='cre02',
            reg_check_table='financeiro_titulo',
            reg_empresa_tipo=dados_csnf
        )

        natureza_id = False
        if dados_natureza in DICT_NATUREZA.keys():
            natureza_dados = db_registro.select(
                table='financeiro_natureza_cobranca', fields=['id'], where=[('name', 'ilike', DICT_NATUREZA[dados_natureza])]
            )
            if natureza_dados:
                natureza_id = natureza_dados[0]['id']

        try:
            data_baixa = parse(dados_data_baixa, yearfirst=True).date().strftime('%Y-%m-%d')
        except:
            data_baixa = dados_data_vencimento

        # SE NAO HOUVER TITULO PARA O HISTORICO, UM NOVO TITULO É CRIADO
        if not cre02_titulo_id:
            # CRIAR UM NOVO TITULO PARA AO MOVIMENTO

            # ADM MOEDA
            adm_moeda_dados = db_registro.select(table='adm_moeda', fields=['id'], where=[('sigla', '=', 'R$')])
            if adm_moeda_dados:
                adm_moeda_id = adm_moeda_dados[0]['id']
            else:
                raise Exception('Nenhuma moeda cadastrada na tabela adm_moeda com a sigla: R$')
            # TIPO DE DOCUMENTO
            documento_tipo_dados = db_registro.select(
                table='documento_documento_tipo', fields=['id'], where=[('sigla', '=', 'DP')]
            )
            if not documento_tipo_dados:
                raise Exception('Cre03 - Nenhum documento encontrado com a sigla DP')

            doc_tipo_id = documento_tipo_dados[0]['id']

            vals_titulo = {
                'company_id': company_id,
                'doc_tipo_id': doc_tipo_id,
                'pessoa_id': pessoa_id,
                'documento': documento,
                'parcela': 0,
                'local_cobranca_id': local_id,
                'tipo_titulo': 'R',
                'data_emissao': dados_data_emissao,
                'data_vencimento': dados_data_vencimento,
                'data_prorrogacao': dados_data_vencimento,
                'tipo_sacado': 'C',
                'vr_original': dados_valor_original,
                'saldo': dados_valor_original,
                'adm_moeda_id': adm_moeda_id,
                'tipo_lancamento': 'M',
                'state': titulo_state
            }

            if natureza_id:
                vals_titulo['natureza_cobranca_id'] = natureza_id

            if dados_obs:
                vals_titulo['observacoes'] = dados_obs

            vals_titulo['data_pagamento'] = data_baixa
            cre02_titulo_id = db_registro.insert(table='financeiro_titulo', vals=vals_titulo)

            db_registro.create_legado_controle(
                reg_empresa_legado=empresa_legado,
                reg_tabela_legado='cre02',
                reg_chave_legado=dados_cliente_codigo + documento,
                reg_chave_sigerp=cre02_titulo_id,
                reg_check_table='financeiro_titulo',
                reg_empresa_tipo=dados_csnf
            )

        vals_titulo_historico = {
            'titulo_id': cre02_titulo_id,
            'local_cobranca_id': local_id,
            'data_prorrogacao': dados_data_vencimento,
            'operacao': historico_titulo
        }

        if natureza_id:
            vals_titulo_historico['natureza_cobranca_id'] = natureza_id
        # CRIA O HISTORICO DO TITULO
        historico_id = db_registro.insert(table='financeiro_titulo_historico', vals=vals_titulo_historico)

        db_registro.create_legado_controle(
            reg_empresa_legado=empresa_legado,
            reg_tabela_legado='cre03',
            reg_chave_legado=chave_cre03,
            reg_chave_sigerp=historico_id,
            reg_check_table='financeiro_titulo_historico',
            reg_empresa_tipo=dados_csnf
        )

        values_titulo = {}

        if dados_tipo_movimento in ('B', 'C'):
            vals_baixa = {
                'data_baixa': data_baixa,
                'data_pgto': data_baixa,
                'titulo_id': cre02_titulo_id,
                'valor_pago': float(dados_valor_pago) + float(dados_juros) - float(dados_desconto),
                'valor_juros': dados_juros,
                'valor_desconto': dados_desconto
            }
            # CRIA A BAIXA DO TITULO
            db_registro.insert(table='financeiro_titulo_baixa', vals=vals_baixa)

            if operacao != 'x' and dados_tipo_movimento == 'B':
                values_titulo.update({
                    'data_pagamento': data_baixa,
                    'juros': dados_juros,
                    'desconto': dados_desconto,
                    'state': 'B',
                    'saldo': 0
                })

        elif dados_tipo_movimento == 'D':
            values_titulo.update({
                'state': 'C',
                'data_cancelamento': dados_data_movimento,
                'fintit_cancel_user_id': db_registro.uid
            })

        if values_titulo:
            db_registro.update(table='financeiro_titulo', values=values_titulo, where=[('id', '=', cre02_titulo_id)])

        return True

    except TransactionRollbackError:
        return False

    except:
        db_registro.cr_integracao.connection.rollback()
        msg_erro = traceback_format_exc().replace("'", '"')
        db_registro.registro_gravar_erro(legado_log_id, msg_erro)
        return False


def cre05_format_data(dados):

    lista_dados = re_sub('#', ' ', dados).replace('\n', '').split('*|*')

    lista_dados[0] = lista_dados[0].strip()
    lista_dados[1] = lista_dados[1].strip()
    lista_dados[2] = lista_dados[2].upper()

    return lista_dados


# NATUREZA DE COBRANCA
def gerarCre05(db_registro, legado_log_id, dados, company_com_nf_id, company_sem_nf_id, empresa_legado, operacao, context=None):

    try:

        lista_dados = cre05_format_data(dados)

        dados_natureza_codigo = lista_dados[0]
        dados_natureza_descricao = lista_dados[1]
        dados_integra_fluxo = lista_dados[2]

        # PROCURA A NATUREZA PELO CODIGO
        cre05_natureza_cob_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=dados_natureza_codigo,
            reg_tabela_legado='cre05',
            reg_check_table='financeiro_natureza_cobranca',
        )

        if not cre05_natureza_cob_id:
            # PROCURA A NATUREZA PELO NOME NA TABELA financeiro_natureza_cobranca
            cre05_natureza_cob_id = db_registro.select(
                table='financeiro_natureza_cobranca', fields=['id'], where=[('name', 'ilike', dados_natureza_descricao)]
            )

        if dados_integra_fluxo == 'S':
            recebimento_antecipado = True
        else:
            recebimento_antecipado = False

        # INSERCAO
        if operacao == 'w':
            if cre05_natureza_cob_id:
                return cre05_natureza_cob_id

            # CRIAR NATUREZA DE COBRANCA

            vals_natureza_cobranca = {
                'name': dados_natureza_descricao,
                'recebimento_antecipado': recebimento_antecipado
            }

            natureza_cob_id = db_registro.insert(table='financeiro_natureza_cobranca', vals=vals_natureza_cobranca)

            args_legado_controle = [
                ('empresa', '=', empresa_legado), ('chave_legado', '=', dados_natureza_codigo),
                ('tabela_legado', '=', 'cre05')
            ]
            legado_controle_dados = db_registro.select_legado_controle(
                reg_fields=['id'],
                reg_args=args_legado_controle,
                reg_check_table='financeiro_natureza_cobranca',
            )

            if legado_controle_dados:
                legado_controle_id = legado_controle_dados[0]['id']

                db_registro.update_legado_controle(
                    reg_values={'chave_sigerp': natureza_cob_id},
                    reg_args=[('id', '=', legado_controle_id)],
                    reg_check_table='financeiro_natureza_cobranca',
                )

            else:
                # REGISTRA A RELACAO NA LEGADO CONTROLE
                db_registro.create_legado_controle(
                    reg_empresa_legado=empresa_legado,
                    reg_tabela_legado='cre05',
                    reg_chave_legado=dados_natureza_codigo,
                    reg_chave_sigerp=natureza_cob_id,
                    reg_check_table='financeiro_natureza_cobranca',
                )

        elif operacao in ('r', 'd'):
            label_operacao = 'delecao' if operacao == 'd' else 'alteracao'

            if not cre05_natureza_cob_id:
                raise Exception(
                    'Cre05 - Codigo da natureza nao encontrado na legado_controle para realizar a %s. '
                    'Chave_legado - %s' % (label_operacao, dados_natureza_codigo))

            # ATUALIZACAO
            elif operacao == 'r':
                values_natureza_cobranca = {
                    'name': dados_natureza_descricao,
                    'recebimento_antecipado': recebimento_antecipado,
                }
                db_registro.update(table='financeiro_natureza_cobranca', values=values_natureza_cobranca)
            # DELECAO
            elif operacao == 'd':
                # APAGA A NATUREZA DE COBRANCA
                db_registro.delete(table='financeiro_natureza_cobranca', where=[('id', '=', cre05_natureza_cob_id)])
                # APAGA O legado_controle
                args_del = [
                    ('empresa', '=', empresa_legado), ('chave_legado', '=', dados_natureza_codigo),
                    ('tabela_legado', '=', 'cre05'), ('chave_sigerp', '=', cre05_natureza_cob_id)
                ]

                db_registro.delete_legado_controle(reg_args=args_del, reg_check_table='financeiro_natureza_cobranca')

        return True

    except TransactionRollbackError:
        return False

    except:
        db_registro.cr_integracao.connection.rollback()
        msg_erro = traceback_format_exc().replace("'", '"')
        db_registro.registro_gravar_erro(legado_log_id, msg_erro)
        return False

def cre10_format_data(dados):

    lista_dados = re_sub('#', ' ', dados).replace('\n', '').split('*|*')

    lista_dados[0] = lista_dados[0].strip()
    lista_dados[1] = lista_dados[1].strip()
    lista_dados[2] = lista_dados[2].upper()

    return lista_dados

# Ocorrencias
def gerarCre10(db_registro, legado_log_id, dados, company_com_nf_id, company_sem_nf_id, empresa_legado, operacao, context=None):

    try:

        lista_dados = cre05_format_data(dados)

        dados_cliente = lista_dados[0]
        dados_sequencia = lista_dados[1]
        dados_ocorrencia = lista_dados[2]

        pessoa_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=dados_cliente,
            reg_tabela_legado='cre01',
            reg_check_table='adm_pessoa',
        )

        if not pessoa_id:
            raise Exception('Cre10 - Cliente nao cadastrado: %s' % dados_cliente)

        chave_ocorrencia = '%s%s' % (dados_cliente, dados_sequencia)

        ocorrencia_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=chave_ocorrencia,
            reg_tabela_legado='cre10',
            reg_check_table='adm.ocorrencia',
        )

        if ocorrencia_id:
            return True

        vals_ocorrencia = {
            'admoco_pessoa_id': pessoa_id,
            'admoco_descricao': dados_ocorrencia
        }
        # INSERCAO
        if operacao == 'w':
            if ocorrencia_id:
                return ocorrencia_id

            # CRIAR Ocorrencia


            ocorrencia_id = db_registro.insert(table='adm.ocorrencia', vals=vals_ocorrencia)

            args_legado_controle = [
                ('chave_legado', '=', chave_ocorrencia),
                ('tabela_legado', '=', 'cre10')
            ]
            legado_controle_dados = db_registro.select_legado_controle(
                reg_fields=['id'],
                reg_args=args_legado_controle,
                reg_check_table='adm.financeiro',
            )

            if legado_controle_dados:
                legado_controle_id = legado_controle_dados[0]['id']

                db_registro.update_legado_controle(
                    reg_values={'chave_sigerp': ocorrencia_id},
                    reg_args=[('id', '=', legado_controle_id)],
                    reg_check_table='adm.ocorrencia',
                )

            else:
                # REGISTRA A RELACAO NA LEGADO CONTROLE
                db_registro.create_legado_controle(
                    reg_empresa_legado=empresa_legado,
                    reg_tabela_legado='cre10',
                    reg_chave_legado=chave_ocorrencia,
                    reg_chave_sigerp=ocorrencia_id,
                    reg_check_table='adm.ocorrencia',
                )

        elif operacao in ('r', 'd'):
            label_operacao = 'delecao' if operacao == 'd' else 'alteracao'

            if not ocorrencia_id:
                raise Exception(
                    'Cre10 - Ocorrencia nao encontrado na legado_controle para realizar a %s. '
                    'Chave_legado - %s' % (label_operacao, chave_ocorrencia))

            # ATUALIZACAO
            elif operacao == 'r':
                db_registro.update(table='adm.ocorrencia', values=vals_ocorrencia, where=[('id', '=', ocorrencia_id)])
            # DELECAO
            elif operacao == 'd':
                # APAGA A NATUREZA DE COBRANCA
                db_registro.delete(table='financeiro_natureza_cobranca', where=[('id', '=', ocorrencia_id)])
                # APAGA O legado_controle
                args_del = [
                    ('empresa', '=', empresa_legado), ('chave_legado', '=', chave_ocorrencia),
                    ('tabela_legado', '=', 'cre10'), ('chave_sigerp', '=', ocorrencia_id)
                ]

                db_registro.delete_legado_controle(reg_args=args_del, reg_check_table='adm.ocorrencia')

        return True

    except TransactionRollbackError:
        return False

    except:
        db_registro.cr_integracao.connection.rollback()
        msg_erro = traceback_format_exc().replace("'", '"')
        db_registro.registro_gravar_erro(legado_log_id, msg_erro)
        return False


def cre22_format_data(dados):

    lista_dados = re_sub('#', ' ', dados).replace('\n', '').split('*|*')

    # lista_dados[0] = lista_dados[0]
    # lista_dados[1] = lista_dados[1]
    # lista_dados[2] = lista_dados[2]
    lista_dados[3] = sigDatas(lista_dados[3]).getDataNoFormato('I', 'S', '-')
    lista_dados[4] = lista_dados[4].strip()
    # lista_dados[5] = lista_dados[5]
    # lista_dados[6] = lista_dados[6]
    lista_dados[7] = lista_dados[7][:10]
    lista_dados[8] = lista_dados[8].strip()
    lista_dados[9] = funct_retira_acentos(lista_dados[9].strip())

    return lista_dados


# FIDELIDADE MOVIMENTO
def gerarCre22(db_registro, legado_log_id, dados, company_com_nf_id, company_sem_nf_id, empresa_legado, operacao, context=None):

    try:

        if operacao != 'w':
            return True

        lista_dados = cre22_format_data(dados)

        dados_contra_data = lista_dados[0]
        dados_contra_hora = lista_dados[1]
        dados_cliente_codigo = lista_dados[2]
        dados_data = lista_dados[3]
        dados_serie = lista_dados[4]
        dados_documento = lista_dados[5]
        dados_ecf = lista_dados[6]
        dados_valor = lista_dados[7]
        # dados_usuario = lista_dados[8]
        dados_historico = lista_dados[9]

        pessoa_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=dados_cliente_codigo,
            reg_tabela_legado='cre01',
            reg_check_table='adm_pessoa',
        )

        if not pessoa_id:
            raise Exception('Cre22 - Cliente nao cadastrado: %s' % dados_cliente_codigo)

        documento = '%s-%s' % (dados_serie, dados_documento)
        chave_data_hora = '%s%s' % (dados_contra_data, dados_contra_hora)

        fidelidade_mov_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=chave_data_hora,
            reg_tabela_legado='cre22',
            reg_check_table='fidelidade_movimento',
        )

        if fidelidade_mov_id:
            return True

        name = '%s-%s-%s-%s' % tuple(map(str, [dados_historico, dados_serie, dados_ecf, documento]))

        fidelidade_mov_company_id = funct_get_empresa(db_registro, 'fidelidade.movimento',
                                                      company_com_nf_id)
        vals_fidelidade_mov = {
            'company_id': fidelidade_mov_company_id,
            'pessoa_id': pessoa_id,
            'data': dados_data,
            'name': name,
            'pontos': dados_valor
        }

        fidelidade_mov_id = db_registro.insert(table='fidelidade_movimento', vals=vals_fidelidade_mov)

        db_registro.create_legado_controle(
            reg_empresa_legado=empresa_legado,
            reg_tabela_legado='cre22',
            reg_chave_legado=chave_data_hora,
            reg_chave_sigerp=fidelidade_mov_id,
            reg_check_table='fidelidade_movimento',
        )

        return True

    except TransactionRollbackError:
        return False

    except:
        db_registro.cr_integracao.connection.rollback()
        msg_erro = traceback_format_exc().replace("'", '"')
        db_registro.registro_gravar_erro(legado_log_id, msg_erro)
        return False
