# !/usr/bin/python
# -*- coding: utf-8 -*-


from SigUtils import datas, calcDigito, formatastring
from ..funcoes.integ_funcoes import funct_retira_acentos
from psycopg2.extensions import TransactionRollbackError
from traceback import format_exc as traceback_format_exc
from ..funcoes.integ_funcoes import funct_get_empresa


def gerarCtb01(db_registro, legado_log_id, dados, company_com_nf_id, company_sem_nf_id,
               empresa_legado, operacao, context=None):
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        _chave = listaDados[0]
        _contaReduzida = listaDados[1]
        _nomeConta = listaDados[2].replace("'", " ").strip()
        _nomeConta = funct_retira_acentos(_nomeConta)
        _digito = listaDados[3]
        _saldo = listaDados[4][:13] + '.' + listaDados[4][13:]
        _apuracao = listaDados[5]
        _sintetAnalit = listaDados[6]
        if _chave[6:] != '00000':
            _sintetAnalit = 'A'
        else:
            _sintetAnalit = 'S'
        _classificaAnaliticas = listaDados[7]
        _naturezaConta = listaDados[8]
        _mes_encerrado = int(listaDados[9][:2])
        _ano_encerrado = int(listaDados[9][2:])
        _mes_saldo = _mes_encerrado + 1
        _ano_saldo = _ano_encerrado
        if _mes_saldo > 12:
            _mes_saldo = 1
            _ano_saldo += 1
        _mes_saldo = formatastring.formataString(_mes_saldo, 2, '0', 'E')
        _ano_saldo = formatastring.formataString(_ano_saldo, 4, '0', 'E')
        _data_saldo = _ano_saldo + '/' + _mes_saldo + '/' + '01'

        company_id_conta = funct_get_empresa(db_registro, 'contabil.conta', company_com_nf_id)

        _grau = 5
        if _chave[6:] == '00000':
            _chave = _chave[:6]
            _grau = 4
        if _chave[4:] == '00':
            _chave = _chave[:4]
            _grau = 3
        if _chave[2:] == '00':
            _chave = _chave[:2]
            _grau = 2
        if _chave[1:] == '0':
            _chave = _chave[:1]
            _grau = 1
        if _naturezaConta == '1':
            _naturezaConta = 'A'
        else:
            if _naturezaConta == '2':
                _naturezaConta = 'P'
            else:
                if _naturezaConta == '3':
                    _naturezaConta = 'L'
                else:
                    if _naturezaConta == '4':
                        _naturezaConta = 'R'
                    else:
                        if _naturezaConta == '5':
                            _naturezaConta = 'C'
                        else:
                            _naturezaConta = 'O'

        valsConta = {
            'company_id': company_id_conta,
            'conta': _chave,
            'digito_conta': _digito,
            'conta_reduzida': _contaReduzida,
            'digito_reduzida': calcDigito.modulo10(_contaReduzida),
            'name': _nomeConta,
            'grau': _grau,
            'conta_tipo': _sintetAnalit,
            'natureza': _naturezaConta,
            'tipo_saldo': 'M',
        }
        _parent = ''
        if _grau == 2:
            _parent = _chave[:1]
        if _grau == 3:
            _parent = _chave[:2]
        if _grau == 4:
            _parent = _chave[:4]
        if _grau == 5:
            _parent = _chave[:6]
        if _parent:
            _args = [('conta', '=', _parent), ('company_id', '=', company_id_conta)]
            _dados_parent = db_registro.select(table='contabil_conta', fields=['id'], where=_args)
            if _dados_parent:
                valsConta['parent_id'] = _dados_parent[0]['id']
        company_id_saldos = funct_get_empresa(db_registro, 'contabil.saldos', company_com_nf_id)
        _dados_saldo = False
        _args = [('company_id', '=', company_id_conta), ("conta", '=', _chave)]
        _dados_conta = db_registro.select(table='contabil_conta', fields=['id'], where=_args)
        if _dados_conta:
            idConta = _dados_conta[0]['id']
            if _sintetAnalit == 'A':
                _args = [('company_id', '=', company_id_saldos), ('contabil_conta_id', '=', idConta),
                         ("data_saldo", '=', _data_saldo)]
                _dados_saldo = db_registro.select(table='contabil_saldos', fields=['id'], where=_args)
                if _dados_saldo:
                    idSaldo = _dados_saldo[0]['id']
        valsSaldo = {
            'company_id': company_id_saldos,
            'data_saldo': _data_saldo,
            'ctbsal_saldo_inicial': _saldo,
            'ctbsal_saldo_final': _saldo
        }
        if operacao in ('w', 'r'):  #Gravar e Regravar
            if _dados_conta:
                db_registro.update(table='contabil_conta', values=valsConta,
                                   where=[('id', '=', idConta)])
            else:
                idConta = db_registro.insert(table='contabil_conta', vals=valsConta)
            if _sintetAnalit == 'A':
                valsSaldo['contabil_conta_id'] = idConta
                if _dados_saldo:
                    db_registro.update(table='contabil_saldos', values=valsSaldo,
                                       where=[('id', '=', idSaldo)])
                else:
                    idSaldo = db_registro.insert(table='contabil_saldos', vals=valsSaldo)
            return True
        if operacao == 'd':  #Deletar
            if not _dados_conta:
                raise Exception('Ctb01: Nao encontrei conta para excluir - conta:' + _chave)
            try:
                db_registro.delete(table='contabil_conta', where=[('id', '=', idConta)])
            except Exception as e:
                raise Exception(
                    'Ctb01: Nao consegui excluir a conta:' + _chave + '  Erro:' + str(e))
            return True
        return False
    except TransactionRollbackError:
        return False

    except:
        db_registro.cr_integracao.connection.rollback()
        msg_erro = traceback_format_exc().replace("'", '"')
        db_registro.registro_gravar_erro(legado_log_id, msg_erro)
        return False



def gerarCtb02(db_registro, legado_log_id, dados, company_com_nf_id, company_sem_nf_id,
               empresa_legado, operacao, context=None):
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        _origem = listaDados[0]
        _data = listaDados[1]
        _hora = listaDados[2]
        _seq_mov = listaDados[3]
        _data_lancamento = listaDados[4]
        _conta = listaDados[5]
        _documento = listaDados[6]
        _contra_partida = listaDados[7].strip()
        _valor = listaDados[8][:13] + '.' + listaDados[8][13:]
        _normal_encerramento = listaDados[9]
        _historico = listaDados[10].strip()
        _chave = _origem + _data + _hora + _seq_mov
        company_id_conta = funct_get_empresa(db_registro, 'contabil.conta', company_com_nf_id)
        _args = [('company_id', '=', company_id_conta), ("conta", '=', _conta)]
        _dados_conta = db_registro.select(table='contabil_conta', fields=['id'], where=_args)
        if _dados_conta:
            _conta_id = _dados_conta[0]['id']
        else:
            raise Exception('Ctb02: Conta nao cadastrada! Conta::' + _conta)
        if _contra_partida:
            _args = [('company_id', '=', company_id_conta), ("conta", '=', _contra_partida)]
            _dados_contra_partida = db_registro.select(table='contabil_conta', fields=['id'],
                                                       where=_args)
            if _dados_contra_partida:
                _contra_partida_id = _dados_contra_partida[0]['id']

        if _valor[:1] == '-':
            _db = 'C'
        else:
            _db = 'D'
        _valor = _valor[1:]
        company_id_documentos = funct_get_empresa(db_registro, 'contabil.documentos',
                                                  company_com_nf_id)
        _data_movimento = str(datas.sigDatas(_data_lancamento).getDataNoFormato('I', 'S', '/'))
        if _data_movimento == '0000/00/00':
            raise Exception('Ctb02: Data invalida:' + _data_lancamento)
        valsDocumento = {
            'company_id': company_id_documentos,
            'data_movimento': _data_movimento,
            'tipo_lancamento': _normal_encerramento,
            'documento': _documento,
        }
        _args = [('company_id', '=', company_id_documentos),
                 ("data_movimento", '=', _data_movimento), ('documento', '=', _documento)]
        _dados_documento = db_registro.select(table='contabil_documentos', fields=['id'],
                                              where=_args)
        if _dados_documento:
            _documento_id = _dados_documento[0]['id']
            db_registro.update(table='contabil_documentos', values=valsDocumento,
                               where=[('id', '=', _documento_id)])
        else:
            _documento_id = db_registro.insert(table='contabil_documentos', vals=valsDocumento)
        vals = {
            'contabil_conta_id': _conta_id,
            'historico': _historico,
            'valor_lancamento': _valor,
            'debito_credito': _db,
            'documento_id': _documento_id,
        }
        if _dados_contra_partida:
            vals['contra_partida_id'] = _contra_partida_id
        legado_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=_chave,
            reg_tabela_legado='ctb02',
            reg_check_table='contabil_documentos',
            reg_empresa_tipo='C'
        )
        if legado_id:
            if operacao == 'w':
                operacao = 'r'
        if operacao == 'w':  #Gravar
            idLancamento = db_registro.insert(table='contabil_lancamentos', vals=vals)
            return True
        if operacao == 'r':  #Regravar
            if legado_id:
                try:
                    db_registro.update(table='contabil_lancamentos', values=vals,
                                       where=[('id', '=', legado_id)])
                except Exception as e:
                    raise Exception(
                        'Ctb02: Nao consegui alterar o lanccamento:' + _chave + '  Erro:' + str(e))
                return True
            else:
                idConta = db_registro.insert(table='contabil_lancamentos', vals=vals)
                return True
        if operacao == 'd':  #Deletar
            if not legado_id:
                raise Exception('Ctb02: Nao encontrei legado controle para excluir ' + _chave)
            try:
                db_registro.delete(table='contabil_lancamentos', where=[('id', '=', legado_id)])
            except Exception as e:
                raise Exception(
                    'Ctb02: Nao consegui excluir o lancamento:' + _chave + '  Erro:' + str(e))
            return True
    except TransactionRollbackError:
        return False

    except:
        db_registro.cr_integracao.connection.rollback()
        msg_erro = traceback_format_exc().replace("'", '"')
        db_registro.registro_gravar_erro(legado_log_id, msg_erro)
        return False

