#!/usr/bin/python
# -*- encoding: utf-8 -*-

from re import sub as re_sub
from datetime import datetime
from traceback import format_exc as traceback_format_exc
from SigUtils.datas import sigDatas
from psycopg2.extensions import TransactionRollbackError
from ....fiscal.model.cfop_data import CFOP_MOVIMENTO_TIPO
from ..funcoes.integ_funcoes import funct_retira_acentos, funct_time_2_float, \
    CalcTempo, funct_get_empresa

DICT_CFOP_MOV_TIPO = dict(CFOP_MOVIMENTO_TIPO)


# NOTA FISCAL DE ENTRADA
def gerarFis01(db_registro, legado_log_id, dados, company_com_nf_id, company_sem_nf_id, empresa_legado, operacao, context=None):

    try:
        inicio =CalcTempo()
        a = CalcTempo()
        lista_dados = re_sub('#', ' ', dados).replace('\n', '').split('*|*')

        _fornecedor = lista_dados[0]
        _serie = lista_dados[1].strip()
        _nota_fiscal = lista_dados[2]
        _data_entrada = sigDatas(lista_dados[3]).getDataNoFormato('N', 'S', '/')
        _codigo_fiscal = lista_dados[4]
        _especie = lista_dados[5].strip()
        _modelo_nf = lista_dados[6].strip()
        # _estado = lista_dados[7].strip()
        _data_documento = sigDatas(lista_dados[8]).getDataNoFormato('N', 'S', '/')
        # _valor_contabil = lista_dados[9]
        # _base_icms = lista_dados[10]
        _valor_icms = lista_dados[11].replace(' ', '0')
        # _base_ipi = lista_dados[12].replace(' ', '0')
        _valor_ipi = lista_dados[13].replace(' ', '0')
        _base_substituicao = lista_dados[14].replace(' ', '0')
        _icms_substituicao = lista_dados[15].replace(' ', '0')
        _desconto = lista_dados[16].replace(' ', '0')
        # _ind_frete = lista_dados[17]
        _vl_frete_na_nf = lista_dados[18].replace(' ', '0')
        _seguro = lista_dados[19].replace(' ', '0')
        _desp_acessoria = lista_dados[20].replace(' ', '0')
        # _avista_aprazo = lista_dados[21]
        _c_s_nf = lista_dados[22]
        # _usar_cliente = lista_dados[23]
        _nf_propria_empresa = lista_dados[24]
        _chave_nfe = lista_dados[25]
        # _nf_origem = lista_dados[26]
        # _nf_origem_serie = lista_dados[27]
        _obs = lista_dados[28]
        _obs = funct_retira_acentos(_obs)
        # _codigo_consumo = lista_dados[29]
        # _tipo_ligacao = lista_dados[30]
        # _grupo_tensao = lista_dados[31]
        # _status_nfe = lista_dados[32]
        _protocolo_nfe = lista_dados[33]
        _protocolo_canc_nfe = lista_dados[34]
        _lote_nfe = lista_dados[35]
        # _finalidade_nfe = lista_dados[36]
        # _motivo_nfe = lista_dados[37]
        # _natureza = lista_dados[38]
        # _nfe_cstat = lista_dados[39]
        # _situacao_nf = lista_dados[40]
        _xml = lista_dados[41].strip()
        _hora = lista_dados[42]
        _hora_saida = lista_dados[42][0:4]
        if _hora_saida:
            _hora_saida = funct_time_2_float(_hora_saida, "%H%M")
        else:
            _hora_saida = 0.00
        if _c_s_nf == 'S':
            company_id = company_sem_nf_id
        else:
            company_id = company_com_nf_id
        a.apurar('Recebimento')
        a = CalcTempo()
        company_id = funct_get_empresa(db_registro, 'fiscal.nf.capa', company_com_nf_id)
        _reg_cfop = db_registro.select(table='fiscal_cfop', fields=['id', 'movimento_tipo'], where=[('codigo', '=', _codigo_fiscal)])
        if not _reg_cfop:
            raise Exception('Fis01 - CFOP nao cadastrado. Codigo - %s' % _codigo_fiscal)
        _cfop_id = _reg_cfop[0]['id']
        _cfop_movimento_tipo = _reg_cfop[0]['movimento_tipo']

        if _cfop_movimento_tipo == 'D':
            tabela_legado = 'cre01'
            label_legado = 'Cliente'
        else:
            tabela_legado = 'cpg01'
            label_legado = 'Fornecedor'

        a.apurar('Achar cfop')
        a = CalcTempo()
        legado_fornec_cli_id = db_registro.controle_get_chave_sigerp(
            reg_empresa_legado=empresa_legado,
            reg_chave=_fornecedor,
            reg_tabela_legado=tabela_legado,
            reg_check_table='adm_pessoa',
            reg_empresa_tipo=_c_s_nf
        )

        if not legado_fornec_cli_id:
            raise Exception(
                'Fis01: %s nao encontrado na legado_controle. Chave_legado - %s, Empresa - %s'
                % (label_legado, _fornecedor, str(empresa_legado))
            )

        _endereco_id = False
        pessoa_dados = db_registro.select(
            table='adm_pessoa', fields=['endereco_nf_id'], where=[('id', '=', legado_fornec_cli_id)]
        )
        if pessoa_dados:
            _endereco_id = pessoa_dados[0]['endereco_nf_id']

        a.apurar('Achar pessoa')
        a = CalcTempo()
        if not _endereco_id:

            args_endereco_pessoa = [('pessoa_id', '=', legado_fornec_cli_id)]

            # ENDERECO DO TIPO NORMAL
            endereco_tipo_dados = db_registro.select(
                table='adm_endereco_tipo', fields=['id'], where=[('name', 'ilike', 'Normal')]
            )
            if endereco_tipo_dados:
                tipo_normal_id = endereco_tipo_dados[0]['id']

                args_endereco_normal = [('endereco_tipo_id', '=', tipo_normal_id)]
                args_endereco_normal.extend(args_endereco_pessoa)

                _regEndereco = db_registro.select(
                    table='adm_pessoa_endereco', fields=['id'], where=args_endereco_normal
                )
                if _regEndereco:
                    _endereco_id = _regEndereco[0]['id']

            # PRIMEIRO ENDERECO ENCONTRADO
            if not _endereco_id:
                _regEndereco = db_registro.select(
                    table='adm_pessoa_endereco', fields=['id'], where=args_endereco_pessoa
                )
                if _regEndereco:
                    _endereco_id = _regEndereco[0]['id']

        a.apurar('Achar endereco')
        a = CalcTempo()
        _reg_modelo_nf = db_registro.select(table='fiscal_modelo_nf', fields=['id'], where=[('fismnf_codigo', '=', _modelo_nf)])
        if not _reg_modelo_nf:
            raise Exception('Fis01: Modelo de NF nao cadastrado. Codigo - %s' % _modelo_nf)

        _modelo_nf_id = _reg_modelo_nf[0]['id']
        _reg_modelo_nf_serie = db_registro.select(
            table='fiscal_modelo_nf_series', fields=['id'], where=[('modelo_nf_id', '=', _modelo_nf_id)]
        )
        if _reg_modelo_nf_serie:
            _modelo_nf_serie_id = _reg_modelo_nf_serie[0]['id']
        else:
            _reg_fiscal = db_registro.select(table='fiscal_parametro', fields=['id'], where=[('company_id', '=', company_id)])
            if _reg_fiscal:
                _param_id = _reg_fiscal[0]['id']
            else:
                raise Exception('Fis01: Parametro do fiscal nao encontrado para a empresa. Company_id - %s' % company_id)

            vals_modelo_nf_series = {
                'modelo_nf_id': _modelo_nf_id,
                'ambiente': '1',
                'parametro_id': _param_id,
                'state': 'A',
                'numero_nf': 0,
                'serie_nf': _serie
            }

            _modelo_nf_serie_id = db_registro.insert(table='fiscal_modelo_nf_series', vals=vals_modelo_nf_series)

        a.apurar('Achar modelo')
        a = CalcTempo()
        _estoque_operacao_dados = db_registro.select(
            table='estoque_natureza_operacao', fields=['id'], where=[('name', '=', 'Compras'), ('active', '=', True)]
        )
        if not _estoque_operacao_dados:
            vals = {
                'active': True,
                'estnto_atualizar_saldo': True,
                'estnto_gerar_estatistica': True,
                'estnto_gerar_financeiro': True,
                'estnto_tipo_operacao': 'E',
                'name': 'Compras'
            }
            _estoque_operacao_id = db_registro.insert(table='estoque_natureza_operacao', vals=vals)
        else:
            _estoque_operacao_id = _estoque_operacao_dados[0]['id']

        a.apurar('Achar operacao')
        a=CalcTempo()
        _reg_natureza = db_registro.select(table='fiscal_cfop_natureza', fields=['id'], where=[('cfop_id', '=', _cfop_id)])
        if not _reg_natureza:
            if _cfop_movimento_tipo == 'C':
                natureza_descricao = 'Compras'
            else:
                natureza_descricao = DICT_CFOP_MOV_TIPO.get(_cfop_movimento_tipo) or 'Compras'

            valsNatureza = {
                'active': True,
                'cfop_id': _cfop_id,
                'name': natureza_descricao,
                'tipo': 'E',
                'fisnat_operacao_id': _estoque_operacao_id
            }
            _natureza_id = db_registro.insert(table='fiscal_cfop_natureza', vals=valsNatureza)
        else:
            _natureza_id = _reg_natureza[0]['id']

        a.apurar('Achar natureza')
        a=CalcTempo()
        valsNF = {
            'company_id': company_id,
            'data_emissao': _data_documento,
            'data_emissao_frete': _data_documento,
            'data_saida_entrada': _data_entrada,
            'destinatario_id': legado_fornec_cli_id,
            'especie': _especie,
            'finalidade_emissao': '1',
            'frete': '0',
            'fisnfc_infcomp_contribuinte': _obs,
            'modelo_nf_series_id': _modelo_nf_serie_id,
            'modelo_nf_id': _modelo_nf_id,
            'natureza_id': _natureza_id,
            'nf_propria': False,
            'nfe_chave_acesso': _chave_nfe,
            'nfe_forma_impressao_danfe': '1',
            'nfe_lote': _lote_nfe,
            'nfe_processo_emissao': '0',
            'nfe_protocolo': _protocolo_nfe,
            'nfe_protocolo_cancelamento': _protocolo_canc_nfe,
            'numero_nf': _nota_fiscal,
            'state': '3',
            'serie_nf': _serie,
            'tipo': 'E',
            'vr_base_icms_substituicao': _base_substituicao,
            'vr_desconto': _desconto,
            'vr_despesas_acessorias': _desp_acessoria,
            'vr_frete': _vl_frete_na_nf,
            'vr_icms': _valor_icms,
            'vr_icms_substituicao': _icms_substituicao,
            'vr_ipi': _valor_ipi,
            'vr_seguro': _seguro,
            'fisnfc_tipo_servico': False,
            #'vr_total_nf': _valor_contabil,
            'hora_emissao': _data_documento + ' ' + _hora[:2] + ':' + _hora[2:4] + ':' + _hora[4:6],
            'fisnfc_recebimento_conferido': False
        }
        if _xml:
            valsNF['nfe_xml_gerado'] = _xml
            valsNF['nfe_xml_proc'] = _xml
        if _endereco_id:
            valsNF['destinatario_endereco_id'] = _endereco_id
        if _modelo_nf == '55':
            valsNF['modelo_55'] = True
        if _nf_propria_empresa == 'S':
            valsNF['nf_propria'] = True
            if _chave_nfe:
                if _serie[:1] == '9':
                    valsNF['nfe_forma_emissao'] = '2'
                else:
                    valsNF['nfe_forma_emissao'] = '1'

        args_nf_capa = [
            ('company_id', '=', company_id), ('destinatario_id', '=', legado_fornec_cli_id),
            ('numero_nf', '=', _nota_fiscal), ('serie_nf', '=', _serie)
        ]
        reg_NF = db_registro.select(table='fiscal_nf_capa', fields=['id'], where=args_nf_capa)

        if operacao in ('w', 'r'):  # Gravar ou Regravar
            if reg_NF:
                _nf_id = reg_NF[0]['id']
                db_registro.update(table='fiscal_nf_capa', values=valsNF, where=[('id', '=', _nf_id)])
            else:
                _nf_id = db_registro.insert(table='fiscal_nf_capa', vals=valsNF)
            a.apurar('Inserir capa')
            a = CalcTempo()
            regCapa = db_registro.select(table='estoque_movimento_capa', fields=['id'], where=[('nf_capa_id', '=', _nf_id)])
            if regCapa:
                capa_id = regCapa[0]['id']
                regItens = db_registro.select(table='estoque_movimento_itens', fields=['id'], where=[('capa_id', '=', capa_id)])
                if regItens:
                    item_ids = tuple(map(lambda i: i['id'], regItens))
                    db_registro.update(table='estoque_movimento_itens', values={'nf_id': _nf_id}, where=[('id', 'in', item_ids)])
            a.apurar('Movimento do estoque')
            a = CalcTempo()
            obj_nf_capa = context.get('ctx_obj_nf_capa')

            #Metodo write e chamado para atualizar os dados dos campos functions
            db_registro.cr_integracao.connection.commit()
            obj_nf_capa.write(
                db_registro.cr,
                db_registro.uid,
                [_nf_id],
                {'write_date': datetime.now().strftime('%Y-%m-%d %H:%M:%S')},
                context=context.update({'salvar_forcado': True})
            )
            a.apurar('Atualizar capa(write)')
            a=CalcTempo()
        elif operacao == 'd':
            if reg_NF:
                _nf_id = reg_NF[0]['id']
                db_registro.delete(table='fiscal_nf_capa', where=[('id', '=', _nf_id)])

        inicio.apurar('Tempo total')
        return True

    except TransactionRollbackError:
        return False

    except:
        db_registro.cr_integracao.connection.rollback()
        msg_erro = traceback_format_exc().replace("'", '"')
        db_registro.registro_gravar_erro(legado_log_id, msg_erro)
        return False


# NOTA FISCAL DE SAIDA
def gerarFis02(db_registro, legado_log_id, dados, company_com_nf_id, company_sem_nf_id, empresa_legado, operacao, context=None):

    try:
        lista_dados = re_sub('#', ' ', dados).replace('\n', '').split('*|*')
        _cliente = lista_dados[0]
        _serie = lista_dados[1].strip()
        _nota_fiscal = lista_dados[2]
        _data_documento = sigDatas(lista_dados[3]).getDataNoFormato('N', 'S', '/')
        _codigo_fiscal = lista_dados[4]
        _especie = lista_dados[5].strip()
        _modelo_nf = lista_dados[6].strip()
        # _estado = lista_dados[7].strip()
        # _valor_bruto = lista_dados[8]
        # _valor_contabil = lista_dados[9]
        # _base_icms = lista_dados[10]
        _valor_icms = lista_dados[11].replace(' ', '0')
        # _aliq_icms = lista_dados[12].replace(' ', '0')
        # _base_ipi = lista_dados[13].replace(' ', '0')
        _valor_ipi = lista_dados[14].replace(' ', '0')
        # _wvalor_isentos = lista_dados[15].replace(' ', '0')
        # _wvalor_outros = lista_dados[16].replace(' ', '0')
        # _wvalor_substituicao = lista_dados[17].replace(' ', '0')
        # _wvalor_mob = lista_dados[18].replace(' ', '0')
        # _wvalor_iss = lista_dados[19].replace(' ', '0')
        # _wvalor_terceiros = lista_dados[20].replace(' ', '0')
        # _wvalor_diferido = lista_dados[21].replace(' ', '0')
        # _base_reduzinda_nao_tributado = lista_dados[22].replace(' ', '0')
        _base_substituicao = lista_dados[23].replace(' ', '0')
        _icms_substituicao = lista_dados[24].replace(' ', '0')
        # _departamento = lista_dados[25].replace(' ', '0')
        # _vendedor = lista_dados[26].replace(' ', '0')
        # _vendedor_externo = lista_dados[27].replace(' ', '0')
        _obs = lista_dados[28]
        _obs = funct_retira_acentos(_obs)
        _c_s_nf = lista_dados[29]
        # _nf_origem = lista_dados[30].replace(' ', '0')
        # _nf_origem_serie = lista_dados[31].replace(' ', '0')
        # _dav = lista_dados[32].replace(' ', '0')
        # _nfe_status = lista_dados[33]
        _chave_nfe = lista_dados[34]
        # _data_saida = sigDatas(lista_dados[35]).getDataNoFormato('N', 'S', '/')
        # _finalidade_nfe = lista_dados[37]
        _lote_nfe = lista_dados[38]
        # _status_nfe = lista_dados[39]
        # _motivo_nfe = lista_dados[40]
        _protocolo_nfe = lista_dados[41]
        _protocolo_canc_nfe = lista_dados[42]
        # _situacao_nf = lista_dados[43]
        _xml = lista_dados[44].strip()

        if _modelo_nf == '2D':  # Cupom fiscal nao importar aqui
            return True
        if _c_s_nf == 'S':
            company = company_sem_nf_id
        else:
            company = company_com_nf_id

        company_id = funct_get_empresa(db_registro, 'fiscal.nf.capa', company_com_nf_id)

        _reg_cfop = db_registro.select(table='fiscal_cfop', fields=['id', 'movimento_tipo'], where=[('codigo', '=', _codigo_fiscal)])
        if not _reg_cfop:
            raise Exception('Fis02: CFOP nao cadastrado. Codigo - %s' % _codigo_fiscal)

        _cfop_id = _reg_cfop[0]['id']
        _cfop_movimento_tipo = _reg_cfop[0]['movimento_tipo']

        if _cfop_movimento_tipo == 'D':
            tabela_legado = 'cpg01'
            label_legado = 'Fornecedor'
        else:
            tabela_legado = 'cre01'
            label_legado = 'Cliente'

        #Quando movimentacao for troca, nota nao devera ter cliente na capa -- Chamado 70210
        if _serie == 'TR' and _especie == 'TRC':
            _cliente = '00000'

        if _cliente != '00000':
            legado_fornec_cli_id = db_registro.controle_get_chave_sigerp(
                reg_empresa_legado=empresa_legado,
                reg_chave=_cliente,
                reg_tabela_legado=tabela_legado,
                reg_check_table='adm_pessoa',
                reg_empresa_tipo=_c_s_nf
            )
            if not legado_fornec_cli_id:
                raise Exception(
                    'Fis02: %s nao encontrado na legado_controle. Chave_legado - %s, Empresa - %s'
                    % (label_legado, _cliente, str(empresa_legado))
                )
            else:
                _endereco_id = False
                pessoa_dados = db_registro.select(
                    table='adm_pessoa', fields=['endereco_nf_id'], where=[('id', '=', legado_fornec_cli_id)]
                )
                if pessoa_dados:
                    _endereco_id = pessoa_dados[0]['endereco_nf_id']

                if not _endereco_id:

                    args_endereco_pessoa = [('pessoa_id', '=', legado_fornec_cli_id)]

                    # ENDERECO DO TIPO NORMAL
                    endereco_tipo_dados = db_registro.select(
                        table='adm_endereco_tipo', fields=['id'], where=[('name', 'ilike', 'Normal')]
                    )
                    if endereco_tipo_dados:
                        tipo_normal_id = endereco_tipo_dados[0]['id']

                        args_endereco_normal = [('endereco_tipo_id', '=', tipo_normal_id)]
                        args_endereco_normal.extend(args_endereco_pessoa)

                        _regEndereco = db_registro.select(
                            table='adm_pessoa_endereco', fields=['id'], where=args_endereco_normal
                        )
                        if _regEndereco:
                            _endereco_id = _regEndereco[0]['id']

                    # PRIMEIRO ENDERECO ENCONTRADO
                    if not _endereco_id:
                        _regEndereco = db_registro.select(
                            table='adm_pessoa_endereco', fields=['id'], where=args_endereco_pessoa
                        )
                        if _regEndereco:
                            _endereco_id = _regEndereco[0]['id']

        else:
            legado_fornec_cli_id = False
            _endereco_id = False

        _reg_modelo_nf = db_registro.select(table='fiscal_modelo_nf', fields=['id'], where=[('fismnf_codigo', '=', _modelo_nf)])
        if not _reg_modelo_nf:
            raise Exception('Fis02: Modelo de NF nao cadastrado. Codigo - %s' % _modelo_nf)

        _modelo_nf_id = _reg_modelo_nf[0]['id']
        _reg_modelo_nf_serie = db_registro.select(
            table='fiscal_modelo_nf_series', fields=['id'], where=[('modelo_nf_id', '=', _modelo_nf_id)]
        )
        if _reg_modelo_nf_serie:
            _modelo_nf_serie_id = _reg_modelo_nf_serie[0]['id']
        else:
            _reg_fiscal = db_registro.select(table='fiscal_parametro', fields=['id'], where=[('company_id', '=', company)])
            if _reg_fiscal:
                _param_id = _reg_fiscal[0]['id']
            else:
                raise Exception('Fis02: Parametro do fiscal nao cadastrado para a Empresa: Company_id - %s' % company)

            vals_modelo_nf_series = {
                'modelo_nf_id': _modelo_nf_id,
                'ambiente': '1',
                'parametro_id': _param_id,
                'state': 'A',
                'numero_nf': 0,
                'serie_nf': _serie
            }

            _modelo_nf_serie_id = db_registro.insert(table='fiscal_modelo_nf_series', vals=vals_modelo_nf_series)

        _estoque_operacao_dados = db_registro.select(
            table='estoque_natureza_operacao', fields=['id'], where=[('name', '=', 'Vendas'), ('active', '=', True)]
        )
        if not _estoque_operacao_dados:
            vals = {
                'active': True,
                'estnto_atualizar_saldo': True,
                'estnto_gerar_estatistica': True,
                'estnto_gerar_financeiro': True,
                'estnto_tipo_operacao': 'S',
                'name': 'Vendas'
            }
            _estoque_operacao_id = db_registro.insert(table='estoque_natureza_operacao', vals=vals)
        else:
            _estoque_operacao_id = _estoque_operacao_dados[0]['id']

        _reg_natureza = db_registro.select(table='fiscal_cfop_natureza', fields=['id'], where=[('cfop_id', '=', _cfop_id)])
        if not _reg_natureza:

            if _cfop_movimento_tipo == 'C':
                natureza_descricao = 'Vendas'
            else:
                natureza_descricao = DICT_CFOP_MOV_TIPO.get(_cfop_movimento_tipo) or 'Vendas'

            valsNatureza = {
                'active': True,
                'cfop_id': _cfop_id,
                'name': natureza_descricao,
                'tipo': 'S',
                'fisnat_operacao_id': _estoque_operacao_id
            }
            _natureza_id = db_registro.insert(table='fiscal_cfop_natureza', vals=valsNatureza)
        else:
            _natureza_id = _reg_natureza[0]['id']
        valsNF = {
            'company_id': company_id,
            'data_emissao': _data_documento,
            'data_emissao_frete': _data_documento,
            'data_saida_entrada': _data_documento,
            'especie': _especie,
            'finalidade_emissao': '1',
            'frete': '0',
            'fisnfc_infcomp_contribuinte': _obs,
            'modelo_nf_series_id': _modelo_nf_serie_id,
            'modelo_nf_id': _modelo_nf_id,
            'natureza_id': _natureza_id,
            'nf_propria': False,
            'nfe_chave_acesso': _chave_nfe,
            'nfe_forma_impressao_danfe': '1',
            'nfe_lote': _lote_nfe,
            'nfe_processo_emissao': '0',
            'nfe_protocolo': _protocolo_nfe,
            'nfe_protocolo_cancelamento': _protocolo_canc_nfe,
            'numero_nf': _nota_fiscal,
            'state': '3',
            'serie_nf': _serie,
            'tipo': 'S',
            'vr_base_icms_substituicao': _base_substituicao,
            'vr_icms': _valor_icms,
            'vr_icms_substituicao': _icms_substituicao,
            'vr_ipi': _valor_ipi,
            'fisnfc_tipo_servico': False,
            'fisnfc_recebimento_conferido': False
            #'vr_total_nf': _valor_contabil,
        }

        args_nf_capa = [('company_id', '=', company_id), ('numero_nf', '=', _nota_fiscal), ('serie_nf', '=', _serie)]

        if legado_fornec_cli_id:
            valsNF['destinatario_id'] = legado_fornec_cli_id
            args_nf_capa.append(('destinatario_id', '=', legado_fornec_cli_id))
        if _xml:
            valsNF['nfe_xml_gerado'] = _xml
            valsNF['nfe_xml_proc'] = _xml
        if _endereco_id:
            valsNF['destinatario_endereco_id'] = _endereco_id
        if _modelo_nf == '55':
            valsNF['modelo_55'] = True
        valsNF['nf_propria'] = True
        if _chave_nfe:
            if _serie[:1] == '9':
                valsNF['nfe_forma_emissao'] = '2'
            else:
                valsNF['nfe_forma_emissao'] = '1'

        reg_NF = db_registro.select(table='fiscal_nf_capa', fields=['id'], where=args_nf_capa)

        if operacao in ('w', 'r'):  # Gravar ou regravar
            if reg_NF:
                _nf_id = reg_NF[0]['id']
                db_registro.update(table='fiscal_nf_capa', values=valsNF, where=[('id', '=', _nf_id)])
            else:
                _nf_id = db_registro.insert(table='fiscal_nf_capa', vals=valsNF)

            regCapa = db_registro.select(table='estoque_movimento_capa', fields=['id'], where=[('nf_capa_id', '=', _nf_id)])
            if regCapa:
                capa_id = regCapa[0]['id']
                regItens = db_registro.select(table='estoque_movimento_itens', fields=['id'], where=[('capa_id', '=', capa_id)])
                if regItens:
                    item_ids = tuple(map(lambda i: i['id'], regItens))

                    db_registro.update(
                        table='estoque_movimento_itens', values={'nf_id': _nf_id}, where=[('id', 'in', item_ids)]
                    )

            db_registro.cr_integracao.connection.commit()
            obj_nf_capa = context.get('ctx_obj_nf_capa')
            obj_nf_capa.write(
                db_registro.cr,
                db_registro.uid,
                [_nf_id],
                {'write_date': datetime.now().strftime('%Y-%m-%d %H:%M:%S')},
                context=context.update({'salvar_forcado': True})
            )
            
        elif operacao == 'd':
            if reg_NF:
                _nf_id = reg_NF[0]['id']
                db_registro.delete(table='fiscal_nf_capa', where=[('id', '=', _nf_id)])
            else:
                raise Exception('Fis02: Nota nao encontrada')
        return True

    except TransactionRollbackError:
        return False

    except:
        db_registro.cr_integracao.connection.rollback()
        msg_erro = traceback_format_exc().replace("'", '"')
        db_registro.registro_gravar_erro(legado_log_id, msg_erro)
        return False


# MAPA DE ECF
def gerarFis05(db_registro, legado_log_id, dados, company_com_nf_id, company_sem_nf_id, empresa_legado, operacao, context=None):
    try:

        lista_dados = dados.replace('#', ' ').replace('\n', '').split('*|*')

        _data = sigDatas(lista_dados[0]).getDataNoFormato('N', 'S', '/')
        _ecf = lista_dados[1].strip()
        _numero_z = lista_dados[2]
        _cup_ini = lista_dados[3]
        _cup_fin = lista_dados[4]
        _gt_ini = lista_dados[5].replace(' ', '0')
        _gt_fin = lista_dados[6].replace(' ', '0')
        _wvalor_substituicao = lista_dados[7].replace(' ', '0')
        _wvalor_isentos = lista_dados[8].replace(' ', '0')
        _wvalor_outros = lista_dados[9].replace(' ', '0')
        _wvalor_cancelamentos = lista_dados[10].replace(' ', '0')
        _wvalor_descontos = lista_dados[11].replace(' ', '0')

        _dic_imposto = {}
        for x in range(10):
            _wimposto = lista_dados[12 + (x * 5)]
            _waliquota = lista_dados[13 + (x * 5)].replace(' ', '0')
            _wbase_imposto = lista_dados[14 + (x * 5)].replace(' ', '0')
            _wvalor_imposto = lista_dados[15 + (x * 5)].replace(' ', '0')
            _wbase_reduzida = lista_dados[16 + (x * 5)].replace(' ', '0')
            _dic_imposto[x] = {
                'tipo': _wimposto,
                'aliq': _waliquota,
                'base': _wbase_imposto,
                'valor': _wvalor_imposto,
                'reduz': _wbase_reduzida
            }

        _wvalor_diferido = lista_dados[62].replace(' ', '0')
        _cro = lista_dados[63]
        _wvalor_acrescimos = lista_dados[64].replace(' ', '0')
        _coo = lista_dados[65]
        company_id = funct_get_empresa(db_registro, 'ecf.ecf', company_com_nf_id)

        _args = [('company_id', '=', company_id), ('caixa', '=', _ecf)]
        _ecf_dados = db_registro.select(table='ecf_ecf', fields=['id'], where=_args)
        if not _ecf_dados:
            raise Exception('Fis05: ECF nao cadastrado. Caixa - %s', _ecf)

        _ecf_id = _ecf_dados[0]['id']

        vals = {
            'data': _data,
            'ecf': _ecf_id,
            'numero_z': _numero_z,
            'cupom_inicial': _cup_ini,
            'cupom_final': _cup_fin,
            'gt_inicial': _gt_ini,
            'gt_final': _gt_fin,
            'cancelamentos': _wvalor_cancelamentos,
            'descontos': _wvalor_descontos,
            'acrescimos': _wvalor_acrescimos,
            'coo': _coo,
            'cro': _cro,
        }
        _mapa_dados = db_registro.select(
            table='ecf_mapa_resumo_capa', fields=['id'], where=[('data', '=', _data), ('ecf', '=', _ecf_id)])

        if operacao in ('w', 'r'):  # Gravar ou Regravar
            if _mapa_dados:
                _mapa_id = _mapa_dados[0]['id']
                db_registro.update(table='ecf_mapa_resumo_capa', values=vals, where=[('id', '=', _mapa_id)])
            else:
                _mapa_id = db_registro.insert(table='ecf_mapa_resumo_capa', vals=vals)

            _args = [('capa_id', '=', _mapa_id)]

            db_registro.delete(table='ecf_mapa_resumo_itens', where=_args)
            if float(_wvalor_substituicao):
                vals = {
                    'capa_id': _mapa_id,
                    'base_valor': _wvalor_substituicao,
                    'imposto': 'C',
                    'tipo': 'F',
                }
                db_registro.insert(table='ecf_mapa_resumo_itens', vals=vals)

            if float(_wvalor_isentos):
                vals = {
                    'capa_id': _mapa_id,
                    'base_valor': _wvalor_isentos,
                    'imposto': 'C',
                    'tipo': 'I',
                }
                db_registro.insert(table='ecf_mapa_resumo_itens', vals=vals)

            if float(_wvalor_outros):
                vals = {
                    'capa_id': _mapa_id,
                    'base_valor': _wvalor_outros,
                    'imposto': 'C',
                    'tipo': 'O',
                }
                db_registro.insert(table='ecf_mapa_resumo_itens', vals=vals)

            if float(_wvalor_diferido):
                vals = {
                    'capa_id': _mapa_id,
                    'base_valor': _wvalor_diferido,
                    'imposto': 'C',
                    'tipo': 'D',
                }
                db_registro.insert(table='ecf_mapa_resumo_itens', vals=vals)

            for _item in _dic_imposto:
                if float(_dic_imposto[_item]['valor']):
                    vals = {
                        'capa_id': _mapa_id,
                        'aliquota': _dic_imposto[_item]['aliq'],
                        'base_reduzida': _dic_imposto[_item]['reduz'],
                        'base_valor': _dic_imposto[_item]['base'],
                        'imposto': _dic_imposto[_item]['tipo'],
                        'imposto_valor': _dic_imposto[_item]['valor'],
                        'tipo': 'T',
                    }
                    db_registro.insert(table='ecf_mapa_resumo_itens', vals=vals)

        elif operacao == 'd':
            if _mapa_dados:
                db_registro.delete(table='ecf_mapa_resumo_capa', where=[('data', '=', _data), ('ecf', '=', _ecf_id)])

        return True

    except TransactionRollbackError:
        return False

    except:
        db_registro.cr_integracao.connection.rollback()
        msg_erro = traceback_format_exc().replace("'", '"')
        db_registro.registro_gravar_erro(legado_log_id, msg_erro)
        return False


def gerarFis18(db_registro, legado_log_id, dados, company_com_nf_id, company_sem_nf_id, empresa_legado, operacao, context=None):

    return True
    # try:
    #
    #     lista_dados = dados.replace('#', ' ').replace('\n', '').split('*|*')
    #
    #     dados_sequencia = lista_dados[0]
    #     dados_cli_fornec = lista_dados[1]
    #     dados_nota_serie = lista_dados[2].strip()
    #     dados_nota_numero = lista_dados[3]
    #     dados_data_pagamento = sigDatas(lista_dados[4]).getDataNoFormato('I', 'S', '/')
    #     dados_data_vencimento = sigDatas(lista_dados[5]).getDataNoFormato('I', 'S', '/')
    #     dados_data_entrada_nf = sigDatas(lista_dados[6]).getDataNoFormato('I', 'S', '/')
    #     dados_refer_ano_mes = lista_dados[7]
    #     dados_guia_valor = '%s.%s' % (lista_dados[8][1:12], lista_dados[8][13:])
    #     dados_banco = lista_dados[9]
    #     dados_agencia = lista_dados[10]
    #     dados_autenticacao = lista_dados[11].strip()
    #     dados_convenio = lista_dados[12].strip()
    #     dados_codigo_antecipacao = '%s.%s' % (lista_dados[13][1:12], lista_dados[13][13:])
    #     dados_recomposicao_aliquota = lista_dados[14]
    #
    #     ano = int(dados_refer_ano_mes[:4])
    #     mes = int(dados_refer_ano_mes[4:])
    #     valor_guia = float(dados_guia_valor)
    #
    #     vals_nf_guia = {
    #         'ano': ano,
    #         'mes': mes,  # required
    #         'data_vencimento': dados_data_vencimento,  # required
    #         'data_pagamento': dados_data_pagamento,
    #         'local_cobranca_id': '',  # required
    #         'autenticacao': '',
    #         'convenio': dados_convenio,  # required
    #         'base': '',  # required
    #         'valor': valor_guia,  # required
    #         'guia_recomp_aliq'
    #         'codigo_antecipa'
    #         'nf_id'
    #         'fisgui_fornecedor_reembolsar'
    #         'fisgui_fornecedor_vencimento'
    #         'fisgui_simples_nacional': '',  # function
    #     }
    #     adm_agencia_dados = db_registro.select(
    #         table='adm_banco_agencia', fields=['id'], where=[('name', 'ilike', dados_agencia)]
    #     )
    #     if adm_agencia_dados:
    #         vals_nf_guia['agencia_id'] = adm_agencia_dados[0]['id']

    # except TransactionRollbackError:
    #     return False
    #
    # except:
    #     db_registro.cr_integracao.connection.rollback()
    #     msg_erro = traceback_format_exc().replace("'", '"')
    #     db_registro.registro_gravar_erro(legado_log_id, msg_erro)
    #     return False