# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class legado_empresa(osv.Model):
    """
    Tabela de correspondencia de empresas
    """

    def ler(self, cr, uid, args, context=None):
        if not args:
            return []
        try:
            ids = self.search(cr, uid, args, context=context)
            vals = self.read(cr, uid, ids, [], context=context)
            return vals
        except:
            return []

    _name = 'legado.empresa'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa'),  # Id da empresa
        'empresa_legado': fields.integer('Empresa no legado', select=True, required=True),
        'tipo': fields.selection([('C', 'Com NF'), ('S', 'Sem NF')], 'Tipo', size=1),
    }
    _sql_constraints = [('empresa_legado_uniq', 'unique (empresa_legado, tipo)', 'Empresa ja cadastrada!')]