# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


LEGLOG_ERRO = 'lelg_erro'
LEGLOG_DATA = 'lelg_data'
LEGLOG_HORA = 'lelg_hora'
LEGLOG_OPERACAO = 'lelg_operacao'
LEGLOG_CONTEUDO = 'lelg_conteudo'
LEGLOG_ARQUIVO_LEGADO = 'lelg_arquivo_legado'
LEGLOG_EMPRESA_LEGADO = 'lelg_empresa_legado'
LEGLOG_ERRO_REGISTRO = 'lelg_erro_registro'
LEGLOG_CONTEUDO_IDS = 'lelg_conteudo_ids'
LEGLOG_CONTADOR_IMPORTACAO = 'lelg_contador_importacao'

READ_LOAD = '_classic_write'


class legado_logs(osv.Model):
    """
    Controle dos logs de integracao
    """
    _name = 'legado.logs'
    _rec_name = LEGLOG_ARQUIVO_LEGADO
    _columns = {
        # _________________ INTEGER ______________________
        'lelg_empresa_legado': fields.integer('Empresa no legado', select=1, required=True),
        'lelg_contador_importacao': fields.integer('Contador de importacao'),
        # _________________ TEXT ______________________
        'lelg_erro': fields.text('Mensagem de Erro'),
        'lelg_conteudo': fields.text('Conteudo'),
        # _________________ DATE ______________________
        'lelg_data': fields.date('Data', select=1),
        # _________________ CHAR ______________________
        'lelg_hora': fields.char('Horario', size=8, select=1),
        'lelg_arquivo_legado': fields.char('Arquivo do legado', size=5, required=True, select=1),
        # _________________ SELECTION ______________________
        'lelg_operacao': fields.selection(
            [('W', 'Incluir'), ('D', 'Excluir'), ('R', 'Regravar')], 'Operacao', size=1, required=True
        ),
        # _________________ BOOLEAN _______________________
        'lelg_erro_registro': fields.boolean('Erro'),
        # _________________ O2M _______________________
        'lelg_conteudo_ids': fields.one2many('legado.logs.conteudo', 'legcon_legado_log_id', 'Detalhes do Conteudo'),
    }
    _defaults = {
        'lelg_erro_registro': False,
        'lelg_contador_importacao': 0
    }














