# # -*- encoding: utf-8 -*-
# ##############################################################################
# #
# # Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# #                    www.siginformatica.com.br luiz@siginformatica.com.br
# #
# ##############################################################################
#
# from openerp.osv import osv, fields
# from openerp.tools.translate import _
# from datetime import datetime
#
#
# class ml_promocoes(osv.Model):
#     _inherit = 'ml.promocoes'
#
#
#     def create(self, cr, uid, vals, context=None):
#         if vals.get('mlpro_data_inicio') and vals.get('mlpro_data_fim'):
#             if vals.get('mlpro_data_fim') < vals.get('mlpro_data_inicio'):
#                 raise osv.except_osv(_('Atencao'), _('Data final anterior a de inicio!'))
#         vals['mlpro_quantidade_concedida'] = 0
#         _hoje = self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, datetime.now(), formato='%Y-%m-%d')
#         if vals.get('mlpro_data_inicio') and (vals.get('mlpro_data_inicio') < _hoje):
#             raise osv.except_osv(_('Atencao'), _('Data de inicio nao pode ser anterior a hoje!'))
#         if vals.get('mlpro_data_fim') and (vals.get('mlpro_data_fim') < _hoje):
#             raise osv.except_osv(_('Atencao'), _('Data final nao pode ser anterior a hoje!'))
#         if not ((vals.get('mlpro_data_inicio') and vals.get('mlpro_data_fim')) or
#             (vals.get('mlpro_quantidade_promocao') and vals.get('mlpro_quantidade_promocao') > 0)):
#                 raise osv.except_osv(_('Atencao'), _('Precisa informar data inicial/final ou quantidade em promocao!'))
#         return super(ml_promocoes, self).create(cr, uid, vals, context=context)
#
#     def write(self, cr, uid, ids, vals, context=None):
#         res = super(ml_promocoes, self).write(cr, uid, ids, vals, context=context)
#         if isinstance(ids, int):
#             ids = [ids]
#         for _dados  in self.read(cr, uid, ids, fields=[], context=context):
#             if _dados.get('mlpro_data_inicio') and _dados.get('mlpro_data_fim'):
#                 if _dados.get('mlpro_data_fim') < _dados.get('mlpro_data_inicio'):
#                     raise osv.except_osv(_('Atencao'), _('Data final anterior a de inicio!'))
#         return res
#
#     def mlpro_registrar_promocao(self, cr, uid, anuncios_ids, context=None):
#         """
#         Método para registrar as promoçoes;
#             - Calcula o valor da promoção para o anuncio
#             - Exporta para o M.L. o anuncio cujo valor da promoção foi alterado
#             - Ajusta (pelos metodos funcionais) a situacao da promocao
#         @param cr:
#         @param uid:
#         @param anuncios_ids:
#         @param qtd_vendida:
#         @param context:
#         @return: Sempre True
#         """
#         context = context and context.copy() or {}
#         obj_anuncios = self.pool.get('mkp.anuncios')
#         _hoje = self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, datetime.now(), formato='%Y-%m-%d')
#         _ultimo_produto = False
#         for _brw_anuncio in obj_anuncios.browse(cr, uid, anuncios_ids, context=context):
#             if _ultimo_produto != _brw_anuncio.mlanu_produto_id.id:
#                 _ultimo_produto = _brw_anuncio.mlanu_produto_id.id
#                 args = [('mlpro_produto_id', '=', _ultimo_produto), ('mlpro_situacao', '=', '1')]
#                 _promocoes_ids = self.search(cr, uid, args, order='mlpro_data_inicio', context=context)
#                 if _promocoes_ids:
#                     _achei = False
#                     for _brw_promocoes in self.browse(cr, uid, _promocoes_ids, context=context):
#                         if _brw_promocoes.mlpro_data_fim < _hoje:
#                             continue
#                         if not (_brw_promocoes.mlpro_quantidade_concedida < _brw_promocoes.mlpro_quantidade_promocao):
#                             continue
#                         _achei = True
#                     if not _achei:
#                         _promocoes_ids = False
#             if not _promocoes_ids:
#                 if _brw_anuncio.mlanu_valor_promocao == 0:
#                     continue
#                 vals = {'mlanu_valor_promocao': 0, 'mkpanu_necessita_atualizar': False}
#                 obj_anuncios.write(cr, uid, _brw_anuncio.id, vals, context=context)
#                 obj_anuncios.mlanu_btn_exportar_um_anuncio(cr, uid, [_brw_anuncio.id], context=None)
#                 continue
#             _valor = ((_brw_anuncio.mlanu_valor - _brw_anuncio.mlanu_valor_frete) * _brw_promocoes.mlpro_fator) \
#                                                                                 + _brw_anuncio.mlanu_valor_frete
#             vals = {'mlanu_valor_promocao': _valor, 'mkpanu_necessita_atualizar': False}
#             res = obj_anuncios.write(cr, uid, _brw_anuncio.id, vals, context=context)
#             obj_anuncios.mlanu_btn_exportar_um_anuncio(cr, uid, [_brw_anuncio.id], context=None)
#         return True
#
#     def mlpro_registrar_venda(self, cr, uid, anuncio_id, qtd_vendida, context=None):
#         """
#         Método que registra a venda na promoção para controlar a quantidade programada da promocao com a quantidade já concedida
#             - Como regrava a promoção, os métodos funcionais são calculados e o state da promoção pode ser mudado se
#               a quantidade concedida alcancar a programada
#         @param cr:
#         @param uid:
#         @param anuncio_id:
#         @param qtd_vendida:
#         @param context:
#         @return: sempre True
#         """
#         context = context and context.copy() or {}
#         obj_anuncios = self.pool.get('mkp.anuncios')
#         _brw_anuncio = obj_anuncios.browse(cr, uid, anuncio_id, context=context)
#         _qtd_concedida = 0
#         _hoje = self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, datetime.now(), formato='%Y-%m-%d')
#         for _brw_promocoes in _brw_anuncio.mlanu_produto_id.estpro_promocoes_ids:
#             vals = {}
#             if _brw_promocoes.mlpro_situacao == '1':
#                 if _brw_promocoes.mlpro_quantidade_promocao > 0:
#                     _qtd_concedida = _brw_promocoes.mlpro_quantidade_concedida + qtd_vendida
#                 if _qtd_concedida > _brw_promocoes.mlpro_quantidade_promocao:
#                     vals['mlpro_data_fim'] = _hoje
#                     vals['mlpro_situacao'] = '3'
#                 if _qtd_concedida != 0:
#                     vals['mlpro_quantidade_concedida'] = _qtd_concedida
#                     self.write(cr, uid, _brw_promocoes.id, vals, context=context)
#         return True