SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL';

CREATE SCHEMA IF NOT EXISTS `mydb` DEFAULT CHARACTER SET latin1 COLLATE latin1_swedish_ci ;
USE `mydb` ;

-- -----------------------------------------------------
-- Table `mydb`.`adm_pessoa`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `mydb`.`adm_pessoa` (
  `id` INT NOT NULL ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`fiscal_nf_capa`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `mydb`.`fiscal_nf_capa` (
  `id` INT NOT NULL ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`res_users`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `mydb`.`res_users` (
  `id` INT NOT NULL ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`veiculos_veiculo`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `mydb`.`veiculos_veiculo` (
  `id` INT NOT NULL ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`vendas_vendedor`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `mydb`.`vendas_vendedor` (
  `id` INT NOT NULL ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`os_os`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `mydb`.`os_os` (
  `id` INT NOT NULL ,
  `osos_data_abertura` DATETIME NOT NULL ,
  `osos_pessoa_id` INT NOT NULL COMMENT 'Cliente ' ,
  `osos_entrada_nf_id` INT NULL ,
  `osos_data_fechamento` DATETIME NULL COMMENT 'Data em que foi fechada a os\n' ,
  `osos_fechamento_user_id` INT NULL COMMENT 'Usuário que fechou a os' ,
  `osos_km` INT NULL ,
  `osos_veiculo_id` INT NULL ,
  `osos_vendedor_id` INT NULL ,
  `osos_vendedor_externo_id` INT NULL ,
  `osos_data_entrega` DATE NULL ,
  `osos_execução` ENUM('I','E') NOT NULL DEFAULT I COMMENT 'Onde será executado o serviço, Interna ou Externamente' ,
  `osos_defeito_relatado` TEXT NULL COMMENT 'Defeito informado pelo cliente\n' ,
  `osos_defeito_constatado` TEXT NULL COMMENT 'Defeito identificado pelo técnico/mecanico' ,
  `osos_garantia` TINYINT(1) NULL DEFAULT False COMMENT 'Informa se a OS é de garantia(não será cobrado)' ,
  `status` ENUM('A', 'C', 'E', 'F') NULL COMMENT 'Estado da OS E=Esboço, A=Aberta, C=Cancelada, F=Fechada' ,
  `os_oscol` VARCHAR(45) NULL ,
  `osos_saida_nf_id` INT NULL ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`estoque_produto`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `mydb`.`estoque_produto` (
  `id` INT NOT NULL ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`os_servicos`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `mydb`.`os_servicos` (
  `osserv_os_id` INT NOT NULL ,
  `osserv_servico_id` INT NOT NULL ,
  `osserv_quantidade` DECIMAL(8,3) NOT NULL DEFAULT 1 ,
  `os_servicoscol` VARCHAR(45) NULL ,
  `osserv_vendedor_id` INT NULL ,
  `osserv_preco_unitario` DECIMAL(12,2) NOT NULL ,
  `osserv_desconto_servico` DECIMAL(8,2) NULL DEFAULT 0 ,
  `osserv_desconto_pecas` DECIMAL(8,2) NULL DEFAULT 0 )
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`rh_funcionario`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `mydb`.`rh_funcionario` (
  `id` INT NOT NULL ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`os_mecanico`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `mydb`.`os_mecanico` (
  `osmeca_funcionario_id` INT NOT NULL ,
  PRIMARY KEY (`osmeca_funcionario_id`) )
ENGINE = InnoDB
COMMENT = 'Cadastro de Técnicos ou mecanicos';


-- -----------------------------------------------------
-- Table `mydb`.`os_requisicao_capa`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `mydb`.`os_requisicao_capa` (
  `id` INT NOT NULL ,
  `osreqc_numero` CHAR(10) NOT NULL COMMENT 'Numero da requisição' ,
  `osreqc_os_id` INT NOT NULL ,
  `osreqc_data` DATE NOT NULL COMMENT 'Data da requisição' ,
  `osreqc_requisitante_id` INT NOT NULL COMMENT 'Quem fez a requisição' ,
  `osreqc_mecanico_id` INT NULL ,
  `osreqc_cancelado_user_id` INT NULL COMMENT 'Usuário que cancelou a requisição.' ,
  `osreqc_devolucao` TINYINT(1) NULL DEFAULT False COMMENT 'Indica que a requisição é de devolução' ,
  UNIQUE INDEX `osreqc_numero_UNIQUE` (`osreqc_numero` ASC) ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB
COMMENT = 'Requisição de peças para a Ordem de Serviço';


-- -----------------------------------------------------
-- Table `mydb`.`estoque_produto_grade`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `mydb`.`estoque_produto_grade` (
  `id` INT NOT NULL ,
  PRIMARY KEY (`id`) )
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `mydb`.`os_requisicao_itens`
-- -----------------------------------------------------
CREATE  TABLE IF NOT EXISTS `mydb`.`os_requisicao_itens` (
  `osreqi_produto_id` INT NOT NULL ,
  `osreqi_capa_id` INT NOT NULL ,
  `osreqi_grade_id` INT NOT NULL ,
  `osreqi_quantidade` DECIMAL(8,3) NOT NULL ,
  `osreqi_preco_unitario` DECIMAL(12,2) NOT NULL ,
  `status` ENUM('E','I','C') NOT NULL COMMENT 'Estado da requisição \'E=Esboço, I=Impresso e C=Cancelada' )
ENGINE = InnoDB;



SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
