#-*- encoding: utf-8 -*-
"""
API Python Rastreio - Rastreamento de Encomendas

"""

import urllib2
from datetime import datetime
from __init__ import Encomendas
import json



def get_encomenda(identificadores):
    try:
        URL = 'http://global.cainiao.com/detail.htm?mailNoList='
        request = urllib2.urlopen('%s%s' % (URL, identificadores))
        html = request.read().decode('latin-1')
    except Exception as e:
        return []
    request.close()

    if html:
        html.find('waybill_list_val_box')
        i = html.find('waybill_list_val_box') + 22
        html_parcial = html[i:]
        f = html_parcial.find('</textarea>')
        html_parcial = html_parcial[:f].replace('&quot;', '"')
        try:
            ret = json.loads(html_parcial).get('data')
        except:
            ret = {}
        return ret


def cainiao_get_rastreio(lista_codigo):
    if not isinstance(lista_codigo, (tuple, list)):
        lista_codigo = [lista_codigo]
    encomendas = Encomendas()
    for codigo in lista_codigo:
        args = codigo.upper()
        encomendas.setEncomenda(args)
    lista_codigo = encomendas.getEncomendaCodigos()
    qtd_encomendas = len(lista_codigo)
    i = 0
    while i < qtd_encomendas:
        args = ''
        for x in range(20): #Limite de codigos para rastreamento no Aliexpress(Cainiao)
            args += lista_codigo[i] + ','
            i += 1
            if i == qtd_encomendas:
                break
        if args:
            args = args[:-1]
        conjunto = get_encomenda(args)
        for res_cainiao in conjunto:
            _codigo_rastreio = res_cainiao.get('mailNo').replace('New Tracking Number:', '')
            if '(' in _codigo_rastreio:
                _pos = _codigo_rastreio.find('(')
                _posF = _codigo_rastreio.find(')')
                _codigo_rastreio_novo = _codigo_rastreio[_pos+1:_posF]
                _codigo_rastreio = _codigo_rastreio[:_pos]
                encomendas.setNovoNumero(_codigo_rastreio, _codigo_rastreio_novo)

            for evento in res_cainiao.get('section2').get('detailList'):
                _d = evento.get('time')
                __atualizacao = datetime.strptime(_d, '%Y-%m-%d %H:%M:%S')
                __cidade = ''
                __estado = ''
                __agencia = ''
                __pais = 'BRASIL'
                __situacao = __observacao = evento.get('desc')
                __fim = False
                encomendas.setEvento(_codigo_rastreio, __atualizacao, __pais, __estado, __cidade, __agencia, __situacao,
                                     __observacao, __fim)
    return encomendas.getEncomendas()




# a = cainiao_get_rastreio(('LP00125645723144','LP00122384564507'))
# pass



