# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.osv import fields, osv

from openerp import tools


class rh_marcacao_dia(osv.Model):

    _name = 'rh.marcacao_dia'
    _inherit = 'rh.marcacao_dia'
    def init(self, cr):
        tools.sql.drop_view_if_exists(cr, "rh_marcacao_dia")
        cr.execute("""
              create view rh_marcacao_dia as (
                select
                    min(P.id) as id,
                    P.rh_funcionario_id,
                    P.rh_data,
                    (select P1.rh_horario from rh_marcacao P1 where P1.rh_data=P.rh_data and P1.rh_funcionario_id=P.rh_funcionario_id order by rh_horario limit 1 offset 0) as rh_entrada1,
                    (select P2.rh_horario from rh_marcacao P2 where P2.rh_data=P.rh_data and P2.rh_funcionario_id=P.rh_funcionario_id order by rh_horario limit 1 offset 1) as rh_saida1,
                    (select P3.rh_horario from rh_marcacao P3 where P3.rh_data=P.rh_data and P3.rh_funcionario_id=P.rh_funcionario_id order by rh_horario limit 1 offset 2) as rh_entrada2,
                    (select P4.rh_horario from rh_marcacao P4 where P4.rh_data=P.rh_data and P4.rh_funcionario_id=P.rh_funcionario_id order by rh_horario limit 1 offset 3) as rh_saida2,
                    (select P5.rh_horario from rh_marcacao P5 where P5.rh_data=P.rh_data and P5.rh_funcionario_id=P.rh_funcionario_id order by rh_horario limit 1 offset 4) as rh_entrada3,
                    (select P6.rh_horario from rh_marcacao P6 where P6.rh_data=P.rh_data and P6.rh_funcionario_id=P.rh_funcionario_id order by rh_horario limit 1 offset 5) as rh_saida3,
                    (select P7.rh_horario from rh_marcacao P7 where P7.rh_data=P.rh_data and P7.rh_funcionario_id=P.rh_funcionario_id order by rh_horario limit 1 offset 6) as rh_entrada4,
                    (select P8.rh_horario from rh_marcacao P8 where P8.rh_data=P.rh_data and P8.rh_funcionario_id=P.rh_funcionario_id order by rh_horario limit 1 offset 7) as rh_saida4,
                    (select P9.rh_horario from rh_marcacao P9 where P9.rh_data=P.rh_data and P9.rh_funcionario_id=P.rh_funcionario_id order by rh_horario limit 1 offset 8) as rh_entrada5,
                    (select P10.rh_horario from rh_marcacao P10 where P10.rh_data=P.rh_data and P10.rh_funcionario_id=P.rh_funcionario_id order by rh_horario limit 1 offset 9) as rh_saida5
                from rh_marcacao P
                    group by rh_funcionario_id, rh_data)
                """)



