# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields

class rh_afastamento(osv.Model):

    _name = 'rh.afastamento'
    _rec_name = 'rh_funcionario_id'
    _columns = {
        'rh_codigo' : fields.integer('Codigo', select=True),
        'rh_funcionario_id' : fields.many2one('rh.funcionario', 'Funcionario', ondelete='restrict', required=True, select=True),
        'rh_justificativa_id' : fields.many2one('rh.justificativa', 'Justificativa', ondelete='restrict', required=True, select=True),
        'rh_data_ini' : fields.date('Data Inicial', required=True),
        'rh_data_fim' : fields.date('Data Final', required=True),
        'rh_tipo' : fields.selection([('P', 'Periodo'), ('T', 'Tempo')], 'Tipo', size=1),
        'rh_minutos' : fields.integer('Minutos'),
    }
    _order = 'rh_funcionario_id, rh_data_ini desc'
    _defaults = {
        'rh_codigo' : lambda *a: 0,
    }

