# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from SigUtils.formatastring import formataString

#Funcoes da classe rh_banco_horas
def _get_name(self, cr, uid, ids, name, arg, context=None):
    """
    Retorna o descricao do banco_horas
    """
    context = context and context.copy() or {}
    res = {}
    if ids:
        banco_horas_datas = self.browse(cr, uid, ids)
        for banco_horas_data in banco_horas_datas:
            _func_lista =  banco_horas_data.rh_funcionario_id.pessoa.name.split()
            if len(_func_lista)  > 1:
                _func_nome =  _func_lista[0] + ' ' + _func_lista[len(_func_lista) -1]
            else:
                _func_nome = _func_lista[0]
            res[banco_horas_data.id] =  _func_nome + '-' +str( banco_horas_data.rh_data) + ' ' + str(banco_horas_data.rh_qtd_hora)
    return res

#Funcoes da classe rh_marcacao
def _get_name_marcacao(self, cr, uid, ids, name, arg, context=None):
    """
    Retorna o descricao do marcacao
    """
    context = context and context.copy() or {}
    res = {}
    if ids:
        marcacao_datas = self.browse(cr, uid, ids)
        for marcacao_data in marcacao_datas:
            _func_lista =  marcacao_data.rh_funcionario_id.pessoa.name.split()
            if len(_func_lista)  > 1:
                _func_nome =  _func_lista[0] + ' ' + _func_lista[len(_func_lista) -1]
            else:
                _func_nome = _func_lista[0]
            res[marcacao_data.id] =  _func_nome + '-' +str( marcacao_data.rh_data) + ' ' + str(marcacao_data.rh_horario)
    return res

#Funcoes da classe rh_marcacao_dia
def _get_tempo(self, cr, uid, ids, name, arg, context=None):
    """
    Retorna o tempo trabalhado
    """
    context = context and context.copy() or {}
    res = {}.fromkeys(ids, 0)
    if ids:
        marcacao_dia_datas = self.browse(cr, uid, ids)
        for marcacao_dia_data in marcacao_dia_datas:
            rh_entrada1 = marcacao_dia_data['rh_entrada1']
            rh_entrada2 = marcacao_dia_data['rh_entrada2']
            rh_entrada3 = marcacao_dia_data['rh_entrada3']
            rh_entrada4 = marcacao_dia_data['rh_entrada4']
            rh_entrada5 = marcacao_dia_data['rh_entrada5']
            rh_saida1 = marcacao_dia_data['rh_saida1']
            rh_saida2 = marcacao_dia_data['rh_saida2']
            rh_saida3 = marcacao_dia_data['rh_saida3']
            rh_saida4 = marcacao_dia_data['rh_saida4']
            rh_saida5 = marcacao_dia_data['rh_saida5']
            if ((rh_entrada1 and not rh_saida1) or
                (rh_entrada2 and not rh_saida2) or
                (rh_entrada3 and not rh_saida3) or
                (rh_entrada4 and not rh_saida4) or
                (rh_entrada5 and not rh_saida5)):
                res[marcacao_dia_data.id] =  9999999
                continue
            _tempo = 0
            if rh_entrada1 and rh_saida1:
                _tempo += (int(rh_saida1) * 60 + (rh_saida1 - int(rh_saida1))) - (int(rh_entrada1) * 60 + (rh_entrada1 - int(rh_entrada1)))
            if rh_entrada2 and rh_saida2:
                _tempo += (int(rh_saida2) * 60 + (rh_saida2 - int(rh_saida2))) - (int(rh_entrada2) * 60 + (rh_entrada2 - int(rh_entrada2)))
            if rh_entrada3 and rh_saida3:
                _tempo += (int(rh_saida3) * 60 + (rh_saida3 - int(rh_saida3))) - (int(rh_entrada3) * 60 + (rh_entrada3 - int(rh_entrada3)))
            if rh_entrada4 and rh_saida4:
                _tempo += (int(rh_saida4) * 60 + (rh_saida4 - int(rh_saida4))) - (int(rh_entrada4) * 60 + (rh_entrada4 - int(rh_entrada4)))
            if rh_entrada5 and rh_saida5:
                _tempo += (int(rh_saida5) * 60 + (rh_saida5 - int(rh_saida5))) - (int(rh_entrada5) * 60 + (rh_entrada5 - int(rh_entrada5)))
            res[marcacao_dia_data.id] =  _tempo
    return res

#Funcoes da classe rh_periodo
def _get_name_periodo(self, cr, uid, ids, name, arg, context=None):
    """
    Retorna o descricao do periodo
    """
    context = context and context.copy() or {}
    res = {}
    if ids:
        for periodo_data in self.read(cr, uid, ids, ['rh_hora_entrada', 'rh_hora_saida'], context=context):
            horas_entrada = int(periodo_data['rh_hora_entrada'])
            minutos_entrada = periodo_data['rh_hora_entrada'] - horas_entrada
            horas_saida = int(periodo_data['rh_hora_saida'])
            minutos_saida = periodo_data['rh_hora_saida'] - horas_saida
            res[periodo_data['id']] = 'De: ' + formataString(int(round(horas_entrada,0)),2,'0','E','N','S') + ':' + formataString(int(round((minutos_entrada*60),0)),2,'0','E','N','S')\
                                      + ' a ' + formataString(int(round(horas_saida,0)),2,'0','E','N','S')  + ':' + formataString(int(round((minutos_saida*60),0)),2,'0','E','N','S')
    return res
