# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.osv import fields, osv

from openerp import tools


class rh_marcacao_dia(osv.Model):

    from funcoes import _get_tempo

    _name = 'rh.marcacao_dia'
    _description = "Resumo das marcacoes por dia"
    _rec_name = 'rh_funcionario_id'
    _auto = False
    _columns = {
        'rh_funcionario_id' : fields.many2one('rh.funcionario', 'Funcionario',ondelete='restrict', required=True, select=True),
        'rh_data' : fields.date('Data'),
        'rh_entrada1' : fields.float('Entrada 1'),
        'rh_saida1' : fields.float('Saida 1'),
        'rh_entrada2' : fields.float('Entrada 2'),
        'rh_saida2' : fields.float('Saida 2'),
        'rh_entrada3' : fields.float('Entrada 3'),
        'rh_saida3' : fields.float('Saida 3'),
        'rh_entrada4' : fields.float('Entrada 4'),
        'rh_saida4' : fields.float('Saida 4'),
        'rh_entrada5' : fields.float('Entrada 5'),
        'rh_saida5' : fields.float('Saida 5'),
        'rh_tempo_trabalhado' : fields.function(_get_tempo, method=True, string='Tempo(minutos)', type='integer',store=False)
                }
    _order = 'rh_funcionario_id, rh_data desc'


