# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _

class supervisor_cad_finalizadora_na_ecf(osv.Model):
    """
    Cadastro de nomes de finalizadoras na ecf
    Prefixo: supfec
    
    """

    _inherit = 'supervisor.cad.finalizadora.na.ecf'
    _columns = {
        'supfec_nro_empresa': fields.integer('Empresa', required=True, select=True),
        'supfec_loja': fields.integer('Loja', required=True, select=True),
    }

    def _auto_init(self, cr, context=None):
        self._sql_constraints = [
            ('cod_fin_loja_caixa_uniq',
             'unique (supfec_codigo_na_ecf, supfec_loja, supfec_nro_empresa)',
             _('O codigo da finalizadora precisa ser unico para a mesma empresa, loja e caixa')),
        ]
        self._order = 'supfec_nro_empresa, supfec_loja, supfec_codigo_na_ecf'
        super(supervisor_cad_finalizadora_na_ecf, self)._auto_init(cr, context)

