# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class supervisor_cad_pdvs(osv.Model):
    """
    Tabela de Cadastro de PFVs
    Prefixo: suppdv
    """
    _inherit = 'supervisor.cad.pdvs'
    _columns = {
        'suppdv_nro_empresa': fields.integer('Empresa', required=True, select=True),
    }

    _defaults = {
        'suppdv_nro_empresa': 0,
    }

    def _auto_init(self, cr, context=None):
        self._sql_constraints = [
        ('suppdv_loja_caixa_uniq', 'unique (suppdv_nro_empresa, suppdv_loja, suppdv_caixa)',
         'A empresa, loja e o caixa precisam ser unicos!'),
        ]
        super(supervisor_cad_pdvs, self)._auto_init(cr, context)