# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class wizard_supervisor_exporta_para_ecf(osv.TransientModel):

    _inherit = "wizard.supervisor.exporta.para.ecf"

    _columns = {
        'configuracao_ids':fields.many2many('supervisor.cfg.configuracao',
                                    'supervisor_loja_exporta_para_ecf', 'id', 'config_id', 'Lojas'),
    }

    _defaults = {
        'pdv_ids': False,
    }

    def onchange_suppdv_configuracao_ids(self, cr, uid, ids, configuracao_ids, context=None):
        context = context and context.copy() or {}
        res = {'value': {}}
        config_ids = []
        map(lambda x: config_ids.extend(x[2]), configuracao_ids)
        if not configuracao_ids or not config_ids:
            res['value']['pdv_ids'] = ''
            return res

        dados = self.pool.get('supervisor.cfg.configuracao').read(cr, uid, config_ids,
                                             ['supcfc_nro_empresa', 'supcfc_loja'], context=context)

        cond_pdv = []
        for i in dados:
            operador = 'OR '
            if not cond_pdv:
                operador = ''

            cond = """%s(suppdv_nro_empresa = %s AND suppdv_loja = %s)\n               """ %\
                   (operador, i.get('supcfc_nro_empresa'), i.get('supcfc_loja'))
            cond_pdv.append(cond)

        sql = """
            SELECT id
            FROM supervisor_cad_pdvs
            WHERE %s 
            ORDER BY suppdv_nro_empresa, suppdv_loja, suppdv_caixa 
        """ % ''.join(cond_pdv)
        cr.execute(sql)
        dados_pdv = cr.dictfetchall()
        if not dados_pdv:
            return res

        pdv_ids = map(lambda x: x.get('id'), dados_pdv)
        res['value']['pdv_ids'] = pdv_ids
        return res

    def get_vals_acao_pendente(self, brw_pdv, context=None):
        context = context and context.copy() or {}
        vals = super(wizard_supervisor_exporta_para_ecf, self).\
                                                            get_vals_acao_pendente(brw_pdv, context)
        vals['supeape_nro_empresa'] = brw_pdv.suppdv_nro_empresa
        return  vals


    def get_args_acao_pendente(self, brw_pdv, context=None):
        context = context and context.copy() or {}
        args = super(wizard_supervisor_exporta_para_ecf, self). \
                                                            get_args_acao_pendente(brw_pdv, context)
        args.append(['supeape_nro_empresa', '=', brw_pdv.suppdv_nro_empresa])
        return args