# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from os import path, listdir, remove, rename
from fnmatch import fnmatch
from SigUtils.registro import Registro
import os
import importlib
import base64
from openerp.tools.translate import _
import time
from datetime import datetime


class wizard_supervisor_importa_arquivo(osv.Model):
    importacao_aut = False
    _inherit = "wizard.supervisor.importa.arquivo"

    def set_listas_itens(self, cr, uid, list_vals_update, list_vals_create, vals, cfg_loja,
                         cfg_empresa, item, truncar_tabela, context=None):
        context = context and context.copy() or {}
        context_aux = context.copy()
        context_aux['active_test'] = False
        vals['supite_nro_empresa'] = cfg_empresa
        args = [('supite_loja', '=', cfg_loja),
                ('supite_codigo_item', '=', item.supite_codigo_item),
                ('supite_nro_empresa','=', cfg_empresa)]
        item_id = not truncar_tabela and self.pool.get('supervisor.cad.itens').search(cr, uid,
                                                                 args, context=context_aux) or False

        if item_id:
            list_vals_update.append((item_id[0], vals))
        else:
            data = "%s" % datetime.now()
            vals['create_date'] = vals['write_date'] = data
            vals['create_uid'] = vals['write_uid'] = uid
            list_vals_create.append(vals)

    def set_listas_kits(self, cr, uid, vals, cfg_loja, cfg_empresa, kit, context=None):
        super(wizard_supervisor_importa_arquivo, self).set_listas_kits(cr, uid, vals, cfg_loja,
                                                                       cfg_empresa, kit, context)
        context = context and context.copy() or {}
        vals['supkit_nro_empresa'] = cfg_empresa

    def truncar_tabelas(self, cr, list_vals_update, list_vals_create, truncar_tabela,
                        context=None):
        "os parametros 'list_vals_update' e 'list_vals_create' sao usados na heranca do metodo"
        context = context and context.copy() or {}
        if not truncar_tabela:
            return

        empresa = list_vals_update and list_vals_update[0].get('supite_nro_empresa') or \
                  list_vals_create and list_vals_create[0].get('supite_nro_empresa')
        loja = list_vals_update and list_vals_update[0].get('supite_loja') or \
               list_vals_create and list_vals_create[0].get('supite_loja')

        cr.execute("""DELETE FROM supervisor_cad_kits 
                      WHERE supkit_nro_empresa = {empresa}
                        AND supkit_loja ={loja};

                      DELETE FROM supervisor_cad_itens 
                      WHERE supite_nro_empresa = {empresa}
                        AND supite_loja ={loja};
                        """.format(empresa=empresa, loja=loja))