# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
import psycopg2
import psycopg2.extras
from openerp.addons.supervisor import print_log
from datetime import datetime

class groupby(dict):
    def __init__(self, seq, key=lambda x: x):
        for value in seq:
            k = key(value)
            self.setdefault(k, []).append(value)

    __iter__ = dict.iteritems

DADOS_TABELAS = {'Tributacao':{'inner':('supervisor_cad_pdvs AS scp',
                                        """scp.suppdv_loja = suptri_loja 
                                           AND scp.suppdv_nro_empresa = suptri_nro_empresa
                                           AND scp.suppdv_caixa = {caixa}"""),
                               'where': """(scp.suppdv_lastup_tributacao < sct.write_date 
                                             OR sct.write_date IS NULL 
                                             OR scp.suppdv_lastup_tributacao IS NULL)
                                        AND suptri_loja = {loja}
                                        AND suptri_nro_empresa = {empresa}"""},
                 'Itens':{'inner': ('supervisor_cad_pdvs AS scp',
                                    """scp.suppdv_loja = sci.supite_loja 
                                        AND scp.suppdv_nro_empresa = sci.supite_nro_empresa
                                        AND scp.suppdv_caixa = {caixa}"""),
                          'where':"""(scp.suppdv_lastup_itens < sci.write_date 
                                         OR sci.write_date IS NULL 
                                         OR scp.suppdv_lastup_itens IS NULL) 
                                  AND sci.supite_loja = {loja}
                                  AND sci.supite_nro_empresa = {empresa}"""},
                 'Kits': {'where':'supkit_loja = {loja} AND supkit_nro_empresa = {empresa}'},
                 'Restricao':{},
                 'Finalizadoras':{'where': """supfin_loja = {loja}
                                          AND supfin_nro_empresa = {empresa}"""},
                 'FinalizadorasECF':{'where': """supfec_loja = {loja}
                                          AND supfec_nro_empresa = {empresa}"""},
                 'Bandeiras':{},
                 'Operadores':{},
                 'Clientes':{},
                 'Mensagem':{},
                 'MensagemPar':{},
                 'Parametros':{},
                 'Configuracoes':{'where': 'supcfc_loja = {loja} AND supcfc_nro_empresa = {empresa}'},
                 'Pdvs':{'where': 'suppdv_loja = {loja} AND suppdv_nro_empresa = {empresa}'},
                 'Ecfs':{'where': 'supcfa_loja = {loja} AND supcfa_nro_empresa = {empresa}'},
                 'Vendedor':{},
                 'Saldo':{'where': 'supsal_loja = {loja} AND supsal_nro_empresa = {empresa}'},
                 }

class wizard_supervisor_exporta_acao_pendente(osv.TransientModel):

    _name = "wizard.supervisor.exporta.acao.pendente"

    RETIRAR_CAMPOS = {'supervisor_cad_finalizadora_na_ecf': ['supfec_nro_empresa', 'supfec_loja'],
                      'supervisor_cad_finalizadora': ['supfin_nro_empresa', 'supfin_loja'],
                      'supervisor_cad_itens': ['supite_nro_empresa', 'log_erro', 'scanntech',
                                               'supite_codigo_local'],
                      'supervisor_cad_kits': ['supkit_nro_empresa'],
                      'supervisor_cad_operadores': ['supope_biometria'],
                      'supervisor_cad_tributacao': ['suptri_nro_empresa'],
                      'supervisor_cad_pdvs': ['suppdv_nro_empresa', 'suppdv_lastup_clientes',
                                              'suppdv_lastup_finalizadora',
                                              'suppdv_lastup_operadores', 'suppdv_lastup_promocao',
                                              'suppdv_lastup_mensagens_clientes',
                                              'suppdv_lastup_tributacao', 'suppdv_lastup_itens',
                                              'suppdv_lastup_kits', 'suppdv_lastup_vendedor',
                                              'suppdv_lastup_promo_capa'],
                      'supervisor_cfg_ecf_autorizada': ['supcfa_nro_empresa'],
                      'supervisor_cfg_configuracao': ['supcfc_nro_emrpesa','supcfc_ip',
                                                      'supcfc_banco', 'supcfc_usuario',
                                                      'supcfc_senha', 'supcfc_porta'],
                      'supervisor_mov_acao_pendente': ['supeape_nro_empresa'],
                      'supervisor_mov_saldo': ['supsal_nro_empresa'],
                      }

    def __init__(self, *args,**kwargs):
        super(wizard_supervisor_exporta_acao_pendente, self).__init__(*args, **kwargs)
        self.dictfetchall = self.pool.get('supervisor.util').suputi_fetchall_to_dictfetchall
        
    def wizsep_get_conection(self, supervisor, context=None):
        context = context and context.copy() or {}
        banco = str(supervisor.get('supcfc_banco') or '')
        usuario = str(supervisor.get('supcfc_usuario') or '')
        ip = str(supervisor.get('supcfc_ip') or '')
        senha = supervisor.get('supcfc_senha') or ''
        try:
            conn = psycopg2.connect(database=banco, user=usuario, password=senha, host=ip,
                                    connect_timeout=3)
            _cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
            return _cr

        except Exception as err:
            print_log('Erro ao conectar com o Banco %s-%s: %s' % (banco, ip, err), tipo='E')
            return False

    def wizsep_get_uid(self, _cr, supervisor, context=None):
        context = context and context.copy() or {}
        if not _cr:
            return False

        banco = str(supervisor.get('supcfc_banco') or '')
        ip = str(supervisor.get('supcfc_ip') or '')
        try:
            _cr.execute("""SELECT id
                           FROM res_users
                           ORDER BY id 
                           LIMIT 1; """)
            dados = self.dictfetchall(_cr)

        except Exception as e:
            print_log(_('Erro ao conectar com o Banco %s-%s: %s') % (banco, ip, e), tipo='E')
            return False

        if not dados:
            print_log(_('Nenhum usuario cadastrado no supervisor - Banco: %s - IP: %s') %
                      (banco, ip), 'E')
            return False

        return dados[0].get('id')


    def wizsep_get_sql_acao_pendente(self, _uid, acoes, context=None):
        context = context and context.copy() or {}
        date = '%s' % datetime.now()
        for i in acoes:
            del i['id']
            i['create_date'] = i['write_date'] = date
            i['create_uid'] = i['write_uid'] = _uid
            for campo in self.RETIRAR_CAMPOS.get('supervisor_mov_acao_pendente'):
                if campo in i:
                    del i[campo]

        self.dados_acao_pendente.extend(acoes)

    def wizsep_get_referencia_trib(self, _cr, acao, context=None):
        context = context and context.copy() or {}
        self.ref_trib_novo_id = {}
        _cr.execute("""SELECT id, 
                              suptri_codigo_trib_ecf AS codigo,
                              suptri_loja            AS loja
                       FROM supervisor_cad_tributacao
                       WHERE suptri_loja = {loja}
                    """.format(loja=acao.get('supeape_loja'))
                    )
        for trib in self.dictfetchall(_cr):
            chave = '%s-%s-%s' % (trib.get('codigo'), trib.get('loja'),
                                  acao.get('supeape_nro_empresa'))
            self.ref_trib_novo_id[chave] = trib.get('id')

    def wizsep_exporta_acao(self, cr, _cr, empresa, loja, context=None):
        context = context and context.copy() or {}
        if not self.dados_acao_pendente:
            return

        campos = ''
        valores = []
        for i in self.dados_acao_pendente:
            # nao exporta acao de saldo, ela eh apenas para o supervisor master
            if i.get('supape_tabela') == 'Saldo':
                continue

            valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
                                                            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = """INSERT INTO supervisor_mov_acao_pendente 
                        %s
                 VALUES %s;
                 COMMIT;""" % (campos, valores)
        try:
            print_log(_('Exportando acoes pendentes.........'))
            _cr.execute(sql)
            cr.execute("""DELETE FROM supervisor_mov_acao_pendente 
                          WHERE supeape_nro_empresa = {empresa}
                            AND supeape_loja = {loja}""".format(empresa=empresa, loja=loja))
        except Exception as e:
            print_log(_('Erro ao exportar acoes pendentes: %s') % e, 'E')

        print_log(_('Exportacao de acoes pendentes finalizada.'))

    def wizsep_exporta_tributacao(self, _cr, context=None):
        context = context and context.copy() or {}
        if not self.dados_tributacao:
            return True

        print_log(_('Exportando %s tributacoes.........') % len(self.dados_tributacao))
        campos = ''
        for trib in self.dados_tributacao:
            if not campos:
                campos = "(%s)" % ', '.join(trib.keys())

            cod = trib.get('suptri_codigo_trib_ecf')
            loja = trib.get('suptri_loja')
            vals = "%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
                                                              else x, trib.values())),)
            vals = vals.replace('None', 'null')
            _cr.execute("""SELECT id 
                           FROM supervisor_cad_tributacao 
                           WHERE suptri_codigo_trib_ecf = '{cod}' 
                             AND suptri_loja = {loja}"""
                        .format(cod=cod,
                                loja=loja))
            trib_id = self.dictfetchall(_cr)
            if not trib_id:
                sql = """INSERT INTO supervisor_cad_tributacao 
                                %s
                         VALUES %s
                         RETURNING id;""" % (campos, vals)
            else:
                sql = """UPDATE supervisor_cad_tributacao
                         SET %s = %s
                         WHERE id = %s
                         RETURNING id;
                      """ % (campos, vals, trib_id[0].get('id'))
            try:
                sql = sql.replace("'None'", "''").replace("None", "null")
                _cr.execute(sql)
            except Exception as e:
                print_log(_('Erro ao exportar tributacoes: %s') % e, 'E')

        try:
            _cr.execute('COMMIT;')
        except Exception as e:
            print_log(_('Erro ao exportar tributacoes: %s') % e, 'E')

        print_log(_('Exportacao de tributacoes finalizada.'))

    def wizsep_exporta_itens(self, _cr, loja, context=None):
        context = context and context.copy() or {}
        if not self.dados_itens:
            return

        campos = ''
        valores = []
        for i in self.dados_itens:
            valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
                                                            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = """INSERT INTO supervisor_cad_itens 
                         %s
                  VALUES %s;
                  COMMIT;""" % (campos, valores)
        try:
            print_log(_('Exportando %s itens.........') % len(self.dados_itens))
            # deleta os itens que serao exportados para ficar mais rapido o sql
            if self.cb_itens:
                _cr.execute("""DELETE FROM supervisor_cad_itens
                               WHERE supite_loja = {loja} 
                               AND supite_codigo_item IN ({itens})""".
                                format(loja=loja,
                                       itens=','.join(self.cb_itens)))
            _cr.execute(sql)
        except Exception as e:
            print_log(_('Erro ao exportar itens: %s') % e, 'E')

        print_log(_('Exportacao de itens finalizada.'))

    def wizsep_exporta_kits(self, _cr, loja, context=None):
        context = context and context.copy() or {}
        if not self.dados_kits:
            return

        campos = ''
        valores = []
        for i in self.dados_kits:
            self.wizsep_ajusta_kits(_cr, i, context)
            valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
                                                            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = """INSERT INTO supervisor_cad_kits 
                        %s
                 VALUES %s;
                 COMMIT;""" % (campos, valores)
        try:
            print_log(_('Exportando %s kits.........') % len(self.dados_kits))
            _cr.execute("""DELETE FROM supervisor_cad_kits
                           WHERE supkit_loja = {loja} """.format(loja=loja))
            _cr.execute(sql)
        except Exception as e:
            print_log(_('Erro ao exportar kits: %s') % e, 'E')

        print_log(_('Exportacao de kits finalizada.'))

    def wizsep_exporta_resticao_itens(self, _cr, loja, context=None):
        context = context and context.copy() or {}
        if not self.dados_restricao:
            return

        campos = ''
        valores = []
        for i in self.dados_restricao:
            valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = """INSERT INTO supervisor_cad_restricao_item 
                                %s
                         VALUES %s;
                         COMMIT;""" % (campos, valores)
        try:
            print_log(_('Exportando %s restricoes de itens.........') % len(self.dados_restricao))
            sql = sql.replace("'None'", "''").replace("None", "null")
            _cr.execute("""DELETE FROM supervisor_cad_restricao_item""")
            _cr.execute(sql)
        except Exception as e:
            print_log(_('Erro ao exportar restricoes de  itens: %s') % e, 'E')

        print_log(_('Exportacao de restricoes de itens finalizada.'))

    def wizsep_exporta_finalizadoras_na_ecf(self, _cr, empresa, loja, context=None):
        context = context and context.copy() or {}
        if not self.dados_finalizadoras_na_ecf:
            return

        try:
            _cr.execute("""SELECT id, 
                                  supfec_codigo_na_ecf
                            FROM supervisor_cad_finalizadora_na_ecf
                        """)
        except Exception as e:
            return print_log(_('Erro ao exportar finalizadoras na ecf: %s') % e, 'E')

        fin_gravadas = {}
        for i in self.dictfetchall(_cr):
            chave = "%s" % i.get('supfec_codigo_na_ecf')
            fin_gravadas[chave] = i.get('id')


        campos = ''
        valores_insert = []
        sql_update = []
        for i in self.dados_finalizadoras_na_ecf:
            chave = "%s" % (i.get('supfec_codigo_na_ecf'))
            valores = "%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
                                                                else x, i.values())),)
            valores = valores.replace('None', 'null')
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

            if chave in fin_gravadas:
                del i['create_date']
                del i['create_uid']
                sql_update.append("""
                             UPDATE supervisor_cad_finalizadora_na_ecf
                             SET %s = %s
                             WHERE id = %s; """ % (campos, valores, fin_gravadas.get(chave)))
            else:
                valores_insert.append(valores)


        sql_insert = ''
        if valores_insert:
            valores_insert = ',\n'.join(map(lambda x: x, valores_insert))
            sql_insert = """INSERT INTO supervisor_cad_finalizadora_na_ecf 
                                    %s
                             VALUES %s;
                             COMMIT;""" % (campos, valores_insert)


        try:
            print_log(_('Exportando %s finalizadoras na ecf.........') %
                      len(self.dados_finalizadoras_na_ecf))
            if sql_insert:
                _cr.execute(sql_insert)

            if sql_update:
                _cr.execute('%s COMMIT;' % ''.join(sql_update))

        except Exception as e:
            print_log(_('Erro ao exportar finalizadoras na ecf: %s') % e, 'E')

        print_log(_('Exportacao de finalizadoras na ecf finalizada.'))

    def wizsep_exporta_bandeiras(self, cr, _cr, loja, context=None):
        context = context and context.copy() or {}
        if not self.dados_bandeiras:
            return

        campos = ''
        valores = []
        for i in self.dados_bandeiras:
            valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = """INSERT INTO supervisor_cad_bandeiras 
                                %s
                         VALUES %s;
                         COMMIT;""" % (campos, valores)
        try:
            print_log(_('Exportando %s bandeiras.........') % len(self.dados_bandeiras))
            _cr.execute("""DELETE FROM supervisor_cad_bandeiras""")
            _cr.execute(sql)
        except Exception as e:
            print_log(_('Erro ao exportar bandeiras: %s') % e, 'E')

        print_log(_('Exportacao de bandeiras finalizada.'))

    def wizsep_ajusta_sql_bandeira(self, cr, _cr, context=None):
        context = context and context.copy() or {}
        cr.execute("""SELECT id, 
                             supban_codigo AS codigo, 
                             supban_tipo AS tipo
                       FROM supervisor_cad_bandeiras""")
        id_dados_ban = {}
        map(lambda x: id_dados_ban.update(
            {'%s-%s' % (x.get('codigo'), x.get('tipo')): x.get('id')}),
            cr.dictfetchall())
        _cr.execute("""SELECT id, 
                              supban_codigo AS codigo, 
                              supban_tipo AS tipo
                       FROM supervisor_cad_bandeiras""")
        id_old_id_new = {}
        map(lambda x: id_old_id_new.update(
            {id_dados_ban.get('%s-%s' % (x.get('codigo'), x.get('tipo'))): x.get('id')}),
            self.dictfetchall(_cr))
        for i in self.dados_finalizadoras:
            if 'supfin_bandeira_cre' in i and i.get('supfin_bandeira_cre'):
                i['supfin_bandeira_cre'] = id_old_id_new.get(i.get('supfin_bandeira_cre'))
            if 'supfin_bandeira_deb' in i and i.get('supfin_bandeira_deb'):
                i['supfin_bandeira_deb'] = id_old_id_new.get(i.get('supfin_bandeira_deb'))

    def wizsep_ajusta_sql_finalizadora(self, cr, _cr, empresa, loja, context=None):
        context = context and context.copy() or {}
        cr.execute("""SELECT id, 
                             supfec_codigo_na_ecf AS codigo,
                             supfec_loja          AS loja,
                             supfec_nro_empresa   AS empresa
                       FROM supervisor_cad_finalizadora_na_ecf""")
        id_dados_fin_ecf = {}
        map(lambda x: id_dados_fin_ecf.update(
            {'%s-%s-%s' % (x.get('codigo'), x.get('loja'), x.get('empresa')): x.get('id')}),
            cr.dictfetchall())
        _cr.execute("""SELECT id, 
                              supfec_codigo_na_ecf AS codigo
                       FROM supervisor_cad_finalizadora_na_ecf""")
        id_old_id_new = {}
        map(lambda x: id_old_id_new.update(
            {id_dados_fin_ecf.get('%s-%s-%s' % (x.get('codigo'), loja, empresa)): x.get('id')}),
            self.dictfetchall(_cr))
        for i in self.dados_finalizadoras:
            i['supfin_codigo_na_ecf'] = id_old_id_new.get(i.get('supfin_codigo_na_ecf'))

    def wizsep_exporta_finalizadoras(self, cr, _cr, loja, empresa, context=None):
        context = context and context.copy() or {}
        if not self.dados_finalizadoras:
            return

        self.wizsep_ajusta_sql_finalizadora(cr, _cr, empresa, loja, context=context)
        self.wizsep_ajusta_sql_bandeira(cr, _cr, context=context)
        campos = ''
        valores = []
        for i in self.dados_finalizadoras:
            valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = """INSERT INTO supervisor_cad_finalizadora 
                                %s
                         VALUES %s;
                         COMMIT;""" % (campos, valores)
        try:
            print_log(_('Exportando %s finalizadoras.........') %
                      len(self.dados_finalizadoras))
            _cr.execute(sql)
        except Exception as e:
            print_log(_('Erro ao exportar finalizadoras: %s') % e, 'E')

        print_log(_('Exportacao de finalizadoras finalizada.'))

    def wizsep_exporta_operadores(self, cr, _cr, loja, context):
        context = context and context.copy() or {}
        if not self.dados_operadores:
            return

        _cr.execute('SELECT supope_codigo FROM supervisor_cad_operadores')
        cod_operadores = map(lambda x: x.get('supope_codigo'), self.dictfetchall(_cr))
        campos = ''
        valores = []
        sql_update = []
        for i in self.dados_operadores:
            if i.get('supope_codigo') in cod_operadores:
                _campos = "(%s)" % ', '.join(i.keys())
                _valores = "%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
                                                              else x, i.values())),)
                sql_update.append("""UPDATE supervisor_cad_operadores
                                     SET {campos} = {vals}
                                     WHERE supope_codigo = '{cod}';"""
                                    .format(campos=_campos,
                                            vals=_valores,
                                            cod=i.get('supope_codigo'))
                                  )
                continue

            valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = ''
        if valores:
            sql = """INSERT INTO supervisor_cad_operadores
                                    %s
                             VALUES %s;
                     COMMIT;""" % (campos, valores)
        try:
            print_log(_('Exportando %s operadores.........') %
                      len(self.dados_operadores))
            sql and _cr.execute(sql)
            sql_update and  _cr.execute(('\n'.join(sql_update)).replace('None', 'null') +
                                        ' COMMIT;')

        except Exception as e:
            print_log(_('Erro ao exportar operadores: %s') % e, 'E')

        print_log(_('Exportacao de operadores finalizada.'))

    def wizsep_exporta_clientes(self, cr, _cr, loja, context=None):
        context = context and context.copy() or {}
        if not self.dados_clientes:
            return

        campos = ''
        valores = []
        for i in self.dados_clientes:
            valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = """INSERT INTO supervisor_cad_clientes
                                %s
                         VALUES %s;
                         COMMIT;""" % (campos, valores)
        try:
            print_log(_('Exportando %s clientes.........') % len(self.dados_clientes))
            _cr.execute("""DELETE FROM supervisor_cad_clientes""")
            _cr.execute(sql)
        except Exception as e:
            print_log(_('Erro ao exportar clientes: %s') % e, 'E')

        print_log(_('Exportacao de clientes finalizada.'))

    def wizsep_exporta_mensagens(self, cr, _cr, loja, context=None):
        context = context and context.copy() or {}
        if not self.dados_mensagem:
            return

        campos = ''
        valores = []
        for i in self.dados_mensagem:
            valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = """INSERT INTO supervisor_cad_mensagens_clientes
                                %s
                         VALUES %s;
                         COMMIT;""" % (campos, valores)
        try:
            print_log(_('Exportando %s mensagens de clientes.........') % len(self.dados_mensagem))
            _cr.execute("""DELETE FROM supervisor_cad_mensagens_clientes""")
            _cr.execute(sql)
        except Exception as e:
            print_log(_('Erro ao exportar mensagens de clientes: %s') % e, 'E')

        print_log(_('Exportacao de mensagens de clientes finalizada.'))

    def wizsep_exporta_cfg_mensagens(self, cr, _cr, loja, context=None):
        context = context and context.copy() or {}
        if not self.dados_cfg_mensagens:
            return

        campos = ''
        valores = []
        for i in self.dados_cfg_mensagens:
            valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = """INSERT INTO supervisor_cfg_mensagens
                                %s
                         VALUES %s;
                         COMMIT;""" % (campos, valores)
        try:
            print_log(_('Exportando %s mensagens da configuracao.........') % len(self.dados_cfg_mensagens))
            _cr.execute("""DELETE FROM supervisor_cfg_mensagens""")
            _cr.execute(sql)
        except Exception as e:
            print_log(_('Erro ao exportar mensagens da configuracao: %s') % e, 'E')

        print_log(_('Exportacao de mensagens da configuracao finalizada.'))

    def wizsep_exporta_parametros(self, cr, _cr, loja, context=None):
        context = context and context.copy() or {}
        if not self.dados_parametros:
            return

        campos = ''
        valores = []
        for i in self.dados_parametros:
            valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = """INSERT INTO supervisor_cfg_parametros
                                %s
                         VALUES %s;
                         COMMIT;""" % (campos, valores)
        try:
            print_log(_('Exportando %s parametros.........') % len(self.dados_parametros))
            _cr.execute("""DELETE FROM supervisor_cfg_parametros""")
            _cr.execute(sql)
        except Exception as e:
            print_log(_('Erro ao exportar parametros: %s') % e, 'E')

        print_log(_('Exportacao de parametros finalizada.'))

    def wizsep_exporta_configuracoes(self, cr, _cr, loja, context=None):
        context = context and context.copy() or {}
        if not self.dados_configuracoes:
            return

        obj_sup_util = self.pool.get('supervisor.util')
        campos = ''
        valores = []
        for i in self.dados_configuracoes:
            valores.append("%s" %
                           (tuple(map(lambda x: str(obj_sup_util.suputi_remover_acentuacao(x))
                           if isinstance(x, unicode) else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = """INSERT INTO supervisor_cfg_configuracao
                                %s
                         VALUES %s;
                         COMMIT;""" % (campos, valores)
        try:
            print_log(_('Exportando %s configuracoes.........') % len(self.dados_configuracoes))
            _cr.execute("""DELETE FROM supervisor_cfg_configuracao""")
            _cr.execute(sql)
        except Exception as e:
            print_log(_('Erro ao exportar configuracoes: %s') % e, 'E')

        print_log(_('Exportacao de configuracoes finalizada.'))

    def wizsep_exporta_pdvs(self, cr, _cr, loja, context=None):
        context = context and context.copy() or {}
        if not self.dados_pdvs:
            return

        campos = ''
        valores = []
        for i in self.dados_pdvs:
            valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = """INSERT INTO supervisor_cad_pdvs
                                %s
                         VALUES %s;
                         COMMIT;""" % (campos, valores)
        try:
            print_log(_('Exportando %s pdvs.........') % len(self.dados_pdvs))
            _cr.execute("""DELETE FROM supervisor_cad_pdvs""")
            _cr.execute(sql)
        except Exception as e:
            print_log(_('Erro ao exportar pdvs: %s') % e, 'E')

        print_log(_('Exportacao de pdvs finalizada.'))

    def wizsep_exporta_ecf(self, cr, _cr, loja, context=None):
        context = context and context.copy() or {}
        if not self.dados_ecf_autorizada:
            return

        campos = ''
        valores = []
        for i in self.dados_ecf_autorizada:
            valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = """INSERT INTO supervisor_cfg_ecf_autorizada
                                %s
                         VALUES %s;
                         COMMIT;""" % (campos, valores)
        try:
            print_log(_('Exportando %s ecfs.........') % len(self.dados_ecf_autorizada))
            _cr.execute("""DELETE FROM supervisor_cfg_ecf_autorizada""")
            _cr.execute(sql)
        except Exception as e:
            print_log(_('Erro ao exportar ecfs: %s') % e, 'E')

        print_log(_('Exportacao de ecfs finalizada.'))

    def wizsep_exporta_vendedor(self, cr, _cr, loja, context=None):
        context = context and context.copy() or {}
        if not self.dados_vendedor:
            return

        _cr.execute('SELECT supven_codigo FROM supervisor_cad_vendedor')
        cod_vendedor = map(lambda x: x.get('supven_codigo'), self.dictfetchall(_cr))
        campos = ''
        valores = []
        sql_update = []
        for i in self.dados_vendedor:
            if i.get('supven_codigo') in cod_vendedor:
                _campos = "(%s)" % ', '.join(i.keys())
                _valores = "%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
                                                              else x, i.values())),)
                sql_update.append("""UPDATE supervisor_cad_vendedor
                                     SET {campos} = {vals}
                                     WHERE supven_codigo = '{cod}';"""
                                    .format(campos=_campos,
                                            vals=_valores,
                                            cod=i.get('supven_codigo'))
                                  )
                continue

            valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = ''
        if valores:
            sql = """INSERT INTO supervisor_cad_vendedor
                                    %s
                             VALUES %s;
                             COMMIT;""" % (campos, valores)

        try:
            print_log(_('Exportando %s vendedores.........') % len(self.dados_vendedor))
            sql and _cr.execute(sql)
            sql_update and  _cr.execute(('\n'.join(sql_update)).replace('None', 'null') +
                                        ' COMMIT;')
        except Exception as e:
            print_log(_('Erro ao exportar vendedores: %s') % e, 'E')

        print_log(_('Exportacao de vendedores finalizada.'))

    def wizsep_exporta_saldo(self, cr, _cr, loja, context=None):
        context = context and context.copy() or {}
        if not self.dados_saldo:
            return

        campos = ''
        valores = []
        for i in self.dados_saldo:
            valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = """INSERT INTO supervisor_mov_saldo
                                %s
                         VALUES %s;
                         COMMIT;""" % (campos, valores)
        try:
            print_log(_('Exportando %s saldos.........') % len(self.dados_saldo))
            _cr.execute("""DELETE FROM supervisor_mov_saldo""")
            _cr.execute(sql)
        except Exception as e:
            print_log(_('Erro ao exportar saldos: %s') % e, 'E')

        print_log(_('Exportacao de saldos finalizada.'))

    def wizsep_exporta(self, cr, uid, _cr, loja, empresa, context=None):
        context = context and context.copy() or {}
        self.wizsep_exporta_itens(_cr, loja, context)
        self.wizsep_exporta_kits(_cr, loja, context)
        self.wizsep_exporta_resticao_itens(_cr, loja, context)
        self.wizsep_exporta_finalizadoras_na_ecf(_cr, empresa, loja, context)
        self.wizsep_exporta_bandeiras(cr, _cr, loja, context)
        self.wizsep_exporta_finalizadoras(cr, _cr, loja, empresa, context)
        self.wizsep_exporta_operadores(cr, _cr, loja, context)
        self.wizsep_exporta_clientes(cr, _cr, loja, context)
        self.wizsep_exporta_mensagens(cr, _cr, loja, context)
        self.wizsep_exporta_cfg_mensagens(cr, _cr, loja, context)

        self.wizsep_exporta_parametros(cr, _cr, loja, context)
        self.wizsep_exporta_configuracoes(cr, _cr, loja, context)
        self.wizsep_exporta_pdvs(cr, _cr, loja, context)
        self.wizsep_exporta_ecf(cr, _cr, loja, context)
        self.wizsep_exporta_vendedor(cr, _cr, loja, context)
        self.wizsep_exporta_saldo(cr, _cr, loja, context)
        self.wizsep_exporta_promo(cr, uid, _cr, empresa, context)

        # deve ser a ultima coisa a ser feita eh a exportacao da acao pendente
        self.wizsep_exporta_acao(cr, _cr, empresa, loja, context)

    def wizsep_exporta_acao_pendente(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_acao = self.pool.get('supervisor.mov.acao.pendente')
        acao_ids = obj_acao .search(cr, uid, [], context=context)
        if not acao_ids:
            return True

        obj_configuracao = self.pool.get('supervisor.cfg.configuracao')
        configuracao_ids = obj_configuracao.search(cr, uid, [], context=context)
        if not configuracao_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nenhuma configuracao cadastrada!'))

        dados_acao = obj_acao.read(cr, uid, acao_ids, [], context=context)
        campos = ['supcfc_nro_empresa', 'supcfc_loja', 'supcfc_ip', 'supcfc_banco',
                  'supcfc_usuario', 'supcfc_senha', 'supeape_pdv']

        dados_config = obj_configuracao.read(cr, uid, configuracao_ids, campos, context=context)
        for dados_acao, vals in groupby(
                        dados_acao, key=lambda r: (r.get('supeape_nro_empresa'),
                                                   r.get('supeape_loja', 0),
                                                   )):
            empresa = dados_acao[0] # quando a empresa for zero, exportar para todas as empresas
            loja = dados_acao[1] # quando a loja for zero, exportar para todas as lojas
            supervisor = filter(lambda x: x.get('supcfc_nro_empresa') == empresa
                                      and x.get('supcfc_loja') == loja, dados_config)
            if not supervisor:
                print_log(_('Sem cadastro de configuracao para a empresa: %s loja: %s') %
                          (empresa, loja), 'E')

            # cursor do supervisor slave
            _cr = self.wizsep_get_conection(supervisor[0])
            # id do super_user no supervisor slave
            _uid = self.wizsep_get_uid(_cr, supervisor[0], context=context)
            if not _cr or not _uid:
                continue

            print_log(_('--------- Exportacao para o supervisor: %s-%s') %
                       (supervisor[0].get('supcfc_banco'), supervisor[0].get('supcfc_ip')))
            self.wizsep_cria_limpa_variaveis(context)
            acao_pendentes = {'Tributacao': [], 'Itens':[], 'Restricao':[],
                              'Mensagem':[], 'Finalizadoras':[], 'Bandeiras':[], 'Operadores':[],
                              'Clientes':[], 'Parametros':[], 'Vendedor':[], 'Configuracao':[],
                              'Saldo': [],
                              'Promocoes': []}
            map(lambda x: acao_pendentes.update({x.get('supape_tabela'):[x.copy()]}), vals)
            self.wizsep_get_sql_acao_pendente(_uid, vals, context)
            for acao in acao_pendentes.get('Tributacao'):
                inner = (DADOS_TABELAS.get('Tributacao').get('inner')[0],
                         DADOS_TABELAS.get('Tributacao').get('inner')[1].format(
                                                                     caixa=acao.get('supeape_pdv')))
                self.dados_tributacao.extend(self.wizsep_get_dados(cr, _cr, uid, _uid, acao,
                           'supervisor_cad_tributacao AS sct',
                    inner=inner,
                    where=DADOS_TABELAS.get('Tributacao').get('where').format(loja=loja,
                                                                              empresa=empresa,),
                                               last_up='suppdv_lastup_tributacao', context=context))

            for acao in acao_pendentes.get('Itens'):
                inner = (DADOS_TABELAS.get('Itens').get('inner')[0],
                         DADOS_TABELAS.get('Itens').get('inner')[1].format(
                                                                     caixa=acao.get('supeape_pdv')))
                self.dados_itens.extend(self.wizsep_get_dados(cr, _cr, uid, _uid, acao,
                                                          'supervisor_cad_itens AS sci',inner=inner,
                    where=DADOS_TABELAS.get('Itens').get('where').format(loja=loja,empresa=empresa),
                    last_up='suppdv_lastup_itens', context=context))
                self.dados_kits.extend(self.wizsep_get_dados(cr, _cr, uid, _uid,  acao,
                                                             'supervisor_cad_kits',
                         where=DADOS_TABELAS.get('Kits').get('where').format(loja=loja,
                                                                             empresa=empresa),
                                                     last_up='suppdv_lastup_kits', context=context))

            for acao in acao_pendentes.get('Restricao'):
                self.dados_restricao.extend(self.wizsep_get_dados(cr, _cr, uid, _uid,  acao,
                                                  'supervisor_cad_restricao_item', context=context))

            for acao in acao_pendentes.get('Finalizadoras'):
                self.dados_finalizadoras_na_ecf.extend(self.wizsep_get_dados(cr, _cr, uid, _uid,
                                             acao,'supervisor_cad_finalizadora_na_ecf',
                        where=DADOS_TABELAS.get('FinalizadorasECF').get('where').format(
                                        loja=loja, empresa=empresa),
                                             last_up='suppdv_lastup_finalizadora', context=context))
                self.dados_finalizadoras.extend(self.wizsep_get_dados(cr, _cr, uid, _uid, acao,
                                                          'supervisor_cad_finalizadora',
                        where=DADOS_TABELAS.get('Finalizadoras').get('where').format(loja=loja,
                                                                                   empresa=empresa),
                                             last_up='suppdv_lastup_finalizadora', context=context))

            for acao in acao_pendentes.get('Bandeiras'):
                self.dados_bandeiras.extend(self.wizsep_get_dados(cr, _cr, uid, _uid, acao,
                                                       'supervisor_cad_bandeiras', context=context))
                # ao exportar bandeiras, deve exportar as finalizadoras
                if not self.dados_finalizadoras:
                    self.dados_finalizadoras.extend(self.wizsep_get_dados(cr, _cr, uid, _uid, acao,
                                                          'supervisor_cad_finalizadora',
                                             last_up='suppdv_lastup_finalizadora', context=context))

            for acao in acao_pendentes.get('Operadores'):
                    self.dados_operadores.extend(self.wizsep_get_dados(cr, _cr, uid, _uid, acao,
                                                          'supervisor_cad_operadores',
                                             last_up='suppdv_lastup_operadores', context=context))

            for acao in acao_pendentes.get('Clientes'):
                self.dados_clientes.extend(self.wizsep_get_dados(cr, _cr, uid, _uid, acao,
                                                          'supervisor_cad_clientes',
                                                 last_up='suppdv_lastup_clientes', context=context))
                self.wizsep_get_dados_funcionario(cr, _cr, uid, _uid, acao, context)

            for acao in acao_pendentes.get('Mensagem'):
                self.dados_mensagem.extend(self.wizsep_get_dados(cr, _cr, uid, _uid, acao,
                                                          'supervisor_cad_mensagens_clientes',
                                       last_up='suppdv_lastup_mensagens_clientes', context=context))
                self.dados_cfg_mensagens.extend(self.wizsep_get_dados(cr, _cr, uid, _uid, acao,
                                                       'supervisor_cfg_mensagens', context=context))

            for acao in acao_pendentes.get('Parametros'):
                self.dados_parametros.extend(self.wizsep_get_dados(cr, _cr, uid, _uid, acao,
                                                       'supervisor_cfg_parametros',
                                                           last_up='write_date', context=context))
                self.dados_configuracoes.extend(self.wizsep_get_dados(cr, _cr, uid, _uid, acao,
                                                    'supervisor_cfg_configuracao',
                            where=DADOS_TABELAS.get('Configuracoes').get('where').format(loja=loja,
                                                                 empresa=empresa),context=context))
                self.dados_pdvs.extend(self.wizsep_get_dados(cr, _cr, uid, _uid, acao,
                                                    'supervisor_cad_pdvs',
                            where=DADOS_TABELAS.get('Pdvs').get('where').format(loja=loja,
                                                                empresa=empresa), context=context))
                self.dados_ecf_autorizada.extend(self.wizsep_get_dados(cr, _cr, uid, _uid, acao,
                                                    'supervisor_cfg_ecf_autorizada',
                            where=DADOS_TABELAS.get('Ecfs').get('where').format(loja=loja,
                                                                 empresa=empresa), context=context))

            for acao in acao_pendentes.get('Vendedor'):
                self.dados_vendedor.extend(self.wizsep_get_dados(cr, _cr, uid, _uid, acao,
                                                        'supervisor_cad_vendedor', context=context))

            for acao in acao_pendentes.get('Saldo'):
                self.dados_saldo.extend(self.wizsep_get_dados(cr, _cr, uid, _uid, acao,
                       'supervisor_mov_saldo',where=DADOS_TABELAS.get('Saldo').get('where').format(
                                                      loja=loja, empresa=empresa), context=context))

            for acao in acao_pendentes.get('Promocoes'):
                self.wizsep_get_dados_promocao(cr, _cr, uid, _uid, acao, empresa, context)

            self.wizsep_exporta(cr, uid, _cr, loja, empresa, context)
            self.wizsep_update_datas_pdv(cr, uid, empresa, loja, context)

        self.wizsep_cria_limpa_variaveis(context)
        return True

    def wizsep_cria_limpa_variaveis(self, context=None):
        'Cria e Limpa. Limpa para nao ficar usando memoria'
        context = context and context.copy() or {}
        self.last_update = {}
        self.cb_itens = []  # guarda os codigos de barras dos itens a serem exportados
        self.dados_acao_pendente = []
        self.dados_itens = []
        self.dados_kits = []
        self.dados_restricao = []
        self.dados_tributacao = []
        self.dados_mensagem = []
        self.dados_cfg_mensagens = []
        self.dados_finalizadoras = []
        self.dados_finalizadoras_na_ecf = []
        self.dados_bandeiras = []
        self.dados_operadores = []
        self.dados_clientes = []
        self.dados_parametros = []
        self.dados_vendedor = []
        self.dados_configuracoes = []
        self.dados_pdvs = []
        self.dados_ecf_autorizada = []
        self.dados_saldo = []

    def wizsep_get_dados_funcionario(self, cr, _cr, uid, _uid, acao, context=None):
        '''
        Implementado por heranca no modulo supervisor_master_funcionario 
        '''
        return

    def wizsep_get_dados_promocao(self, cr, _cr, uid, _uid, acao, empresa, context=None):
        '''
        Implementado por heranca no modulo supervisor_master_promocoes
        '''
        return

    def wizsep_exporta_promo(self, cr, uid, _cr, empresa, context=None):
        '''
        Implementado por heranca no modulo supervisor_master_promocoes 
        '''
        return

    def wizsep_update_datas_pdv(self, cr, uid, empresa, loja, context=None):
        context = context and context.copy() or {}
        if not self.last_update:
            return

        pdv_ids = self.pool.get('supervisor.cad.pdvs').search(cr, uid,
                                            [('suppdv_nro_empresa', '=', empresa),
                                             ('suppdv_loja', '=', loja)], context=context)
        self.pool.get('supervisor.cad.pdvs').write(cr, uid, pdv_ids, self.last_update,
                                                   context=context)

    def wizsep_ajusta_itens(self, cr, uid, _cr, tabela, dados, acao, context=None):
        context = context and context.copy() or {}
        if  tabela != 'supervisor_cad_itens':
            return

        self.wizsep_get_referencia_trib(_cr, acao, context)
        date = datetime.now()
        self.last_update['suppdv_lastup_itens'] = date
        trib_ids = list(set(map(lambda x: x.get('supite_tributacao_id'), dados)))
        if not trib_ids:
            print_log(_('Nao existe tributacao cadastrastrada no supervisor para a '
                        'Empresa: , Loja: ') % (acao.get('supeape_nro_empresa'),
                                                acao.get('supeape_loja')), 'E')
            return False

        trib_id_dados = {}
        map(lambda x: trib_id_dados.update({x.get('id'): x}),
            self.pool.get('supervisor.cad.tributacao').read(cr, uid, trib_ids,
                                                            ['suptri_codigo_trib_ecf',
                                                             'suptri_loja',
                                                             'suptri_nro_empresa'],
                                                            context=context))
        for item in dados:
            trib_id = item.get('supite_tributacao_id')
            chave = '%s-%s-%s' % (trib_id_dados.get(trib_id).get('suptri_codigo_trib_ecf'),
                                  trib_id_dados.get(trib_id).get('suptri_loja'),
                                  trib_id_dados.get(trib_id).get('suptri_nro_empresa'))
            item['supite_tributacao_id'] = self.ref_trib_novo_id.get(chave)
            self.cb_itens.append("'%s'" % item.get('supite_codigo_item'))

    def wizsep_ajusta_kits(self, _cr, kit, context=None):
        context = context and context.copy() or {}
        _cr.execute(''' SELECT id
                        FROM supervisor_cad_itens
                        WHERE supite_codigo_item = '%s' ''' % kit.get('supkit_codigo_barra_kit'))
        dados_kit = self.dictfetchall(_cr)
        _cr.execute(''' SELECT id
                        FROM supervisor_cad_itens
                        WHERE supite_codigo_item = '%s' ''' % kit.get('supkit_codigo_barra_item'))
        dados_item = self.dictfetchall(_cr)
        if not dados_kit:
            print_log(_("Item kit %s nao cadastrado no supervisor") %
                      kit.get('supkit_codigo_barra_kit'), 'E')
            return

        if not dados_item:
            print_log(_("Item %s de kit nao cadastrado no supervisor") %
                      kit.get('supkit_codigo_barra_item'), 'E')
            return

        kit['supkit_codigo_kit'] = dados_kit[0].get('id')
        kit['supkit_codigo_item'] = dados_item[0].get('id')

    def wizsep_get_dados(self, cr, _cr, uid, _uid, acao, tabela, inner='', where='', last_up='',
                         context=None):
        context = context and context.copy() or {}
        if inner:
            inner = "INNER JOIN %s ON %s" % inner

        if where:
            where = "WHERE %s" % where

        alias = 'AS' in tabela and ('%s.' % tabela[-3:]) or ''
        sql = """SELECT {alias}*
                 FROM {tabela}
                 {inner}
                 {where}
                 ORDER BY id""".format(alias=alias,
                                       inner=inner,
                                       tabela=tabela,
                                       where=where)
        cr.execute(sql)
        dados = cr.dictfetchall()
        if not dados:
            return []

        if 'AS' in tabela:
            tabela = tabela[:-7]

        self.wizsep_ajusta_itens(cr, uid, _cr, tabela, dados, acao, context)
        for i in dados:
            del i['id']
            if self.RETIRAR_CAMPOS.get(tabela):
                for campo in self.RETIRAR_CAMPOS.get(tabela):
                    if campo in i:
                        del i[campo]

            date = '%s' % datetime.now()
            i['create_date'] = i['write_date'] = date
            i['create_uid'] =i['write_uid'] = _uid

        if 'supervisor_cad_tributacao' == tabela:
            # as tributacoes devem ser criadas antes das consultas de itens para poder fazer a
            # correlacao dos ids da tributacao entre os dois bancos
            self.dados_tributacao.extend(dados)
            self.wizsep_exporta_tributacao(_cr, context)

        if last_up:
            self.last_update[last_up] = '%s' % datetime.now()

        return dados