# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from openerp.addons.supervisor import print_log


DADOS_TABELAS = {'supervisor_mov_caixa': {'where': "supcax_enviado = 'N'",
                                          'empresa': 'supcax_nro_empresa',},
                 'supervisor_mov_capa': {'inner':('supervisor_mov_cupom_servidor AS smcs',
                                                  """smcs.supcse_capa_id = smc.id"""),
                                        'where': """smcs.supcse_enviado = False""",
                                        'empresa': 'supcap_nro_empresa',},
                 'supervisor_mov_corpo_xz': {'where': """supcxz_capa_id IN ({cond})"""},
                 'supervisor_mov_corpos': {'where': """supcor_capa_id IN ({cond})"""},
                 'supervisor_mov_fechamentos': {'where': """supfec_capa_id IN ({cond})"""},
                 'supervisor_mov_vencimentos': {'where': """supfve_fechamentos_id IN ({cond})"""},
                 'supervisor_mov_meios_pagamentos': {'where': "supmpa_enviado = 'N'",
                                                     'empresa': 'supmpa_nro_empresa'},
                 'supervisor_mov_recebimentos': {'where': """suprec_capa_id IN ({cond})"""},
                 'supervisor_mov_totalizadores_xz': {'where': """suptxz_capa_id IN ({cond})"""},
                 'supervisor_autorizacoes': {'where': """supaut_capa_id IN ({cond})"""},
                 'supervisor_cad_finalizadora': {'empresa': 'supfin_nro_empresa',
                                                 'loja': 'supfin_loja'},
                 'supervisor_cad_finalizadora_na_ecf': {'empresa': 'supfec_nro_empresa',
                                                        'loja': 'supfec_loja',},
                 }


class wizimo_supervisor_importa_movimentacao(osv.TransientModel):

    _name = "wizard.supervisor.importa.movimentacao"

    CAMPOS_CAPA = {'supervisor_mov_corpo_xz': 'supcxz_capa_id',
                   'supervisor_mov_corpos': 'supcor_capa_id',
                   'supervisor_mov_fechamentos': 'supfec_capa_id',
                   'supervisor_mov_recebimentos': 'suprec_capa_id',
                   'supervisor_mov_totalizadores_xz': 'suptxz_capa_id',
                   'supervisor_mov_vencimentos': 'supfve_fechamentos_id',
                   'supervisor_autorizacoes': 'supaut_capa_id',
                   'supervisor_cad_finalizadora': 'supfin_codigo_na_ecf',
                   }

    def __init__(self, *args,**kwargs):
        super(wizimo_supervisor_importa_movimentacao, self).__init__(*args, **kwargs)
        obj_exporta_acao = self.pool.get('wizard.supervisor.exporta.acao.pendente')
        self.dictfetchall = obj_exporta_acao.dictfetchall
        self.wizimo_get_conection = obj_exporta_acao.wizsep_get_conection
        self.wizimo_get_uid = obj_exporta_acao.wizsep_get_uid


    def wizimo_referencia_operador(self, cr, uid, _cr, context=None):
        context = context and context.copy() or {}
        if self.ref_operadores:
            return

        obj_operadores = self.pool.get('supervisor.cad.operadores')
        operadores_ids = obj_operadores.search(cr, uid, [], context=context)
        _cr.execute("""SELECT id, supope_codigo FROM supervisor_cad_operadores""")
        cod_id = {}
        for i in obj_operadores.read(cr, uid, operadores_ids, ['supope_codigo'], context=context):
            cod_id[i.get('supope_codigo')] = i.get('id')

        for i in self.dictfetchall(_cr):
            self.ref_operadores[i.get('id')] = cod_id.get(i.get('supope_codigo'))

    def wizimo_grava_mov_caixa(self, cr, _cr, context=None):
        context = context and context.copy() or {}
        if not self.dados_mov_caixa:
            return

        campos = ''
        valores = []
        for i in self.dados_mov_caixa:
            i['supcax_operador_id'] = self.ref_operadores.get(i.get('supcax_operador_id'))
            i['supcax_enviado'] = 'S'
            valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
                                                            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = """INSERT INTO supervisor_mov_caixa 
                         %s
                  VALUES %s;
                  COMMIT;""" % (campos, valores)
        sql_sup = """UPDATE supervisor_mov_caixa
                     SET supcax_enviado = 'S'
                     WHERE id IN (%s);
                     COMMIT;
                  """ % ','.join(self.mov_caixa_ids)
        try:
            cr.execute(sql.replace('None', 'null'))
            _cr.execute(sql_sup)
        except Exception as e:
            print_log(_('Erro ao gravar Turnos: %s') % e, 'E')

    def wizimo_get_cupons_gravados(self, cr, context=None):
        context = context and context.copy() or {}
        if not self.dados_mov_capa:
            return[]

        cr.execute('''SELECT id,
                             supcap_data_cupom,
                             supcap_nro_empresa,
                             supcap_loja,
                             supcap_caixa,
                             supcap_nro_cupom
                      FROM supervisor_mov_capa
                      WHERE supcap_nro_cupom IN (%s)
                   ''' % ','.join(map(lambda x: '%s' % x.get('supcap_nro_cupom'),
                                      self.dados_mov_capa)))
        cupons_gravados = []
        for dados in cr.dictfetchall():
            chave = '%s-%s-%s-%s-%s' % (dados.get('supcap_data_cupom'),
                                        dados.get('supcap_nro_empresa'),
                                        dados.get('supcap_loja'),
                                        dados.get('supcap_caixa'),
                                        dados.get('supcap_nro_cupom'))
            if not self.ref_mov_capa_sup.get(chave):
                continue

            cupons_gravados.append(chave)

        return cupons_gravados

    def wizimo_grava_mov_capa(self, cr, uid, _cr, capa, cupons_gravados, context=None):
        context = context and context.copy() or {}
        if not self.dados_mov_capa:
            return

        chave = '%s-%s-%s-%s-%s' % (capa.get('supcap_data_cupom'),
                                    capa.get('supcap_nro_empresa'),
                                    capa.get('supcap_loja'),
                                    capa.get('supcap_caixa'),
                                    capa.get('supcap_nro_cupom'))
        if chave in cupons_gravados:
            return

        capa_id = capa.get('id')
        capa['supcap_operador_id'] = self.ref_operadores.get(capa.get('supcap_operador_id'))
        if self.dados_mov_corpos_xz.get(capa_id):
            capa['supcap_mov_corpo_xz_ids'] = self.dados_mov_corpos_xz.get(capa_id)

        if self.dados_mov_corpos.get(capa_id):
            capa['supcap_mov_corpos_ids'] = self.dados_mov_corpos.get(capa_id)

        if self.dados_mov_fechamento.get(capa_id):
            for fechamento in self.dados_mov_fechamento.get(capa_id):
                if self.dados_mov_vencimentos.get(fechamento[2].get('id')):
                    fechamento[2]['supfec_mov_vencimentos_ids'] = self.dados_mov_vencimentos.get(
                                                                            fechamento[2].get('id'))

                del(fechamento[2]['id'])

            capa['supcap_mov_fechamentos_ids'] = self.dados_mov_fechamento.get(capa_id)

        if self.dados_mov_recebimentos.get(capa_id):
            capa['supcap_mov_recebimentos_ids'] = self.dados_mov_recebimentos.get(capa_id)

        if self.dados_mov_totalizadores_xz.get(capa_id):
            capa['supcap_mov_totalizadores_xz_ids'] = self.dados_mov_totalizadores_xz.get(
                                                                                     capa_id)

        if self.dados_mov_autorizacoes.get(capa_id):
            for i in self.dados_mov_autorizacoes.get(capa_id):
                i[2]['supaut_autorizador_id'] = self.ref_operadores.get(
                                                                  i[2].get('supaut_autorizador_id'))

            capa['supcap_autorizacoes_ids'] = self.dados_mov_autorizacoes.get(capa_id)

        # capa['supcap_mov_cupom_servidor_ids'] = [(0, 0, {'supcse_enviado': False,
        #                                                  'supcse_capa_id': capa_id})]
        del(capa['id'])
        try:
            context['supervisor_importacao_automatica'] = True
            self.pool.get('supervisor.mov.capa').create(cr, uid, capa, context=context)
            _cr.execute("""UPDATE supervisor_mov_cupom_servidor 
                           SET supcse_enviado = TRUE 
                           WHERE supcse_capa_id = %s;
                           COMMIT;""" % capa_id)
        except Exception as e:
            print_log(_('Erro ao gravar Cupom:%s Loja:%s Caixa:%s Empresa:%s\n Erro: %s') %
                        (capa.get('supcap_nro_cupom'),
                         capa.get('supcap_loja'),
                         capa.get('supcap_caixa'),
                         capa.get('supcap_nro_empresa'),
                         e), 'E')
        cr.commit()

    def wizimo_graca_mov_meio_pgto(self, cr, uid, context=None):
        context = context and context.copy() or {}
        if not self.dados_mov_meios_pgto:
            return

        for i in self.dados_mov_meios_pgto:
            try:
                self.pool.get('supervisor.mov.meios.pagamentos').create(cr, uid, i, context)
            except Exception as e:
                print_log(_('Erro ao gravar Meios de Pagamentos: %s') % e, 'E')

    def wizimo_grava_cad_bandeira(self, cr, uid, _cr, empresa, loja, context=None):
        context = context and context.copy() or {}
        if not self.dados_cad_bandeira:
            return

        cr.execute('SELECT id, supban_codigo, supban_tipo FROM supervisor_cad_bandeiras')
        dados_bandeiras = {}
        for i in cr.dictfetchall():
            chave = '%s-%s' % (i.get('supban_codigo'), i.get('supban_tipo'))
            dados_bandeiras[chave] = i.get('id')

        for i in self.dados_cad_bandeira:
            antigo_id = i.pop('id')
            chave = '%s-%s' % (i.get('supban_codigo'), i.get('supban_tipo'))
            if chave in dados_bandeiras: # atualiza
                id = dados_bandeiras.get(chave)
                self.pool.get('supervisor.cad.bandeiras').write(cr, uid, id, i, context=context)
            else: # cria uma nova
                id = self.pool.get('supervisor.cad.bandeiras').create(cr, uid, i, context=context)

            self.ref_cad_bandeira[antigo_id] = id
        try:
            _cr.execute("""DELETE FROM supervisor_mov_acao_pendente 
                           WHERE supape_tabela = 'Bandeiras' 
                             AND supeape_pdv IS NULL;
                           COMMIT;""")
            cr.execute("""SELECT suppdv_caixa,
                                 suppdv_nro_empresa AS empresa,
                                 suppdv_loja        AS loja
                          FROM supervisor_cad_pdvs
                          WHERE suppdv_nro_empresa != {empresa}
                             OR suppdv_loja != {loja} """.format(empresa=empresa,
                                                                 loja=loja))
            # cria uma acao pendente para cadas ecf que nao possui aquela finalizadora
            for i in cr.dictfetchall():
                vals = {'supeape_loja': i.get('loja'),
                        'supeape_nro_empresa': i.get('empresa'),
                        'supeape_pdv': i.get('suppdv_caixa'),
                        'supape_tabela': 'Bandeiras',
                        'supape_situacao': 'A'}
                self.pool.get('supervisor.mov.acao.pendente').create(cr, uid, vals, context=context)
        except Exception as e:
            print_log(_('Erro ao deletar acoes pendentes no supervisor secundario: %s') % e, 'E')

    def get_finalizadora_outra_empresa(self, cr, uid, fin_id, empresa, loja, context=None):
        context = context and context.copy() or {}
        obj_fin_na_ecf = self.pool.get('supervisor.cad.finalizadora.na.ecf')
        dados_fin = obj_fin_na_ecf.read(cr, uid, fin_id, ['name'], context=context)
        ids = obj_fin_na_ecf.search(cr, uid, [('name', 'ilike', dados_fin.get('name')),
                                               ('supfec_nro_empresa', '=', empresa),
                                               ('supfec_loja', '=', loja)], context=context)
        if ids:
            return ids[0]

        return False

    def set_finalizadoras_outras_empresas(self, cr, uid, finalizadoras, empresa, loja,
                                          context=None):
        "Cria as finalizadoras cadastradas pelo frente para as outras empresas e lojas"
        context = context and context.copy() or {}
        cr.execute("""SELECT supcfc_nro_empresa, supcfc_loja
                      FROM supervisor_cfg_configuracao 
                      WHERE supcfc_nro_empresa != {empresa}
                         OR supcfc_loja != {loja}
                   """.format(empresa=empresa, loja=loja))
        dados_empresa = cr.dictfetchall()
        cr.execute("""SELECT supfin_codigo, 
                             supfin_loja, 
                             supfin_nro_empresa
                      FROM supervisor_cad_finalizadora
                      WHERE supfin_nro_empresa != {empresa}
                         OR supfin_loja != {loja}
                   """.format(empresa=empresa, loja=loja))
        fin_gravadas = {}
        for i in cr.dictfetchall():
            chave = "%s-%s-%s" % (i.get('supfin_codigo'),
                                  i.get('supfin_loja'),
                                  i.get('supfin_nro_empresa'))
            fin_gravadas[chave] = True

        for i in dados_empresa:
            for fin in finalizadoras:
                chave = "%s-%s-%s" % (fin.get('supfin_codigo'),
                                      i.get('supcfc_loja'),
                                      i.get('supcfc_nro_empresa'))
                if chave in fin_gravadas or not fin.get('supfin_codigo_na_ecf'):
                    continue

                fin['supfin_loja'] = i.get('supcfc_loja')
                fin['supfin_nro_empresa'] = i.get('supcfc_nro_empresa')

                fin_na_ecf_id = self.get_finalizadora_outra_empresa(cr, uid,
                                            fin.get('supfin_codigo_na_ecf'), empresa, loja, context)
                if not fin_na_ecf_id:
                    continue

                fin['supfin_codigo_na_ecf'] = fin_na_ecf_id
                self.pool.get('supervisor.cad.finalizadora').create(cr, uid, fin, context=context)

        return

    def wizimo_grava_cad_finalizadora_na_ecf(self, cr, uid, _cr, empresa, loja, context=None):
        context = context and context.copy() or {}
        if not self.dados_cad_finalizadora_na_ecf:
            return

        cr.execute("""SELECT id, 
                             supfec_codigo_na_ecf AS codigo, 
                             supfec_loja          AS loja, 
                             supfec_nro_empresa   AS empresa
                      FROM supervisor_cad_finalizadora_na_ecf
                   """)
        dados_fin_na_ecf = {}
        for i in cr.dictfetchall():
            chave = '%s-%s-%s' % (i.get('codigo'), i.get('loja'),  i.get('empresa'))
            dados_fin_na_ecf[chave] = i.get('id')

        finalizadoras_sup = []
        for i in self.dados_cad_finalizadora_na_ecf:
            antigo_id = i.pop('id')
            finalizadoras = self.dados_cad_finalizadora.get(antigo_id)
            if finalizadoras:
                for fin in finalizadoras:
                    if fin[2].get('supfin_bandeira_cre'):
                        fin[2]['supfin_bandeira_cre'] = self.ref_cad_bandeira.get(
                                                                  fin[2].get('supfin_bandeira_cre'))
                    if fin[2].get('supfin_bandeira_deb'):
                        fin[2]['supfin_bandeira_deb'] = self.ref_cad_bandeira.get(
                                                                  fin[2].get('supfin_bandeira_deb'))

                    finalizadoras_sup.append(fin[2])

                i['supfec_cad_finalizadora_ids'] = finalizadoras

            chave = '%s-%s-%s' % (i.get('supfec_codigo_na_ecf'), i.get('supfec_loja'),
                                     i.get('supfec_nro_empresa'))
            if chave in dados_fin_na_ecf: # atualiza
                id = dados_fin_na_ecf.get(chave)
                obj_finalizadora = self.pool.get('supervisor.cad.finalizadora')
                fin_ids = obj_finalizadora.search(cr, uid, [('supfin_codigo_na_ecf','=', id)],
                                                  context=context)
                obj_finalizadora.unlink(cr, uid, fin_ids, context=context)
                self.pool.get('supervisor.cad.finalizadora.na.ecf').write(cr, uid, id, i,
                                                                          context=context)
            else: # cria uma nova
                self.pool.get('supervisor.cad.finalizadora.na.ecf').create(cr, uid, i,
                                                                           context=context)

        try:
            self.set_finalizadoras_outras_empresas(cr, uid, finalizadoras_sup, empresa, loja,
                                                   context)
            cr.execute("""SELECT suppdv_caixa, 
                                 suppdv_nro_empresa AS empresa,
                                 suppdv_loja        AS loja
                          FROM supervisor_cad_pdvs
                          WHERE suppdv_nro_empresa != {empresa}
                             OR suppdv_loja != {loja} """.format(empresa=empresa,
                                                                 loja=loja))
            for i in cr.dictfetchall():
                vals = {'supeape_loja':  i.get('loja'),
                        'supeape_nro_empresa': i.get('empresa'),
                        'supeape_pdv': i.get('suppdv_caixa'),
                        'supape_tabela':'Finalizadoras',
                        'supape_situacao': 'A'}
                self.pool.get('supervisor.mov.acao.pendente').create(cr, uid, vals, context=context)
            _cr.execute("""DELETE FROM supervisor_mov_acao_pendente 
                           WHERE supape_tabela = 'Finalizadoras' 
                             AND supeape_pdv IS NULL;
                           COMMIT;""")
        except Exception as e:
            print_log(_('Erro ao deletar acoes pendentes no supervisor secundario: %s') % e,
                      'E')

    def wizimo_grava_dados(self, cr, uid, _cr, empresa, loja, context=None):
        context = context and context.copy() or {}
        self.wizimo_grava_cad_bandeira(cr, uid, _cr, empresa, loja, context)
        self.wizimo_grava_cad_finalizadora_na_ecf(cr, uid, _cr, empresa, loja, context)
        self.wizimo_grava_mov_caixa(cr, _cr, context)
        # grava cupom por cupom
        cupons_gravados = self.wizimo_get_cupons_gravados(cr, context)
        for capa in self.dados_mov_capa:
            self.wizimo_grava_mov_capa(cr, uid, _cr, capa, cupons_gravados, context)

        self.wizimo_graca_mov_meio_pgto(cr, uid, context)

    def wizimo_cron_importar_movimentacao_sup(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_configuracao = self.pool.get('supervisor.cfg.configuracao')
        configuracao_ids = obj_configuracao.search(cr, uid, [], context=context)
        if not configuracao_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nenhuma configuracao cadastrada!'))

        campos = ['supcfc_nro_empresa', 'supcfc_ip', 'supcfc_banco', 'supcfc_usuario',
                  'supcfc_senha', 'supcfc_loja']
        condicao = False # controla a variavel de referencia para operadores
        for config in obj_configuracao.read(cr, uid, configuracao_ids, campos, context=context):
            empresa = config.get('supcfc_nro_empresa')
            loja = config.get('supcfc_loja')

            # cursor do supervisor slave
            _cr = self.wizimo_get_conection(config)
            # id do SuperUser no supervisor slave
            _uid = self.wizimo_get_uid(_cr, config, context=context)
            if not _cr or not _uid:
                continue

            print_log(_('Importando movimentacao do supervisor: %s-%s ......') %
                       (config.get('supcfc_banco'), config.get('supcfc_ip')))

            self.wizimo_cria_limpa_variaveis(condicao)
            condicao = True
            _cr.execute("""SELECT * 
                           FROM supervisor_mov_acao_pendente
                           WHERE supeape_pdv IS NULL
                        """)
            dados_acoes = self.dictfetchall(_cr)
            if dados_acoes:
                acao_pendentes = {'Finalizadoras':[], 'Bandeiras':[]}
                map(lambda x: acao_pendentes[x.get('supape_tabela')].append(x), dados_acoes)
                if acao_pendentes.get('Bandeiras'):
                    tabela = 'supervisor_cad_bandeiras'
                    self.dados_cad_bandeira.extend(self.wizimo_get_dados(_cr, empresa, tabela,
                                                                         context=context))
                if acao_pendentes.get('Finalizadoras'):
                    tabela = 'supervisor_cad_finalizadora_na_ecf'
                    self.dados_cad_finalizadora_na_ecf.extend(self.wizimo_get_dados(_cr, empresa,
                                                                tabela, loja=loja, context=context))
                    tabela = 'supervisor_cad_finalizadora'
                    self.dados_cad_finalizadora = self.wizimo_get_dados(_cr, empresa, tabela,
                                                                       loja=loja, context=context)

            self.wizimo_referencia_operador(cr, uid, _cr, context)
            tabela = 'supervisor_mov_caixa'
            self.dados_mov_caixa.extend(self.wizimo_get_dados(_cr, empresa, tabela,
                                                       where=DADOS_TABELAS.get(tabela).get('where'),
                                                             context=context))
            tabela = 'supervisor_mov_capa'
            self.dados_mov_capa.extend(self.wizimo_get_dados(_cr, empresa, '%s AS smc' %
                                               tabela, inner=DADOS_TABELAS.get(tabela).get('inner'),
                                                       where=DADOS_TABELAS.get(tabela).get('where'),
                                                             context=context))
            tabela = 'supervisor_mov_corpo_xz'
            self.dados_mov_corpos_xz = self.wizimo_get_dados(_cr, empresa, tabela,
                                where=DADOS_TABELAS.get(tabela).get('where').format(
                                                                  cond=','.join(self.mov_capa_ids)),
                                                                  context=context)
            tabela = 'supervisor_mov_corpos'
            self.dados_mov_corpos = self.wizimo_get_dados(_cr, empresa, tabela,
                                where=DADOS_TABELAS.get(tabela).get('where').format(
                                                                  cond=','.join(self.mov_capa_ids)),
                                                                  context=context)
            tabela = 'supervisor_mov_fechamentos'
            self.dados_mov_fechamento = self.wizimo_get_dados(_cr, empresa, tabela,
                                where=DADOS_TABELAS.get(tabela).get('where').format(
                                                                  cond=','.join(self.mov_capa_ids)),
                                                                  context=context)
            tabela = 'supervisor_mov_vencimentos'
            self.dados_mov_vencimentos = self.wizimo_get_dados(_cr, empresa, tabela,
                                where=DADOS_TABELAS.get(tabela).get('where').format(
                                                            cond=','.join(self.mov_fechamento_ids)),
                                                            context=context)
            tabela = 'supervisor_mov_meios_pagamentos'
            self.dados_mov_meios_pgto.extend(self.wizimo_get_dados(_cr, empresa, tabela,
                                where=DADOS_TABELAS.get(tabela).get('where').format(
                                                            cond=','.join(self.mov_fechamento_ids)),
                                                            context=context))
            tabela = 'supervisor_mov_recebimentos'
            self.dados_mov_recebimentos = self.wizimo_get_dados(_cr, empresa, tabela,
                                where=DADOS_TABELAS.get(tabela).get('where').format(
                                                                  cond=','.join(self.mov_capa_ids)),
                                                                  context=context)
            tabela = 'supervisor_mov_totalizadores_xz'
            self.dados_mov_totalizadores_xz = self.wizimo_get_dados(_cr, empresa, tabela,
                                where=DADOS_TABELAS.get(tabela).get('where').format(
                                                                  cond=','.join(self.mov_capa_ids)),
                                                                  context=context)
            tabela = 'supervisor_autorizacoes'
            self.dados_mov_autorizacoes = self.wizimo_get_dados(_cr, empresa, tabela,
                                where=DADOS_TABELAS.get(tabela).get('where').format(
                                                                  cond=','.join(self.mov_capa_ids)),
                                                                  context=context)
            self.wizimo_get_dados_promocao(cr, _cr, empresa, loja, context)
            self.wizimo_get_dados_comanda(cr, _cr, empresa, loja, context)

            self.wizimo_grava_dados(cr, uid, _cr, empresa, loja, context)

        self.wizimo_cria_limpa_variaveis()
        return True

    def wizimo_get_dados_promocao(self, cr, _cr, empresa, loja, context=None):
        'Implementado por herancao no modulo supervisor_master_prmocoes'
        pass

    def wizimo_get_dados_comanda(self, cr, _cr, empresa, loja, context=None):
        'Implementado por herancao no modulo supervisor_master_comanda'
        pass

    def wizimo_cria_limpa_variaveis(self, condicao=False, context=None):
        context = context and context.copy() or {}
        self.ref_operadores = condicao and self.ref_operadores or {}
        self.ref_mov_capa_sup = {}
        self.ref_cad_bandeira = {}

        self.mov_caixa_ids = []
        self.mov_capa_ids = []
        self.mov_fechamento_ids = []
        self.mov_meios_pgto_ids = []

        self.dados_cad_bandeira = []
        self.dados_cad_finalizadora_na_ecf = []
        self.dados_cad_finalizadora = {}

        self.dados_mov_caixa = []
        self.dados_mov_meios_pgto = []
        self.dados_mov_capa = []
        self.dados_mov_corpos_xz = {}
        self.dados_mov_corpos = {}
        self.dados_mov_fechamento = {}
        self.dados_mov_vencimentos = {}
        self.dados_mov_recebimentos = {}
        self.dados_mov_totalizadores_xz = {}
        self.dados_mov_autorizacoes = {}

    def wizimo_get_mov_caixa_id(self, i, tabela, context=None):
        context = context and context.copy() or {}
        if tabela != 'supervisor_mov_caixa':
            return

        self.mov_caixa_ids.append('%s' % i.get('id'))
        
    def wizimo_get_ref_mov_capa_sup(self, i, tabela, empresa, context=None):
        'Cria uma referencia com os ids antigos para as tabelas que usam id da capa'
        context = context and context.copy() or {}
        if tabela != 'supervisor_mov_capa':
            return

        chave = '%s-%s-%s-%s-%s' % (i.get('supcap_data_cupom'),
                                    i.get('supcap_nro_empresa'),
                                    i.get('supcap_loja'),
                                    i.get('supcap_caixa'),
                                    i.get('supcap_nro_cupom'))
        self.ref_mov_capa_sup[chave] = i.get('id')
        self.mov_capa_ids.append('%s' % i.get('id'))

    def wizimo_get_mov_fechamento_ids(self, i, tabela, empresa, context=None):
        context = context and context.copy() or {}
        if tabela != 'supervisor_mov_fechamentos':
            return

        self.mov_fechamento_ids.append('%s' % i.get('id'))

    def wizimo_get_mov_meios_pgto_id(self, i, tabela, context=None):
        context = context and context.copy() or {}
        if tabela != 'supervisor_mov_meios_pagamentos':
            return

        self.mov_meios_pgto_ids.append('%s' % i.get('id'))
        
    def wizimo_get_dados(self, _cr, empresa, tabela, loja='', inner='', where='', context=None):
        context = context and context.copy() or {}
        tabelas_dependentes = ['supervisor_mov_corpo_xz', 'supervisor_mov_corpos',
                               'supervisor_mov_fechamentos', 'supervisor_mov_recebimentos',
                               'supervisor_mov_totalizadores_xz', 'supervisor_autorizacoes',]
        if tabela in tabelas_dependentes and not self.mov_capa_ids:
            return {}

        elif tabela == 'supervisor_mov_vencimentos' and not self.mov_fechamento_ids:
            return {}
        
        if inner:
            inner = "INNER JOIN %s ON %s" % inner

        if where:
            where = "WHERE %s" % where

        campo_empresa = ''
        # adiciona o campo empresa para as tabelas que possuem os mesmos
        tabela_aux = 'AS' in tabela and tabela[:-7] or tabela
        if DADOS_TABELAS.get(tabela_aux):
            if DADOS_TABELAS.get(tabela_aux).get('empresa'):
                campo_empresa = ', %s AS %s' % (empresa, DADOS_TABELAS.get(tabela_aux).get('empresa'))

        campo_loja = ''
        # adiciona o campo loja para as tabelas que possuem os mesmos
        tabela_aux = 'AS' in tabela and tabela[:-7] or tabela
        if loja and DADOS_TABELAS.get(tabela_aux):
            if DADOS_TABELAS.get(tabela_aux).get('loja'):
                campo_loja = ', %s AS %s' % (loja, DADOS_TABELAS.get(tabela_aux).get('loja'))

        alias = 'AS' in tabela and ('%s.' % tabela[-3:]) or ''
        sql = """SELECT {alias}* 
                        {empresa}
                        {loja}
                 FROM {tabela}
                 {inner}
                 {where}
                 ORDER BY id""".format(alias=alias,
                                   empresa=campo_empresa,
                                   loja=campo_loja,
                                   inner=inner,
                                   tabela=tabela,
                                   where=where)
        _cr.execute(sql)
        dados = self.dictfetchall(_cr)
        if not dados:
            if tabela in self.CAMPOS_CAPA:
                return {}

            return []

        if 'AS' in tabela:
            tabela = tabela[:-7]

        res = {}
        for i in dados:
            self.wizimo_get_mov_caixa_id(i, tabela, context)
            self.wizimo_get_mov_meios_pgto_id(i, tabela, context)
            self.wizimo_get_ref_mov_capa_sup(i, tabela, empresa, context)
            self.wizimo_get_mov_fechamento_ids(i, tabela, empresa, context)
            # nao deleta o id para a capa, fechamento e finalizadora na ecf
            if tabela not in ['supervisor_mov_capa', 'supervisor_mov_fechamentos',
                              'supervisor_cad_bandeiras', 'supervisor_cad_finalizadora_na_ecf']:
                del(i['id'])

            campos_del = ['create_date','create_uid','write_date','write_uid']
            for j in i:
                if i.get(j) == None:
                    campos_del.append(j)

            for x in campos_del:
                if x in i:
                    del i[x]

            if tabela in self.CAMPOS_CAPA:
                # para nao criar referencia de ids, colocase o id da capa como chave para gravar os
                # itens via one2many
                if not res.get(i.get(self.CAMPOS_CAPA.get(tabela))):
                    res[i.get(self.CAMPOS_CAPA.get(tabela))] = [(0, 0, i)]
                else:
                    res[i.get(self.CAMPOS_CAPA.get(tabela))].append((0, 0, i))

        # para as tabelas que possuem capa_id retorna um dicionario para as outras uma lista
        if res:
            return res
        else:
            return dados