# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2015 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2015, Creative Commons
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields
from openerp.tools.translate import _
from ....supervisor_comanda.report.listagem_de_comandas import report_relatorio_listagem_comandas

class report_relatorio_listagem_comandas_inherit(report_relatorio_listagem_comandas):

    def get_tam_linha(self, listagem):
        super(report_relatorio_listagem_comandas_inherit, self).get_tam_linha(listagem)
        listagem.defineFonte(tam=5.7)
        return 164

    def get_cond(self, cr, datas):
        super(report_relatorio_listagem_comandas_inherit, self).get_cond(cr, datas)
        if not datas.get('empresa'):
            return ''

        return 'AND capa.supcda_nro_empresa = %s' % datas.get('empresa')

    def get_empresa(self):
        super(report_relatorio_listagem_comandas_inherit, self).get_empresa()
        return """capa.supcda_nro_empresa                        AS empresa,
                  capa.supcda_loja                               AS loja,"""

    def get_group_empresa(self):
        super(report_relatorio_listagem_comandas_inherit, self).get_empresa()
        return ', capa.supcda_nro_empresa, capa.supcda_loja'

    def get_det_format(self):
        return  '|{:^15}'.decode('utf-8') + \
                super(report_relatorio_listagem_comandas_inherit, self).get_det_format()


    def get_colunas(self):
        return (_('Empresa/Loja'),) + \
               super(report_relatorio_listagem_comandas_inherit, self).get_colunas()

    def get_val_empresa(self, val_conlunas, dados):
        empresa_loja = '%7s-%s' % (dados.get('empresa') or '', dados.get('loja') or '')
        return (empresa_loja,) + val_conlunas

report_relatorio_listagem_comandas_inherit('report.wizard_listagem_comandas_inherit')

class wizard_listagem_comandas(osv.TransientModel):

    _inherit = 'wizard.listagem.comandas'
    _columns = {
        'wizlco_nro_empresa': fields.integer('Nro. Empresa'),
    }

    def button_imprimir(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = super(wizard_listagem_comandas, self).button_imprimir(cr, uid, ids, context)
        listagem_comandas = self.read(cr, uid, ids, [], context=context)
        if isinstance(listagem_comandas, (list, tuple)):
            listagem_comandas = listagem_comandas[0]

        res['report_name'] = 'wizard_listagem_comandas_inherit'
        res['datas']['empresa'] = listagem_comandas.get('wizlco_nro_empresa')
        return res

