# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from openerp.addons.supervisor import print_log
from datetime import datetime

class wizimo_supervisor_importa_movimentacao(osv.TransientModel):

    _inherit = "wizard.supervisor.importa.movimentacao"

    def wizimo_get_dados_comanda(self, cr, _cr, empresa, loja, context=None):
        context = context and context.copy() or {}
        super(wizimo_supervisor_importa_movimentacao, self).wizimo_get_dados_comanda(cr, _cr,
                                                                             empresa, loja, context)
        cr.execute("""SELECT supccs_id_supervisor AS id
                      FROM supervisor_cda_comanda_servidor_capa
                      WHERE supccs_nro_empresa = %s
                        AND supccs_loja = %s
                   """ % (empresa, loja))
        comanda_ids = map(lambda x: '%s' % x.get('id'), cr.dictfetchall())
        cond = ''
        if comanda_ids:
            cond = """AND id NOT IN (%s) """ % ','.join(comanda_ids)

        sql = """SELECT *, 
                        {empresa} AS supcda_nro_empresa 
                 FROM supervisor_cda_capa
                 WHERE supcda_restricao = 2 -- Faturada
                 {cond}
              """.format(cond=cond,
                         empresa=empresa)
        _cr.execute(sql)
        self.dados_comanda_capa = self.dictfetchall(_cr)
        if not self.dados_comanda_capa:
            return

        capa_ids = ','.join(map(lambda x: "%s" % x.get('id'), self.dados_comanda_capa))
        _cr.execute("""SELECT *
                       FROM supervisor_cda_corpo  
                       WHERE supcdo_capa_id IN ({capa_ids})
                    """.format(capa_ids=capa_ids))
        self.dados_corpos = {}
        for dados in self.dictfetchall(_cr):
            del dados['id']
            deletar_campos = []
            for i in dados:
                if not dados.get(i):
                    deletar_campos.append(i)

            for campo in deletar_campos:
                del dados[campo]

            if not self.dados_corpos.get(dados.get('supcdo_capa_id')):
                self.dados_corpos = {dados.get('supcdo_capa_id'): [(0,0, dados)]}
            else:
                self.dados_corpos[dados.get('supcdo_capa_id')].append((0,0, dados))



    def wizimo_grava_dados(self, cr, uid, _cr, empresa, loja, context=None):
        context = context and context.copy() or {}
        super(wizimo_supervisor_importa_movimentacao, self).wizimo_grava_dados(cr, uid, _cr,
                                                                             empresa, loja, context)
        if not self.dados_comanda_capa:
            return

        comanda_ids = []
        for i in self.dados_comanda_capa:
            capa_id = i.pop('id') # usado no exec abaixo
            deletar_campos =[]
            for campo in i:
                if not i.get(campo):
                    deletar_campos.append(campo)

            for del_campo in deletar_campos:
                del i[del_campo]

            comanda_ids.append(capa_id)
            i['supproc_nro_empresa'] = empresa
            if self.dados_corpos.get(capa_id):
                i['supcda_comanda_item_ids'] = self.dados_corpos.get(capa_id)

            self.pool.get('supervisor.cda.capa').create(cr, uid, i, context=context)

        for i in comanda_ids:
            vals = {'supccs_nro_empresa': empresa,
                    'supccs_loja': loja,
                    'supccs_id_supervisor': i}
            self.pool.get('supervisor.cda.comanda.servidor.capa').create(cr, uid, vals,
                                                                         context=context)
