# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from openerp.addons.supervisor import print_log

class wizard_supervisor_exporta_acao_pendente(osv.TransientModel):

    _inherit = "wizard.supervisor.exporta.acao.pendente"

    def wizsep_get_dados_funcionario(self, cr, _cr, uid, _uid, acao, context=None):
        context = context and context.copy() or {}
        self.dados_funcionarios = self.wizsep_get_dados(cr, _cr, uid, _uid, acao,
                                                     'supervisor_cad_funcionarios', context=context)

    def wizsep_exporta_clientes(self, cr, _cr, loja, context=None):
        context = context and context.copy() or {}
        super(wizard_supervisor_exporta_acao_pendente, self).wizsep_exporta_clientes(cr, _cr, loja,
                                                                                     context)

        if not 'dados_funcionarios' in self.__dict__ or not self.dados_funcionarios:
            return

        campos = ''
        valores = []
        for i in self.dados_funcionarios:
            valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = """INSERT INTO supervisor_cad_funcionarios
                                %s
                         VALUES %s;
                         COMMIT;""" % (campos, valores)
        try:
            print_log(_('Exportando %s funcionarios.........') % len(self.dados_funcionarios))
            _cr.execute("""DELETE FROM supervisor_cad_funcionarios""")
            _cr.execute(sql)
            del self.dados_funcionarios
        except Exception as e:
            print_log(_('Erro ao exportar funcionarios: %s') % e, 'E')

        print_log(_('Exportacao de funcionarios finalizada.'))

