#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class supervisor_cad_promo_capa(osv.TransientModel):
    """
    Prefixo: suprep
    """
    _inherit = 'supervisor.relatorio.promocoes'

    _columns = {
        'configuracao_ids':fields.many2many('supervisor.cfg.configuracao',
                                    'supervisor_rel_promo_lojas', 'id', 'config_id', 'Lojas'),
    }

    _defaults = {
        'suprep_pdv_ids': False,
    }

    def onchange_suprep_configuracao_ids(self, cr, uid, ids, configuracao_ids, context=None):
        context = context and context.copy() or {}
        res = {'value': {}}
        config_ids = []
        map(lambda x: config_ids.extend(x[2]), configuracao_ids)
        if not configuracao_ids or not config_ids:
            res['value']['suprep_pdv_ids'] = ''
            return res

        dados = self.pool.get('supervisor.cfg.configuracao').read(cr, uid, config_ids,
                                                                  ['supcfc_nro_empresa',
                                                                   'supcfc_loja'],
                                                                  context=context)

        cond_pdv = []
        for i in dados:
            operador = 'OR '
            if not cond_pdv:
                operador = ''

            cond = """%s(suppdv_nro_empresa = %s AND suppdv_loja = %s)\n               """ % \
                   (operador, i.get('supcfc_nro_empresa'), i.get('supcfc_loja'))
            cond_pdv.append(cond)

        sql = """
            SELECT id
            FROM supervisor_cad_pdvs
            WHERE %s 
            ORDER BY suppdv_nro_empresa, suppdv_loja, suppdv_caixa 
        """ % ''.join(cond_pdv)
        cr.execute(sql)
        dados_pdv = cr.dictfetchall()
        if not dados_pdv:
            return res

        pdv_ids = map(lambda x: x.get('id'), dados_pdv)
        res['value']['suprep_pdv_ids'] = pdv_ids
        return res