# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from openerp.addons.supervisor import print_log
from datetime import datetime

class wizard_supervisor_exporta_acao_pendente(osv.TransientModel):

    _inherit = "wizard.supervisor.exporta.acao.pendente"
    PROMO_FILHAS = ['1','2','3p','3f','4','5p','5f','6', '7']

    def wizsep_get_dados_promocao(self, cr, _cr, uid, _uid, acao, empresa, context=None):
        context = context and context.copy() or {}
        tabela = 'supervisor_cad_promo_capa'
        if not self.RETIRAR_CAMPOS.get(tabela):
            self.RETIRAR_CAMPOS[tabela] = ['supproc_nro_empresa', '']

        sql = '''SELECT * 
                 FROM supervisor_cad_promo_capa
                 WHERE supproc_nro_empresa = %s
                   AND supproc_scanntech = False 
              ''' % empresa
        cr.execute(sql)
        dados_promo = cr.dictfetchall()
        if not dados_promo:
            return

        self.last_update['suppdv_lastup_promo_capa'] = '%s' % datetime.now()
        promo_ids = []
        self.ref_promo = {}
        for promo in dados_promo:
            chave = '%s-%s-%s' % (promo.get('supproc_nro_empresa'),
                                  promo.get('supproc_scanntech'),
                                  promo.get('supproc_id_promo'))
            promo_id = '%s' % promo.pop('id')
            del(promo['supproc_nro_empresa'])
            promo_ids.append(promo_id)
            self.ref_promo[chave] = int(promo_id)

        self.dados_promocoes = dados_promo
        for i in self.PROMO_FILHAS:
            where = 'suppro%s_capa_id IN (%s)' % (i, ','.join(promo_ids))
            tabela = 'supervisor_cad_promo%s' % i
            exec("""self.dados_promocoes%s = self.wizsep_get_dados(cr, _cr, uid, _uid, acao, tabela,
                                                         where=where,context=context)""" % i)
    def wizsep_deleta_variaveis_promocao(self, codigo, context=None):
        context = context and context.copy() or {}
        if codigo == '1':
            del(self.dados_promocoes1)
        elif codigo == '2':
            del(self.dados_promocoes2)
        elif codigo == '3p':
            del(self.dados_promocoes3p)
        elif codigo == '3f':
            del(self.dados_promocoes3f)
        elif codigo == '4':
            del(self.dados_promocoes4)
        elif codigo == '5p':
            del(self.dados_promocoes5p)
        elif codigo == '5f':
            del(self.dados_promocoes5f)
        elif codigo == '6':
            del(self.dados_promocoes6)
        elif codigo == '7':
            del(self.dados_promocoes7)

    def wizsep_exporta_promo(self, cr, uid, _cr, empresa, context=None):
        context = context and context.copy() or {}
        super(wizard_supervisor_exporta_acao_pendente, self).wizsep_exporta_promo(cr, _cr, empresa,
                                                                                  context)
        if not 'dados_promocoes' in self.__dict__ or not self.dados_promocoes:
            return

        campos = ''
        valores = []
        obj_sup_util = self.pool.get('supervisor.util')
        for i in self.dados_promocoes:
            valores.append("%s" % (tuple(map(lambda x:
                                             str(obj_sup_util.suputi_remover_acentuacao(x))
            if isinstance(x, unicode)
            else x, i.values())),))
            if not campos:
                campos = "(%s)" % ', '.join(i.keys())

        valores = ',\n'.join(map(lambda x: x, valores))
        valores = valores.replace('None', 'null')
        sql = """INSERT INTO supervisor_cad_promo_capa
                                %s
                         VALUES %s;
                         COMMIT;""" % (campos, valores)
        try:
            print_log(_('Exportando %s promocoes.........') % len(self.dados_promocoes))
            del self.dados_promocoes
            _cr.execute("""DELETE FROM supervisor_cad_promo_capa where supproc_scanntech = False""")
            _cr.execute(sql)
            _cr.execute("""SELECT id,  
                                  supproc_scanntech   AS scanntech, 
                                  supproc_id_promo    AS id_promo 
                           FROM supervisor_cad_promo_capa
                           WHERE supproc_scanntech = False 
                        """)
            new_ref_promo = {}
            for promo in self.dictfetchall(_cr):
                chave = '%s-%s-%s' % (empresa,
                                      promo.get('scanntech'),
                                      promo.get('id_promo'))
                new_ref_promo[self.ref_promo.get(chave)] = promo.get('id')

            del(self.ref_promo)
            for j in self.PROMO_FILHAS:
                campos = ''
                valores = []

                for i in eval('self.dados_promocoes%s' % j):
                    i['suppro%s_capa_id' % j] = new_ref_promo.get(i.get('suppro%s_capa_id' % j))
                    valores.append("%s" % (tuple(map(lambda x: str(x) if isinstance(x, unicode)
                                                     else x, i.values())),))
                    if not campos:
                        campos = "(%s)" % ', '.join(i.keys())

                self.wizsep_deleta_variaveis_promocao(j, context)
                if not valores:
                    continue

                valores = ',\n'.join(map(lambda x: x, valores))
                valores = valores.replace('None', 'null')
                sql = """INSERT INTO supervisor_cad_promo%s
                                     %s
                         VALUES %s;
                         COMMIT;""" % (j, campos, valores)
                _cr.execute(sql)

        except Exception as e:
            print_log(_('Erro ao exportar promocoes: %s') % e, 'E')

        print_log(_('Exportacao de promocoes finalizada.'))

