# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from openerp.addons.supervisor import print_log
from datetime import datetime

class wizimo_supervisor_importa_movimentacao(osv.TransientModel):

    _inherit = "wizard.supervisor.importa.movimentacao"
    PROMO_FILHAS = ['1','2','3p','3f','4','5p','5f','6','7']

    def wizimo_get_dados_promocao(self, cr, _cr, empresa, loja, context=None):
        context = context and context.copy() or {}
        super(wizimo_supervisor_importa_movimentacao, self).wizimo_get_dados_promocao(cr, _cr,
                                                                             empresa, loja, context)
        cr.execute("""SELECT max(suppdv_lastup_promo_capa) AS data
                      FROM supervisor_cad_pdvs
                      WHERE suppdv_nro_empresa = %s
                        AND suppdv_loja = %s
                   """ % (empresa, loja))
        dados_pdv = cr.dictfetchall()
        where = ''
        if dados_pdv and dados_pdv[0].get('data'):
            where = """WHERE write_date > '%s' """ % dados_pdv[0].get('data')

        sql = """SELECT *
                 FROM supervisor_cad_promo_capa
                 {where}
              """.format(where=where)
        _cr.execute(sql)
        self.dados_promocoes = self.dictfetchall(_cr)
        if not self.dados_promocoes:
            return

        capa_ids = ','.join(map(lambda x: "%s" % x.get('id'), self.dados_promocoes))
        for i in self.PROMO_FILHAS:
            exec('self.dados_promo%s = {}' % i)

        for i in self.PROMO_FILHAS:

            _cr.execute("""SELECT scp.*
                           FROM supervisor_cad_promo{cod} AS scp
                           WHERE suppro{cod}_capa_id IN ({capa_ids})
                        """.format(cod=i,
                                   capa_ids=capa_ids))
            for dados in self.dictfetchall(_cr):
                del dados['id']
                del dados['create_date']
                del dados['create_uid']
                del dados['write_date']
                del dados['write_uid']
                if not eval("self.dados_promo%s.get('suppro%s_capa_id')" % (i, i)):
                    exec("self.dados_promo{cod}[dados.get('suppro{cod}_capa_id')] = [(0,0,{dados})]"
                         .format(cod=i, dados=dados))
                else:
                    exec("self.dados_promo{cod}[dados.get('suppro{cod}_capa_id')]"
                         ".append((0,0,{dados}))".format(cod=i, dados=dados))



    def wizimo_grava_dados(self, cr, uid, _cr, empresa, loja, context=None):
        context = context and context.copy() or {}
        super(wizimo_supervisor_importa_movimentacao, self).wizimo_grava_dados(cr, uid, _cr,
                                                                             empresa, loja, context)
        if not self.dados_promocoes:
            return

        cr.execute("""SELECT id,
                             supproc_nro_empresa AS empresa, 
                             supproc_scanntech   AS scanntech, 
                             supproc_id_promo    AS id_promo
                      FROM supervisor_cad_promo_capa""")
        promo_gravadas = {}       
        for i in cr.dictfetchall():
            chave = "%s-%s-%s" % (i.get('empresa'),i.get('scanntech'),i.get('id_promo'))
            promo_gravadas[chave] = i.get('id')
            
        for i in self.dados_promocoes:
            capa_id = i.pop('id') # usado no exec abaixo
            del i['create_date']
            del i['create_uid']
            del i['write_date']
            del i['write_uid']
            cod = i.get('supproc_tipo_promo')
            i['supproc_nro_empresa'] = empresa
            chave = "%s-%s-%s" % (empresa,
                                  i.get('supproc_scanntech'),
                                  i.get('supproc_id_promo'))
            if cod in ('3', '5'):
                exec("i['supproc_promo{cod}p_ids'] = self.dados_promo{cod}p.get(capa_id)"
                     .format(cod=cod))
                exec("i['supproc_promo{cod}f_ids'] = self.dados_promo{cod}f.get(capa_id)"
                     .format(cod=cod))
                
            else:
                exec("i['supproc_promo{cod}_ids'] = self.dados_promo{cod}.get(capa_id)"
                     .format(cod=cod))

            if chave in promo_gravadas:
                # deleta as promocoes filhas para atualizar mais rapido
                master_capa_id = promo_gravadas.get(chave)
                if cod in ['3', '5']:
                    for j in ['p', 'f']:
                        filhas_ids = self.pool.get('supervisor.cad.promo%s%s' % (cod,j)).search(cr,
                              uid, [('suppro%s%s_capa_id'%(cod,j), '=', master_capa_id)],
                                                                                    context=context) 
                                      
                        self.pool.get('supervisor.cad.promo%s%s'%(cod,j)).unlink(cr, uid, filhas_ids,
                                                                             context=context)
                else:
                    filhas_ids = self.pool.get('supervisor.cad.promo%s'%cod).search(cr, uid, 
                                 [('suppro%s_capa_id'%cod, '=', master_capa_id)], 
                                                                                    context=context)
                    self.pool.get('supervisor.cad.promo%s' % cod).unlink(cr, uid, filhas_ids, 
                                                                         context=context)
                    
                self.pool.get('supervisor.cad.promo_capa').write(cr, uid, master_capa_id, i,
                                                                 context=context)
                    
            else:
                self.pool.get('supervisor.cad.promo_capa').create(cr, uid, i, context=context)

        # atualiza last_update das prmocoes
        pdv_ids = self.pool.get('supervisor.cad.pdvs').search(cr, uid,
                                            [('suppdv_nro_empresa', '=', empresa),
                                             ('suppdv_loja', '=', loja)], context=context)
        data = "%s" % datetime.now()
        self.pool.get('supervisor.cad.pdvs').write(cr, uid, pdv_ids,
                                                   {'suppdv_lastup_promo_capa':data},
                                                   context=context)