# -*- encoding: utf-8 -*-
import openerp
import openerp.addons.web.http as http
from openerp.tools import config
from openerp.tools.translate import _
from lxml import etree
import psycopg2
import logging


class Controller(openerp.addons.web.http.Controller):
    _cp_path = "/web_sig"


    def _parse_node(self, root_node):
        result = []
        for node in root_node:
            field_name = node.get('name')
            if not eval(str(node.attrib.get('invisible', False)), {'context': {}}):
                if node.tag == 'field':
                    result.append(field_name)
                else:
                    result.extend(self._parse_node(node))
        return result

    def _parse_string(self, view):
        try:
            dom = etree.XML(view.encode('utf-8'))
        except:
            dom = etree.XML(view)
        return self._parse_node(dom)

    @openerp.addons.web.http.jsonrequest
    def fields_view_get(self, req, model):
        Model = req.session.model(model)
        # fields = Model.fields_get(False, req.session.eval_context(req.context))
        result = Model.fields_view_get(False, 'tree')
        parse = self._parse_string(result['arch'])
        res = []
        for f in parse:
            res.append({'name': f,
                        'string': result['fields'][f]['string']}
            )
        return res

    @http.httprequest
    def healthcheck(self, req, s_action=None, **kw):
        # :return: O valor retornado indica o estado funcional do serviço:
        # 0: healthy - o serviço está funcional e pronto para uso
        # 1: unhealthy - o serviço não está funcionando adequadamente
        # 2: reserved - este valor é reservado e não deve ser retornado por essa função

        (HEALTHY,UNHEALTHY) = (0,1)
        _logger = logging.getLogger('HEALTHCHECK')

        _dbuser = config.options.get('db_user') or 'postgres'
        _dbpass = config.options.get('db_password') or None
        _dbhost = config.options.get('db_host') or '127.0.0.1'
        _dbport = config.options.get('db_port') or '5432'

        try:
            _conn = psycopg2.connect(
                database='postgres', 
                user=_dbuser, password=_dbpass, 
                host=_dbhost, port=_dbport, 
                connect_timeout=3
            )

            _cr = _conn.cursor()
            _cr.execute('SELECT 1')
            _data = _cr.fetchone() or []
            _conn.close()
        except Exception as e:
            _logger.exception(
                _("The service healthy status is: %s:%") % ('UHEALTHY', e)
            )
            return '%i %s:%s' % (UNHEALTHY,'UNHEALTHY', e)
        finally:
            if len(_data) > 0 and _data[0] == 1:
                _logger.info(
                    _("The service healthy status is: %s") % ('HEALTHY')
                )
                return '%i %s' % (HEALTHY,'HEALTHY')
            e = "Unexpected query result"
            _logger.error(
                _("The service healthy status is: %s:%s") % ('UHEALTHY', e)
            )
            return '%i:%s:%s' % (UNHEALTHY,'UNHEALTHY', e)
