# -*- coding: utf-8 -*-
################################################################################
#
# Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
#              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
#                                -------
#
# Copyleft (CC) 2013, Creative Commons
# Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
#
# Atribuicao-Nao Comercial-Compartilhada Igual 3 Nao Adaptada (CC BY-NC-SA 3.0)
# http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
#
################################################################################

# noinspection PyStatementEffect
{
    'name': 'Warehouse Management System',
    'version': '7.0.2310.2',
    'author': 'Sig Informatica Ltda',
    'website': 'http://www.siginformatica.com.br',
    'category': 'Estoque',
    'summary': 'Armazenamento, estoque e suprimento',
    'description': """
Warehouse Management System
===========================

Um sistema chamado Warehouse Management System (WMS), ou Sistema de Gerenciamento de Armazem, e uma
parte importante da cadeia de suprimentos (supply chain) para maximizar o uso do valioso espaco do
armazem.

Fornece
-------
a) Rotacao dirigida de estoques
b) Diretivas inteligentes de picking
c) Consolidacao automatica e cross-docking

O sistema tambem dirige e **otimiza** a colocacao no armazem, baseado em informacoes de tempo real
sobre o status do uso dos enderecos do deposito.
    """,
    'depends': ['veiculos', 'recebimento'],
    'data': [
        # Security
        'security/wms_security.xml',
        'security/ir.model.access.csv',
        # ________________________ WMS _______________________________________
        # Data (exportacao)
        'data/ir_exports.xml',  # Modelo estoque.produto.grade
        'data/ir_exports_line.xml',  # Dados do produto a serem exportados

        # Wizard
        'wizard/enderecofaixa_view.xml',  # Criar faixa de enderecos
        'wizard/endereco_sentidorua_view.xml',  # Sentido das ruas (endereco/separacao)
        'wizard/endereco_ressuprimento_manual_view.xml',  # Ressuprimento preventivo
        'wizard/consulta_produto_grade_view.xml',  # Consulta de produtos
        'wizard/produto_sem_movimentacao_view.xml',  # Relatorio - Produtos sem movimentacao
        'wizard/etiqueta_endereco_view.xml',  # Impressao de etiquetas de endereco
        'wizard/produto_sem_picking_view.xml',  # Relatorio - Produtos sem picking
        'wizard/estoque_picking_view.xml',  # Relatorio de estoque (picking)
        'wizard/posicao_nf_view.xml',  # Relatorio - Posicao de notas fiscais

        # Views
        'views/enderecotipo_view.xml',  # Tipos de endereco
        'views/estruturatipo_view.xml',  # Tipos de estrutura
        'views/produtotipo_view.xml',  # Tipos de produto
        'views/endereco_view.xml',  # Enderecos
        'views/campoetiqueta_view.xml',  # Campos da etiqueta
        'views/modeloetiqueta_view.xml',  # Modelos de etiqueta
        'views/produto_sem_movimentacao_view.xml',  # Produtos sem movimentacao
        'views/impressora_etiqueta_view.xml',  # Cadastro de impressora de etiquetas
        'views/ocupacao_cd_view.xml',  # Ocupacao do C.D.

        # Inherit
        'inherit/estoque/produto_embalagem_view.xml',  # Calculo do volume (altura/largura/profundidade)
        'inherit/estoque/produto_grade_view.xml',  # Mostra produtos sem dado logisticos
        'inherit/veiculos/veiculo_view.xml',  # Acrescimo dos campos volume, tipo de veiculo, tipo de carroceria e quantidade de paletes
        'inherit/estoque/parametro_view.xml',  # Aba "WMS" com parametros para o modulo
        'inherit/recebimento/os/os_view.xml',  # Informacao de dado logistico e data de validade requerida
        'inherit/recebimento/recebimento_itens_view.xml',  # Data de validade obrigatoria
        'inherit/estoque/produto_view.xml',  # Produto utilizado pelo WMS

        # Action & Menu
        'views/action.xml',
        'views/menu.xml',  # WMS

        # ________________________ Enderecamento _____________________________
        # Views
        'enderecamento/views/enderecamento_itens_view.xml',

        # Inherit
        'enderecamento/inherit/recebimento/os/os_view.xml',  # Aba "Itens de enderecamento"

        # ________________________ Transferencia _____________________________
        # Data
        'transferencia/data/os_tipo.xml',  # Tipo de ordem de servico: "TRF" - Transferencia

        # Inherit
        'transferencia/inherit/recebimento/os/os_view.xml',  # Ordem de servico de transferencia

        # Views
        'transferencia/views/transferencia_itens_view.xml',  # Lista de transferencias (solicitacoes)
        'transferencia/views/action.xml',
        'transferencia/views/menu.xml',  # WMS/Transferencia/Lista de transferencias

        # Wizard
        'transferencia/wizard/transferencia_view.xml',  # Transferencia automatica
        'transferencia/wizard/action.xml',
        'transferencia/wizard/menu.xml',  # WMS/Transferencia - Solicitacao de transferencia

        # Reports
        'transferencia/report/transferencia.xml',

        # ________________________ Montagem de carga _________________________
        # Views
        'montagemcarga/views/montagemcarga_view.xml',  # Montagem de carga
        'montagemcarga/views/montagemcarga_itens_view.xml',  # Carga (itens da Montagem de carga)

        # Inherit
        'montagemcarga/inherit/estoquepedidos/pedido_capa_view.xml',  # Agrupar por pedido e data de emissao (search)
        'montagemcarga/inherit/estoquepedidos/pedido_item_view.xml',  # Itens do pedido
        'montagemcarga/inherit/estoquepedidos/pedido_pendente_view.xml',  # WMS/Consultas/Pedidos pendentes (nao expedidos)
        'montagemcarga/inherit/estoque/parametro_view.xml',  # Parametros para montagem de carga
        'montagemcarga/inherit/veiculos/veiculo_view.xml',  # Veiculos em viagem

        # Reports
        'montagemcarga/report/report.xml',

        # Action & Menu
        'montagemcarga/views/action.xml',
        'montagemcarga/views/menu.xml',  # WMS/Montagem de carga

        # ________________________ Separacao _________________________________
        # Data
        'separacao/data/os_tipo.xml',  # Tipos de ordem de servico: "SPC" e "SPR"

        # Wizard
        'separacao/wizard/mapaseparacao_view.xml',  # Mapas de separacao: paletizada por carga ou por rua
        'separacao/wizard/etiqueta_volume_view.xml',  # Impressao das etiquetas de volume
        'separacao/wizard/action.xml',

        # Inherit
        'separacao/inherit/recebimento/os/os_view.xml',  # Ordens de servico
        'separacao/inherit/recebimento/os/os_historico_view.xml',
        'separacao/inherit/wms/produtotipo_view.xml',  # Tipos de produto - Acrescenta o campo sequence prevendo a quebra/ordenacao no mapa de separacao
        'separacao/inherit/estoque/parametro_view.xml',  # Parametros para separacao
        'separacao/inherit/rh/funcionario_view.xml',  # Permitir ver ou nao a quantidade contada
        'separacao/inherit/montagemcarga/montagemcarga_view.xml',  # Separacao paletizada (carga/rua)

        # Views
        'separacao/views/separacao_itens_view.xml',
        'separacao/views/action.xml',
        'separacao/views/menu.xml',  # WMS/Separacao

        # Reports
        'separacao/report/mapa_separacao.xml',

        # ________________________ Conferencia _______________________________
        # Views
        'conferencia/views/conferencia_itens_view.xml',
        'conferencia/views/conferencia_checkout_view.xml',
        'conferencia/views/action.xml',
        'conferencia/views/menu.xml',

        # Inherit
        'conferencia/inherit/separacao/os_view.xml',
        'conferencia/inherit/estoque/parametro_view.xml',  # Visualizar quantidade (checkout)
        'conferencia/inherit/montagemcarga/montagemcarga_view.xml',  # Relatorio de conferencia
        'conferencia/inherit/separacao/separacao_itens_view.xml',  # Historico da conferencia

        # ________________________ Inventario ________________________________
        # Data
        'inventario/data/os_tipo.xml',  # Tipo de ordem de servico: "INV" - Inventario

        # Inherit
        'inventario/inherit/recebimento/os/os_view.xml',  # Ordem de servico de nventario
        'inventario/inherit/estoque/parametro_view.xml',  # Parametros do inventario

        # Views
        'inventario/views/inventario_view.xml',  # Lista de inventarios
        'inventario/views/inventario_itens_view.xml',  # Itens de inventario
        'inventario/views/action.xml',
        'inventario/views/menu.xml',  # WMS/Inventario

        # Wizard
        'inventario/wizard/inventario_view.xml',
        'inventario/wizard/exportar_dados_view.xml',  # Exportar dados do inventario
        'inventario/wizard/action.xml',
        'inventario/wizard/menu.xml',  # WMS/Inventario/Planejamento

        # ________________________ Crossdocking ______________________________
        # Inherit
        'crossdocking/inherit/estoque/produto_view.xml',  # Marcacao de crossdocking no produto
        'crossdocking/inherit/wms/endereco_view.xml',
        'crossdocking/inherit/montagemcarga/montagemcarga_view.xml',  # Coluna de item crossdocking
        'crossdocking/inherit/inventario/wizard_inventario_view.xml',  # Considerar enderecos de crossdocking

        # ________________________ Controle de ordens de servico _____________
        # Views
        'controle_os/views/controle_ordem_servico_view.xml',
        'controle_os/views/action.xml',
        'controle_os/views/menu.xml',

        # Report
        'controle_os/report/report.xml',
    ],
    'license': 'Other proprietary',
    "application": True,
    'installable': True,
    'active': False,
}

