# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class estoque_parametro(osv.Model):
    """
    Novo campo de parametro. Mostra ou nao a quantidade a ser separada durante as operacoes de
    checkout de produto. (heranca)

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'estoque.parametro'  # estpar
    _inherit = 'estoque.parametro'  # estoque/model/parametro_data

    _columns = {
        # ___________________________ Boolean ________________________________
        # Se marcaddo (verdadeiro) a quantidade a ser separada sera visualizada no checkout
        'estpar_mostra_quantidade': fields.boolean('Mostrar quantidade',
                                                    help='Se a opcao estiver marcada a quantidade a ser separada durante as operacoes de checkout sera mostrada.')
    }

    _defaults = {
        'estpar_mostra_quantidade': lambda *args: False
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
