# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields

STATUS_CONFERENCIA = [('<', 'A menor'), ('=', 'OK'), ('>', 'A maior'), ('*', 'Recontagem')]


class wms_conferencia_itens(osv.Model):
    """
    Historico de conferencia dos itens.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wms.conferencia.itens'  # wmscit

    from funcoes import wmscit_fields_function

    _columns = {
        # ___________________________ Many2One _______________________________
        'wmscit_separacao_id': fields.many2one('separacao.os', 'Mapa de separacao'),
        'wmscit_separacao_item_id': fields.many2one('wms.separacao.itens',  'Item de separacao'),
        'wmscit_pessoa_id': fields.many2one('adm.pessoa', 'Cliente'),  # Cliente ou loja
        'wmscit_produto_id': fields.many2one('estoque.produto', 'Produto', select=True),
        'wmscit_grade_id': fields.many2one('estoque.produto.grade', 'Grade', select=True),
        'wmscit_produto_embalagem_id': fields.many2one('estoque.produto.embalagem', 'Embalagem'),
        'wmscit_conferente_id': fields.many2one('res.users', 'Conferente',
                                                help='Responsavel pela conferencia no checkout.'),

        # ___________________________ Function _______________________________
        'wmscit_grade': fields.function(wmscit_fields_function, method=True, type='char', size=50,
                                        string='Grade'),
        'wmscit_embalagem': fields.function(wmscit_fields_function, method=True, type='char',
                                            size=30, string='Embalagem'),
        'wmscit_item': fields.function(wmscit_fields_function, method=True, type='integer',
                                       string='Item'),

        # ___________________________ Float __________________________________
        'wmscit_quantidade': fields.float('Quantidade contada', digits=(9, 3)),

        # ___________________________ Datetime _______________________________
        'wmscit_data_conferencia': fields.datetime('Data/Hora da conferencia'),

        # ___________________________ Boolean ________________________________
        'active': fields.boolean('Ativo'),

        # ___________________________ Selection ______________________________
        'wmscit_status_conferencia': fields.selection(STATUS_CONFERENCIA, 'Status')
    }

    _order = 'wmscit_separacao_item_id, wmscit_data_conferencia desc'

    _defaults = {
        'active': lambda *args: True
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
