# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


# _______________________ wms.conferencia.itens ______________________________
def wmscit_fields_function(self, cr, uid, ids, name, args, context=None):
    """
    Manipulacao de campos. Valores de campos pre-definidos.

    :param cr: a linha atual do cursor do banco de dados
    :param uid: ID do usuario utilizado para a verificacao de perfil
    :param ids: lista dos IDs
    :param name: lista com o nome dos campos
    :param args: dicionario com os argumentos e valores
    :param context: um dicionario padrao para valores contextuais
    :type cr: object
    :type uid: int
    :type ids: list|int
    :type name: list
    :type args: dict
    :type context: dict
    :return: valores ajustados dos campos.
    :rtype: dict

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    result = {}

    for item in self.browse(cr, uid, ids, context):
        try:
            if name == 'wmscit_grade':
                valor = item.wmscit_grade_id.grade
            elif name == 'wmscit_embalagem':
                valor = item.wmscit_produto_embalagem_id.embalagem_id.sigla
            elif name == 'wmscit_item':
                valor = item.wmscit_separacao_item_id.id
            else:
                valor = None
        except Exception as e:
            print '[erro] %s' % e
            valor = None

        result[item.id] = valor

    return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
