# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv


# noinspection PyPep8Naming
class wms_enderecotipo(osv.Model):
    """
    Tipo de endereco picking/pulmao.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wms.enderecotipo'  # wmseti
    _inherit = 'wms.enderecotipo'  # wms/control/enderecotipo

    # noinspection PyMethodMayBeStatic
    def wmseti_onchange_cubagem(self, cr, uid, ids, altura, largura, profundidade, context=None):
        """
        Calculo do volume (metros cubicos)

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: ID do usuario utilizado para a verificacao de perfil,
        :param ids: lista dos IDs,
        :param altura: altura do tipo de endereco (metros),
        :param largura: largura do tipo de endereco (metros),
        :param profundidade: profundidade do tipo de endereco (metros),
        :param context: um dicionario padrao para valores contextuais,
        :type cr: object
        :type uid: int
        :type ids: int|list[int|long]
        :type largura: float
        :type profundidade: float
        :type context: dict
        :return: resultado da multiplicacao entre altura, largura e profundidade.
        :rtype: float

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}
        volume = altura * largura * profundidade

        result = dict(value=dict(cubagem=volume))

        return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
