# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv


# noinspection PyPep8Naming
class estoque_produto_grade(osv.Model):
    """
    Heranca na classe.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'estoque.produto.grade'  # estgrd
    _inherit = 'estoque.produto.grade'  # estoque/control/produto_grade

    def estpgr_falta_dado_logistico(self, cr, uid, ids, context=None):
        """
        Se o produto for crossdocking, a falta de dado logistico nao deve considerar o endereco de
        picking.

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: ID do usuario utilizado para a verificacao de perfil,
        :param ids: lista dos IDs,
        :param context: um dicionario padrao para valores contextuais,
        :return: verdadeiro se o produto tiver dado logistico faltando
        :rtype: bool

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}

        result = super(estoque_produto_grade, self).estpgr_falta_dado_logistico(
            cr, uid, ids, context)

        # Verifica se item crossdocking
        brw_grade = self.browse(cr, uid, ids[0] if isinstance(ids, list) else ids, context)

        if brw_grade.produto_id.estpro_crossdocking:
            if result == 'Endereco de picking':
                result = ''
            elif result[:21] == 'Endereco de picking, ':
                result = result[21:].capitalize()
            elif result[:22] == 'Endereco de picking e ':
                result = result[22:].capitalize()

        return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
