# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


# _______________________ recebimento.itens __________________________________
def recite_function_falta_dado_logistico(self, cr, uid, ids, name, arg, context):
    """
    ´´Flag´´ de itens faltando dado logistico.

    @param cr: {cursor} a linha atual do cursor do banco de dados,
    @param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    @param ids: {list} lista dos IDs,
    @param name: {list} lista com o nome dos campos,
    @param arg: {dict} dicionario com os argumentos e valores,
    @param context: {dict} um dicionario padrao para valores contextuais,
    @return: {dict} a ´flag´ indicando se ha ou nao dado logistico faltando.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    result = {}

    for item in self.browse(cr, uid, ids):
        if item.grade_id.falta_dado_logistico:
            result[item.id] = True
        else:
            result[item.id] = False

    return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
