# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


# _______________________ recebimento.os _____________________________________
def recosv_function_enderecamento_ok(self, cr, uid, ids, name, arg,  context=None):
    """
    Verifica se todos os itens da ordem de servico de recebimento foram enderecados.

    @param cr: {cursor} a linha atual do cursor do banco de dados,
    @param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    @param ids: {list} lista dos IDs,
    @param name: {list} lista com o nome dos campos,
    @param arg: {dict} dicionario com os argumentos e valores,
    @param context: {dict} um dicionario padrao para valores contextuais,
    @return: {char} sempre o codigo do tipo de ordem de servico.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    result = {}

    for os in self.browse(cr, uid, ids):
        if os.recosv_enderecamento_item_ids:
            result[os.id] = all(map(lambda item: item.wmseit_enderecado,
                                    os.recosv_enderecamento_item_ids))
        else:
            result[os.id] = False

    return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
