# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuição-NãoComercial-Compartilhada Igual 3.0 Não Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class wms_enderecamento_itens(osv.Model):
    """
    Itens de movimentação (Endereçamento).

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    from funcoes import wmseit_fields_function

    _name = 'wms.enderecamento.itens'  # wmseit

    _columns = {
        # ___________________________ Many2One _______________________________
        'wmseit_recebimento_item_id': fields.many2one('recebimento.itens', 'Item', required=True,
                                                      ondelete='restrict'),
        'wmseit_endereco_id': fields.many2one('wms.endereco', 'Endereco', required=True,
                                              help='O endereco de destino (picking ou pulmao).'),
        'wmseit_produto_id': fields.many2one('estoque.produto', 'Produto', select=True),
        'wmseit_grade_id': fields.many2one('estoque.produto.grade', 'Grade', select=True),
        'wmseit_usuario_mov_id': fields.many2one('res.users', 'Responsavel pela movimentacao'),
        'wmseit_embalagem_id': fields.many2one('estoque.produto.embalagem', 'Embalagem'),

        # ___________________________ Integer ________________________________
        'wmseit_quantidade': fields.integer('Quantidade'),  # Quantidade enderecada

        # ___________________________ Date ___________________________________
        # Data de movimentacao ou enderecamento
        'wmseit_data_movimentacao': fields.date('Data da movimentacao'),
        'wmseit_data_validade': fields.date('Data de validade'),

        # ___________________________ Boolean ________________________________
        'wmseit_enderecado': fields.boolean('Enderecado'),

        # ___________________________ Function _______________________________
        'wmseit_grade_sigla': fields.function(wmseit_fields_function, method=True, type='char',
                                              size=2, string='Grade'),  # Sigla da grade
        'wmseit_endereco_nome': fields.function(wmseit_fields_function, method=True, type='char',
                                                size=20, store=True, string='Endereco'),
        'wmseit_produto': fields.function(wmseit_fields_function, method=True, type='char',
                                          size=60, string='Produto')
    }

    _order = 'wmseit_endereco_nome'

    _defaults = {
        'wmseit_enderecado': lambda *args: False
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
