# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz:siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


# _______________________ enderecamento.itens_________________________________
def wmseit_fields_function(self, cr, uid, ids, name, arg, context=None):
    """
    Manipulacao de campos. Valores de campos pre-definidos.

    :param cr: {cursor} a linha atual do cursor do banco de dados,
    :param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    :param ids: {list} lista dos IDs,
    :param name: {list} lista com o nome dos campos,
    :param arg: {dict} dicionario com os argumentos e valores,
    :param context: {dict} um dicionario padrao para valores contextuais,
    :return: {dict} valores ajustados dos campos.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    # ___________________________ Objects ________________________________
    obj_adm_utils = self.pool.get('adm.utils')

    result = {}

    # Contexto para mostrar produto baseado no parametro de descricao da grade
    campos = ['estpar_descricao_grade']
    adm_utils_dados = obj_adm_utils.admutl_get_parametros(cr, uid, 'estoque', campos, context=context)

    for brw_enderecamento_item in self.browse(cr, uid, ids):
        try:
            if name == 'wmseit_grade_sigla':
                value = brw_enderecamento_item.wmseit_grade_id.grade
            elif name == 'wmseit_endereco_nome':
                value = brw_enderecamento_item.wmseit_endereco_id.name
            elif name == 'wmseit_produto':
                codigo = brw_enderecamento_item.wmseit_produto_id.codigo or ''
                if adm_utils_dados.get('estpar_descricao_grade') == 'G':  # Apenas a grade
                    produto = brw_enderecamento_item.wmseit_grade_id.descricao or ''
                else:  # Produto + grade
                    produto = brw_enderecamento_item.wmseit_produto_id.name or ''
                value = "%s%s%s" % (codigo, ' - ' if codigo else '', produto)
            else:
                value = None
        except Exception as e:
            print '[ERRO] - %s: Atributo %s: %s' % (__name__, name, e)
            value = None

        result[brw_enderecamento_item.id] = value

    return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
