# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv
from openerp.report import report_sxw
from datetime import datetime
from pytz import timezone
from openerp.tools.translate import _


class rel_etiqueta_palete(report_sxw.rml_parse):
    """
    Impressao da etiqueta de palete

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    def __init__(self, cr, uid, name, context):
        super(rel_etiqueta_palete, self).__init__(cr, uid, name, context=context)

        tz = context.get('tz') or 'Brazil/East'
        agora = datetime.now(timezone('UTC')).astimezone(timezone(tz))

        # Parametro de descricao do produto/grade
        obj_adm_utils = self.pool.get('adm.utils')
        campos = ['estpar_descricao_grade']
        adm_utils_dados = obj_adm_utils.admutl_get_parametros(cr, uid, 'estoque', campos, context=context)
        tipo_descricao = adm_utils_dados.get('estpar_descricao_grade')

        self.localcontext.update({
            'tipo_descricao': tipo_descricao
        })

        self.context = context

        obj_enderecamento_itens = self.pool.get('wms.enderecamento.itens')
        args = [('wmseit_recebimento_os_id', '=', context.get('active_id'))]
        if not obj_enderecamento_itens.search(cr, uid, args, context=context):
            msg = _('Nao ha itens de enderecamento para emissao das etiquetas de palete.')

            raise osv.except_osv(_('Atencao!'), msg)

report_sxw.report_sxw('report.etiqueta.palete', 'recebimento.os',
                      'addons/wms/enderecamento/report/etiqueta_palete.rml',
                      parser=rel_etiqueta_palete, header=False)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
