# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.tools.translate import _


#TODO Remover método porque já foi implementado direto na classe estoque produto embalagem(luiz)
# _______________________ estoque.produto.embalagem __________________________
def estpre_function_cubagem(self, cr, uid, ids, name, arg, context=None):
    """
    Calculo do volume da embalagem. (em metros cubicos - m3)

    :param cr: {cursor} a linha atual do cursor do banco de dados,
    :param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    :param ids: {list} lista dos IDs,
    :param name: {list} lista com o nome dos campos,
    :param arg: {dict} dicionario com os argumentos e valores,
    :param context: {dict} um dicionario padrao para valores contextuais,
    :return: {dict} produto entre a altura, largura e profundidade da embalagem.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    result = {}

    for embalagem in self.browse(cr, uid, ids, context):
        altura = embalagem.altura or 0.00  # Altura em centimetros
        largura = embalagem.largura or 0.00  # Largura em centimetros
        profundidade = embalagem.profundidade or 0.00  # Profundidade em centimetros

        result[embalagem.id] = altura * largura * profundidade / 1000000  # Volume em m3

    return result


def estpre_function_codigo_barras(self, cr, uid, ids, name, arg, context=None):
    """
    Calculo do volume da embalagem. (em metros cubicos - m3)

    :param cr: {cursor} a linha atual do cursor do banco de dados,
    :param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    :param ids: {list} lista dos IDs,
    :param name: {list} lista com o nome dos campos,
    :param arg: {dict} dicionario com os argumentos e valores,
    :param context: {dict} um dicionario padrao para valores contextuais,
    :return: {dict} produto entre a altura, largura e profundidade da embalagem.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    # ___________________________ Objects ________________________________
    obj_automacao_codigo_barra = self.pool.get('automacao.codigo.barra')

    result = {}.fromkeys(ids, '')

    for _id in ids:
        args = [('produto_embalagem_id', '=', _id)]
        codigo_barra_ids = obj_automacao_codigo_barra.search(cr, uid, args, context=context)

        campos = ['codigo_barra']
        dados_codigo_barras = obj_automacao_codigo_barra.read(
            cr, uid, codigo_barra_ids, campos, context=context)

        if dados_codigo_barras and isinstance(dados_codigo_barras, list):
            dados_codigo_barras = dados_codigo_barras[0]

        if dados_codigo_barras and isinstance(dados_codigo_barras, dict):
            result[_id] = dados_codigo_barras.get('codigo_barra', '')

    return result


# _______________________ estoque.produto.grade ______________________________
def estpgr_fields_function(self, cr, uid, ids, name, arg, context=None):
    """
    Manipulacao de campos. Valores de campos pre-definidos.

    :param cr: {cursor} a linha atual do cursor do banco de dados,
    :param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    :param ids: {list} lista dos IDs,
    :param name: {list} lista com o nome dos campos,
    :param arg: {dict} dicionario com os argumentos e valores,
    :param context: {dict} um dicionario padrao para valores contextuais,
    :return: {dict} valores ajustados dos campos.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    # ___________________________ Objects ________________________________
    obj_adm_utils = self.pool.get('adm.utils')
    obj_automacao_codigo_barra = self.pool.get('automacao.codigo.barra')

    result = {}

    # Contexto para mostrar produto baseado no parametro de descricao da grade
    campos = ['estpar_descricao_grade']
    adm_utils_dados = obj_adm_utils.admutl_get_parametros(cr, uid, 'estoque', campos, context=context)

    for brw_estoque_produto_grade in self.browse(cr, uid, ids, context):
        try:
            lastro = brw_estoque_produto_grade.lastro or 0
            camada = brw_estoque_produto_grade.camada or 0
            embalagem_master = brw_estoque_produto_grade.embalagem_master_id
            embalagem_expedicao = brw_estoque_produto_grade.embalagem_expedicao_id
            peso_bruto = embalagem_master.peso_bruto or 0.0  # Peso bruto em Kg
            altura = embalagem_master.altura or 0.0  # Altura em centimetros
            largura = embalagem_master.largura or 0.0  # Largura em centimetros
            profundidade = embalagem_master.profundidade or 0.0  # Profundidade em centimetros
            cubagem = altura * largura * profundidade * lastro * camada / 1000000.0

            if name == 'norma_palete':
                value = brw_estoque_produto_grade.lastro * brw_estoque_produto_grade.camada
            elif name == 'peso_palete':
                value = peso_bruto * lastro * camada
            elif name == 'cubagem':
                value = cubagem  # Volume em m3 (metro cubico)
            elif name == 'fracionado':
                value = embalagem_master.id != embalagem_expedicao.id
            elif name == 'dinamico':
                value = True if not brw_estoque_produto_grade.endereco_produto_id.id else False
            elif name == 'estpgr_wms_uso':
                value = brw_estoque_produto_grade.produto_id.estpro_wms_uso
            elif name == 'estprg_produto':
                codigo = brw_estoque_produto_grade.produto_id.codigo or ''
                if adm_utils_dados.get('estpar_descricao_grade') == 'G':  # Apenas a grade
                    produto = brw_estoque_produto_grade.grade_id.descricao or ''
                else:  # Produto + grade
                    produto = brw_estoque_produto_grade.produto_id.name or ''
                value = "%s%s%s" % (codigo, ' - ' if codigo else '', produto)
            elif name == 'estpgr_ean':
                args = [('grade_id', '=', brw_estoque_produto_grade.id),
                        ('produto_embalagem_id', '=', embalagem_expedicao.id)]
                embalagem_ids = obj_automacao_codigo_barra.search(cr, uid, args, context=context)

                if embalagem_ids:
                    campos = ['codigo_barra']
                    automacao_codigo_barra_dados = obj_automacao_codigo_barra.read(
                        cr, uid, embalagem_ids[0], campos, context=context)

                    if automacao_codigo_barra_dados and isinstance(automacao_codigo_barra_dados, list):
                        automacao_codigo_barra_dados = automacao_codigo_barra_dados[0]

                    if automacao_codigo_barra_dados and isinstance(automacao_codigo_barra_dados, dict):
                        value = automacao_codigo_barra_dados.get('codigo_barra', '')
                    else:
                        value = ''
                else:
                    value = ''
            elif name == 'estpgr_dun':
                args = [('grade_id', '=', brw_estoque_produto_grade.id),
                        ('produto_embalagem_id', '=', embalagem_master.id)]
                embalagem_ids = obj_automacao_codigo_barra.search(cr, uid, args, context=context)

                if embalagem_ids:
                    campos = ['codigo_barra']
                    automacao_codigo_barra_dados = obj_automacao_codigo_barra.read(
                        cr, uid, embalagem_ids[0], campos, context=context)

                    if automacao_codigo_barra_dados and isinstance(automacao_codigo_barra_dados, list):
                        automacao_codigo_barra_dados = automacao_codigo_barra_dados[0]

                    if automacao_codigo_barra_dados and isinstance(automacao_codigo_barra_dados, dict):
                        value = automacao_codigo_barra_dados.get('codigo_barra', '')
                    else:
                        value = ''
                else:
                    value = ''
            else:
                value = None
        except Exception as e:
            print '[ERRO] - %s: Atributo %s: %s' % (__name__, name, e)
            value = None

        result[brw_estoque_produto_grade.id] = value

    return result


def estpgr_function_falta_dado_logistico(self, cr, uid, ids, name, arg, context=None):
    """
    Verifica se ha dado logistico faltando para um determinado produto.

    :param cr: {cursor} a linha atual do cursor do banco de dados,
    :param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    :param ids: {list} lista dos IDs,
    :param name: {list} lista com o nome dos campos,
    :param arg: {dict} dicionario com os argumentos e valores,
    :param context: {dict} um dicionario padrao para valores contextuais,
    :return: {dict} a ´´flag´´ indicando se ha ou nao dado logistico faltando.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    result = {}

    for grade_id in ids:
        result[grade_id] = self.estpgr_falta_dado_logistico(cr, uid, grade_id, context)

    return result


def estpgr_constraint_estrutura_pulmao(self, cr, uid, ids, context=None):
    """
    Verifica se o tipo de estrutura do pulmao e igual ao tipo de estrutura do endereco de pikcing.

    :param cr: {cursor} a linha atual do cursor do banco de dados,
    :param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    :param ids: {list} lista dos IDs,
    :param context: {dict} um dicionario padrao para valores contextuais,
    :return: {boolean} falso se os tipos forem diferentes.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    brw_produto = self.browse(cr, uid, ids[0], context)
    estrutura_pulmao_id = brw_produto.estrutura_tipo_pulmao_id.id

    if brw_produto.endereco_produto_id:
        if brw_produto.endereco_produto_id.tipo_nivel == 'VT':
            return True

        estrutura_picking_id = brw_produto.endereco_produto_id.estrutura_tipo_id.id
        if estrutura_pulmao_id and estrutura_pulmao_id != estrutura_picking_id:
            return False

    return True


def estpgr_constraint_estrutura_pulmao_msg(self, cr, uid, ids, context=None):
    """
    Mensagem de erro se o tipo de estrutura do pulmao e igual ao tipo de estrutura do endereco de
    pikcing.

    :param cr: {cursor} a linha atual do cursor do banco de dados,
    :param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    :param ids: {list} lista dos IDs,
    :param context: {dict} um dicionario padrao para valores contextuais,
    :return: {char} mensagem de erro.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    brw_produto = self.browse(cr, uid, ids[0], context)
    endereco = brw_produto.endereco_produto_id.name
    estrutura_picking = brw_produto.endereco_produto_id.estrutura_tipo_id.descricao
    estrutura_pulmao = brw_produto.estrutura_tipo_pulmao_id.descricao
    produto = brw_produto.produto_id.name
    grade = brw_produto.grade

    msg = _('O tipo de estrutura "%s" deve ser compativel com o tipo de estrutura do endereco de '
            'picking. Dados do produto: %s (%s), picking: %s (%s)')
    msg %= (estrutura_pulmao, produto, grade, endereco, estrutura_picking)

    return msg

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
