# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-NaoComercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class estoque_parametro(osv.Model):
    """
    Parametros do WMS.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'estoque.parametro'  # estpar
    _inherit = 'estoque.parametro'  # estoque/model/parametro_data

    __help_printer = "O nome da impressora que sera utilizada para impressao das etiquetas de " \
                     "pulmao. Geralmente uma impressora termica especifica para impressao de " \
                     "etiquetas."
    _columns = {
        # ___________________________ Many2One________________________________
        'estpar_empresa_id': fields.many2one('res.company', 'Empresa', ondelete="restrict",
                                             required=True,
                                             help='Empresa do local base da embalagem utilizada na '
                                                  'expedicao (dados logisticos).'),
        'estpar_local_id': fields.many2one('estoque.local', 'Local', ondelete='restrict',
                                           required=True,
                                           help='Local base da embalagem utilizada na expedicao '
                                                '(venda - dados logisticos).'),

        'estpar_impressora_picking_id': fields.many2one('wms.impressora.etiqueta',
                                                        'Impressora de picking',
                                                        ondelete='restrict',
                                                        help=__help_printer),
        'estpar_impressora_pulmao_id': fields.many2one('wms.impressora.etiqueta',
                                                       'Impressora de pulmao',
                                                       ondelete='restrict',
                                                       help=__help_printer),
        # ___________________________ Binary _________________________________
        'modelo_etiqueta_picking': fields.binary('Modelo de etiqueta de picking'),
        'modelo_etiqueta_pulmao': fields.binary('Modelo de etiqueta de pulmao'),
        'modelo_etiqueta_volume': fields.binary('Modelo de etiqueta de volume'),

        # ___________________________ Boolean ________________________________
        'mostrar_descricao_pk': fields.boolean('Mostrar descricao (picking'),
        'mostrar_capacidade': fields.boolean('Mostrar capacidade (picking)'),
        'mostrar_descricao_pu': fields.boolean('Mostrar descricao (pulmao'),
        'mostrar_norma': fields.boolean('Mostar norma palete (pulmao)'),
        'mostrar_fornecedor': fields.boolean('Mostrar Fornecedor (PK/PU)'),
        'mostrar_codigobarra': fields.boolean('Mostrar codigo de barras')
    }

    _defaults = {
        'mostrar_descricao_pk': lambda *args: True,
        'mostrar_capacidade': lambda *args: True,
        'mostrar_descricao_pu': lambda *args: True,
        'mostrar_norma': lambda *args: True,
        'mostrar_fornecedor': lambda *args: True,
        'mostrar_codigobarra': lambda *args: True,
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
