# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class estoque_produto_embalagem(osv.Model):
    """
    Acrescimo do campo "volume" e codigo de barra da embalagem.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'estoque.produto.embalagem'  # estpre
    _inherit = 'estoque.produto.embalagem'  # estoque/model/produto_embalagem_data

    from funcoes import estpre_function_cubagem
    from funcoes import estpre_function_codigo_barras

    _columns = {
        # ___________________________ Function _______________________________
        'cubagem': fields.function(estpre_function_cubagem, method=True, digits=(15, 6),
                                   string='Volume (m3)'),
        'estpre_codigo_barras': fields.function(estpre_function_codigo_barras, method=True,
                                                type='char', size=14, string='Codigo de barras')
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
