# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-NaoComercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class recebimento_itens(osv.Model):
    """
    Adiciona a coluna "recite_falta_dado_logistico" que mostra se falta algum
    dado logistico para o item.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'recebimento.itens'  # recite
    _inherit = 'recebimento.itens'  # recebimento/model/recebimento_itens_data

    from funcoes import recite_ver_falta_dado_logistico

    _columns = {
        # ___________________________ Function _______________________________
        'recite_falta_dado_logistico': fields.function(recite_ver_falta_dado_logistico, type='boolean',
                                                       string='Falta dado logistico'),
        # Lista dos dados logisticos faltando (com divergencia)
        'recite_dado_logistico_divergencia': fields.function(recite_ver_falta_dado_logistico,
                                                             type='char',
                                                             string='Divergencias (dados logisticos)')
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

