# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


def veivei_constraint_cubagem(self, cr, uid, ids, context=None):
    """
    Verifica se o calculo da cubagem (volume) do veiculo esta correto.

    :param cr: {cursor} a linha atual do cursor do banco de dados,
    :param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    :param ids: {list} lista dos IDs,
    :param context: {dict} um dicionario padrao para valores contextuais,
    :return: {boolean} falso se a cubagem estiver incorreta.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    brw_veiculo = self.browse(cr, uid, ids[0], context)
    result = True

    if brw_veiculo.cubagem <= 0:
        result = False

    return result


def veivei_constraint_qtde_palete(self, cr, uid, ids, context=None):
    """
    Verifica a quantidade de paletes.

    :param cr: {cursor} a linha atual do cursor do banco de dados,
    :param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    :param ids: {list} lista dos IDs,
    :param context: {dict} um dicionario padrao para valores contextuais,
    :return: {boolean} falso se a quantidade for inferior a 2.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}
    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    brw_veiculo = self.browse(cr, uid, ids[0], context)
    result = True

    if brw_veiculo.qtde_palete < 2:
        result = False

    return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
