# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv


class veiculos_veiculo(osv.Model):
    """
    Veiculos.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'veiculos.veiculo'  # veivei
    _inherit = 'veiculos.veiculo'  # veiculos/control/veiculo

    def veivei_onchange_altura_largura_profundidade(self, cr, uid, ids, altura, largura,
                                                    profundidade, context=None):
        """
        Calculo do volume suportado pelo veiculo. produto entre altura, largura
        e profundidade (em metros) do veiculo.

        @param cr: {cursor} a linha atual do cursor do banco de dados,
        @param uid: {int} ID do usuario utilizado para a verificacao de perfil,
        @param ids: {list} lista dos IDs,
        @param altura: {float} altura do veiculo (em metros),
        @param largura {float} largura do veiculo (em metros),
        @param profundidade: {float} profundidade do veiculo (em metros),
        @param context: {dict} um dicionario padrao para valores contextuais,
        @return: {float} volume do veiculo (em metros cubicos).

        @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}

        if ids and isinstance(ids, (int, long)):
            ids = [ids]

        result = {'value': {'cubagem': altura * largura * profundidade}}

        return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
