# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class veiculos_veiculo(osv.Model):
    """
    Dados do veiculo. Caclulo do volume. (heranca)

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'veiculos.veiculo'  # veivei
    _inherit = 'veiculos.veiculo'  # veiculos/model/veiculo_data

    from funcoes import veivei_constraint_cubagem
    from funcoes import veivei_constraint_qtde_palete

    _columns = {
        # ___________________________ Integer ________________________________
        'qtde_palete': fields.integer('Quantidade de paletes'),
    }

    _constraints = [(veivei_constraint_cubagem, 'Verifique os valores para o calculo correto do '
                                                'volume.', ['Altura', 'Largura', 'Profundidade']),
                    (veivei_constraint_qtde_palete, 'A quantidade de paletes nao pode ser inferior '
                                                    'a 2 (dois).', ['Quantidade de paletes'])]

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
