# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-NaoComercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


# noinspection PyPep8Naming
class estoque_parametro(osv.Model):
    """
    Parametros do WMS/Inventario.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'estoque.parametro'  # estpar
    _inherit = 'estoque.parametro'  # estoque/model/parametro_data

    _columns = {
        # ___________________________ Integer ________________________________
        'estpar_qtde_predios': fields.integer('Quantidade de predios para contagem de inventario',
                                              help='"Quebra" por numero de predios. Quantidade '
                                                   'maxima de predios em cada ordem de servico. '
                                                   'Valor menor que 1 (um) informa que nao havera '
                                                   'limites para a quantidade de predios.')
    }

    _defaults = {
        'estpar_qtde_predios': lambda *args: 10
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
