# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


# _______________________ os _________________________________________________
def invosv_tipo_padrao(self, cr, uid, context=None):
    """
    Define o tipo da OS / INV - Inventario.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    result = []
    args = [('codigo', '=', 'INV')]
    os_tipo_ids = self.pool.get('os.tipo').search(cr, uid, args, context=context)

    if os_tipo_ids:
        result = os_tipo_ids[0]  # Tipo padrao = "Inventario"

    return result


def invosv_codigo_padrao(self, cr, uid, context=None):
    """
    Define o codigo do tipo da OS / INV.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    return 'INV'


def invosv_fields_function(self, cr, uid, ids, name, arg, context=None):
    """
    Manipulacao de campos. Valores de campos pre-definidos.

    :param cr: a linha atual do cursor do banco de dados,
    :param uid: ID do usuario utilizado para a verificacao de perfil,
    :param ids: lista dos IDs,
    :param name: lista com o nome dos campos,
    :param arg: dicionario com os argumentos e valores,
    :param context: um dicionario padrao para valores contextuais,
    :return: valores ajustados dos campos.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}
    result = {}

    for brw_os in self.browse(cr, uid, ids if isinstance(ids, list) else [ids], context):
        item_inventariado = 0
        divergencia = False  # Assume que nao ha divergencias

        try:
            # Conta os itens ja inventariados ou contados
            for item in brw_os.inventario_item_ids:
                if item.state == 'I':
                    item_inventariado += 1
                if item.state == 'D':  # Registro de divergencia
                    divergencia = True

            if name == 'inventariado':
                value = item_inventariado
            elif name == 'inventariado_percent':
                if brw_os.inventario_item_ids:  # Sempre previnir divisao por zero ;)
                    value = float(item_inventariado) / len(brw_os.inventario_item_ids) * 100.0
                else:
                    value = None
            elif name == 'itens_total':
                value = len(brw_os.inventario_item_ids)
            elif name == 'invosv_divergencia':
                value = divergencia
            else:
                value = None
        except Exception as e:
            print '[ERRO] - %s: Atributo %s: %s' % (__name__, name, e)
            value = None

        result[brw_os.id] = value

    return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
