# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


# noinspection PyPep8Naming
class inventario_os(osv.Model):
    """
    Enderecamento. Ordens de armazenagem. (heranca)

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'inventario.os'  # invosv
    _inherit = 'os'  # recebimento/os/model/os_data
    _inherits = {'wms.inventario': 'inventario_id'}

    from funcoes import invosv_tipo_padrao, invosv_codigo_padrao, invosv_fields_function

    _columns = {
        # ___________________________ Many2One _______________________________
        'inventario_id': fields.many2one('wms.inventario', 'Inventario', required=True,
                                         ondelete='restrict'),

        # ___________________________ One2Many _______________________________
        'inventario_item_ids': fields.one2many('wms.inventario.itens', 'os_id',
                                               'Item de inventario'),

        # ___________________________ Function _______________________________
        'inventariado_percent': fields.function(invosv_fields_function, type='integer', method=True,
                                                store=True, string='% Inventariado',
                                                help='Percentual dos itens (enderecos) inventariados.'),
        'inventariado': fields.function(invosv_fields_function, type='integer', method=True,
                                        string='Itens inventariados',
                                        help='Numero de itens (enderecos) ja inventariados.'),
        'itens_total': fields.function(invosv_fields_function, type='integer', method=True,
                                       string='Total de itens',
                                       help='Numero total de item a ser inventariado.'),
        'invosv_divergencia': fields.function(invosv_fields_function, type='boolean', method=True,
                                              store=True, string='Divergencia'),

        # ___________________________ Integer ________________________________
        'impressao': fields.integer('Nr de impressoes', readonly=True,
                                    help='Controle do numero de impressoes efetuadas.'),
        'invosv_contagem': fields.integer('Nr. da contagem')
    }

    _order = 'inventario_id, id'

    # Valores padrao
    _defaults = {
        'tipo_id': invosv_tipo_padrao,  # ID - Inventario
        'tipo': invosv_codigo_padrao  # "INV" - Inventario
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
