# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv


class os_historico(osv.Model):
    """
    Registro do hitorico das Ordens de Servico. (heranca)

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'inventario.os.historico'  # invosh
    _inherit = 'inventario.os.historico'  # wms/inventario/inherit/os_historico_data

    def osvhis_registra_acao(self, cr, uid, ids, acao, context=None):
        """
        Registro do historico.

        @param cr: {cursor} a linha atual do cursor do banco de dados,
        @param uid: {int} ID do usuario utilizado para a verificacao de perfil,
        @param ids: {list} lista de IDs,
        @param acao: {char} nome da acao,
        @param context: {dict} um dicionario padrao para valores contextuais,
        @return: {boolean} verdadeiro se os registros foram criados corretamente.
        """

        context = context and context.copy() or {}
        if not isinstance(ids, list):
            ids = [ids]

        result = []  # Lista dos ID das ordens de servico

        for _id in ids:
            # Cria novo registro de historico
            dados = {'inventario_id': _id, 'acao': acao.capitalize()}
            if self.create(cr, uid, dados, context):  # Registra dados da nova acao
                result.append(_id)

        result = all(result)

        return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
