# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


# noinspection PyPep8Naming
class inventario_os_historico(osv.Model):
    """
    Dados historicos (log) do inventario. Relacionamento entre ordem de servico de inventario e o
    historico de inventario. (heranca)

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'inventario.os.historico'  # invosh
    _inherit = 'os.historico'  # recebimento/os/model/os_historico_data

    _columns = {
        # ___________________________ Many2One _______________________________
        'inventario_id': fields.many2one('inventario.os', 'Ordem de servico')
    }


# noinspection PyPep8Naming
class inventario_os(osv.Model):
    """
    Relacionamento entre o historico de inventario e as Ordens de Servico de inventario. (heranca)

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'inventario.os'  # invhis
    _inherit = 'inventario.os'  # inventario/inherit/os_historico_data

    _columns = {
        # ___________________________ One2Many _______________________________
        'historico_ids': fields.one2many('inventario.os.historico', 'inventario_id', 'Historico')
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
