# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields
import time

TIPO_INVENTARIO = [('R', 'Rotativo'), ('T', 'Total')]
STATUS_INVENTARIO = [('E', 'Em contagem'), ('C', 'Cancelado'), ('F', 'Fechado')]


# noinspection PyPep8Naming
class wms_inventario(osv.Model):
    """
    Inventario.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wms.inventario'  # wmsinv

    from funcoes import wmsinv_fields_function

    _columns = {
        # ___________________________ Many2One _______________________________
        'wmsinv_os_ids': fields.one2many('inventario.os', 'inventario_id', 'Ordem de servico'),
        'wmsinv_produto_ids': fields.one2many('wms.inventario.produto', 'wmsipr_inventario_id',
                                              'Produto', select=True),
        # ___________________________ Char ___________________________________
        'wmsinv_descricao': fields.char('Descricao', size=100),

        # ___________________________ Datetime _______________________________
        'wmsinv_data_criacao': fields.datetime('Data de criacao', readonly=True),
        'wmsinv_data_fechamento': fields.datetime('Data de fechamento', readonly=True),
        'wmsinv_data_cancelamento': fields.datetime('Data de cancelamento', readonly=True),

        # ___________________________ Selection ______________________________
        'wmsinv_tipo': fields.selection(TIPO_INVENTARIO, 'Tipo',
                                        help='O tipo de inventario: Rotativo ou Total.'),
        'state': fields.selection(STATUS_INVENTARIO, 'Status', readonly=True,
                                  help='O "status" do inventario.'),

        # ___________________________ Function _______________________________
        'name': fields.function(wmsinv_fields_function, type='char',  method=True,
                                string='Descricao'),
        'wmsinv_numero': fields.function(wmsinv_fields_function, type='char', size=15,
                                         method=True, string='Inventario nr'),
        'wmsinv_inventario_ok': fields.function(wmsinv_fields_function, type='boolean', method=True,
                                                string='Inventariado'),

        # ___________________________ Boolean ________________________________
        'active': fields.boolean('Ativo'),

    }

    _order = 'id'

    _defaults = {
        'active': lambda *args: True,
        'state': lambda *args: 'E',
        'wmsinv_data_criacao': lambda *args: time.strftime('%Y-%m-%d %H:%M:%S'),
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
