# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv
from openerp.tools import drop_view_if_exists


# noinspection PyPep8Naming
class wms_inventario_pgview_estatistica(osv.Model):
    """
    Visao para estatistica de inventario.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = "view.wms.inventario.estatistica"
    _inherit = "view.wms.inventario.estatistica"
    _auto = False

    def init(self, cr):
        drop_view_if_exists(cr, 'view_wms_inventario_estatistica')
        cr.execute("""
        CREATE VIEW view_wms_inventario_estatistica AS (
            SELECT  ROW_NUMBER() OVER ()        AS id,
                    wi.id                       AS inventario_id,
                    ios.invosv_contagem         AS contagem,
                    count(ios.invosv_contagem)  AS contagem_total
            FROM    inventario_os as ios
            INNER   JOIN wms_inventario as wi on wi.id = ios.inventario_id
            GROUP   BY wi.id, ios.invosv_contagem
            HAVING  wi.state = 'E')
        """)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
