# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz:siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.report import report_sxw


class wms_relatorio_inventario_rotativo(report_sxw.rml_parse):
    """
    Relatorio de inventario rotativo

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    def __init__(self, cr, uid, name, context):
        """
        Atribui valores as funcoes utilizada no relatorio.

        :param cr: {cursor} a linha atual do cursor do banco de dados,
        :param uid: {int} ID do usuario utilizado para a verificacao de perfil,
        :param name: {char} nome do modelo utilizado,
        :param context: {dict} um dicionario padrao para valores contextuais,
        :return: relatorio de inventario.

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        from datetime import datetime
        from pytz import timezone

        super(wms_relatorio_inventario_rotativo, self).__init__(cr, uid, name, context=context)

        tz = context.get('tz') or 'Brazil/East'
        agora = datetime.now(timezone('UTC')).astimezone(timezone(tz))

        self.localcontext.update({'datetime': datetime, 'agora': agora})

        self.context = context

report_sxw.report_sxw('report.inventario.rotativo', 'wms.inventario',
                      'addons/wms/inventario/report/inventario_rotativo.rml',
                      parser=wms_relatorio_inventario_rotativo, header=False)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
