# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


# noinspection PyPep8Naming
class wizard_inventario(osv.TransientModel):
    """
    Planejamento de inventario.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wizard.inventario'  # wizinv

    _columns = {
        # ___________________________ Char ___________________________________
        'wizinv_descricao': fields.char('Descricao', size=100),

        # ___________________________ Boolean ________________________________
        'verifica_validade': fields.boolean('Comparar data de validade',
                                            help='Se marcado, as datas de validade serao '
                                                 'comparadas a fim de validar a contagem do '
                                                 'inventario.'),
        'importar_saldo': fields.boolean('Utilizar saldo do endereco na primeira contagem',
                                         help='Se marcado, a quantidade igual ao saldo no endereco '
                                              'sera assumida como a quantidade para a primeira '
                                              'contagem e uma segunda contagem sera gerada '
                                              'automaticamente.'),
        'wizinv_virtual': fields.boolean('Considerar enderecos virtuais',
                                         help='Se marcado, os enderecos virtuais serao considerados '
                                              'na contagem do inventario.'),
        'wizinv_avaria': fields.boolean('Considerar enderecos de avaria',
                                        help='Se marcado, os enderecos destianados a avaria serao '
                                             'considerados na contagem do inventario.')
    }

    _defaults = {
        'importar_saldo': lambda *args: True
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
