# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class wms_estruturatipo(osv.Model):
    """
    Tipo de estrutura utilizada no endereco.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wms.estruturatipo'  # wmsest

    from funcoes import wmsest_fields_function

    _rec_name = 'descricao'
    _columns = {
        # ___________________________ Char ___________________________________
        # Nome/descricao do tipo da estrutura utilizada no endereco. Porta Palete, Flowrack, etc
        'descricao': fields.char('Tipo de estrutura', size=45),

        # ___________________________ Boolean ________________________________
        # Marcacao (logica) de registro ativo ou inativo. O padrao e 1 (ativo)
        'active': fields.boolean('Ativo'),

        # ___________________________ Function _______________________________
        'name': fields.function(wmsest_fields_function, method=True, type='char', size=50,
                                string='Tipo de estrutura')
    }

    _defaults = {
        'active': lambda *args: True
    }

    _sql_constraints = [
        ('descricao', 'unique(descricao)', 'Tipo de estrutura ja cadastrada.')]

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
