# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class wms_etiqueta_campo(osv.Model):
    """
    Campos dos modelos de etiqueta

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wms.etiqueta_campo'  # etqcmp
    _inherits = {'ir.model.fields': 'etqcmp_campo_id'}

    _columns = {
        # ___________________________ Many2One _______________________________
        'etqcmp_tabela_id': fields.many2one('ir.model', 'Tabela', required=True,
                                            ondelete='restrict'),
        'etqcmp_campo_id': fields.many2one('ir.model.fields', 'Nome do campo', required=True,
                                           ondelete='restrict',
                                           domain="[('model_id', '=', etqcmp_tabela_id)]"),

        # ___________________________ Char ___________________________________
        'etqcmp_identificador': fields.char('Identificador', size=64, required=True)
    }

    _sql_constraints = [('etqcmp_ident_uniq', 'unique (etqcmp_identificador)',
                         'O identificador do campo deve ser unico.')]

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
