# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


# noinspection PyPep8Naming
class wms_impressora_etiqueta(osv.Model):
    """
    Cadastro de impressoras para impressao de etiquetas.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wms.impressora.etiqueta'  # wmsimp

    _columns = {
        # ___________________________ Char ___________________________________
        'name': fields.char('Nome da impressora', size=128, required=True),
        'wmsimp_descricao': fields.char('Descricao', size=255,
                                        help='Descricao da impressora. Pode ser o local, modelo '
                                             'ou qualquer tipo de informacao.'),

        # ___________________________ Integer ________________________________
        'sequence': fields.integer('Prioridade'),  # Prioridade da ordem de contagem

        'active': fields.boolean('Ativo')
    }

    _order = 'sequence, name'

    _defaults = {
        'active': lambda *args: True,
        'sequence': lambda s, cr, uid, c: 1 if not s.search_count(
            cr, uid, [], c) else (s.read(cr, uid, s.search(
                cr, uid, [], context=c, order='sequence desc', limit=1), [], c)[0].get('sequence')) + 1
    }

    _sql_constraints = [
        ('name', 'unique(name)', 'Nome de impressora deve ser unico no cadastro.')]

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
