# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class wms_parametro(osv.Model):
    """
    Parametros do WMS.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wms.parametro'  # wmspar
    _rec_name = 'company_id'

    _description = 'Parametros do WMS'

    _columns = {
        # ___________________________ Many2One _______________________________
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True,
                                      select=True, oldname="empresa_id"),
        'wmspar_etiqueta_picking': fields.many2one('wms.etiqueta_modelo',
                                                   'Modelo de etiqueta de picking'),
        'wmspar_etiqueta_pulmao': fields.many2one('wms.etiqueta_modelo',
                                                  'Modelo de etiqueta de pulmao'),
        'wmspar_etiqueta_volume': fields.many2one('wms.etiqueta_modelo',
                                                  'Modelo de etiqueta de volume'),

        # ___________________________ Char ___________________________________
        'wmspar_impressora': fields.char('Impressora', size=64)
    }

    _defaults = {
        'company_id': lambda self, cr, uid, c:
        self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=c)
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
