# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class wms_produtotipo(osv.Model):
    """
    Tipos de produto.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wms.produtotipo'  # wmspti

    from funcoes import wmspti_fields_function

    _rec_name = 'descricao'
    _columns = {
        # ___________________________ Char ___________________________________
        'descricao': fields.char('Tipo de produto', size=45),  # Descricao do tipo de produto

        # ___________________________ Function _______________________________
        'name': fields.function(wmspti_fields_function, method=True, type='char', size=50,
                                string='Tipo de produto'),

        # ___________________________ Boolean ________________________________
        'active': fields.boolean('Ativo')  # Marcacao (logica) de registro ativo ou inativo.

    }

    _defaults = {
        'active': lambda *args: True
    }

    _sql_constraints = [
        ('descricao', 'unique(descricao)', 'Tipo de produto ja cadastrado.')]

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
