# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz:siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


# _______________________ estoquepedidos.pedido.item _________________________
def pedite_fields_function(self, cr, uid, ids, name, args, context=None):
    """
    Manipulacao de campos. Valores de campos pre-definidos.

    :param cr: {cursor} a linha atual do cursor do banco de dados,
    :param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    :param ids: {list} lista dos IDs,
    :param name: {list} lista com o nome dos campos,
    :param args: {dict} dicionario com os argumentos e valores,
    :param context: {dict} um dicionario padrao para valores contextuais,
    :return: {dict} valores ajustados dos campos.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    # ___________________________ Objects ________________________________
    obj_adm_utils = self.pool.get('adm.utils')

    result = {}

    # Contexto para mostrar produto baseado no parametro de descricao da grade
    campos = ['estpar_descricao_grade']
    adm_utils_dados = obj_adm_utils.admutl_get_parametros(cr, uid, 'estoque', campos, context=context)

    for brw_estoquepedidos_pedido_item in self.browse(cr, uid, ids, context):
        try:
            if name == 'pedite_numero_pedido':
                value = brw_estoquepedidos_pedido_item.pedido_id.numero_pedido
            elif name == 'pedite_grade':
                value = brw_estoquepedidos_pedido_item.grade_id.grade
            elif name == 'pedite_embalagem':
                value = brw_estoquepedidos_pedido_item.produto_embalagem_id.embalagem_id.sigla
            elif name == 'pedite_peso':
                peso_bruto = brw_estoquepedidos_pedido_item.produto_embalagem_id.peso_bruto
                qtde_pedida = brw_estoquepedidos_pedido_item.qtde_pedida
                value = peso_bruto * qtde_pedida
            elif name == 'pedite_volume':
                volume = brw_estoquepedidos_pedido_item.produto_embalagem_id.cubagem
                qtde_pedida = brw_estoquepedidos_pedido_item.qtde_pedida
                value = volume * qtde_pedida
            elif name == 'pedite_cliente':
                value = brw_estoquepedidos_pedido_item.pedido_id.pessoa_id.nome
            elif name == 'pedite_falta_dado_logistico':
                value = brw_estoquepedidos_pedido_item.grade_id.falta_dado_logistico
            elif name == 'pedite_data_emissao':
                value = brw_estoquepedidos_pedido_item.pedido_id.data_emissao
            elif name == 'pedite_valor_total':
                value = brw_estoquepedidos_pedido_item.pedido_id.valor_total
            elif name == 'pedite_produto':
                codigo = brw_estoquepedidos_pedido_item.produto_id.codigo
                if adm_utils_dados.get('estpar_descricao_grade') == 'G':  # Apenas a grade
                    produto = brw_estoquepedidos_pedido_item.grade_id.descricao or ''
                else:  # Produto + grade
                    produto = brw_estoquepedidos_pedido_item.produto_id.name or ''
                value = "%s%s%s" % (codigo, ' - ' if codigo else '', produto)
            elif name == 'pedite_endereco':
                value = brw_estoquepedidos_pedido_item.grade_id.endereco_produto_id.name
            else:
                value = None
        except Exception as e:
            print '[ERRO] - %s: Atributo %s: %s' % (__name__, name, e)
            value = None

        result[brw_estoquepedidos_pedido_item.id] = value

    return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
