# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class estoquepedidos_pedido_item(osv.Model):
    """
    Insere a coluna relativa ao ID da montagem de carga.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    from funcoes import pedite_fields_function

    _name = 'estoquepedidos.pedido.item'  # pedite
    _inherit = 'estoquepedidos.pedido.item'  # estoquepedidos/model/estoquepedidos_pedido_item_data

    _columns = {
        # ___________________________ Many2One _______________________________
        'montagemcarga_id': fields.many2one('wms.montagemcarga', 'Montagem de carga'),

        # ___________________________ Function _______________________________
        'pedite_numero_pedido': fields.function(pedite_fields_function, method=True, type='char',
                                                size=20, store=True, string='Pedido'),
        'pedite_grade': fields.function(pedite_fields_function, method=True, type='char', size=2,
                                        store=True, string='Grade'),
        'pedite_embalagem': fields.function(pedite_fields_function, method=True, type='char',
                                            size=7, store=True, string='Embalagem'),
        'pedite_peso': fields.function(pedite_fields_function, method=True, digits=(9, 3),
                                       store=True, string='Peso (Kg)'),
        'pedite_volume': fields.function(pedite_fields_function, method=True, digits=(12, 6),
                                         store=True, string='Volume (m3)'),
        'pedite_cliente': fields.function(pedite_fields_function, method=True, type='char',
                                          size=64, store=True, string='Cliente'),
        'pedite_falta_dado_logistico': fields.function(pedite_fields_function, method=True,
                                                       type='boolean',
                                                       string='Falta dado logistico'),
        'pedite_data_emissao': fields.function(pedite_fields_function, method=True, type='date',
                                               store=True, string='Data de emissao'),
        'pedite_valor_total': fields.function(pedite_fields_function, method=True, digits=(9, 2),
                                              store=True, string='Valor total'),
        'pedite_produto': fields.function(pedite_fields_function, method=True, type='char',
                                          size=60, string='Produto'),
        'pedite_endereco': fields.function(pedite_fields_function, method=True, type='char',
                                           store=True, size=20, string='Picking do produto')
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
