# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv


class veiculos_veiculo(osv.Model):
    """

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'veiculos.veiculo'
    _inherit = 'veiculos.veiculo'

    # _________________________ ORM Methods __________________________________
    def name_search(self, cr, uid, name='', args=None, operator='ilike', context=None, limit=100):
        """
        Mostra ou nao veiculos em viagem de acordo com o parametro.

        @param cr: {cursor} a linha atual do cursor do banco de dados,
        @param uid: {int} ID do usuario utilizado para a verificacao de perfil,
        @param name: nome do objeto para procurar,
        @param args: {list} lista com os parametros da pesquisa,
        @param operator: {char} operador de comparacao utilizado na consulta,
        @param context: {dict} um dicionario padrao para valores contextuais,
        @param limit: numero maximo de registros para retornar,
        @return: {list} lista com os dados da pesquisa.

        @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}
        if not args or not isinstance(args, list):
            args = []

        # ___________________________ Objects ________________________________
        obj_adm_utils = self.pool.get('adm.utils')

        # Mostrar ou nao veiculos em viagem
        campos = ['veiculos_viagem']
        dados_parametro = obj_adm_utils.admutl_get_parametros(cr, uid, 'estoque', campos)

        if not dados_parametro.get('veiculos_viagem'):
            args.append(['veivei_veiculo_viagem', '=', False])

        result = super(veiculos_veiculo, self).name_search(
            cr, uid, name, args, operator, context, limit)

        return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
