# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz:siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


# _______________________ wms.montagemcarga __________________________________
def wmsmcg_fields_function(self, cr, uid, ids, name, args, context=None):
    """
    Manipulacao de campos. Valores de campos pre-definidos.

    :param cr: {cursor} a linha atual do cursor do banco de dados,
    :param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    :param ids: {list} lista dos IDs,
    :param name: {list} lista com o nome dos campos,
    :param args: {dict} dicionario com os argumentos e valores,
    :param context: {dict} um dicionario padrao para valores contextuais,
    :return: {dict} valores ajustados dos campos.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}
    result = {}

    for brw_wms_montagemcarga in self.browse(cr, uid, ids, context):
        try:
            if name in ('peso_total', 'cubagem_total', 'qtde_volumes'):
                valor = 0.0
                itens = []
                for item in brw_wms_montagemcarga.pedido_item_ids:
                    if item.produto_id.id not in itens:
                        itens.append(item.produto_id.id)
                    if name == 'cubagem_total':
                        volume = item.grade_id.embalagem_expedicao_id.cubagem
                        embalagem_expedicao = item.grade_id.embalagem_expedicao_id.embalagem_id
                        qtde_na_embalagem_expedicao = embalagem_expedicao.quantidade_na_embalagem
                        embalagem_pedido = item.produto_embalagem_id.embalagem_id
                        qtde_na_embalagem_pedido = embalagem_pedido.quantidade_na_embalagem
                        qtde_pedida_item = item.qtde_pedida * qtde_na_embalagem_pedido
                        qtde_pedida_expedicao = qtde_pedida_item / qtde_na_embalagem_expedicao
                        valor += volume * qtde_pedida_expedicao
                    if name == 'peso_total':
                        peso_bruto = item.grade_id.embalagem_expedicao_id.peso_bruto
                        embalagem_expedicao = item.grade_id.embalagem_expedicao_id.embalagem_id
                        qtde_na_embalagem_expedicao = embalagem_expedicao.quantidade_na_embalagem
                        embalagem_pedido = item.produto_embalagem_id.embalagem_id
                        qtde_na_embalagem_pedido = embalagem_pedido.quantidade_na_embalagem
                        qtde_pedida_item = item.qtde_pedida * qtde_na_embalagem_pedido
                        qtde_pedida_expedicao = qtde_pedida_item / qtde_na_embalagem_expedicao
                        valor += peso_bruto * qtde_pedida_expedicao
                    if name == 'qtde_volumes':
                        embalagem_expedicao = item.grade_id.embalagem_expedicao_id.embalagem_id
                        qtde_na_embalagem_expedicao = embalagem_expedicao.quantidade_na_embalagem
                        embalagem_pedido = item.produto_embalagem_id.embalagem_id
                        qtde_na_embalagem_pedido = embalagem_pedido.quantidade_na_embalagem
                        qtde_pedida_item = item.qtde_pedida * qtde_na_embalagem_pedido
                        qtde_pedida_expedicao = qtde_pedida_item / qtde_na_embalagem_expedicao
                        valor += qtde_pedida_expedicao
            elif name == 'qtde_itens':
                grade_ids = list(set(map(lambda i: i.grade_id.id,
                                         brw_wms_montagemcarga.pedido_item_ids)))
                valor = len(grade_ids)
            elif name == 'name':
                if brw_wms_montagemcarga.descricao:
                    valor = '%s - %s' % (brw_wms_montagemcarga.id, brw_wms_montagemcarga.descricao)
                else:  # Mesmo a descricao sendo obrigatoria...
                    valor = '%s' % brw_wms_montagemcarga.id
            elif name == 'wmsmcg_veiculo_palete':
                valor = brw_wms_montagemcarga.veiculo_id.qtde_palete
            elif name == 'wmsmcg_veiculo_carga':
                valor = brw_wms_montagemcarga.veiculo_id.carga_maxima_peso
            elif name == 'wmsmcg_veiculo_volume':
                valor = brw_wms_montagemcarga.veiculo_id.cubagem
            else:
                valor = None
        except Exception as e:
            print '[ERRO] - %s: Atributo %s: %s' % (__name__, name, e)
            valor = None

        result[brw_wms_montagemcarga.id] = valor

    return result


# _______________________ wms.montagemcarga.itens ____________________________
def wmsmci_fields_function(self, cr, uid, ids, name, arg, context=None):
    """
    Manipulacao de campos. Valores de campos pre-definidos.

    :param cr: {cursor} a linha atual do cursor do banco de dados,
    :param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    :param ids: {list} lista dos IDs,
    :param name: {list} lista com o nome dos campos,
    :param arg: {dict} dicionario com os argumentos e valores,
    :param context: {dict} um dicionario padrao para valores contextuais,
    :return: {dict} valores ajustados dos campos.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    # ___________________________ Objects ________________________________
    obj_wms_endereco = self.pool.get('wms.endereco')
    obj_adm_utils = self.pool.get('adm.utils')

    context = context and context.copy() or {}

    result = {}

    # Contexto para mostrar produto baseado no parametro de descricao da grade
    campos = ['estpar_descricao_grade']
    adm_utils_dados = obj_adm_utils.admutl_get_parametros(cr, uid, 'estoque', campos, context=context)

    for brw_wms_montagemcarga_item in self.browse(cr, uid, ids, context=context):
        try:
            if name == 'wmsmci_falta_dado_logistico':
                value = bool(brw_wms_montagemcarga_item.wmsmci_grade_id.falta_dado_logistico)
            elif name == 'wmsmci_saldo':
                args = [('grade_id', '=', brw_wms_montagemcarga_item.wmsmci_grade_id.id)]
                endereco_ids = obj_wms_endereco.search(cr, uid, args, context=context)
                value = obj_wms_endereco.wmsend_saldo(cr, uid, endereco_ids)
            elif name == 'wmsmci_produto':
                codigo = brw_wms_montagemcarga_item.wmsmci_produto_id.codigo or ''
                if adm_utils_dados.get('estpar_descricao_grade') == 'G':  # Apenas a grade
                    produto = brw_wms_montagemcarga_item.wmsmci_grade_id.descricao or ''
                else:  # Produto + grade
                    produto = brw_wms_montagemcarga_item.wmsmci_produto_id.name or ''
                value = "%s%s%s" % (codigo, ' - ' if codigo else '', produto)
            elif name == 'wmsmci_grade':
                value = brw_wms_montagemcarga_item.wmsmci_grade_id.grade
            else:
                value = None
        except Exception as e:
            print '[ERRO] - %s: Atributo %s: %s' % (__name__, name, e)
            value = None

        result[brw_wms_montagemcarga_item.id] = value

    return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
