# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class wms_montagemcarga_clientes(osv.Model):
    """
    Mapa de separacao - Clientes.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wms.montagemcarga.clientes'  # wmsmcc

    _columns = {
        # ___________________________ Many2One _______________________________
        'wmsmcc_pessoa_id': fields.many2one('adm.pessoa', 'Cliente', required=True,
                                            ondelete='restrict', help='Nome do cliente.'),
        'wmsmcc_rota_id': fields.many2one('vendas.rotas', 'Rota para entrega'),

        # ___________________________ Char ___________________________________
        'wmsmcc_cpf_cnpj': fields.char('CPF/CNPJ', size=19),
        'wmsmcc_nome': fields.char('Nome', size=150),
        'wmsmcc_endereco': fields.char('Endereco', size=64),

        # ___________________________ Integer ________________________________
        'wmsmcc_sequencia_entrega': fields.integer('Sequencia de entrega na rota'),

        # ___________________________ Boolean ________________________________
        'active': fields.boolean('Ativo')
    }

    _order = 'wmsmcc_sequencia_entrega'

    _defaults = {
        'active': lambda *args: True
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
