# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class wms_montagemcarga_itens(osv.Model):
    """
    Mapa de separacao - Itens.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wms.montagemcarga.itens'  # wmsmci

    from funcoes import wmsmci_fields_function

    _columns = {
        # ___________________________ Many2One _______________________________
        'wmsmci_produto_id': fields.many2one('estoque.produto', 'Produto', required=True, select=True,
                                             ondelete='restrict'),
        'wmsmci_grade_id': fields.many2one('estoque.produto.grade', 'Grade', required=True, select=True,
                                           ondelete='restrict'),
        'wmsmci_produto_tipo_id': fields.many2one('wms.produtotipo', 'Tipo de produto'),

        # ___________________________ Float __________________________________
        'wmsmci_quantidade': fields.float('Quantidade', digits=(9, 3),
                                          help='Quantidade a ser separada.'),
        'wmsmci_peso': fields.float('Peso (Kg)', digits=(12, 3)),
        'wmsmci_volume': fields.float('Volume (m3)', digits=(16, 6)),

        # ___________________________ Function _______________________________
        'wmsmci_falta_dado_logistico': fields.function(wmsmci_fields_function, method=True,
                                                       type='boolean', store=True,
                                                       string='Falta dado logistico'),
        'wmsmci_saldo': fields.function(wmsmci_fields_function, method=True, store=True,
                                        digits=(15, 3), string='Saldo',
                                        help='Saldo do item no estoque (C.D).'),
        'wmsmci_produto': fields.function(wmsmci_fields_function, method=True, type='char',
                                          size=60, string='Produto'),
        'wmsmci_grade': fields.function(wmsmci_fields_function, method=True, type='char',
                                        store=True, size=2, string='Grade'),

        # ___________________________ Boolean ________________________________
        'wmsmci_fracionado': fields.boolean('Fracionado'),
        'wmsmci_embalado': fields.boolean('Embalado'),
        'wmsmci_perigoso': fields.boolean('Produto perigoso'),
        'active': fields.boolean('Ativo')
    }

    _defaults = {
        'active': lambda *args: True
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
