# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.report import report_sxw
from datetime import datetime
from pytz import timezone


# noinspection PyPep8Naming
class report_montagemcarga_pedidos_efetuados(report_sxw.rml_parse):
    """
    Mostra todos os pedidos da montagem de carga que foram efetuados.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    def __init__(self, cr, uid, name, context=None):
        """
        Atribui valores as funcoes utilizada no relatorio.

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: ID do usuario utilizado para a verificacao de perfil,
        :param name: nome do modelo utilizado,
        :param context: um dicionario padrao para valores contextuais,
        :type cr: cursor
        :type uid: int
        :type name: str
        :type context: dict
        :return: relatorio de pedidos da carga.
        :rtype: object

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}

        super(report_montagemcarga_pedidos_efetuados, self).__init__(
            cr, uid, name, context=context)

        tz = context.get('tz') or 'Brazil/East'
        agora = datetime.now(timezone('UTC')).astimezone(timezone(tz))
        self.localcontext.update(dict(datetime=datetime, agora=agora, sorted=sorted))

        self.context = context

report_sxw.report_sxw('report.montagemcarga.pedidos.efetuados', 'wms.montagemcarga',
                      'addons/wms/montagemcarga/report/pedidos_efetuados.rml',
                      parser=report_montagemcarga_pedidos_efetuados, header=False)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
