# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.report import report_sxw
from datetime import datetime
from pytz import timezone


# noinspection PyPep8Naming
class report_wms_montagemcarga_resumo_carga(report_sxw.rml_parse):
    """
    Relatorio de resumo de carga.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    def __init__(self, cr, uid, name, context):
        super(report_wms_montagemcarga_resumo_carga, self).__init__(cr, uid, name, context=context)

        tz = context.get('tz') or 'Brazil/East'
        agora = datetime.now(timezone('UTC')).astimezone(timezone(tz))
        dados = dict(datetime=datetime, agora=agora)

        self.localcontext.update(dados)

        self.context = context

report_sxw.report_sxw('report.wms.montagemcarga.resumo.carga', 'wms.montagemcarga',
                      'addons/wms/montagemcarga/report/resumo_carga.rml',
                      parser=report_wms_montagemcarga_resumo_carga, header=False)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
