# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2014 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2014, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields
from openerp.tools import drop_view_if_exists


# noinspection PyPep8Naming
class pgview_wms_ocupacao_cd(osv.Model):

    _name = "view.wms.ocupacao.cd"  # wmsaoc
    _auto = False
    _columns = {
        # ___________________________ Integer ________________________________
        'id': fields.integer('id'),
        'wmsocd_existente_pk': fields.integer('Quantidade de picking',
                                              help='Quantidade total de pickings na rua.'),
        'wmsocd_ocupado_pk': fields.integer('Picking ocupados',
                                            help='Quantidade total de pickings ocupados na rua.'),
        'wmsocd_existente_pu': fields.integer('Quantidade de pulmao',
                                              help='Quantidade total de pulmoes na rua.'),
        'wmsocd_ocupado_pu': fields.integer('Pulmoes ocupados',
                                            help='Quantidade total de pulmoes ocupados na rua.'),
        'wmsocd_existente_vt': fields.integer('Quantidade de enderecos virtuais',
                                              help='Quantidade total de enderecos virtuais na '
                                                   'rua.'),
        'wmsocd_ocupado_vt': fields.integer('Virtuais ocupados',
                                            help='Quantidade total de enderecos virtuais ocupados '
                                                 'na rua.'),

        # ___________________________ Float __________________________________
        'wmsocd_percent_pk': fields.float('% Pickings ocupados', digits=(5, 2),
                                          help='Percentual de picking ocupados na rua.'),
        'wmsocd_percent_pu': fields.float('% Pulmoes ocupados', digits=(5, 2),
                                          help='Percentual de pulmoes ocupados na rua.'),
        'wmsocd_percent_vt': fields.float('% Virtuais ocupados', digits=(5, 2),
                                          help='Percentual de enderecos virtuais ocupados na rua.'),

    }

    # noinspection PyMethodMayBeStatic
    def init(self, cr):
        drop_view_if_exists(cr, 'view_wms_ocupacao_cd')
        cr.execute(
            """
            CREATE VIEW view_wms_ocupacao_cd AS (
                SELECT  rua                                                                                 AS id,
                        -- PICKING --
                        SUM(CASE WHEN   tipo_nivel = 'PK' THEN 1 ELSE 0 END)                                AS wmsocd_existente_pk,
                        SUM(CASE WHEN   tipo_nivel = 'PK'
                            AND (quantidade+reserva_credito-reserva_debito) > 0 THEN 1 ELSE 0 END)          AS wmsocd_ocupado_pk,
                        CASE WHEN SUM(CASE WHEN tipo_nivel = 'PK' THEN 1 ELSE 0 END) > 0
                            THEN (1.0 * (SUM(CASE WHEN tipo_nivel = 'PK'
                            AND (quantidade+reserva_credito-reserva_debito) > 0 THEN 1 ELSE 0 END)) /
                                (SUM(CASE WHEN tipo_nivel = 'PK' THEN 1 ELSE 0 END)) * 100) ELSE 0.0 END    AS wmsocd_percent_pk,

                        -- PULMAO --
                        SUM(CASE WHEN   tipo_nivel = 'PU' THEN 1 ELSE 0 END)                                AS wmsocd_existente_pu,
                        SUM(CASE WHEN   tipo_nivel = 'PU'
                            AND (quantidade+reserva_credito-reserva_debito) > 0 THEN 1 ELSE 0 END)          AS wmsocd_ocupado_pu,
                        CASE WHEN SUM(CASE WHEN tipo_nivel = 'PU' THEN 1 ELSE 0 END) > 0
                            THEN (1.0 * (SUM(CASE WHEN tipo_nivel = 'PU'
                            AND (quantidade+reserva_credito-reserva_debito) > 0 THEN 1 ELSE 0 END)) /
                                (SUM(CASE WHEN tipo_nivel = 'PU' THEN 1 ELSE 0 END)) * 100) ELSE 0.0 END    AS wmsocd_percent_pu,

                        -- VIRTUAL --
                        SUM(CASE WHEN   tipo_nivel = 'VT' THEN 1 ELSE 0 END)                                AS wmsocd_existente_vt,
                        SUM(CASE WHEN   tipo_nivel = 'VT'
                            AND (quantidade+reserva_credito-reserva_debito) > 0 THEN 1 ELSE 0 END)          AS wmsocd_ocupado_vt,
                        CASE WHEN SUM(CASE WHEN tipo_nivel = 'VT' THEN 1 ELSE 0 END) > 0
                            THEN (1.0 * (SUM(CASE WHEN tipo_nivel = 'VT'
                            AND (quantidade+reserva_credito-reserva_debito) > 0 THEN 1 ELSE 0 END)) /
                                (SUM(CASE WHEN tipo_nivel = 'VT' THEN 1 ELSE 0 END)) * 100) ELSE 0.0 END    AS wmsocd_percent_vt

                FROM        wms_endereco
                GROUP BY    rua
                ORDER BY    rua
            );
            """
        )

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
