# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2014 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2014, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields
from openerp.tools import drop_view_if_exists


# noinspection PyPep8Naming
class pgview_wms_posicao_nf(osv.Model):

    _name = "view.wms.posicao.nf"  # wmspnf
    _auto = False
    _columns = {
        # ___________________________ Integer ________________________________
        'id': fields.integer('id'),
        'wmspnf_nf_numero': fields.integer('Nota fiscal',
                                           help='Numero da nota fiscal de entrada.'),
        'wmspnf_rec_numero': fields.integer('Recebimento',
                                            help='Numero da ordem de servico de recebimento.'),

        # ___________________________ Float __________________________________
        'wmspnf_nf_valor': fields.float('Valor total da nota fiscal', digits=(9, 2)),

        # ___________________________ Date ___________________________________
        'wmspnf_nf_data': fields.date('Data da nota fiscal'),

        # ___________________________ Datetime _______________________________
        'wmspnf_rec_data_abertura': fields.datetime('Data de abertura',
                                                    help='Data de abertura da ordem de servico de '
                                                         'recebimento.'),
        'wmspnf_rec_data_fechamento': fields.datetime('Data de fechamento',
                                                      help='Data de fechamento da ordem de servico '
                                                           'de recebimento.')
    }

    _order = 'wmspnf_nf_data'

    # noinspection PyMethodMayBeStatic
    def init(self, cr):
        drop_view_if_exists(cr, 'view_wms_posicao_nf')
        cr.execute(
            """
            CREATE VIEW view_wms_posicao_nf AS (
                SELECT	        ROW_NUMBER() OVER()         AS id,
                                fnf.numero_nf               AS wmspnf_nf_numero,
                                fnf.data_emissao            AS wmspnf_nf_data,
                                fnf.vr_total_nf             AS wmspnf_nf_valor,
                                ros.id                      AS wmspnf_rec_numero,
                                ros.data_abertura           AS wmspnf_rec_data_abertura,
                                ros.data_fechamento         AS wmspnf_rec_data_fechamento
                FROM            fiscal_nf_capa              AS fnf
                    LEFT JOIN   recebimento_os              AS ros  ON fnf.recebimento_id = ros.id
                WHERE           fnf.state                   IN ('2', '3')
                    AND         fnf.tipo                    = 'E'
                    AND         fnf.fisnfc_tipo_servico	    IS FALSE
                    AND         fnf.vr_total_nf             >  0
            );
            """
        )

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
