# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields
from openerp.tools import drop_view_if_exists


class pgview_wms_relatorio_produto_sem_movimentacao(osv.Model):

    _name = "view.wms.produto.sem.movimentacao"
    _auto = False
    _columns = {
        # ___________________________ Integer ________________________________
        'id': fields.integer('id'),

        # ___________________________ Char ___________________________________
        'wmspsm_codigo': fields.char('Codigo do produto', size=20),
        'wmspsm_produto': fields.char('Produto', size=60),
        'wmspsm_grade': fields.char('Grade', size=2),
        'wmspsm_endereco': fields.char('Endereco', size=20),
        'wmspsm_nivel': fields.char('Nivel', size=2),

        # ___________________________ Integer_________________________________
        'wmspsm_capacidade_picking': fields.integer('Capacidade'),
        'wmspsm_lastro': fields.integer('Lastro'),
        'wmspsm_camada': fields.integer('Camada'),
        'wmspsm_norma_palete': fields.integer('Norma Palete'),

        # ___________________________ Boolean ________________________________
        'wmspsm_dinamico': fields.boolean('Dinamico')
    }

    def init(self, cr):
        drop_view_if_exists(cr, 'view_wms_produto_sem_movimentacao')
        cr.execute(
            """
            CREATE VIEW view_wms_produto_sem_movimentacao AS (
                SELECT  epg.id                              AS id,
                        ep.codigo                           AS wmspsm_codigo,
                        ep.name                             AS wmspsm_produto,
                        epg.grade                           AS wmspsm_grade,
                        wms.name                            As wmspsm_endereco,
                        wms.tipo_nivel                      AS wmspsm_nivel,
                        wms.picking_dinamico                AS wmspsm_dinamico,
                        epg.capacidade_picking              AS wmspsm_capacidade_picking,
                        epg.lastro                          AS wmspsm_lastro,
                        epg.camada                          AS wmspsm_camada,
                        epg.lastro * epg.camada             AS wmspsm_norma_palete
                FROM    estoque_produto_grade               AS epg
                    INNER JOIN wms_endereco                 AS wms ON epg.endereco_produto_id = wms.id
                    INNER JOIN estoque_produto              AS ep  ON wms.produto_id = ep.id
                WHERE   epg.id NOT IN
                    (
                        SELECT  DISTINCT ri.grade_id
                        FROM    recebimento_itens           AS ri
                            INNER JOIN recebimento_os       AS ros ON ri.recebimento_id = ros.id
                        WHERE   ros.state NOT IN ('esboco', 'cancelada')
                    )
                AND      epg.id NOT IN
                    (
                        SELECT DISTINCT si.grade_id
                        FROM    wms_separacao_itens         AS si
                            INNER JOIN separacao_os         AS sos ON si.os_id = sos.id
                        WHERE sos.state NOT IN ('esboco', 'cancelada')
                    )
                ORDER BY wms.name
            );
            """
        )

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
