# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2014 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2014, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields
from openerp.tools import drop_view_if_exists


# noinspection PyPep8Naming
class pgview_wms_relatorio_produto_sem_picking(osv.Model):

    _name = "view.wms.produto.sem.picking"  # wmspsp
    _auto = False
    _columns = {
        # ___________________________ Integer ________________________________
        'id': fields.integer('id'),
        'wmspsp_saldo': fields.integer('Saldo'),

        # ___________________________ Char ___________________________________
        'wmspsp_codigo': fields.char('Codigo do produto', size=20),
        'wmspsp_descricao': fields.char('Produto', size=60),
        'wmspsp_grade': fields.char('Grade', size=2),
    }

    _order = 'wmspsp_descricao'

    # noinspection PyMethodMayBeStatic
    def init(self, cr):
        drop_view_if_exists(cr, 'view_wms_produto_sem_picking')
        cr.execute(
            """
            CREATE VIEW     view_wms_produto_sem_picking AS (
                SELECT      ROW_NUMBER() OVER ()            AS id,
                            SUM(e.quantidade)               AS wmspsp_saldo,
                            ep.codigo                       AS wmspsp_codigo,
                            ep.name                         AS wmspsp_descricao,
                            epg.grade                       AS wmspsp_grade
                FROM        estoque_produto_grade           AS epg
                    LEFT    JOIN wms_endereco               AS e    ON epg.id = e.grade_id
                    LEFT    JOIN estoque_produto            AS ep   on epg.produto_id = ep.id
                WHERE       epg.endereco_produto_id         IS NULL
                    AND     epg.active                      IS TRUE
                    AND     ep.estpro_wms_uso               IS TRUE
                GROUP BY    ep.codigo, ep.name, epg.grade
            );
            """
        )

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
