# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv
from openerp.tools.translate import _
from openerp.report import report_sxw
from datetime import datetime
from pytz import timezone


class report_dadoslogisticos(report_sxw.rml_parse):
    """
    Relatorio de Dados Logisticos.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    def __init__(self, cr, uid, name, context):
        super(report_dadoslogisticos, self).__init__(cr, uid, name, context=context)

        tz = context.get('tz') or 'Brazil/East'
        agora = datetime.now(timezone('UTC')).astimezone(timezone(tz))
        dados = {'datetime': datetime, 'agora': agora, 'subtitulo': context.get('subtitulo', '')}

        self.localcontext.update(dados)

        self.context = context

        # Verifica se existe item com dado logistico faltando
        obj_recebimento_itens = self.pool.get('recebimento.itens')
        args = [('recebimento_id', '=', context.get('active_id'))]
        item_ids = obj_recebimento_itens.search(cr, uid, args, context=context)

        if not item_ids:
            msg = _('Nao ha itens de recebimento.')

            raise osv.except_osv(_('Atencao!'), msg)

        brw_recebimento = obj_recebimento_itens.browse(cr, uid, item_ids, context)
        item_ids = map(lambda i: i.id, filter(lambda r: r.recite_ver_falta_dado_logistico,
                                              brw_recebimento))

        if not item_ids:
            msg = _('Nao ha itens de recebimento com dado logistico faltando.')

            raise osv.except_osv(_('Atencao!'), msg)


report_sxw.report_sxw('report.dadoslogisticos', 'recebimento.os',
                      'addons/wms/report/produto_dadoslogisticos.rml',
                      parser=report_dadoslogisticos, header=False)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
