# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.report import report_sxw
from datetime import datetime
from pytz import timezone


class report_wms_produto_sem_movimentacao(report_sxw.rml_parse):
    """
    Relatorio de produtos sem movimentacao.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    def __init__(self, cr, uid, name, context):
        super(report_wms_produto_sem_movimentacao, self).__init__(cr, uid, name, context=context)

        tz = context.get('tz') or 'Brazil/East'
        agora = datetime.now(timezone('UTC')).astimezone(timezone(tz))
        dados = {'datetime': datetime, 'agora': agora}

        # ___________________________ Objects ________________________________
        obj_wms_produto_sem_movimentacao = self.pool.get('wizard.wms.produto.sem.movimentacao')

        campos = ['wizpsm_periodo_inicio', 'wizpsm_periodo_fim']
        wms_produto_sem_movimentacao_dados = obj_wms_produto_sem_movimentacao.read(
            cr, uid, context.get('active_id'), campos, context)

        if wms_produto_sem_movimentacao_dados and \
                isinstance(wms_produto_sem_movimentacao_dados, list):
            wms_produto_sem_movimentacao_dados = wms_produto_sem_movimentacao_dados[0]

        if wms_produto_sem_movimentacao_dados and \
                isinstance(wms_produto_sem_movimentacao_dados, dict):
            inicio = wms_produto_sem_movimentacao_dados.get('wizpsm_periodo_inicio')
            fim = wms_produto_sem_movimentacao_dados.get('wizpsm_periodo_fim')

            if inicio and fim:
                inicio = datetime.strptime(inicio, '%Y-%m-%d').strftime('%d/%m/%Y')
                fim = datetime.strptime(fim, '%Y-%m-%d').strftime('%d/%m/%Y')
                if inicio == fim:
                    dados['periodo'] = 'Em %s' % inicio or fim
                else:
                    dados['periodo'] = 'De %s a %s' % (inicio, fim)
            elif inicio and not fim:
                inicio = datetime.strptime(inicio, '%Y-%m-%d').strftime('%d/%m/%Y')
                dados['periodo'] = 'Desde %s' % inicio
            elif not inicio and fim:
                fim = datetime.strptime(fim, '%Y-%m-%d').strftime('%d/%m/%Y')
                dados['periodo'] = 'Ate %s' % fim
            else:
                dados['periodo'] = ''

        self.localcontext.update(dados)

        self.context = context

report_sxw.report_sxw('report.produto.sem.movimentacao', 'view.wms.produto.sem.movimentacao',
                      'addons/wms/report/produto_sem_movimentacao.rml',
                      parser=report_wms_produto_sem_movimentacao, header=False)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

