# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv


# noinspection PyPep8Naming
class wms_montagemcarga(osv.Model):
    """
    Montagem de carga. (heranca)

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wms.montagemcarga'  # wmsmcg
    _inherit = 'wms.montagemcarga'  # wms/montagemcarga/model/montagemcarga_data

    def wmsmcg_button_cancelar_montagemcarga(self, cr, uid, ids, context=None):
        """
        Cancelar a carga com ordens de servico de separacao. (heranca)

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: ID do usuario utilizado para a verificacao de perfil,
        :param ids: lista dos IDs,
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type uid: int
        :type ids: int|list[int|long]
        :type context: dict
        :return: verdadeiro se a montagem de carga foi cancelada.
        :rtype: bool

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}

        if ids and isinstance(ids, (int, long)):
            ids = [ids]

        # ___________________________ Objects ________________________________
        obj_separacao_os = self.pool.get('separacao.os')
        obj_transferencia_os = self.pool.get('transferencia.os')

        # Cancela as ordens de servico de separacao e as ordens de servico de movimentacao
        args = [('montagemcarga_id', 'in', ids)]
        separacao_os_ids = obj_separacao_os.search(cr, uid, args, context=context)
        movimentacao_os_ids = obj_transferencia_os.search(cr, uid, args, context=context)
        obj_separacao_os.osvosv_cancelar_os(cr, uid, separacao_os_ids, context)
        obj_transferencia_os.osvosv_cancelar_os(cr, uid, movimentacao_os_ids, context)

        result = super(wms_montagemcarga, self).wmsmcg_button_cancelar_montagemcarga(
            cr, uid, ids, context)

        return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
