# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
"""

from openerp.osv import osv, fields


class wms_montagemcarga(osv.Model):
    """
    Relacionamento entre montagem de carga e a ordem de servico de separacao e ordem de servico de
    transferencia/movimentacao. (heranca)

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wms.montagemcarga'  # wmsmcg
    _inherit = 'wms.montagemcarga'  # wms/montagemcarga/model/montagemcarga_data

    _columns = {
        # ___________________________ One2Many _______________________________
        # Nr da ordem de servico de separacao (carga/rua/fracionado)
        'separacao_os_ids': fields.one2many('separacao.os', 'montagemcarga_id',
                                            'Ordem de servico de separacao'),
        'movimentacao_os_ids': fields.one2many('transferencia.os', 'montagemcarga_id',
                                               'Ordem de servico de movimentacao'),
        'wmsmcg_separacao_item_ids': fields.one2many('wms.separacao.itens', 'wmssit_carga_id',
                                                     'Item de separacao'),
        # Nr do ET
        'wmsmcg_et_ids': fields.one2many('wms.separacao.fracionado.et', 'wmssfe_montagemcarga_id',
                                         'Elemento de transporte')
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

