# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


# _______________________ separacao.os _______________________________________
def seposv_fields_function(self, cr, uid, ids, name, arg, context=None):
    """
    Manipulacao de campos. Valores de campos pre-definidos.

    @param cr: {cursor} a linha atual do cursor do banco de dados,
    @param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    @param ids: {list} lista dos IDs,
    @param name: {list} lista com o nome dos campos,
    @param arg: {dict} dicionario com os argumentos e valores,
    @param context: {dict} um dicionario padrao para valores contextuais,
    @return: {dict} valores ajustados dos campos.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    # ___________________________ Objects ________________________________
    obj_estoque_parametro = self.pool.get('estoque.parametro')

    result = {}

    for os in self.browse(cr, uid, ids, context):
        try:
            if name in ('qtde_volumes', 'qtde_itens', 'peso_total',
                        'cubagem_total', 'seposv_conferencia_ok'):
                valor = 0
                for item in os.separacao_item_ids:
                    if name == 'qtde_volumes':
                        valor += item.quantidade
                    elif name == 'qtde_itens':
                        valor += 1
                    elif name == 'peso_total':
                        valor += item.produto_embalagem_id.peso_bruto * item.quantidade
                    elif name == 'cubagem_total':
                        valor += item.produto_embalagem_id.cubagem * item.quantidade
                    elif name == 'seposv_conferencia_ok':
                        if item.item_conferido:
                            valor = True
                        else:
                            valor = False
                            break
                    else:
                        valor = False
            elif name == 'conferente':
                valor = os.conferente_id.name
            elif name == 'mesmo_conferente':
                valor = False
                campos = ['conferente_id']
                dados_os = self.read(cr, uid, os.id, campos, context, load='_classic_write')

                if dados_os and isinstance(dados_os, list):
                    dados_os = dados_os[0]

                if dados_os and isinstance(dados_os, dict):
                    if dados_os.get('conferente_id') == uid:
                        valor = True
            elif name == 'seposv_mostra_quantidade':
                estoque_parametro_ids = obj_estoque_parametro.search(cr, uid, [], context=context)

                if estoque_parametro_ids:
                    _id = estoque_parametro_ids
                    dados_parametro = obj_estoque_parametro.browse(cr, uid, _id)

                    valor = dados_parametro[0].estpar_mostra_quantidade
                else:
                    valor = False
            else:
                valor = None
        except Exception as e:
            print '[erro] %s' % e
            valor = None

        result[os.id] = valor

    return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
