# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv


# noinspection PyPep8Naming
class os_historico(osv.Model):
    """
    Registro do hitorico das ordens de servico.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'separacao.os.historico'  # seposh
    _inherit = 'separacao.os.historico'  # wms/separacao/inherit/os_historico_data

    def osvhis_registra_acao(self, cr, uid, ids, acao, context=None):
        """
        Registro do historico.

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: ID do usuario utilizado para a verificacao de perfil,
        :param ids: lista de IDs,
        :param acao: nome da acao,
        :param context: um dicionario padrao para valores contextuais,
        :type cr: object
        :type uid: int
        :type ids: int|list
        :type acao: str
        :type context: dict
        :return: lista com o ID dos registros que foram criados.
        :rtype: bool

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}

        result = []  # Lista dos ID dos registros de historico

        for separacao_id in ids if isinstance(ids, list) else [ids]:
            dados = {
                'separacao_id': separacao_id,
                'acao': acao.capitalize()
            }

            # Cria novo registro de historico
            result.append(self.create(cr, uid, dados, context))  # Registra dados da nova acao

        result = all(result)

        return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
