# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class separacao_os_historico(osv.Model):
    """
    Relacionamento entre ordem de servico de separacao e historico de separacao. (heranca)

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'separacao.os.historico'  # seposh
    _inherit = 'os.historico'  # wms/separacao/inherit/os_historico_data

    _columns = {
        # ___________________________ Many2One _______________________________
        'separacao_id': fields.many2one('separacao.os', 'Ordem de servico'),
    }


class separacao_os(osv.Model):
    """
    Relacionamento entre Historico de Separacao e ordem de servico de Separacao. (heranca)

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'separacao.os'  # seposv
    _inherit = 'separacao.os'  # wms/separacao/inherit/os_data

    _columns = {
        # ___________________________ One2Many _______________________________
        'historico_ids': fields.one2many('separacao.os.historico', 'separacao_id', 'Historico')
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
