# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


# _______________________ wms.produtotipo ____________________________________
def wmspti_nova_sequencia(self, cr, uid, context):
    """
    Define a nova sequencia dos tipos de produto. (heranca)

    @param cr: {cursor} a linha atual do cursor do banco de dados,
    @param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    @return: {int} nova sequencia.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    # Busca pela maior sequencia
    sequencia_id = self.search(cr, uid, [], limit=1, order='sequence', context=context)
    sequencia = 0

    if sequencia_id:
        dados_sequencia = self.read(cr, uid, sequencia_id, ['sequence'], context)

        if dados_sequencia and isinstance(dados_sequencia, list):
            dados_sequencia = dados_sequencia[0]

        if dados_sequencia and isinstance(dados_sequencia, dict):
            sequencia = dados_sequencia.get('sequence', 0)

    sequencia += 1

    return sequencia

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
