# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz:siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


# _______________________ wms.separacao.itens ________________________________
def wmssit_fields_function(self, cr, uid, ids, name, arg, context):
    """
    Manipulacao de campos. Valores de campos pre-definidos.

    :param cr: {cursor} a linha atual do cursor do banco de dados,
    :param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    :param ids: {list} lista dos IDs,
    :param name: {list} lista com o nome dos campos,
    :param arg: {dict} dicionario com os argumentos e valores,
    :param context: {dict} um dicionario padrao para valores contextuais,
    :return: {dict} valores ajustados dos campos.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    # ___________________________ Objects ________________________________
    obj_financeiro_cliente = self.pool.get('financeiro.cliente')
    obj_automacao_codigo_barra = self.pool.get('automacao.codigo.barra')
    obj_adm_utils = self.pool.get('adm.utils')

    result = {}

    # Contexto para mostrar produto baseado no parametro de descricao da grade
    campos = ['estpar_descricao_grade']
    adm_utils_dados = obj_adm_utils.admutl_get_parametros(cr, uid, 'estoque', campos, context=context)

    for brw_wms_separacao_item in self.browse(cr, uid, ids, context):
        try:
            if name == 'rua':
                value = brw_wms_separacao_item.endereco_id.rua
            elif name == 'seq_rota':
                args = [('pessoa_id', '=', brw_wms_separacao_item.pessoa_id.id)]
                cliente_id = obj_financeiro_cliente.search(cr, uid, args, context=context)

                campos = ['sequence']  # Sequencia de entrega na rota
                dados_cliente = obj_financeiro_cliente.read(cr, uid, cliente_id, campos, context)

                if dados_cliente and isinstance(dados_cliente, list):
                    dados_cliente = dados_cliente[0]

                if dados_cliente and isinstance(dados_cliente, dict):
                    value = dados_cliente.get('sequence', 1)
                else:
                    value = 1  # Sequencia de entrega padrao
            elif name == 'seq_tipo_produto':
                value = brw_wms_separacao_item.grade_id.produto_tipo_id.sequence
            elif name == 'embalagem':
                value = brw_wms_separacao_item.produto_embalagem_id.embalagem_id.sigla
            elif name == 'codigo_barra':  # Codigo de barra do produto relacionado a embalagem.
                embalagem_id = brw_wms_separacao_item.produto_embalagem_id.id
                args = [('produto_id', '=', brw_wms_separacao_item.produto_id.id),
                        ('grade_id', '=', brw_wms_separacao_item.grade_id.id),
                        ('produto_embalagem_id', '=', embalagem_id)]
                ids = obj_automacao_codigo_barra.search(cr, uid, args, context=context)

                if ids:
                    browse_cb = obj_automacao_codigo_barra.browse(cr, uid, ids)
                    value = browse_cb[0].codigo_barra
                else:
                    value = None
            elif name == 'item_conferido':
                value = brw_wms_separacao_item.quantidade == brw_wms_separacao_item.qtde_conferida + brw_wms_separacao_item.qtde_cortada
            elif name == 'wmssit_endereco':
                value = brw_wms_separacao_item.endereco_id.name
            elif name == 'wmssit_produto':
                codigo = brw_wms_separacao_item.produto_id.codigo or ''
                if adm_utils_dados.get('estpar_descricao_grade') == 'G':  # Apenas a grade
                    produto = brw_wms_separacao_item.grade_id.descricao or ''
                else:  # Produto + grade
                    produto = brw_wms_separacao_item.produto_id.name or ''
                value = "%s%s%s" % (codigo, ' - ' if codigo else '', produto)
            else:
                value = None
        except Exception as e:
            print '[ERRO] - %s: Atributo %s: %s' % (__name__, name, e)
            value = None

        result[brw_wms_separacao_item.id] = value

    return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
