# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv
from openerp.report import report_sxw
from datetime import datetime
from pytz import timezone
from openerp.tools.translate import _


class report_mapa_fracionado(report_sxw.rml_parse):
    """
    Mapa de separacao fracionado

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    def __init__(self, cr, uid, name, context=None):
        """
        Atribui valores as funcoes utilizada no relatorio.

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: ID do usuario utilizado para a verificacao de perfil,
        :param name: nome do modelo utilizado,
        :param context: um dicionario padrao para valores contextuais,
        :type cr: object
        :type uid: integer
        :type name: char|list
        :return: impressao do relatorio.
        :rtype: object

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}

        super(report_mapa_fracionado, self).__init__(cr, uid, name, context)

        tz = context.get('tz') or 'Brazil/East'
        agora = datetime.now(timezone('UTC')).astimezone(timezone(tz))

        self.localcontext.update({
            'datetime': datetime,
            'agora': agora,
            'sorted': sorted,
        })

        self.context = context

        # Verifica se existem itens fracionados
        obj_separacao_os = self.pool.get('separacao.os')
        args = [('montagemcarga_id', '=', context.get('active_id')), ('fracionado', '=', True)]

        if not obj_separacao_os.search(cr, uid, args, context=context):
            msg = _('Mapa de separacao nao pode ser impresso. Nao ha ordens de servico para itens '
                    'fracionados.')

            raise osv.except_osv(_('Atencao!'), msg)

report_sxw.report_sxw('report.mapa.fracionado', 'wms.montagemcarga',
                      'addons/wms/separacao/report/mapa_fracionado.rml',
                      parser=report_mapa_fracionado, header=False)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
