# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.report import report_sxw
from datetime import datetime
from pytz import timezone


class report_paletizada_carga(report_sxw.rml_parse):
    """
    Mapa de separacao - Paletizada por carga.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    def __init__(self, cr, uid, name, context=None):
        """
        Atribui valores as funcoes utilizada no relatorio.

        @param cr: {cursor} a linha atual do cursor do banco de dados,
        @param uid: {int} o ID do usuario utilizado para a verificacao de perfil,
        @param name: {char} nome do modelo utilizado,
        @param context: {dict} um dicionario padrao para valores contextuais,
        @return: Relatorio mapa de separacao

        @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}

        super(report_paletizada_carga, self).__init__(cr, uid, name, context)

        agora = datetime.now(timezone('UTC')).astimezone(timezone(context.get('tz', 'Brazil/East')))

        self.localcontext.update({'datetime': datetime, 'agora': agora})

        self.context = context

report_sxw.report_sxw('report.separacao.paletizada.carga', 'separacao.os',
                      'addons/wms/separacao/report/paletizada_carga.rml',
                      parser=report_paletizada_carga, header=False)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
