# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


# noinspection PyPep8Naming
class wizard_etiquta_volume(osv.TransientModel):
    """
    Impressao das etiquetas de volume.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wizard.etiqueta.volume'  # wiziev

    __help_printer = "O nome da impressora que sera utilizada para impressao das etiquetas de " \
                     "pulmao. Geralmente uma impressora termica especifica para impressao de " \
                     "etiquetas."
    _columns = {
        # ___________________________ Many2One _______________________________
        'wiziev_impressora_volume_id': fields.many2one('wms.impressora.etiqueta',
                                                       'Nome da impressora', ondelete='restrict',
                                                       help=__help_printer),

        # ___________________________ Integer ________________________________
        'wiziev_qtde_volumes': fields.integer('Quantidade de volumes')
    }

    _defaults = {
        'wiziev_qtde_volumes': lambda *args: 1
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
