# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields

class wizard_mapa_separacao(osv.TransientModel):
    """
    Mapa de separacao.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wizard.mapa.separacao'  # wizmap

    from funcoes import wizmap_fields_selection_tipo

    _columns = {
        # ___________________________ Selection ______________________________
        'wizmap_separacao_tipo': fields.selection(wizmap_fields_selection_tipo,
                                                  'Tipo de separacao', size=3),

        # ___________________________ Boolean ________________________________
        # Somente uitlizado em separacao por carga
        'wizmap_calculo_veiculo': fields.boolean('Utilizar dados do veiculo na separacao',
                                                 help='Utilizado em separacao por carga. Se marcado, a quantidade de paletes, o total da carga e o volume do veiculo serao utilizados para o calculo da separacao.')
    }

    _defaults = {
        'wizmap_separacao_tipo': lambda *args: 'C',  # Separacao por carga
        'wizmap_calculo_veiculo': lambda *args: False
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

