# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


# _______________________ transferencia.os ___________________________________
def trfosv_tipo_padrao(self, cr, uid, context=None):
    """
    Define o tipo da OS / TRF - Transferencia

    :param cr: a linha atual do cursor do banco de dados,
    :param uid: ID do usuario utilizado para a verificacao de perfil,
    :param context: um dicionario padrao para valores contextuais,
    :return: ID do tipo de ordem de servico.
    :rtype: long

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    # ___________________________ Objects ________________________________
    obj_os_tipo = self.pool.get('os.tipo')

    args = [('codigo', '=', 'TRF')]
    os_tipo_ids = obj_os_tipo.search(cr, uid, args, context=context)

    if os_tipo_ids:
        return os_tipo_ids[0]  # Tipo padrao = "Transferencia"

    return []


def trfosv_codigo_padrao(self, cr, uid, context=None):
    """
    Define o codigo do tipo da ordem de servico: 'TRF'

    :param cr: a linha atual do cursor do banco de dados,
    :param uid: ID do usuario utilizado para a verificacao de perfil,
    :param context: um dicionario padrao para valores contextuais,
    :return: o codigo padrao de transferencia = "TRF".

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}
    return 'TRF'


def trfosv_function_movimentacao_ok(self, cr, uid, ids, name, arg,  context=None):
    """
    Verifica se todos os itens da ordem de servico de movimentacao foram movimentados.

    :param cr: a linha atual do cursor do banco de dados,
    :param uid: ID do usuario utilizado para a verificacao de perfil,
    :param ids: lista dos IDs,
    :param name: lista com o nome dos campos,
    :param arg: dicionario com os argumentos e valores,
    :param context: um dicionario padrao para valores contextuais,
    :return: sempre o codigo do tipo de ordem de servico.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    result = {}

    for os in self.browse(cr, uid, ids if isinstance(ids, list) else [ids], context=context):
        result[os.id] = all(map(lambda m: m.state in ['3', '9'], os.transferencia_item_ids))

    return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
