# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


# noinspection PyPep8Naming
class transferencia_os(osv.Model):
    """
    Ordem de servico de transferencia. (heranca)

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'transferencia.os'  # trfosv
    _inherit = 'os'  # recebimento/os/model/os_data

    from funcoes import trfosv_codigo_padrao, trfosv_tipo_padrao, trfosv_function_movimentacao_ok

    _columns = {
        # ___________________________ Many2Many ______________________________
        'responsavel_ids': fields.many2many('res.users', 'transferencia_m2m_user',
                                            'transferencia_id', 'user_id', 'Responsaveis',
                                            help='Responsaveis pela ordem de servico.'),

        'transferencia_item_ids': fields.one2many('wms.transferencia.itens', 'transferencia_id',
                                                  'Item de movimentacao',
                                                  help='Itens de movimentacao.'),

        # ___________________________ Function _______________________________
        'trfosv_movimentacao_ok': fields.function(trfosv_function_movimentacao_ok, type='boolean',
                                                  method=True, string='Enderecamento OK',
                                                  help='Se marcado, todos as movimetacoes ja foram '
                                                       'efetuadas.')
    }

    _order = 'data_abertura desc, state'

    # Valores padrao
    _defaults = {
        'tipo_id': trfosv_tipo_padrao,  # ID - Transferencia
        'tipo': trfosv_codigo_padrao  # "TRF" - Transferencia
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
