# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class transferencia_os_historico(osv.Model):
    """
    Relacionamento entre ordem de servico de transferencia e o historico das transferencias.
    (heranca)

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'transferencia.os.historico'  # trfosh
    _inherit = 'os.historico'  # recebimento/os/model/os_historico_data

    _columns = {
        # ___________________________ Many2One _______________________________
        'transferencia_id': fields.many2one('transferencia.os', 'Ordem de servico')
    }


class transferencia_os(osv.Model):
    """
    Relacionamento entre o historico de transferencia e as ordens de servico de
    Transferencia. (heranca)

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'transferencia.os'  # trfosv
    _inherit = 'transferencia.os'  # wms/transferencia/inherit/os_data

    _columns = {
        # ___________________________ One2Many _______________________________
        'historico_ids': fields.one2many('transferencia.os.historico',
                                         'transferencia_id', 'Historico')
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
