# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


def wiztrf_virtuais_ocupados(self, cr, uid, context=None):
    """
    Retorna os enderecos virtuais ocupados.

    @param cr: {cursor} a linha atual do cursor do banco de dados,
    @param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    @param context: {dict} um dicionario padrao para valores contextuais,
    @return: {int} quantidade de Enderecos virtuais

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    # ___________________________ Objects ________________________________
    obj_wms_endereco = self.pool.get('wms.endereco')

    # Total dos enderecos virtuais ocupados
    result = len(obj_wms_endereco.wmsend_virtuais_ocupados(cr, uid, context))

    return result


def wiztrf_pulmao_livre(self, cr, uid, context=None):
    """
    Retorna os enderecos de pulmao livre.

    @param cr: {cursor} a linha atual do cursor do banco de dados,
    @param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    @param context: {dict} um dicionario padrao para valores contextuais,
    @return: {list} a lista dos ID's dos enderecos ocupados.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    # ___________________________ Objects ________________________________
    obj_wms_endereco = self.pool.get('wms.endereco')

    # Total de enderecos de pulmao livre encontrado
    result = len(obj_wms_endereco.wmsend_pulmao_livre(cr, uid, context))

    return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
