# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class wms_wizard_consulta_produto_grade(osv.TransientModel):
    """
    Realiza consulta a produto/grade.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wizard.wms.consulta.produto.grade'  # wizcpg
    _inherits = {'estoque.produto.grade': 'wizcpg_grade_id'}

    _columns = {
        # ___________________________ Many2One________________________________
        'wizcpg_endereco_id': fields.many2one('wms.endereco', 'Endereco de picking'),
        'wizcpg_produto_id': fields.many2one('estoque.produto', 'Produto'),
        'wizcpg_grade_id': fields.many2one('estoque.produto.grade', 'Grade', ondelete="restrict",
                                           required=True),

        # ___________________________ Char ___________________________________
        'wizcpg_codigo': fields.char('Codigo de barras', required=True, size=15,
                                     help='Codigo de barras do produto.'),
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
