# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


# noinspection PyPep8Naming
class wms_wizard_endereco_ressuprimento_manual(osv.TransientModel):

    # noinspection PyMethodMayBeStatic
    def __get_endereco_ids(self, cr, uid, context=None):
        """
        Define os enderecos do ressuprimento preventivo.

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: ID do usuario utilizado para a verificacao de perfil,
        :param context: um dicionario padrao para valores contextuais,
        :type cr: cursor
        :type uid: int
        :type context: dict
        """

        context = context and context.copy() or {}

        # Somente enderecos de picking com produto alocado
        args = [('id', 'in', context.get('active_ids')), ('tipo_nivel', '=', 'PK'),
                ('grade_id', '!=', False)]
        endereco_ids = self.pool.get('wms.endereco').search(cr, uid, args, context=context)

        return [(6, 0, endereco_ids)]

    """
    Realiza ressuprimento preventivo do picking. Atualiza o estoque quando o saldo esta abaixo do
    ponto de reposicao.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wizard.wms.endereco.ressuprimento.manual'  # wizerm

    _columns = {
        # ___________________________ Many2Many ______________________________
        'wizerm_endereco_ids': fields.many2many('wms.endereco', 'ressuprimento_m2m_endereco',
                                                'ressuprimento', 'endereco_id',
                                                'Enderecos de picking'),

        # ___________________________ Char ___________________________________
        'wizerm_mensagem': fields.char('Mensagem', size=200)
    }

    _defaults = {
        'wizerm_endereco_ids': __get_endereco_ids
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
