# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv


class wizard_wms_endereco_sentidorua(osv.TransientModel):
    """
    Determina o sentido que devera ser seguido durante o processo de separacao.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wizard.wms.endereco.sentido_rua'  # wizesr
    _inherit = 'wizard.wms.endereco.sentido_rua'  # wms/wizard/endereco_sentidorua_data

    def wizesr_definir_sentido_rua(self, cr, uid, ids, context=None):
        """
        Cria ou altera o sentido de uma rua.

        @param cr: {cursor} a linha atual do cursor do banco de dados,
        @param uid: {int} ID do usuario utilizado para a verificacao de perfil,
        @param ids: {list} lista com os IDs,
        @param context: {dict} um dicionario padrao para valores contextuais,
        @return: {boolean} Verdadeiro se foi criada a rua e seu sentido ou se o sentido foi
        alterado.

        @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}

        if ids and isinstance(ids, (int, long)):
            ids = [ids]

        # ___________________________ Objects ________________________________
        obj_wms_endereco = self.pool.get('wms.endereco')

        result = False
        campos = ['wizesr_deposito', 'wizesr_rua', 'wizesr_sentido']
        dados_sentido_rua = self.read(cr, uid, ids, campos, context=context)

        if dados_sentido_rua and isinstance(dados_sentido_rua, list):
            dados_sentido_rua = dados_sentido_rua[0]

        if dados_sentido_rua and isinstance(dados_sentido_rua, dict):
            deposito = dados_sentido_rua.get('wizesr_deposito')
            rua = dados_sentido_rua.get('wizesr_rua')
            sentido = dados_sentido_rua.get('wizesr_sentido')

            args = [('deposito', '=', deposito), ('rua', '=', rua)]
            dados = {'rua_sentido': sentido}
            sentido_rua_ids = obj_wms_endereco.search(cr, uid, args, context=context)

            if sentido_rua_ids:
                result = obj_wms_endereco.write(cr, uid, sentido_rua_ids, dados, context)

        return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
