# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz:siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields

# Tipos de Nivel
ENDERECO_TIPO_NIVEL = [('PK', 'Picking'), ('PU', 'Pulmao'), ('VT', 'Virtual')]

# Na criacao dos enderecos - Lado (par/impar/ambos)
ENDERECO_TIPO_LADO = [('1', 'Impar'), ('2', 'Par')]

# Status do Endereco
ENDERECO_STATUS = [('L', 'LIVRE'), ('O', 'OCUPADO'), ('R', 'Reservado')]


class wizard_wms_enderecofaixa(osv.TransientModel):
    """
    Endereco destinado ao armazenamento de produtos.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wizard.wms.enderecofaixa'  # wizwef

    _columns = {
        # ___________________________ Integer ________________________________
        'deposito': fields.integer('Deposito'),
        'rua_inicial': fields.integer('Rua inicial'),
        'rua_final': fields.integer('Rua final'),
        'predio_inicial': fields.integer('Predio inicial'),
        'predio_final': fields.integer('Predio final'),
        'nivel_inicial': fields.integer('Nivel inicial'),
        'nivel_final': fields.integer('Nivel final'),
        'apartamento_inicial': fields.integer('Apartamento inicial'),
        'apartamento_final': fields.integer('Apartamento final'),

        # ___________________________ Selection ______________________________
        'tipo_nivel': fields.selection(ENDERECO_TIPO_NIVEL, 'Tipo'),
        'lado': fields.selection(ENDERECO_TIPO_LADO, 'Lado'),
        'state': fields.selection(ENDERECO_STATUS, 'Status'),

        # ___________________________ Many2One________________________________
        'estrutura_tipo_id': fields.many2one('wms.estruturatipo', 'Tipo de estrutura'),
        'endereco_tipo_id': fields.many2one('wms.enderecotipo', 'Tipo de endereco'),
        'wizwef_estrutura_tipo_id': fields.many2one('wms.estruturatipo', 'Novo tipo de estrutura'),
        'wizwef_endereco_tipo_id': fields.many2one('wms.enderecotipo', 'Novo tipo de endereco'),

        # ___________________________ Boolean ________________________________
        'bloqueado': fields.boolean('Bloqueado'),
        'reservado': fields.boolean('Reservar endereco'),
        'picking_dinamico': fields.boolean('Dinamico'),
        'wizwef_bloqueado': fields.boolean('Considerar endereco bloqueado',
                                           help='Se marcado, os enderecos bloqueados tambem serao considerados.'),
    }

    _defaults = {
        'state': lambda *args: 'L'
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
