# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2014 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz:siginformatica.com.br>
                                -------

Copyleft (CC) 2014, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


# noinspection PyPep8Naming
class wizard_wms_estoque_picking(osv.TransientModel):
    """
    Relatorio de estoque (picking).

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wizard.wms.estoque.picking'  # wizepk

    _columns = {
        # ____________________________ Many2One ______________________________
        'wizepk_produto_id': fields.many2one('estoque.produto', 'Produto'),

        # ___________________________ Integer ________________________________
        'wizepk_deposito': fields.integer('Deposito'),
        'wizepk_rua_inicio': fields.integer('Rua inicial',
                                            help='O inicio do intervalo de ruas.'),
        'wizepk_rua_fim': fields.integer('Rua final',
                                         help='O final do intervalo de ruas.'),
        'wizepk_predio_inicio': fields.integer('Predio inicial',
                                               help='O inicio do intervalo de predios.'),
        'wizepk_predio_fim': fields.integer('Predio final',
                                            help='O final do intervalo de predios.'),
        'wizepk_nivel_inicio': fields.integer('Nivel inicial',
                                              help='O inicio do intervalo de niveis.'),
        'wizepk_nivel_fim': fields.integer('Nivel final',
                                           help='O final do intervalo de niveis.'),
        'wizepk_apartamento_inicio': fields.integer('Apartamento inicial',
                                                    help='O inicio do intervalo de apartamentos.'),
        'wizepk_apartamento_fim': fields.integer('Apartamento final',
                                                 help='O final do intervalo de apartamentos.'),

        # ___________________________ Selection ______________________________
        'wizepk_situacao': fields.selection(
            [('L', 'Livre'), ('O', 'Ocupado'), ('R', 'Reservado')], 'Situacao do endereco'),
        'wizepk_reposicao_situacao': fields.selection(
            [('acima', 'Acima'), ('abaixo', 'Abaixo')], 'Estado do ponto de reposicao'),

        # ___________________________ Char ___________________________________
        'wizepk_mensagem': fields.char('Mensagem', size=200),

        # ___________________________ Boolean ________________________________
        'wizepk_bloqueado': fields.boolean('Considerar enderecos bloqueados'),
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
