# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz:siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv


class wizard_wms_etiqueta_endereco(osv.TransientModel):
    """
    Impressao de etiquetas de endereco.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wizard.wms.etiqueta.endereco'  # wizwee
    _inherit = 'wizard.wms.etiqueta.endereco'  # wms/transferencia/wizard/enderecofiaxa_data

    def wizwee_button_imprimir_etiqueta(self, cr, uid, ids, context=None):
        """
        Impessao de etiquetas de endereco

        :param cr: {cursor} a linha atual do cursor do banco de dados,
        :param uid: {int} ID do usuario utilizado para a verificacao de perfil,
        :param ids: {list} lista com os IDs,
        :param context: {dict} um dicionario padrao para valores contextuais,
        :return: {boolean} verdadeiro se a etiquetas foram impressas.

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}

        if ids and isinstance(ids, (int, long)):
            ids = [ids]

        # ___________________________ Objects ________________________________
        obj_wms_endereco = self.pool.get('wms.endereco')

        endereco_ids = context.get('active_ids', [])
        campos = ['imprimir_virtual']
        wizard_wms_etiqueta_endereco_dados = self.read(cr, uid, ids, campos, context=context)

        if wizard_wms_etiqueta_endereco_dados and isinstance(wizard_wms_etiqueta_endereco_dados, list):
            wizard_wms_etiqueta_endereco_dados = wizard_wms_etiqueta_endereco_dados[0]

        if wizard_wms_etiqueta_endereco_dados and isinstance(wizard_wms_etiqueta_endereco_dados, dict):
            # Remove os IDs dos enderecos virtuais
            if not wizard_wms_etiqueta_endereco_dados.get('imprimir_virtual', False):
                args = [('id', 'in', endereco_ids), ('tipo_nivel', '!=', 'VT')]
                endereco_ids = obj_wms_endereco.search(cr, uid, args, context=context)

        result = obj_wms_endereco.wmsend_imprimir_etiqueta(cr, uid, endereco_ids, context=context)

        return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
