# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2014 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2014, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv


# noinspection PyPep8Naming
class wizard_wms_produto_sem_picking(osv.TransientModel):
    """
    Produtos sem picking.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'wizard.wms.produto.sem.picking'  # wizpsp
    _inherit = 'wizard.wms.produto.sem.picking'  # wms/wizard/produto_sem_picking_data

    def wizpsp_button_imprimir_relatorio(self, cr, uid, ids, context=None):
        """
        Impressao do relatorio de produtos sem picking.

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: ID do usuario utilizado para a verificacao de perfil,
        :param ids: lista com os IDs,
        :param context: um dicionario padrao para valores contextuais,
        :type cr: Cursor
        :type uid: integer
        :type ids: long|list[long]
        :type context: dict
        :return: relatorio de produtos sem picking.
        :rtype: object

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}
        result = dict(type='ir.actions.report.xml', report_name='produto.sem.picking',
                      name='produto_sem_picking')

        campos = ['wizpsp_produto_id']
        wizard_wms_produto_sem_picking_dados = self.read(cr, uid, ids, campos, context)

        if wizard_wms_produto_sem_picking_dados:
            if isinstance(wizard_wms_produto_sem_picking_dados, list):
                wizard_wms_produto_sem_picking_dados = wizard_wms_produto_sem_picking_dados[0]
                codigo = wizard_wms_produto_sem_picking_dados.get('wizpsp_produto_id')

                if codigo:
                    args = [('wmspsp_codigo', '=', codigo[1].split()[0])]
                else:
                    args = []

                produto_ids = self.pool.get('view.wms.produto.sem.picking').search(cr, uid, args, context=context)
                result['datas'] = dict(ids=produto_ids)

        return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
